---@type RegisterTableItems?
local items = {
	{id = 1, name = "water"},
	{id = 2, name = "lifefluid"},
	{id = 3, name = "beer"},
	{id = 4, name = "slime"},
	{id = 5, name = "lemonade"},
	{id = 6, name = "milk"},
	{id = 7, name = "manafluid"},
	{id = 10, name = "blood"},
	{id = 11, name = "oil"},
	{id = 13, name = "urine"},
	{id = 14, name = "coconut milk"},
	{id = 15, name = "wine"},
	{id = 19, name = "mud"},
	{id = 21, name = "fruit juice"},
	{id = 26, name = "lava"},
	{id = 27, name = "rum"},
	{id = 28, name = "swamp"},
	{id = 35, name = "tea"},
	{id = 43, name = "mead"},
	{id = 100, name = "void"},
	{id = 101, name = "earth"},
	{id = 103, name = "dirt"},
	{id = 104, name = "sand"},
	{id = 106, name = "grass"},
	{fromId = 108, toId = 109, name = "flowers"},
	{id = 194, name = "dirt"},
	{id = 231, name = "sand"},
	{id = 280, name = "dirt floor"},
	{id = 293, name = "grass", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 294, name = "pitfall", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 293, duration = 300},
	{fromId = 351, toId = 353, name = "dirt floor"},
	{id = 354, name = "muddy floor"},
	{id = 355, name = "muddy floor", fluidSource = FLUID_MUD},
	{fromId = 356, toId = 367, name = "dirt wall", article = "a"},
	{id = 368, name = "earth ground"},
	{fromId = 369, toId = 370, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 371, toId = 382, name = "stone wall", article = "a"},
	{id = 383, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 384, name = "dirt floor", description = "There is a hole in the ceiling."},
	{id = 385, name = "small hole", article = "a", description = "It seems too narrow to climb through."},
	{fromId = 386, toId = 387, name = "stalagmites"},
	{id = 388, name = "lava hole", article = "a", description = "It seems to be inactive."},
	{id = 389, name = "lava hole", article = "a", fluidSource = FLUID_LAVA, description = "It emits heat and light."},
	{fromId = 390, toId = 391, name = "stalagmites"},
	{id = 392, name = "hole", article = "a", decayTo = 354, duration = 300, floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 405, name = "wooden floor"},
	{id = 406, name = "white marble floor"},
	{id = 407, name = "black marble floor"},
	{fromId = 408, toId = 409, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 410, toId = 411, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 412, name = "sandstone floor"},
	{id = 413, name = "stone floor"},
	{id = 414, name = "tiled floor"},
	{id = 415, name = "stone floor"},
	{fromId = 416, toId = 417, name = "stone tile", article = "a", description = "It seems to be a switch.", walkStack = false},
	{id = 418, name = "sandy floor", description = "There is a hole in the ceiling."},
	{id = 419, name = "sandstone tile", article = "a"},
	{id = 420, name = "tiled floor"},
	{fromId = 421, toId = 422, name = "sandstone floor"},
	{id = 423, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 424, name = "stone tile", article = "a"},
	{fromId = 425, toId = 426, name = "stone tile", article = "a", description = "It seems to be a switch.", walkStack = false},
	{id = 427, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 428, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 429, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 430, name = "sewer grate", article = "a"},
	{id = 431, name = "stone floor"},
	{fromId = 432, toId = 433, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 434, toId = 445, name = "wooden floor"},
	{fromId = 446, toId = 447, name = "wooden floor", description = "It seems to be a switch.", walkStack = false},
	{fromId = 448, toId = 456, name = "wooden floor"},
	{id = 457, name = "white stone tile", article = "a"},
	{id = 458, name = "wooden floor"},
	{id = 459, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 460, name = "nothing special"},
	{id = 461, name = "closed trapdoor", article = "a"},
	{id = 462, name = "open trapdoor", article = "an", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 461, duration = 5},
	{id = 463, name = "pedestal", article = "a"},
	{id = 464, name = "sandstone wall", article = "a"},
	{id = 465, name = "stone floor"},
	{id = 466, name = "sandstone wall", article = "a"},
	{id = 467, name = "stone floor"},
	{id = 468, name = "loose stone pile", article = "a"},
	{id = 469, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 468, duration = 60},
	{id = 470, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 471, toId = 474, name = "strange carving", article = "a"},
	{fromId = 475, toId = 476, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 477, toId = 478, name = "ramp", article = "a"},
	{fromId = 479, toId = 480, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 481, name = "loose stone pile", article = "a"},
	{id = 482, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 481, duration = 300},
	{id = 483, name = "loose ice pile", article = "a"},
	{id = 484, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 483, duration = 300},
	{id = 485, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 486, name = "snow heap", article = "a"},
	{fromId = 487, toId = 488, name = "ramp", article = "a"},
	{id = 489, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 9059, duration = 30},
	{id = 493, name = "water", type = ITEM_TYPE_TRASHHOLDER, effect = CONST_ME_LOSEENERGY, ignoreBlocking = true},
	{fromId = 598, toId = 601, name = "lava", type = ITEM_TYPE_TRASHHOLDER, effect = CONST_ME_HITBYFIRE, ignoreBlocking = true},
	{id = 670, name = "snow"},
	{id = 671, name = "ice"},
	{fromId = 708, toId = 711, name = "tar", type = ITEM_TYPE_TRASHHOLDER, effect = CONST_ME_POFF, ignoreBlocking = true},
	{id = 724, name = "cobbled pavement"},
	{fromId = 777, toId = 790, name = "sandstone floor"},
	{id = 791, name = "road", article = "a"},
	{id = 804, name = "soil"},
	{id = 806, name = "ploughed soil"},
	{id = 836, name = "dry earth"},
	{fromId = 873, toId = 878, name = "mountain", article = "a"},
	{fromId = 891, toId = 902, name = "rocks"},
	{fromId = 903, toId = 913, name = "mountain", article = "a"},
	{fromId = 914, toId = 917, name = "archway", article = "an"},
	{fromId = 918, toId = 919, name = "mountain", article = "a"},
	{fromId = 920, toId = 923, name = "flat roof", article = "a"},
	{id = 924, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 925, toId = 944, name = "tiled roof", article = "a"},
	{fromId = 945, toId = 964, name = "wooden roof", article = "a"},
	{fromId = 965, toId = 966, name = "chess board", article = "a"},
	{fromId = 967, toId = 1015, name = "mill board", article = "a"},
	{fromId = 1016, toId = 1024, name = "tic-tac-toe board", article = "a"},
	{fromId = 1025, toId = 1035, name = "brick wall", article = "a"},
	{fromId = 1036, toId = 1048, name = "framework wall", article = "a"},
	{fromId = 1049, toId = 1059, name = "stone wall", article = "a"},
	{fromId = 1060, toId = 1070, name = "sandstone wall", article = "a"},
	{fromId = 1071, toId = 1083, name = "sandstone"},
	{fromId = 1084, toId = 1093, name = "sandstone wall", article = "a"},
	{fromId = 1095, toId = 1099, name = "sandstone wall", article = "a"},
	{fromId = 1100, toId = 1110, name = "stone wall", article = "a"},
	{fromId = 1111, toId = 1119, name = "white stone wall", article = "a"},
	{fromId = 1120, toId = 1127, name = "archway", article = "an"},
	{fromId = 1128, toId = 1153, name = "ornamented wall", article = "an"},
	{fromId = 1154, toId = 1157, name = "wall fountain", article = "a", fluidSource = FLUID_WATER},
	{fromId = 1158, toId = 1163, name = "archway", article = "an"},
	{fromId = 1164, toId = 1169, name = "ornamented wall", article = "an"},
	{id = 1170, name = "paravent", article = "a"},
	{fromId = 1171, toId = 1175, name = "paravent wall", article = "a"},
	{fromId = 1176, toId = 1193, name = "ornamented wall", article = "an"},
	{fromId = 1194, toId = 1195, name = "wall fountain", article = "a", fluidSource = FLUID_WATER},
	{fromId = 1196, toId = 1204, name = "lava wall", article = "a"},
	{fromId = 1205, toId = 1208, name = "archway", article = "an"},
	{id = 1209, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 1210, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1211, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1212, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 1213, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1214, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 1215, toId = 1218, name = "buttress", article = "a"},
	{id = 1219, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1220, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1221, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1222, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1223, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1224, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1225, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1226, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1227, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 1228, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1229, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 1230, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1231, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 1232, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1233, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1234, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 1235, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1236, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1237, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1238, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1239, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1240, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1241, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1242, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1243, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1244, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1245, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 1246, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1247, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 1248, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1249, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 1250, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1251, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1252, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 1253, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1254, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1255, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1256, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1257, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1258, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1259, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 1260, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1261, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 1262, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 1263, toId = 1264, name = "framework window", article = "a"},
	{fromId = 1265, toId = 1266, name = "brick window", article = "a"},
	{fromId = 1267, toId = 1268, name = "stone wall window", article = "a"},
	{fromId = 1269, toId = 1272, name = "white stone wall window", article = "a"},
	{fromId = 1273, toId = 1276, name = "sandstone window", article = "a"},
	{id = 1277, name = "mast", article = "a"},
	{fromId = 1278, toId = 1279, name = "sail", article = "a"},
	{fromId = 1280, toId = 1283, name = "steering wheel", article = "a"},
	{id = 1284, name = "drawbridge", article = "a"},
	{fromId = 1285, toId = 1292, name = "stone", article = "a"},
	{id = 1293, name = "stone", article = "a", weight = 1500},
	{
		id = 1294,
		name = "small stone",
		article = "a",
		weight = 360,
		attack = 5,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_SMALLSTONE,
		maxHitChance = 76,
		range = 4
	},
	{id = 1295, name = "stone", article = "a", weight = 3000},
	{fromId = 1296, toId = 1306, name = "stone", article = "a"},
	{fromId = 1307, toId = 1334, name = "debris"},
	{fromId = 1335, toId = 1336, name = "stone pile", article = "a"},
	{fromId = 1337, toId = 1352, name = "debris"},
	{id = 1353, name = "mossy stone", article = "a"},
	{id = 1354, name = "blue shrine stone", article = "a"},
	{id = 1355, name = "red shrine stone", article = "a"},
	{fromId = 1356, toId = 1359, name = "stone", article = "a"},
	{fromId = 1360, toId = 1363, name = "fountain", article = "a", fluidSource = FLUID_WATER},
	{fromId = 1364, toId = 1367, name = "water basin", article = "a", fluidSource = FLUID_WATER},
	{fromId = 1368, toId = 1369, name = "draw well", article = "a", fluidSource = FLUID_WATER},
	{fromId = 1370, toId = 1373, name = "marble well", article = "a"},
	{fromId = 1374, toId = 1377, name = "marble fountain", article = "a"},
	{id = 1378, name = "small basin", article = "a"},
	{fromId = 1379, toId = 1380, name = "wheel", article = "a"},
	{fromId = 1381, toId = 1384, name = "millstone", article = "a"},
	{id = 1385, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 1386, name = "ladder", article = "a"},
	{
		id = 1387,
		name = "magic forcefield",
		article = "a",
		description = "You can see the other side through it.",
		type = ITEM_TYPE_TELEPORT,
		effect = CONST_ME_TELEPORT
	},
	{id = 1388, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_EAST},
	{id = 1389, name = "ramp", article = "a"},
	{id = 1390, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 1391, name = "ramp", article = "a"},
	{id = 1392, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH},
	{id = 1393, name = "ramp", article = "a"},
	{id = 1394, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 1395, name = "ramp", article = "a"},
	{id = 1396, name = "wooden stairs", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{
		id = 1397,
		name = "mystic flame",
		article = "a",
		description = "You feel drawn to the mesmerizing light.",
		type = ITEM_TYPE_TELEPORT,
		effect = CONST_ME_TELEPORT
	},
	{id = 1398, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_EAST},
	{id = 1399, name = "ramp", article = "a"},
	{id = 1400, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 1401, name = "ramp", article = "a"},
	{id = 1402, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH},
	{id = 1403, name = "ramp", article = "a"},
	{id = 1404, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 1405, name = "ramp", article = "a"},
	{id = 1406, name = "grave", article = "a"},
	{fromId = 1407, toId = 1409, name = "grave stone", article = "a"},
	{id = 1410, name = "stone coffin", article = "a", containerSize = 10},
	{id = 1411, name = "stone coffin", article = "a"},
	{fromId = 1412, toId = 1414, name = "stone coffin", article = "a", containerSize = 10},
	{fromId = 1415, toId = 1416, name = "buried coffin", article = "a"},
	{id = 1417, name = "sarcophagus", article = "a", containerSize = 10},
	{id = 1418, name = "sarcophagus", article = "a"},
	{id = 1419, name = "sarcophagus", article = "a", containerSize = 10},
	{id = 1420, name = "sarcophagus", article = "a"},
	{id = 1421, name = "stone circle", article = "a"},
	{id = 1422, name = "unlit campfire", article = "an"},
	{
		fromId = 1423,
		toId = 1425,
		name = "campfire",
		article = "a",
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 2, initDamage = 20, ticks = 4000}
	},
	{fromId = 1426, toId = 1427, name = "unlit campfire", article = "an"},
	{id = 1428, name = "campfire", article = "a"},
	{fromId = 1429, toId = 1434, name = "sign", article = "a", allowDistRead = true},
	{id = 1435, name = "dragon flag", article = "a"},
	{id = 1436, name = "castle flag", article = "a"},
	{id = 1437, name = "flag of World", article = "a"},
	{fromId = 1438, toId = 1439, name = "street sign", article = "a", allowDistRead = true},
	{fromId = 1440, toId = 1441, name = "sign", article = "a", allowDistRead = true},
	{id = 1442, name = "statue", article = "a", rotateTo = 1476},
	{id = 1443, name = "statue", article = "a"},
	{id = 1444, name = "hero statue", article = "a"},
	{id = 1445, name = "monument", article = "a"},
	{id = 1446, name = "minotaur statue", article = "a", rotateTo = 1462},
	{id = 1447, name = "goblin statue", article = "a", rotateTo = 1465},
	{id = 1448, name = "angel statue", article = "an"},
	{id = 1449, name = "dwarven statue", article = "a"},
	{id = 1450, name = "watchdog statue", article = "a"},
	{id = 1451, name = "sandstone statue", article = "a"},
	{fromId = 1452, toId = 1455, name = "gargoyle statue", article = "a"},
	{fromId = 1456, toId = 1459, name = "pedestal", article = "a"},
	{id = 1460, name = "minotaur statue", article = "a", rotateTo = 1461},
	{id = 1461, name = "minotaur statue", article = "a", rotateTo = 1446},
	{id = 1462, name = "minotaur statue", article = "a", rotateTo = 1460},
	{id = 1463, name = "goblin statue", article = "a", rotateTo = 1464},
	{id = 1464, name = "goblin statue", article = "a", rotateTo = 1447},
	{id = 1465, name = "goblin statue", article = "a", rotateTo = 1463},
	{id = 1466, name = "pedestal", article = "a"},
	{fromId = 1467, toId = 1468, name = "cobra statue", article = "a"},
	{id = 1469, name = "pedestal", article = "a"},
	{fromId = 1470, toId = 1472, name = "cobra statue", article = "a"},
	{id = 1473, name = "ornament", article = "an"},
	{id = 1474, name = "cobra statue", article = "a"},
	{id = 1475, name = "ornament", article = "an"},
	{id = 1476, name = "statue", article = "a", rotateTo = 1477},
	{id = 1477, name = "statue", article = "a", rotateTo = 1478},
	{id = 1478, name = "statue", article = "a", rotateTo = 1442},
	{fromId = 1479, toId = 1480, name = "street lamp", article = "a"},
	{fromId = 1481, toId = 1484, name = "coal basin", article = "a"},
	{id = 1485, name = "empty coal basin", article = "an"},
	{id = 1486, name = "stone coal basin", article = "a"},
	{
		id = 1487,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 1488,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, initDamage = 20, ticks = 10000}
	},
	{
		id = 1488,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 1489,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, ticks = 10000}
	},
	{
		id = 1489,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 0,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE}
	},
	{
		id = 1490,
		name = "poison gas",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 0,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_POISON, combatType = COMBAT_EARTHDAMAGE, start = 5, damage = 100, ticks = 5000}
	},
	{
		id = 1491,
		name = "energy field",
		article = "an",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 0,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_ENERGY, combatType = COMBAT_ENERGYDAMAGE, damage = 25, initDamage = 30, ticks = 10000}
	},
	{
		id = 1492,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, initDamage = 20, ticks = 10000}
	},
	{
		id = 1493,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, ticks = 10000}
	},
	{
		id = 1494,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE}
	},
	{
		id = 1495,
		name = "energy field",
		article = "an",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_ENERGY, combatType = COMBAT_ENERGYDAMAGE, damage = 25, initDamage = 30, ticks = 10000}
	},
	{
		id = 1496,
		name = "poison gas",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_POISON, combatType = COMBAT_EARTHDAMAGE, start = 5, damage = 100, ticks = 5000}
	},
	{id = 1497, name = "magic wall", article = "a", type = ITEM_TYPE_MAGICFIELD, decayTo = 0, minDuration = 14, maxDuration = 20},
	{id = 1498, name = "magic wall", article = "a", type = ITEM_TYPE_MAGICFIELD},
	{
		id = 1499,
		name = "rush wood",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 0,
		minDuration = 38,
		maxDuration = 45,
		blocking = true
	},
	{
		id = 1500,
		name = "yellow flame",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 1501,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, initDamage = 20, ticks = 10000}
	},
	{
		id = 1501,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 1502,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, ticks = 10000}
	},
	{
		id = 1502,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 0,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE}
	},
	{
		id = 1503,
		name = "poison gas",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 0,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_POISON, combatType = COMBAT_EARTHDAMAGE, start = 5, damage = 100, ticks = 5000}
	},
	{
		id = 1504,
		name = "energy field",
		article = "an",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 0,
		duration = 120,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_ENERGY, combatType = COMBAT_ENERGYDAMAGE, damage = 25, initDamage = 30, ticks = 10000}
	},
	{id = 1505, name = "smoke", type = ITEM_TYPE_MAGICFIELD, replaceable = false},
	{
		id = 1506,
		name = "searing fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 1507,
		duration = 10,
		replaceable = false,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 300}
	},
	{
		id = 1507,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		decayTo = 1508,
		duration = 10,
		replaceable = false,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 300}
	},
	{id = 1508, name = "ashes", type = ITEM_TYPE_MAGICFIELD, decayTo = 1506, duration = 5, replaceable = false},
	{id = 1509, name = "lava", type = ITEM_TYPE_TRASHHOLDER, ignoreBlocking = true, effect = CONST_ME_HITBYFIRE},
	{id = 1510, name = "strange slits"},
	{id = 1511, name = "blades", decayTo = 1510, duration = 3},
	{id = 1512, name = "strange holes", decayTo = 1513, duration = 1},
	{id = 1513, name = "spikes", decayTo = 1512, duration = 4},
	{id = 1514, name = "stone pillar", article = "a"},
	{id = 1515, name = "marble pillar", article = "a"},
	{fromId = 1516, toId = 1523, name = "wooden railing", article = "a"},
	{fromId = 1524, toId = 1531, name = "stone railing", article = "a"},
	{id = 1532, name = "framework wall", article = "a"},
	{fromId = 1533, toId = 1538, name = "fence", article = "a"},
	{id = 1539, name = "closed fence gate", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1540, name = "open fence gate", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1541, name = "closed fence gate", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1542, name = "open fence gate", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 1543, toId = 1545, name = "fence", article = "a"},
	{fromId = 1546, toId = 1547, name = "bars"},
	{id = 1548, name = "nothing special"},
	{id = 1549, name = "sandstone pillar", article = "a"},
	{id = 1550, name = "sandstone statue", article = "a"},
	{id = 1551, name = "oriental pillar", article = "an"},
	{id = 1552, name = "ramp", article = "a"},
	{id = 1553, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH | TILESTATE_FLOORCHANGE_WEST},
	{id = 1554, name = "ramp", article = "a"},
	{id = 1555, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH | TILESTATE_FLOORCHANGE_EAST},
	{id = 1556, name = "ramp", article = "a"},
	{id = 1557, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH | TILESTATE_FLOORCHANGE_EAST},
	{id = 1558, name = "ramp", article = "a"},
	{id = 1559, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH | TILESTATE_FLOORCHANGE_WEST},
	{id = 1560, name = "obelisk", article = "an"},
	{id = 1561, name = "broken obelisk", article = "a"},
	{fromId = 1562, toId = 1569, name = "stone railing", article = "a"},
	{fromId = 1570, toId = 1577, name = "sandstone railing", article = "a"},
	{fromId = 1578, toId = 1581, name = "ramp", article = "a"},
	{fromId = 1582, toId = 1593, name = "white stone railing", article = "a"},
	{fromId = 1594, toId = 1601, name = "wooden railing", article = "a"},
	{fromId = 1602, toId = 1613, name = "big table", article = "a"},
	{id = 1614, name = "big table", article = "a", destroyTo = 2253},
	{id = 1615, name = "square table", article = "a", destroyTo = 2253},
	{id = 1616, name = "small round table", article = "a", destroyTo = 2253},
	{fromId = 1617, toId = 1618, name = "counter", article = "a"},
	{id = 1619, name = "small table", article = "a", destroyTo = 2255},
	{fromId = 1620, toId = 1621, name = "counter", article = "a"},
	{fromId = 1622, toId = 1633, name = "table", article = "a"},
	{id = 1634, name = "passthrough", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1635, name = "open passthrough", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1636, name = "passthrough", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1637, name = "open passthrough", article = "an", type = ITEM_TYPE_DOOR},
	{id = 1638, name = "passthrough", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1639, name = "open passthrough", article = "an", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 1640, name = "passthrough", article = "a", type = ITEM_TYPE_DOOR},
	{id = 1641, name = "open passthrough", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 1642, toId = 1645, name = "counter", article = "a"},
	{fromId = 1646, toId = 1649, name = "throne", article = "a"},
	{id = 1650, name = "wooden chair", article = "a", rotateTo = 1651, destroyTo = 2253},
	{id = 1651, name = "wooden chair", article = "a", rotateTo = 1652, destroyTo = 2253},
	{id = 1652, name = "wooden chair", article = "a", rotateTo = 1653, destroyTo = 2253},
	{id = 1653, name = "wooden chair", article = "a", rotateTo = 1650, destroyTo = 2253},
	{fromId = 1654, toId = 1657, name = "throne", article = "a"},
	{id = 1658, name = "sofa chair", article = "a", rotateTo = 1661},
	{id = 1659, name = "sofa chair", article = "a", rotateTo = 1660},
	{id = 1660, name = "sofa chair", article = "a", rotateTo = 1658},
	{id = 1661, name = "sofa chair", article = "a", rotateTo = 1659},
	{fromId = 1662, toId = 1665, name = "bench", article = "a"},
	{id = 1666, name = "red cushioned chair", article = "a", rotateTo = 1669, destroyTo = 2253},
	{id = 1667, name = "red cushioned chair", article = "a", rotateTo = 1668, destroyTo = 2253},
	{id = 1668, name = "red cushioned chair", article = "a", rotateTo = 1666, destroyTo = 2253},
	{id = 1669, name = "red cushioned chair", article = "a", rotateTo = 1667, destroyTo = 2253},
	{id = 1670, name = "green cushioned chair", article = "a", rotateTo = 1673, destroyTo = 2253},
	{id = 1671, name = "green cushioned chair", article = "a", rotateTo = 1672, destroyTo = 2253},
	{id = 1672, name = "green cushioned chair", article = "a", rotateTo = 1670, destroyTo = 2253},
	{id = 1673, name = "green cushioned chair", article = "a", rotateTo = 1671, destroyTo = 2253},
	{id = 1674, name = "rocking chair", article = "a", rotateTo = 1677, destroyTo = 2253},
	{id = 1675, name = "rocking chair", article = "a", rotateTo = 1676, destroyTo = 2253},
	{id = 1676, name = "rocking chair", article = "a", rotateTo = 1674, destroyTo = 2253},
	{id = 1677, name = "rocking chair", article = "a", rotateTo = 1675, destroyTo = 2253},
	{id = 1678, name = "small purple pillow", article = "a", weight = 1500},
	{id = 1679, name = "small green pillow", article = "a", weight = 1500},
	{id = 1680, name = "small red pillow", article = "a", weight = 1500},
	{id = 1681, name = "small blue pillow", article = "a", weight = 1500},
	{id = 1682, name = "small orange pillow", article = "a", weight = 1500},
	{id = 1683, name = "small turquoise pillow", article = "a", weight = 1500},
	{id = 1684, name = "small white pillow", article = "a", weight = 1500},
	{id = 1685, name = "heart pillow", article = "a", weight = 1700},
	{id = 1686, name = "blue pillow", article = "a", weight = 1600},
	{id = 1687, name = "red pillow", article = "a", weight = 1600},
	{id = 1688, name = "green pillow", article = "a", weight = 1600},
	{id = 1689, name = "yellow pillow", article = "a", weight = 1600},
	{id = 1690, name = "round blue pillow", article = "a", weight = 1550},
	{id = 1691, name = "round red pillow", article = "a", weight = 1550},
	{id = 1692, name = "round purple pillow", article = "a", weight = 1550},
	{id = 1693, name = "round turquoise pillow", article = "a", weight = 1550},
	{fromId = 1694, toId = 1701, name = "couch", article = "a"},
	{fromId = 1702, toId = 1709, name = "luxurious couch", article = "a"},
	{fromId = 1710, toId = 1713, name = "wardrobe", article = "a", containerSize = 6},
	{id = 1714, name = "chest of drawers", article = "a", rotateTo = 1717, containerSize = 10, destroyTo = 2252},
	{id = 1715, name = "chest of drawers", article = "a", rotateTo = 1714, containerSize = 10, destroyTo = 2252},
	{id = 1716, name = "chest of drawers", article = "a", rotateTo = 1715, containerSize = 10, destroyTo = 2252},
	{id = 1717, name = "chest of drawers", article = "a", rotateTo = 1716, containerSize = 10, destroyTo = 2252},
	{fromId = 1718, toId = 1723, name = "bookcase", article = "a", containerSize = 6},
	{id = 1724, name = "dresser", article = "a", rotateTo = 1727, containerSize = 10, destroyTo = 2254},
	{id = 1725, name = "dresser", article = "a", rotateTo = 1724, containerSize = 10, destroyTo = 2254},
	{id = 1726, name = "dresser", article = "a", rotateTo = 1725, containerSize = 10, destroyTo = 2254},
	{id = 1727, name = "dresser", article = "a", rotateTo = 1726, containerSize = 10, destroyTo = 2254},
	{id = 1728, name = "pendulum clock", article = "a", rotateTo = 1731, destroyTo = 2254},
	{id = 1729, name = "pendulum clock", article = "a", rotateTo = 1728, destroyTo = 2254},
	{id = 1730, name = "pendulum clock", article = "a", rotateTo = 1729, destroyTo = 2254},
	{id = 1731, name = "pendulum clock", article = "a", rotateTo = 1730, destroyTo = 2254},
	{id = 1732, name = "locker", article = "a", rotateTo = 1735, containerSize = 6, destroyTo = 2254},
	{id = 1733, name = "locker", article = "a", rotateTo = 1734, containerSize = 6, destroyTo = 2254},
	{id = 1734, name = "locker", article = "a", rotateTo = 1732, containerSize = 6, destroyTo = 2254},
	{id = 1735, name = "locker", article = "a", rotateTo = 1733, containerSize = 6, destroyTo = 2254},
	{id = 1736, name = "standing mirror", article = "a", rotateTo = 1737, destroyTo = 2254},
	{id = 1737, name = "standing mirror", article = "a", rotateTo = 1736, destroyTo = 2254},
	{id = 1738, name = "box", article = "a", weight = 3500, containerSize = 10, destroyTo = 2250},
	{id = 1739, name = "crate", article = "a", weight = 8000, containerSize = 15, destroyTo = 2250},
	{id = 1740, name = "chest", article = "a", weight = 12000, rotateTo = 1748, containerSize = 15, destroyTo = 2251},
	{id = 1741, name = "box", article = "a", weight = 3500, containerSize = 10, destroyTo = 2255},
	{id = 1742, name = "wooden coffin", article = "a", containerSize = 6},
	{id = 1743, name = "wooden coffin", article = "a"},
	{id = 1744, name = "wooden coffin", article = "a", containerSize = 6},
	{id = 1745, name = "wooden coffin", article = "a"},
	{id = 1746, name = "treasure chest", article = "a", weight = 9500, containerSize = 10},
	{id = 1747, name = "chest", article = "a", weight = 12000, rotateTo = 1749, containerSize = 15, destroyTo = 2251},
	{id = 1748, name = "chest", article = "a", weight = 12000, rotateTo = 1747, containerSize = 15, destroyTo = 2251},
	{id = 1749, name = "chest", article = "a", weight = 12000, rotateTo = 1740, containerSize = 15, destroyTo = 2251},
	{id = 1750, name = "large trunk", article = "a", rotateTo = 1753, containerSize = 18, destroyTo = 2255},
	{id = 1751, name = "large trunk", article = "a", rotateTo = 1752, containerSize = 18, destroyTo = 2255},
	{id = 1752, name = "large trunk", article = "a", rotateTo = 1750, containerSize = 18, destroyTo = 2255},
	{id = 1753, name = "large trunk", article = "a", rotateTo = 1751, containerSize = 18, destroyTo = 2255},
	{
		id = 1754,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_SOUTH,
		maleSleeper = 1762,
		femaleSleeper = 7778
	},
	{
		id = 1755,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_NORTH,
		maleSleeper = 1763,
		femaleSleeper = 8075
	},
	{
		id = 1756,
		name = "cot",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_EAST,
		maleSleeper = 1768,
		femaleSleeper = 7783
	},
	{
		id = 1757,
		name = "cot",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_WEST,
		maleSleeper = 1769,
		femaleSleeper = 7784
	},
	{
		id = 1758,
		name = "cot",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_SOUTH,
		maleSleeper = 1766,
		femaleSleeper = 7781
	},
	{
		id = 1759,
		name = "cot",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_NORTH,
		maleSleeper = 1767,
		femaleSleeper = 7782
	},
	{
		id = 1760,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_EAST,
		maleSleeper = 1764,
		femaleSleeper = 7779
	},
	{
		id = 1761,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_WEST,
		maleSleeper = 1765,
		femaleSleeper = 7780
	},
	{id = 1762, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 1754},
	{id = 1763, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 1755},
	{id = 1764, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 1760},
	{id = 1765, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 1761},
	{id = 1766, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 1758},
	{id = 1767, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 1759},
	{id = 1768, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 1756},
	{id = 1769, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 1757},
	{id = 1770, name = "barrel", article = "a", containerSize = 25, destroyTo = 2250},
	{id = 1771, name = "cask of beer", article = "a", fluidSource = FLUID_BEER},
	{id = 1772, name = "water cask", article = "a", fluidSource = FLUID_WATER},
	{id = 1773, name = "lemonade cask", article = "a", fluidSource = FLUID_LEMONADE},
	{id = 1774, name = "barrel", article = "a", containerSize = 25, destroyTo = 2250},
	{id = 1775, name = "trough", article = "a", destroyTo = 2250},
	{id = 1776, name = "wine cask", article = "a", fluidSource = FLUID_WINE},
	{id = 1777, name = "dustbin", article = "a", type = ITEM_TYPE_TRASHHOLDER, ignoreBlocking = true},
	{fromId = 1778, toId = 1785, name = "big wine cask", article = "a", fluidSource = FLUID_WINE},
	{fromId = 1786, toId = 1793, name = "oven", article = "an"},
	{fromId = 1794, toId = 1802, name = "red carpet", article = "a"},
	{fromId = 1803, toId = 1808, name = "oriental carpet", article = "an"},
	{id = 1809, name = "painting", article = "a"},
	{id = 1810, name = "blackboard", article = "a"},
	{id = 1811, name = "blackboard", article = "a", writeable = true, maxTextLen = 1023},
	{fromId = 1812, toId = 1813, name = "tapestry", article = "a"},
	{id = 1814, name = "painting", article = "a"},
	{id = 1815, name = "blackboard", article = "a"},
	{fromId = 1816, toId = 1817, name = "wall mirror", article = "a", description = "You look fine today."},
	{id = 1818, name = "blackboard", article = "a", writeable = true, maxTextLen = 1023},
	{fromId = 1819, toId = 1824, name = "emblem", article = "an"},
	{fromId = 1825, toId = 1828, name = "painting", article = "a"},
	{fromId = 1829, toId = 1830, name = "scarab ornament", article = "a"},
	{fromId = 1831, toId = 1842, name = "painting", article = "a"},
	{fromId = 1843, toId = 1844, name = "wall mirror", article = "a", description = "You look fine today."},
	{id = 1845, name = "wall mirror", article = "a", weight = 1000},
	{fromId = 1846, toId = 1847, name = "wall mirror", article = "a", description = "You look fine today."},
	{id = 1848, name = "wall mirror", article = "a", weight = 1000},
	{fromId = 1849, toId = 1850, name = "wall mirror", article = "a", description = "You look fine today."},
	{id = 1851, name = "wall mirror", article = "a", weight = 1000},
	{fromId = 1852, toId = 1854, name = "picture", article = "a", weight = 1000},
	{fromId = 1855, toId = 1856, name = "purple tapestry", article = "a"},
	{id = 1857, name = "purple tapestry", article = "a", weight = 1000},
	{fromId = 1858, toId = 1859, name = "green tapestry", article = "a"},
	{id = 1860, name = "green tapestry", article = "a", weight = 1000},
	{fromId = 1861, toId = 1862, name = "yellow tapestry", article = "a"},
	{id = 1863, name = "yellow tapestry", article = "a", weight = 1000},
	{fromId = 1864, toId = 1865, name = "orange tapestry", article = "an"},
	{id = 1866, name = "orange tapestry", article = "an", weight = 1000},
	{fromId = 1867, toId = 1868, name = "red tapestry", article = "a"},
	{id = 1869, name = "red tapestry", article = "a", weight = 1000},
	{fromId = 1870, toId = 1871, name = "blue tapestry", article = "a"},
	{id = 1872, name = "blue tapestry", article = "a", weight = 1000},
	{id = 1873, name = "cuckoo clock", article = "a", decayTo = 1874, duration = 54},
	{id = 1874, name = "cuckoo clock", article = "a", decayTo = 1873, duration = 6},
	{id = 1875, name = "cuckoo clock", article = "a", decayTo = 1876, duration = 54},
	{id = 1876, name = "cuckoo clock", article = "a", decayTo = 1875, duration = 6},
	{id = 1877, name = "cuckoo clock", article = "a", weight = 800},
	{id = 1878, name = "white tapestry", article = "a"},
	{id = 1879, name = "tapestry", article = "a"},
	{id = 1880, name = "white tapestry", article = "a", weight = 1000},
	{id = 1881, name = "cuckoo clock", article = "a", weight = 800},
	{fromId = 1882, toId = 1883, name = "demon trophy", article = "a"},
	{fromId = 1884, toId = 1885, name = "wolf trophy", article = "a"},
	{fromId = 1886, toId = 1887, name = "orc trophy", article = "an"},
	{fromId = 1888, toId = 1889, name = "behemoth trophy", article = "a"},
	{fromId = 1890, toId = 1891, name = "deer trophy", article = "a"},
	{fromId = 1892, toId = 1893, name = "cyclops trophy", article = "a"},
	{fromId = 1894, toId = 1895, name = "dragon lord trophy", article = "a"},
	{fromId = 1896, toId = 1897, name = "lion trophy", article = "a"},
	{fromId = 1898, toId = 1899, name = "minotaur trophy", article = "a"},
	{fromId = 1900, toId = 1905, name = "bloodspot", article = "a"},
	{fromId = 1906, toId = 1908, name = "cobwebs"},
	{fromId = 1909, toId = 1920, name = "flowery wall", article = "a"},
	{fromId = 1921, toId = 1933, name = "mossy wall", article = "a"},
	{fromId = 1935, toId = 1937, name = "mossy wall", article = "a"},
	{fromId = 1939, toId = 1944, name = "mossy wall", article = "a"},
	{fromId = 1945, toId = 1946, name = "lever", article = "a"},
	{id = 1947, name = "blank paper", article = "a", weight = 50, writeable = true, maxTextLen = 1023, writeOnceItemId = 1954},
	{
		id = 1948,
		name = "parchment",
		article = "a",
		weight = 200,
		description = "It is rewriteable.",
		writeable = true,
		maxTextLen = 1023
	},
	{id = 1949, name = "scroll", article = "a", weight = 50, description = "It is rewriteable.", writeable = true, maxTextLen = 1023},
	{id = 1950, name = "book", article = "a", maxTextLen = 1023, weight = 1300, writeOnceItemId = 1971},
	{id = 1951, name = "blank parchment", article = "a", weight = 200, writeable = true, maxTextLen = 1023, writeOnceItemId = 1953},
	{id = 1952, name = "document", article = "a", weight = 150, writeable = true, maxTextLen = 1023, writeOnceItemId = 1968},
	{id = 1953, name = "parchment", article = "a", weight = 200},
	{id = 1954, name = "sheet of paper", article = "a", weight = 50},
	{id = 1955, name = "book", article = "a", weight = 1300},
	{id = 1956, name = "map", article = "a", weight = 830},
	{id = 1957, name = "map", article = "a", weight = 790},
	{fromId = 1958, toId = 1966, name = "book", article = "a", weight = 1300},
	{id = 1967, name = "parchment", article = "a", writeable = true, maxTextLen = 1023, weight = 200},
	{id = 1968, name = "document", article = "a", writeable = true, maxTextLen = 1023, weight = 150},
	{id = 1969, name = "parchment", article = "a", writeable = true, maxTextLen = 1023, weight = 200},
	{id = 1970, name = "holy Tible", article = "the", weight = 1300},
	{id = 1971, name = "book", article = "a", writeable = true, maxTextLen = 1023, writeOnceItemId = 1950, weight = 1300},
	{id = 1972, name = "book", article = "a", writeable = true, maxTextLen = 1023, writeOnceItemId = 1955, weight = 1300},
	{id = 1973, name = "book", article = "a", writeable = true, maxTextLen = 1023, writeOnceItemId = 1958, weight = 1300},
	{id = 1974, name = "book", article = "a", writeable = true, maxTextLen = 1023, writeOnceItemId = 1959, weight = 1300},
	{id = 1975, name = "book", article = "a", writeable = true, maxTextLen = 1023, writeOnceItemId = 1960, weight = 1300},
	{id = 1976, name = "book", article = "a", writeable = true, maxTextLen = 1100, weight = 1300},
	{id = 1977, name = "book", article = "a", writeable = true, maxTextLen = 1023, weight = 1300, writeOnceItemId = 1962},
	{id = 1978, name = "book", article = "a", writeable = true, maxTextLen = 1023, weight = 1300, writeOnceItemId = 1963},
	{id = 1979, name = "book", article = "a", writeable = true, maxTextLen = 1023, weight = 1300, writeOnceItemId = 1964},
	{id = 1980, name = "book", article = "a", writeable = true, maxTextLen = 1023, weight = 1300, writeOnceItemId = 1965},
	{id = 1981, name = "book", article = "a", writeable = true, maxTextLen = 1023, weight = 1300, writeOnceItemId = 1966},
	{
		id = 1982,
		name = "purple tome",
		article = "a",
		weight = 1900,
		description = "It's a volume of The Mystic Secrets of the world."
	},
	{id = 1983, name = "green tome", article = "a", weight = 1900, description = "It's a volume of The Mystic Secrets of the world."},
	{id = 1984, name = "blue tome", article = "a", weight = 1900, description = "It's a volume of The Mystic Secrets of the world."},
	{id = 1985, name = "grey tome", article = "a", weight = 1900, description = "It's a volume of The Mystic Secrets of the world."},
	{id = 1986, name = "red tome", article = "a", weight = 1900, description = "It's a volume of The Mystic Secrets of the world."},
	{id = 1987, name = "bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1988, name = "backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 1989, name = "basket", article = "a", weight = 950, containerSize = 5},
	{id = 1990, name = "present", article = "a", weight = 600, containerSize = 5},
	{id = 1991, name = "green bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1992, name = "yellow bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1993, name = "red bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1994, name = "purple bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1995, name = "blue bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1996, name = "grey bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1997, name = "golden bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 1998, name = "green backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 1999, name = "yellow backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 2000, name = "red backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 2001, name = "purple backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 2002, name = "blue backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 2003, name = "grey backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 2004, name = "golden backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 2005, name = "bucket", article = "a", weight = 2000, pickupable = true},
	{id = 2006, name = "vial", article = "a", weight = 180, pickupable = true},
	{id = 2007, name = "bottle", article = "a", weight = 250, pickupable = true},
	{id = 2008, name = "vase", article = "a", weight = 940, pickupable = true},
	{id = 2009, name = "green flask", article = "a", weight = 300, pickupable = true},
	{id = 2010, name = "broken flask", article = "a", weight = 100},
	{
		id = 2011,
		name = "elven vase",
		article = "an",
		description = "It is made of very fine glass and covered with decorations.",
		weight = 940,
		pickupable = true
	},
	{id = 2012, name = "mug", article = "a", weight = 250, pickupable = true},
	{id = 2013, name = "cup", article = "a", weight = 200, pickupable = true},
	{id = 2014, name = "jug", article = "a", weight = 750, pickupable = true},
	{id = 2015, name = "brown flask", article = "a", weight = 300, pickupable = true},
	{id = 2016, name = "pool", article = "a", decayTo = 2017, duration = 45},
	{id = 2017, name = "pool", article = "a", decayTo = 2018, duration = 45},
	{id = 2018, name = "pool", article = "a", decayTo = 0, duration = 600},
	{id = 2019, name = "pool", article = "a", decayTo = 2020, duration = 45},
	{id = 2020, name = "pool", article = "a", decayTo = 2021, duration = 45},
	{id = 2021, name = "pool", article = "a", decayTo = 0, duration = 60},
	{id = 2022, name = "broken bottle", article = "a", weight = 80},
	{id = 2023, name = "amphora", article = "an", weight = 9700, pickupable = true},
	{id = 2024, name = "broken flask", article = "a", weight = 100},
	{fromId = 2025, toId = 2030, name = "pool", article = "a"},
	{id = 2031, name = "waterskin", article = "a", weight = 700, pickupable = true},
	{id = 2032, name = "bowl", article = "a", weight = 380, pickupable = true},
	{id = 2033, name = "golden mug", article = "a", weight = 470, pickupable = true},
	{id = 2034, name = "large amphora", article = "a"},
	{id = 2035, name = "plate", article = "a", weight = 150},
	{id = 2036, name = "watch", article = "a", weight = 50},
	{id = 2037, name = "wall lamp", article = "a"},
	{id = 2038, name = "lit wall lamp", article = "a"},
	{id = 2039, name = "wall lamp", article = "a"},
	{id = 2040, name = "lit wall lamp", article = "a"},
	{id = 2041, name = "candelabrum", article = "a", slotPosition = SLOTP_AMMO, weight = 5000, stopDuration = true},
	{id = 2042, name = "lit candelabrum", article = "a", slotPosition = SLOTP_AMMO, weight = 5000, decayTo = 2043, duration = 180},
	{id = 2043, name = "used candelabrum", article = "a", slotPosition = SLOTP_AMMO, weight = 4500},
	{id = 2044, name = "lamp", article = "a", slotPosition = SLOTP_AMMO, weight = 3000, stopDuration = true},
	{id = 2045, name = "lit lamp", article = "a", slotPosition = SLOTP_AMMO, weight = 3000, decayTo = 2046, duration = 180},
	{id = 2046, name = "used lamp", article = "a", slotPosition = SLOTP_AMMO, weight = 3000},
	{id = 2047, name = "candlestick", article = "a", slotPosition = SLOTP_AMMO, weight = 300, stopDuration = true},
	{id = 2048, name = "lit candlestick", article = "a", slotPosition = SLOTP_AMMO, weight = 300, decayTo = 2049, duration = 240},
	{id = 2049, name = "used candlestick", article = "a", slotPosition = SLOTP_AMMO, weight = 200, decayTo = 0, duration = 60},
	{id = 2050, name = "torch", article = "a", slotPosition = SLOTP_AMMO, weight = 500, stopDuration = true},
	{id = 2051, name = "lit torch", article = "a", slotPosition = SLOTP_AMMO, weight = 500, decayTo = 2053, duration = 600},
	{id = 2052, name = "torch", article = "a", slotPosition = SLOTP_AMMO, weight = 450, stopDuration = true},
	{id = 2053, name = "lit torch", article = "a", slotPosition = SLOTP_AMMO, weight = 450, decayTo = 2055, duration = 300},
	{id = 2054, name = "torch", article = "a", slotPosition = SLOTP_AMMO, weight = 400, stopDuration = true},
	{id = 2055, name = "lit torch", article = "a", slotPosition = SLOTP_AMMO, weight = 400, decayTo = 2056, duration = 300},
	{id = 2056, name = "burnt down torch", article = "a", slotPosition = SLOTP_AMMO, weight = 350, decayTo = 0, duration = 300},
	{id = 2057, name = "lit candelabrum", article = "a", slotPosition = SLOTP_AMMO, weight = 5000},
	{id = 2058, name = "torch bearer", article = "a"},
	{id = 2059, name = "lit torch bearer", article = "a"},
	{id = 2060, name = "torch bearer", article = "a"},
	{id = 2061, name = "lit torch bearer", article = "a"},
	{id = 2062, name = "oil lamp", article = "an", weight = 1400},
	{id = 2063, name = "small oil lamp", article = "a", weight = 900},
	{id = 2064, name = "tablelamp", article = "a", destroyTo = 2250},
	{id = 2065, name = "lit tablelamp", article = "a"},
	{id = 2066, name = "wall lamp", article = "a"},
	{id = 2067, name = "lit wall lamp", article = "a"},
	{id = 2068, name = "wall lamp", article = "a"},
	{id = 2069, name = "lit wall lamp", article = "a"},
	{id = 2070, name = "wooden flute", article = "a", weight = 200},
	{id = 2071, name = "lyre", article = "a", weight = 1250},
	{id = 2072, name = "lute", article = "a", weight = 3400},
	{id = 2073, name = "drum", article = "a", weight = 3200},
	{id = 2074, name = "panpipes", weight = 820},
	{id = 2075, name = "simple fanfare", article = "a", weight = 2200},
	{id = 2076, name = "fanfare", article = "a", weight = 2300},
	{id = 2077, name = "royal fanfare", article = "a", weight = 2500},
	{
		id = 2078,
		name = "post horn",
		article = "a",
		weight = 1500,
		description = "It's property of the Postmaster's Guild and only rewarded to loyal members."
	},
	{id = 2079, name = "war horn", article = "a", weight = 1500},
	{id = 2080, name = "piano", article = "a", rotateTo = 2083, destroyTo = 2254},
	{id = 2081, name = "piano", article = "a", rotateTo = 2082, destroyTo = 2254},
	{id = 2082, name = "piano", article = "a", rotateTo = 2080, destroyTo = 2254},
	{id = 2083, name = "piano", article = "a", rotateTo = 2081, destroyTo = 2254},
	{id = 2084, name = "harp", article = "a", rotateTo = 2085, destroyTo = 2254},
	{id = 2085, name = "harp", article = "a", rotateTo = 2084, destroyTo = 2254},
	{id = 2086, name = "magical key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 2087, name = "wooden key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 2088, name = "silver key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 2089, name = "copper key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 2090, name = "crystal key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 2091, name = "golden key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 2092, name = "bone key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 2093, name = "water pipe", article = "a", weight = 6500},
	{
		id = 2094,
		name = "birdcage",
		article = "a",
		description = "The poor bird seems to have died from a heart attack.",
		weight = 9200,
		destroyTo = 2254
	},
	{id = 2095, name = "birdcage", article = "a", description = "You see a little bird inside.", weight = 9200, destroyTo = 2254},
	{id = 2096, name = "pumpkinhead", article = "a", slotPosition = SLOTP_AMMO, weight = 950},
	{id = 2097, name = "pumpkinhead", article = "a", slotPosition = SLOTP_AMMO, weight = 1250},
	{id = 2098, name = "globe", article = "a", destroyTo = 2250},
	{id = 2099, name = "water pipe", article = "a", weight = 5600},
	{id = 2100, name = "god flowers", weight = 1100},
	{id = 2101, name = "indoor plant", article = "an"},
	{id = 2102, name = "flower bowl", article = "a", weight = 1100},
	{id = 2103, name = "honey flower", article = "a", weight = 1000},
	{id = 2104, name = "potted flower", article = "a", weight = 2300},
	{id = 2105, name = "christmas tree", article = "a"},
	{id = 2106, name = "potted flower", article = "a"},
	{id = 2107, name = "exotic flowers", weight = 1100},
	{id = 2108, name = "wooden doll", article = "a", weight = 860},
	{id = 2109, name = "football", article = "a"},
	{id = 2110, name = "doll", article = "a", weight = 650},
	{
		id = 2111,
		name = "snowball",
		article = "a",
		weight = 80,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_SNOWBALL,
		range = 6
	},
	{id = 2112, name = "teddy bear", article = "a", weight = 590},
	{id = 2113, name = "model ship", article = "a", weight = 1300},
	{id = 2114, name = "piggy bank", article = "a", weight = 750},
	{id = 2115, name = "broken piggy bank", article = "a", weight = 750},
	{id = 2116, name = "rocking horse", article = "a", rotateTo = 2117, destroyTo = 2254},
	{id = 2117, name = "rocking horse", article = "a", rotateTo = 2118, destroyTo = 2254},
	{id = 2118, name = "rocking horse", article = "a", rotateTo = 2119, destroyTo = 2254},
	{id = 2119, name = "rocking horse", article = "a", rotateTo = 2116, destroyTo = 2254},
	{id = 2120, name = "rope", article = "a", weight = 1800},
	{id = 2121, name = "wedding ring", article = "a", weight = 40, slotPosition = SLOTP_RING},
	{id = 2122, name = "elven brooch", article = "an", weight = 90},
	{id = 2123, name = "ring of the sky", article = "a", weight = 40, slotPosition = SLOTP_RING},
	{id = 2124, name = "crystal ring", article = "a", weight = 90, slotPosition = SLOTP_RING},
	{id = 2125, name = "crystal necklace", article = "a", weight = 490, slotPosition = SLOTP_NECKLACE},
	{id = 2126, name = "bronze necklace", article = "a", weight = 410, slotPosition = SLOTP_NECKLACE},
	{id = 2127, name = "emerald bangle", article = "an", weight = 179},
	{id = 2128, name = "crown", article = "a", weight = 1900, slotPosition = SLOTP_HEAD},
	{id = 2129, name = "wolf tooth chain", article = "a", weight = 330, slotPosition = SLOTP_NECKLACE},
	{
		id = 2130,
		name = "golden amulet",
		article = "a",
		description = "Many gems glitter on the amulet.",
		weight = 830,
		slotPosition = SLOTP_NECKLACE
	},
	{id = 2131, name = "star amulet", article = "a", weight = 610, slotPosition = SLOTP_NECKLACE},
	{id = 2132, name = "silver necklace", article = "a", weight = 480, slotPosition = SLOTP_NECKLACE},
	{id = 2133, name = "ruby necklace", article = "a", weight = 570, slotPosition = SLOTP_NECKLACE},
	{id = 2134, name = "silver brooch", article = "a", plural = "silver brooches", weight = 116},
	{id = 2135, name = "scarab amulet", article = "a", weight = 770, slotPosition = SLOTP_NECKLACE},
	{id = 2136, name = "demonbone amulet", article = "a", weight = 690, slotPosition = SLOTP_NECKLACE},
	{id = 2137, name = "some golden fruits", weight = 1070},
	{id = 2138, name = "sapphire amulet", article = "a", weight = 680, slotPosition = SLOTP_NECKLACE},
	{id = 2139, name = "ancient tiara", article = "an", weight = 820, slotPosition = SLOTP_HEAD},
	{id = 2140, name = "holy scarab", article = "a", weight = 870},
	{id = 2141, name = "holy falcon", article = "a", weight = 840},
	{id = 2142, name = "ancient amulet", article = "an", weight = 840, slotPosition = SLOTP_NECKLACE},
	{id = 2143, name = "white pearl", article = "a", weight = 20},
	{id = 2144, name = "black pearl", article = "a", weight = 20},
	{id = 2145, name = "small diamond", article = "a", weight = 10},
	{id = 2146, name = "small sapphire", article = "a", weight = 10},
	{id = 2147, name = "small ruby", article = "a", weight = 10},
	{id = 2148, name = "gold coin", article = "a", weight = 10, worth = 1},
	{id = 2149, name = "small emerald", article = "a", weight = 10},
	{id = 2150, name = "small amethyst", article = "a", weight = 10},
	{id = 2151, name = "talon", article = "a", weight = 20, description = "There are many rumours about these magic gems."},
	{id = 2152, name = "platinum coin", article = "a", weight = 10, worth = 100},
	{id = 2153, name = "violet gem", article = "a", weight = 30},
	{id = 2154, name = "yellow gem", article = "a", weight = 30},
	{id = 2155, name = "green gem", article = "a", weight = 30},
	{id = 2156, name = "red gem", article = "a", weight = 30},
	{id = 2157, name = "gold nugget", article = "a", weight = 80},
	{id = 2158, name = "blue gem", article = "a", weight = 30},
	{id = 2159, name = "scarab coin", article = "a", weight = 20},
	{id = 2160, name = "crystal coin", article = "a", weight = 10, worth = 10000},
	{
		id = 2161,
		name = "strange talisman",
		article = "a",
		weight = 290,
		slotPosition = SLOTP_NECKLACE,
		charges = 200,
		showCharges = true,
		absorbPercent = {[COMBAT_ENERGYDAMAGE] = 10},
		showAttributes = true
	},
	{
		id = 2162,
		name = "magic light wand",
		article = "a",
		slotPosition = SLOTP_AMMO,
		weight = 1500,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2163,
		name = "magic light wand",
		article = "a",
		slotPosition = SLOTP_AMMO,
		weight = 1500,
		decayTo = 0,
		showDuration = true,
		duration = 3000
	},
	{
		id = 2164,
		name = "might ring",
		article = "a",
		weight = 100,
		slotPosition = SLOTP_RING,
		charges = 20,
		showCharges = true,
		absorbPercent = {
			[COMBAT_PHYSICALDAMAGE] = 20,
			[COMBAT_ENERGYDAMAGE] = 20,
			[COMBAT_FIREDAMAGE] = 20,
			[COMBAT_EARTHDAMAGE] = 20,
			[COMBAT_ICEDAMAGE] = 20,
			[COMBAT_HOLYDAMAGE] = 20,
			[COMBAT_DEATHDAMAGE] = 20
		},
		showAttributes = true
	},
	{
		id = 2165,
		name = "stealth ring",
		article = "a",
		weight = 100,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2202,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2166,
		name = "power ring",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2203,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2167,
		name = "energy ring",
		article = "an",
		weight = 80,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2204,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2168,
		name = "life ring",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2205,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2169,
		name = "time ring",
		article = "a",
		weight = 90,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2206,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2170,
		name = "silver amulet",
		article = "a",
		weight = 500,
		slotPosition = SLOTP_NECKLACE,
		charges = 200,
		showCharges = true,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 10},
		showAttributes = true
	},
	{
		id = 2171,
		name = "platinum amulet",
		article = "a",
		description = "It is an amulet of protection.",
		weight = 600,
		armor = 2,
		slotPosition = SLOTP_NECKLACE
	},
	{
		id = 2172,
		name = "bronze amulet",
		article = "a",
		weight = 500,
		slotPosition = SLOTP_NECKLACE,
		charges = 200,
		showCharges = true,
		absorbPercent = {[COMBAT_MANADRAIN] = 20},
		showAttributes = true
	},
	{id = 2173, name = "amulet of loss", article = "an", weight = 420, slotPosition = SLOTP_NECKLACE, charges = 1},
	{id = 2174, name = "strange symbol", article = "a", slotPosition = SLOTP_AMMO, weight = 200},
	{
		id = 2175,
		name = "spellbook",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 1800,
		defense = 14,
		weaponType = WEAPON_SHIELD
	},
	{id = 2176, name = "orb", article = "an", weight = 800},
	{id = 2177, name = "life crystal", article = "a", weight = 263},
	{id = 2178, name = "mind stone", article = "a", weight = 250},
	{id = 2179, name = "gold ring", article = "a", weight = 100, slotPosition = SLOTP_RING},
	{id = 2180, name = "orb of nature", article = "the"},
	{
		id = 2181,
		name = "terra rod",
		article = "a",
		description = "Small stones are flying from its tip.",
		weight = 2500,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_SMALLEARTH,
		range = 3
	},
	{
		id = 2182,
		name = "snakebite rod",
		article = "a",
		description = "It seems to twitch and quiver as if trying to escape your grip.",
		weight = 1900,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_SMALLEARTH,
		range = 3
	},
	{
		id = 2183,
		name = "hailstorm rod",
		article = "a",
		description = "It grants you the power of striking your foes with furious hailstorms.",
		weight = 2700,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_SMALLICE,
		range = 3
	},
	{id = 2184, name = "crystal wand", article = "a", weight = 2800},
	{
		id = 2185,
		name = "necrotic rod",
		article = "a",
		description = "It was brought up from hell to deliver death.",
		weight = 2300,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_DEATH,
		range = 3
	},
	{
		id = 2186,
		name = "moonlight rod",
		article = "a",
		description = "Icecold rays of moonlight shimmer on its tip.",
		weight = 2100,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_SMALLICE,
		range = 3
	},
	{
		id = 2187,
		name = "wand of inferno",
		article = "a",
		description = "It unleashes the very fires of hell.",
		weight = 2700,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_FIRE,
		range = 3
	},
	{
		id = 2188,
		name = "wand of decay",
		article = "a",
		description = "It is half-rotten itself and reeks terribly.",
		weight = 2300,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_DEATH,
		range = 3
	},
	{
		id = 2189,
		name = "wand of cosmic energy",
		article = "a",
		description = "The energy of a radiant star is trapped inside its globe.",
		weight = 2500,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_ENERGY,
		range = 3
	},
	{
		id = 2190,
		name = "wand of vortex",
		article = "a",
		description = "Surges of energy rush through the tip of this wand.",
		weight = 1900,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_ENERGY,
		range = 3
	},
	{
		id = 2191,
		name = "wand of dragonbreath",
		article = "a",
		description = "Legends say that this wand holds the soul of a young dragon.",
		weight = 2100,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_FIRE,
		range = 3
	},
	{id = 2192, name = "crystal ball", article = "a", weight = 3400},
	{id = 2193, name = "ankh", article = "an", weight = 420},
	{id = 2194, name = "mysterious fetish", article = "a", weight = 490},
	{id = 2195, name = "boots of haste", weight = 750, slotPosition = SLOTP_FEET, speed = 40, showAttributes = true},
	{id = 2196, name = "broken amulet", article = "a", weight = 420, slotPosition = SLOTP_NECKLACE},
	{
		id = 2197,
		name = "stone skin amulet",
		article = "a",
		weight = 700,
		slotPosition = SLOTP_NECKLACE,
		charges = 5,
		showCharges = true,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 80, [COMBAT_DEATHDAMAGE] = 80},
		showAttributes = true
	},
	{
		id = 2198,
		name = "elven amulet",
		article = "an",
		weight = 270,
		slotPosition = SLOTP_NECKLACE,
		charges = 50,
		showCharges = true,
		absorbPercent = {
			[COMBAT_PHYSICALDAMAGE] = 5,
			[COMBAT_ENERGYDAMAGE] = 5,
			[COMBAT_FIREDAMAGE] = 5,
			[COMBAT_EARTHDAMAGE] = 5,
			[COMBAT_ICEDAMAGE] = 5,
			[COMBAT_HOLYDAMAGE] = 5,
			[COMBAT_DEATHDAMAGE] = 5
		},
		showAttributes = true
	},
	{
		id = 2199,
		name = "garlic necklace",
		article = "a",
		weight = 380,
		slotPosition = SLOTP_NECKLACE,
		charges = 150,
		showCharges = true,
		absorbPercent = {[COMBAT_LIFEDRAIN] = 20},
		showAttributes = true
	},
	{
		id = 2200,
		name = "protection amulet",
		article = "a",
		weight = 550,
		slotPosition = SLOTP_NECKLACE,
		charges = 250,
		showCharges = true,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 6},
		showAttributes = true
	},
	{
		id = 2201,
		name = "dragon necklace",
		article = "a",
		weight = 630,
		slotPosition = SLOTP_NECKLACE,
		charges = 200,
		showCharges = true,
		absorbPercent = {[COMBAT_FIREDAMAGE] = 8},
		showAttributes = true
	},
	{
		id = 2202,
		name = "stealth ring",
		article = "a",
		weight = 100,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2165,
		duration = 600,
		showDuration = true,
		invisible = true,
		showAttributes = true
	},
	{
		id = 2203,
		name = "power ring",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2166,
		skillFist = 6,
		duration = 1800,
		showDuration = true
	},
	{
		id = 2204,
		name = "energy ring",
		article = "an",
		weight = 80,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2167,
		duration = 600,
		showDuration = true,
		manashield = 1,
		showAttributes = true
	},
	{
		id = 2205,
		name = "life ring",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2168,
		duration = 1200,
		healthGain = 2,
		healthTicks = 6000,
		manaGain = 8,
		manaTicks = 6000,
		showDuration = true,
		showAttributes = true
	},
	{
		id = 2206,
		name = "time ring",
		article = "a",
		weight = 90,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2169,
		duration = 600,
		showDuration = true,
		speed = 60,
		showAttributes = true
	},
	{
		id = 2207,
		name = "sword ring",
		article = "a",
		weight = 90,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2210,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2208,
		name = "axe ring",
		article = "an",
		weight = 90,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2211,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2209,
		name = "club ring",
		article = "a",
		weight = 90,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2212,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2210,
		name = "sword ring (sword fighting +4)",
		article = "a",
		weight = 90,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2207,
		skillSword = 4,
		duration = 1800,
		showDuration = true
	},
	{
		id = 2211,
		name = "axe ring",
		article = "an",
		weight = 90,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2208,
		skillAxe = 4,
		duration = 1800,
		showDuration = true
	},
	{
		id = 2212,
		name = "club ring (club fighting +4)",
		article = "a",
		weight = 90,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2209,
		skillClub = 4,
		duration = 1800,
		showDuration = true
	},
	{
		id = 2213,
		name = "dwarven ring",
		article = "a",
		weight = 110,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2215,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2214,
		name = "ring of healing",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		transformEquipTo = 2216,
		stopDuration = true,
		showDuration = true
	},
	{
		id = 2215,
		name = "dwarven ring (hard drinking)",
		article = "a",
		weight = 110,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2213,
		conditionSuppressions = CONDITION_DRUNK,
		duration = 3600,
		showDuration = true,
		showAttributes = true
	},
	{
		id = 2216,
		name = "ring of healing",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		decayTo = 0,
		transformDeEquipTo = 2214,
		duration = 450,
		healthGain = 6,
		healthTicks = 6000,
		manaGain = 24,
		manaTicks = 6000,
		showDuration = true,
		showAttributes = true
	},
	{id = 2217, name = "spellbook", article = "a", weight = 5800},
	{id = 2218, name = "paw amulet", article = "a", slotPosition = SLOTP_NECKLACE, weight = 420},
	{id = 2219, name = "banana skin", article = "a", weight = 30},
	{id = 2220, name = "dirty fur", article = "a", weight = 200},
	{id = 2221, name = "old twig", article = "an", weight = 50},
	{id = 2222, name = "some wood", weight = 40},
	{fromId = 2223, toId = 2224, name = "rubbish", weight = 10},
	{id = 2225, name = "piece of iron", article = "a", plural = "pieces of iron", weight = 20},
	{id = 2226, name = "fishbone", article = "a", weight = 70},
	{id = 2227, name = "rotten meat", weight = 60},
	{id = 2228, name = "broken pottery", weight = 180},
	{id = 2229, name = "skull", article = "a", weight = 2180},
	{id = 2230, name = "bone", article = "a", weight = 950},
	{id = 2231, name = "big bone", article = "a", weight = 1900},
	{id = 2232, name = "broken brown glass", weight = 250},
	{id = 2233, name = "broken green glass", weight = 170},
	{id = 2234, name = "broken sword", article = "a", weight = 3500},
	{id = 2235, name = "mouldy cheese", article = "a", weight = 400},
	{id = 2236, name = "torn book", article = "a", weight = 1100},
	{id = 2237, name = "dirty cape", article = "a", weight = 500},
	{id = 2238, name = "worn leather boots", weight = 900},
	{id = 2239, name = "burnt scroll", article = "a", weight = 40},
	{id = 2240, name = "remains of a fish", weight = 110},
	{id = 2241, name = "rubbish", weight = 50},
	{fromId = 2242, toId = 2243, name = "rubbish", weight = 60},
	{id = 2244, name = "some leaves", weight = 80},
	{id = 2245, name = "twigs", weight = 80},
	{id = 2246, name = "burnt down firewood", weight = 420},
	{id = 2247, name = "animal skull", article = "an"},
	{id = 2248, name = "humanoid remains"},
	{id = 2249, name = "ashes"},
	{fromId = 2250, toId = 2255, name = "wooden trash", weight = 570},
	{id = 2256, name = "stone rubbish", weight = 300},
	{fromId = 2257, toId = 2259, name = "stone rubbish", weight = 980},
	{id = 2260, name = "blank rune", article = "a", type = ITEM_TYPE_RUNE, weight = 210},
	{
		id = 2261,
		name = "destroy field rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adito grav",
		weight = 70,
		charges = 3
	},
	{
		id = 2262,
		name = "energy bomb rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo mas vis",
		weight = 105,
		charges = 2
	},
	{fromId = 2263, toId = 2264, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2265,
		name = "intense healing rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adura gran",
		weight = 210,
		charges = 1
	},
	{
		id = 2266,
		name = "cure poison rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adana pox",
		weight = 210,
		charges = 1
	},
	{id = 2267, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2268,
		name = "sudden death rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori gran mort",
		weight = 70,
		charges = 3
	},
	{
		id = 2269,
		name = "wild growth rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo grav vita",
		weight = 105,
		charges = 2
	},
	{id = 2270, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{id = 2271, name = "icicle rune", article = "an", type = ITEM_TYPE_RUNE, runeSpellName = "adori frigo", weight = 42, charges = 5},
	{id = 2272, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2273,
		name = "ultimate healing rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adura vita",
		weight = 210,
		charges = 1
	},
	{
		id = 2274,
		name = "avalanche rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori mas frigo",
		weight = 52,
		charges = 4
	},
	{fromId = 2275, toId = 2276, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2277,
		name = "energy field rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo grav vis",
		weight = 70,
		charges = 3
	},
	{id = 2278, name = "paralyse rune", article = "a", type = ITEM_TYPE_RUNE, runeSpellName = "adana ani", weight = 210, charges = 1},
	{
		id = 2279,
		name = "energy wall rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo mas grav vis",
		weight = 52,
		charges = 4
	},
	{fromId = 2280, toId = 2284, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2285,
		name = "poison field rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo grav pox",
		weight = 70,
		charges = 3
	},
	{
		id = 2286,
		name = "poison bomb rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo mas pox",
		weight = 105,
		charges = 2
	},
	{
		id = 2287,
		name = "light magic missile rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori min vis",
		weight = 21,
		charges = 10
	},
	{
		id = 2288,
		name = "stone shower rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori mas tera",
		weight = 52,
		charges = 4
	},
	{
		id = 2289,
		name = "poison wall rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo mas grav pox",
		weight = 52,
		charges = 4
	},
	{
		id = 2290,
		name = "convince creature rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adeta sio",
		weight = 210,
		charges = 1
	},
	{
		id = 2291,
		name = "chameleon rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo ina",
		weight = 210,
		charges = 1
	},
	{
		id = 2292,
		name = "stalagmite rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori tera",
		weight = 21,
		charges = 10
	},
	{
		id = 2293,
		name = "magic wall rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo grav tera",
		weight = 70,
		charges = 3
	},
	{id = 2294, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2295,
		name = "holy missile rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori san",
		weight = 42,
		charges = 5
	},
	{fromId = 2296, toId = 2300, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2301,
		name = "fire field rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo grav flam",
		weight = 70,
		charges = 3
	},
	{id = 2302, name = "fireball rune", article = "a", type = ITEM_TYPE_RUNE, runeSpellName = "adori flam", weight = 42, charges = 5},
	{
		id = 2303,
		name = "fire wall rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo mas grav flam",
		weight = 52,
		charges = 4
	},
	{
		id = 2304,
		name = "great fireball rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori mas flam",
		weight = 52,
		charges = 4
	},
	{
		id = 2305,
		name = "fire bomb rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo mas flam",
		weight = 105,
		charges = 2
	},
	{fromId = 2306, toId = 2307, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2308,
		name = "soulfire rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo res flam",
		weight = 70,
		charges = 3
	},
	{id = 2309, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2310,
		name = "disintegrate rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adito tera",
		weight = 70,
		charges = 3
	},
	{
		id = 2311,
		name = "heavy magic missile rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori vis",
		weight = 21,
		charges = 10
	},
	{id = 2312, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2313,
		name = "explosion rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adevo mas hur",
		weight = 35,
		charges = 6
	},
	{id = 2314, name = "spell rune", article = "a", type = ITEM_TYPE_RUNE, weight = 120},
	{
		id = 2315,
		name = "thunderstorm rune",
		article = "a",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adori mas vis",
		weight = 52,
		charges = 4
	},
	{
		id = 2316,
		name = "animate dead rune",
		article = "an",
		type = ITEM_TYPE_RUNE,
		runeSpellName = "adana mort",
		weight = 210,
		charges = 1
	},
	{id = 2317, name = "your own dead body"},
	{
		id = 2318,
		name = "family brooch",
		article = "a",
		description = "You see the familyname Windtrouser engraved on this brooch.",
		weight = 110
	},
	{id = 2319, name = "dragonfetish", article = "a", weight = 490},
	{id = 2320, name = "skull of Ratha", article = "a", plural = "skulls of Ratha", weight = 2180},
	{
		id = 2321,
		name = "giant smithhammer",
		article = "a",
		description = "This cyclopean hammer seems to be an awesome smithing tool.",
		weight = 6800,
		defense = 14,
		attack = 24,
		weaponType = WEAPON_CLUB
	},
	{id = 2322, name = "voodoo doll", article = "a", description = "It looks like a little king.", weight = 650},
	{
		id = 2323,
		name = "hat of the mad",
		article = "a",
		description = "You have a vague feeling that it looks somewhat silly.",
		weight = 700,
		armor = 3,
		magicLevelPoints = 1,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 2324,
		name = "witchesbroom",
		article = "a",
		description = "Don't use it without flying license. Not suitable for minors.",
		weight = 1100
	},
	{id = 2325, name = "book", article = "a", weight = 1300},
	{
		id = 2326,
		name = "annihilation bear",
		article = "an",
		description = "I braved the Annihilator and all I got is this lousy teddy bear.",
		weight = 4300
	},
	{
		id = 2327,
		name = "blessed ankh",
		article = "a",
		description = "You see the engraving of a white raven on its surface.",
		weight = 420
	},
	{id = 2328, name = "egg", article = "an", weight = 30},
	{
		id = 2329,
		name = "bill",
		article = "a",
		weight = 150,
		description = "This is a bill for an expensive magicians hat and several rabbits."
	},
	{
		id = 2330,
		name = "letterbag",
		article = "a",
		weight = 50000,
		description = "This bag is nearly bursting from all the letters inside."
	},
	{id = 2331, name = "present", article = "a", weight = 1200},
	{id = 2332, name = "Waldo's post horn", weight = 2200},
	{id = 2333, name = "letter to Markwin", article = "a", weight = 50},
	{id = 2334, name = "Santa's Mailbox"},
	{
		id = 2335,
		name = "helmet ornament",
		article = "a",
		description = "This item seems to be a single part of a bigger object.",
		weight = 160
	},
	{
		id = 2336,
		name = "gem holder",
		article = "a",
		description = "This item seems to be a single part of a bigger object.",
		weight = 80
	},
	{
		id = 2337,
		name = "right horn",
		article = "a",
		description = "This item seems to be a single part of a bigger object.",
		weight = 140
	},
	{
		id = 2338,
		name = "left horn",
		article = "a",
		description = "This item seems to be a single part of a bigger object.",
		weight = 140
	},
	{
		id = 2339,
		name = "damaged helmet",
		article = "a",
		description = "This item seems to have several parts missing.",
		weight = 1800,
		armor = 5
	},
	{
		id = 2340,
		name = "helmet piece",
		article = "a",
		description = "This item seems to be a single part of a bigger object.",
		weight = 260
	},
	{
		id = 2341,
		name = "helmet adornment",
		article = "a",
		description = "This item seems to be a single part of a bigger object.",
		weight = 180
	},
	{
		id = 2342,
		name = "helmet of the ancients",
		article = "a",
		description = "The gem of the helmet is burned out and should be replaced.",
		weight = 2760,
		armor = 8,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 2343,
		name = "helmet of the ancients",
		article = "a",
		description = "The gem is glowing with power.",
		weight = 2760,
		armor = 11,
		slotPosition = SLOTP_HEAD,
		duration = 1800,
		decayTo = 2342
	},
	{id = 2344, name = "gemmed lamp", article = "a", weight = 1300, description = "It is Fa'hradin's enchanted lamp."},
	{id = 2345, name = "spyreport", article = "a", weight = 150, description = "The report is written in some coded language."},
	{id = 2346, name = "tear of daraman", article = "a", weight = 30},
	{id = 2347, name = "cookbook", article = "a", weight = 1500, description = "It contains several exotic recipes."},
	{
		id = 2348,
		name = "ancient rune",
		article = "an",
		description = "This rune vibrates with ancient powers. It seems to be rotting rapidly.",
		weight = 300,
		decayTo = 0,
		duration = 86400
	},
	{
		id = 2349,
		name = "blue note",
		article = "a",
		description = "The blue crystal is softly humming a ghostly melody. It seems to be rotting rapidly.",
		weight = 250,
		decayTo = 0,
		duration = 86400
	},
	{
		id = 2350,
		name = "sword hilt",
		article = "a",
		description = "It was once part of a formidable two handed weapon. It seems to be rotting rapidly.",
		weight = 900,
		decayTo = 0,
		duration = 86400
	},
	{
		id = 2351,
		name = "cobrafang dagger",
		article = "a",
		description = "This ritual weapon was forged from the sharp fang of a giant cobra. It seems to be rotting rapidly.",
		weight = 600,
		decayTo = 0,
		duration = 86400
	},
	{
		id = 2352,
		name = "crystal arrow",
		article = "a",
		description = "This arrow seems not suitable for the use with ordinary bows. It seems to be rotting rapidly.",
		weight = 100,
		decayTo = 0,
		duration = 86400
	},
	{
		id = 2353,
		name = "burning heart",
		article = "a",
		description = "It is still beating with unholy life. It seems to be rotting rapidly.",
		weight = 400,
		decayTo = 0,
		duration = 86400
	},
	{
		id = 2354,
		name = "ornamented ankh",
		article = "an",
		description = "This ancient relic shows signs of untold age. It seems to be rotting rapidly.",
		weight = 200,
		decayTo = 0,
		duration = 86400
	},
	{id = 2355, name = "stuffed bunny", article = "a", weight = 350},
	{id = 2356, name = "gemmed lamp", article = "a", weight = 1300, description = "It is the djinn leader's sleeping lamp."},
	{
		id = 2357,
		name = "ring of wishes",
		article = "a",
		description = "(This item has 3 charges left).",
		weight = 90,
		slotPosition = SLOTP_RING
	},
	{
		id = 2358,
		name = "boots of waterwalking",
		description = "(This item has 5 charges left).",
		weight = 770,
		slotPosition = SLOTP_FEET
	},
	{id = 2359, name = "djinn's lamp", article = "a", description = "(This item has 2 charges left).", weight = 600},
	{id = 2360, name = "portable hole", article = "a"},
	{id = 2361, name = "frozen starlight", slotPosition = SLOTP_AMMO, weight = 20},
	{id = 2362, name = "carrot of doom", article = "the", description = "You can sense the evil power of the carrot.", weight = 160},
	{id = 2363, name = "blood orb", article = "a", weight = 150},
	{id = 2364, name = "post horn", article = "a", weight = 1500},
	{id = 2365, name = "backpack of holding", article = "a", weight = 1500, containerSize = 24, slotPosition = SLOTP_BACKPACK},
	{id = 2366, name = "roc feather", article = "a", weight = 100},
	{id = 2367, name = "drum", article = "a", weight = 3200},
	{id = 2368, name = "simple fanfare", article = "a", weight = 2200},
	{id = 2369, name = "cornucopia", article = "a", weight = 1400},
	{id = 2370, name = "lute", article = "a", weight = 3400},
	{id = 2371, name = "horn of sundering", article = "the", weight = 2300},
	{id = 2372, name = "lyre", article = "a", weight = 1250},
	{id = 2373, name = "panpipe", article = "a", weight = 820},
	{id = 2374, name = "wooden flute", article = "a", weight = 200},
	{id = 2375, name = "gemmed lamp", article = "a", description = "It is the djinn leader's sleeping lamp.", weight = 1300},
	{id = 2376, name = "sword", article = "a", weight = 3500, defense = 12, attack = 14, weaponType = WEAPON_SWORD, extraDefense = 1},
	{
		id = 2377,
		name = "two handed sword",
		article = "a",
		weight = 7000,
		defense = 25,
		attack = 30,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2378,
		name = "battle axe",
		article = "a",
		weight = 5000,
		defense = 10,
		attack = 25,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2379, name = "dagger", article = "a", weight = 950, defense = 6, attack = 8, weaponType = WEAPON_SWORD},
	{id = 2380, name = "hand axe", article = "a", weight = 1800, defense = 5, attack = 10, weaponType = WEAPON_AXE},
	{
		id = 2381,
		name = "halberd",
		article = "a",
		weight = 9000,
		defense = 14,
		attack = 35,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2382, name = "club", article = "a", weight = 2500, defense = 7, attack = 7, weaponType = WEAPON_CLUB},
	{
		id = 2383,
		name = "spike sword",
		article = "a",
		weight = 5000,
		defense = 21,
		attack = 24,
		weaponType = WEAPON_SWORD,
		extraDefense = 2
	},
	{id = 2384, name = "rapier", article = "a", weight = 1500, defense = 8, attack = 10, weaponType = WEAPON_SWORD, extraDefense = 1},
	{id = 2385, name = "sabre", article = "a", weight = 2500, defense = 10, attack = 12, weaponType = WEAPON_SWORD, extraDefense = 1},
	{id = 2386, name = "axe", article = "an", weight = 4000, defense = 6, attack = 12, weaponType = WEAPON_AXE},
	{
		id = 2387,
		name = "double axe",
		article = "a",
		weight = 7000,
		defense = 12,
		attack = 35,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2388, name = "hatchet", article = "a", weight = 3500, defense = 8, attack = 15, weaponType = WEAPON_AXE},
	{
		id = 2389,
		name = "spear",
		article = "a",
		weight = 2000,
		attack = 25,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_SPEAR,
		maxHitChance = 76,
		range = 3
	},
	{
		id = 2390,
		name = "magic longsword",
		article = "a",
		description = "It's the magic Cyclopmania Sword.",
		weight = 4300,
		defense = 40,
		attack = 55,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2391,
		name = "war hammer",
		article = "a",
		weight = 8500,
		defense = 10,
		attack = 45,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2392,
		name = "fire sword",
		article = "a",
		description = "The blade is a magic flame.",
		weight = 2300,
		defense = 20,
		attack = 24,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 11,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 2393,
		name = "giant sword",
		article = "a",
		description = "This sword has been forged by ancient giants.",
		weight = 18000,
		defense = 22,
		attack = 46,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2394, name = "morning star", article = "a", weight = 5400, defense = 11, attack = 25, weaponType = WEAPON_CLUB},
	{
		id = 2395,
		name = "carlin sword",
		article = "a",
		weight = 4000,
		defense = 13,
		attack = 15,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 2396,
		name = "ice rapier",
		article = "an",
		description = "A deadly but fragile weapon.",
		weight = 1500,
		attack = 42,
		defense = 1,
		weaponType = WEAPON_SWORD,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 18,
		charges = 1
	},
	{id = 2397, name = "longsword", article = "a", weight = 4200, defense = 14, attack = 17, weaponType = WEAPON_SWORD},
	{id = 2398, name = "mace", article = "a", weight = 3800, defense = 11, attack = 16, weaponType = WEAPON_CLUB},
	{
		id = 2399,
		name = "throwing star",
		article = "a",
		weight = 200,
		attack = 30,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_THROWINGSTAR,
		maxHitChance = 76,
		range = 4
	},
	{
		id = 2400,
		name = "magic sword",
		article = "a",
		description = "It's the Sword of Valor.",
		weight = 4200,
		defense = 35,
		attack = 48,
		weaponType = WEAPON_SWORD,
		extraDefense = 3
	},
	{
		id = 2401,
		name = "staff",
		article = "a",
		weight = 3800,
		defense = 25,
		attack = 10,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2402, name = "silver dagger", article = "a", weight = 1020, defense = 7, attack = 9, weaponType = WEAPON_SWORD},
	{id = 2403, name = "knife", article = "a", weight = 420, defense = 5, attack = 5, weaponType = WEAPON_SWORD},
	{id = 2404, name = "combat knife", article = "a", weight = 870, defense = 6, attack = 8, weaponType = WEAPON_SWORD},
	{id = 2405, name = "sickle", article = "a", weight = 1050, defense = 4, attack = 5, weaponType = WEAPON_AXE},
	{id = 2406, name = "short sword", article = "a", weight = 3500, defense = 11, attack = 11, weaponType = WEAPON_SWORD},
	{
		id = 2407,
		name = "bright sword",
		article = "a",
		description = "The blade shimmers in light blue.",
		weight = 2900,
		defense = 30,
		attack = 36,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 2408,
		name = "warlord sword",
		article = "a",
		description = "Strong powers flow in this magic sword.",
		weight = 6400,
		defense = 38,
		attack = 53,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2409,
		name = "serpent sword",
		article = "a",
		weight = 4100,
		defense = 15,
		attack = 18,
		weaponType = WEAPON_SWORD,
		extraDefense = 1,
		elementEarth = 8
	},
	{
		id = 2410,
		name = "throwing knife",
		article = "a",
		plural = "throwing knives",
		weight = 500,
		attack = 25,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_THROWINGKNIFE,
		maxHitChance = 76,
		range = 4
	},
	{
		id = 2411,
		name = "poison dagger",
		article = "a",
		weight = 880,
		defense = 8,
		attack = 18,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 2,
		weaponType = WEAPON_SWORD
	},
	{
		id = 2412,
		name = "katana",
		article = "a",
		weight = 3100,
		defense = 12,
		attack = 16,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 2413,
		name = "broadsword",
		article = "a",
		weight = 5250,
		defense = 23,
		attack = 26,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2414,
		name = "dragon lance",
		article = "a",
		description = "The extraordinary sharp blade penetrates every armor.",
		weight = 6700,
		defense = 16,
		attack = 47,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2415,
		name = "great axe",
		article = "a",
		description = "A masterpiece of a dwarven smith.",
		weight = 9000,
		defense = 22,
		attack = 52,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2416,
		name = "crowbar",
		article = "a",
		description = "It may come in handy sometime.",
		weight = 2100,
		defense = 6,
		attack = 5,
		weaponType = WEAPON_CLUB
	},
	{id = 2417, name = "battle hammer", article = "a", weight = 6800, defense = 14, attack = 24, weaponType = WEAPON_CLUB},
	{id = 2418, name = "golden sickle", article = "a", weight = 1950, defense = 6, attack = 13, weaponType = WEAPON_AXE},
	{
		id = 2419,
		name = "scimitar",
		article = "a",
		weight = 2900,
		defense = 13,
		attack = 19,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{id = 2420, name = "machete", article = "a", weight = 1650, defense = 9, attack = 12, weaponType = WEAPON_SWORD},
	{
		id = 2421,
		name = "thunder hammer",
		article = "a",
		description = "It is blessed by the gods.",
		weight = 12500,
		defense = 35,
		attack = 49,
		weaponType = WEAPON_CLUB,
		extraDefense = 1
	},
	{id = 2422, name = "iron hammer", article = "an", weight = 6600, defense = 10, attack = 18, weaponType = WEAPON_CLUB},
	{
		id = 2423,
		name = "clerical mace",
		article = "a",
		weight = 5800,
		defense = 15,
		attack = 28,
		weaponType = WEAPON_CLUB,
		extraDefense = 1
	},
	{
		id = 2424,
		name = "silver mace",
		article = "a",
		description = "You feel an aura of protection.",
		weight = 6700,
		defense = 30,
		attack = 41,
		weaponType = WEAPON_CLUB,
		extraDefense = 2
	},
	{
		id = 2425,
		name = "obsidian lance",
		article = "an",
		weight = 8000,
		defense = 10,
		attack = 34,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2426,
		name = "naginata",
		article = "a",
		weight = 7800,
		defense = 25,
		attack = 39,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2427,
		name = "guardian halberd",
		article = "a",
		weight = 11000,
		defense = 15,
		attack = 46,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2428, name = "orcish axe", article = "an", weight = 4500, defense = 12, attack = 23, weaponType = WEAPON_AXE},
	{
		id = 2429,
		name = "barbarian axe",
		article = "a",
		weight = 5100,
		defense = 18,
		attack = 28,
		weaponType = WEAPON_AXE,
		extraDefense = 1
	},
	{
		id = 2430,
		name = "knight axe",
		article = "a",
		weight = 5900,
		defense = 21,
		attack = 33,
		weaponType = WEAPON_AXE,
		extraDefense = 1
	},
	{
		id = 2431,
		name = "stonecutter axe",
		article = "a",
		description = "You feel the power of this mighty axe.",
		weight = 9900,
		defense = 30,
		attack = 50,
		weaponType = WEAPON_AXE,
		extraDefense = 3
	},
	{
		id = 2432,
		name = "fire axe",
		article = "a",
		description = "The blade is a magic flame.",
		weight = 4000,
		defense = 16,
		attack = 27,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 11,
		weaponType = WEAPON_AXE,
		extraDefense = 1
	},
	{
		id = 2433,
		name = "enchanted staff",
		article = "an",
		description = "Temporary magic powers enchant this staff.",
		weight = 3800,
		defense = 45,
		attack = 39,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		decayTo = 2401,
		duration = 60
	},
	{id = 2434, name = "dragon hammer", article = "a", weight = 9700, defense = 20, attack = 32, weaponType = WEAPON_CLUB},
	{
		id = 2435,
		name = "dwarven axe",
		article = "a",
		weight = 8200,
		defense = 19,
		attack = 31,
		weaponType = WEAPON_AXE,
		extraDefense = 2
	},
	{
		id = 2436,
		name = "skull staff",
		article = "a",
		description = "The staff longs for death.",
		weight = 1700,
		defense = 12,
		attack = 36,
		weaponType = WEAPON_CLUB,
		extraDefense = 1
	},
	{id = 2437, name = "light mace", article = "a", weight = 4100, defense = 9, attack = 14, weaponType = WEAPON_CLUB},
	{id = 2438, name = "epee", article = "an", weight = 1450, defense = 23, attack = 37, weaponType = WEAPON_SWORD},
	{id = 2439, name = "daramian mace", article = "a", weight = 6800, defense = 12, attack = 21, weaponType = WEAPON_CLUB},
	{
		id = 2440,
		name = "daramian waraxe",
		article = "a",
		weight = 5250,
		defense = 15,
		attack = 39,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2441, name = "daramian axe", article = "a", weight = 4100, defense = 8, attack = 17, weaponType = WEAPON_AXE},
	{id = 2442, name = "heavy machete", article = "a", weight = 1840, defense = 10, attack = 16, weaponType = WEAPON_SWORD},
	{
		id = 2443,
		name = "ravager's axe",
		article = "a",
		weight = 5250,
		defense = 14,
		attack = 49,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2444,
		name = "hammer of wrath",
		article = "a",
		description = "A giant is said to have forged this hammer to take revenge for the death of his brother.",
		weight = 7000,
		defense = 12,
		attack = 48,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2445,
		name = "crystal mace",
		article = "a",
		weight = 8000,
		defense = 16,
		attack = 38,
		extraDefense = 1,
		weaponType = WEAPON_CLUB
	},
	{
		id = 2446,
		name = "pharaoh sword",
		article = "a",
		weight = 5200,
		defense = 23,
		attack = 41,
		weaponType = WEAPON_SWORD,
		extraDefense = 2
	},
	{
		id = 2447,
		name = "twin axe",
		article = "a",
		weight = 6400,
		defense = 24,
		attack = 45,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2448,
		name = "studded club",
		article = "a",
		description = "It has been reinforced with iron.",
		weight = 3500,
		defense = 8,
		attack = 9,
		weaponType = WEAPON_CLUB
	},
	{
		id = 2449,
		name = "bone club",
		article = "a",
		description = "It apparently originally belonged to some lesser undead.",
		weight = 3900,
		defense = 8,
		attack = 12,
		weaponType = WEAPON_CLUB
	},
	{id = 2450, name = "bone sword", article = "a", weight = 1900, defense = 10, attack = 13, weaponType = WEAPON_SWORD},
	{
		id = 2451,
		name = "djinn blade",
		article = "a",
		weight = 2450,
		defense = 22,
		attack = 38,
		weaponType = WEAPON_SWORD,
		extraDefense = 2
	},
	{
		id = 2452,
		name = "heavy mace",
		article = "a",
		description = "Its tip is made of extremely solid steel.",
		weight = 11000,
		defense = 15,
		attack = 49,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2453,
		name = "arcane staff",
		article = "an",
		description = "It is enchanted with ancient magic that renders a weak staff into a powerful weapon.",
		weight = 4000,
		defense = 30,
		attack = 50,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2454,
		name = "war axe",
		article = "a",
		weight = 6150,
		defense = 10,
		attack = 48,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 2455,
		name = "crossbow",
		article = "a",
		weight = 4000,
		weaponType = WEAPON_DISTANCE,
		slotPosition = SLOTP_TWO_HAND,
		ammoType = AMMO_BOLT,
		range = 5
	},
	{
		id = 2456,
		name = "bow",
		article = "a",
		weight = 3100,
		weaponType = WEAPON_DISTANCE,
		slotPosition = SLOTP_TWO_HAND,
		ammoType = AMMO_ARROW,
		range = 6
	},
	{id = 2457, name = "steel helmet", article = "a", weight = 4600, armor = 6, slotPosition = SLOTP_HEAD},
	{id = 2458, name = "chain helmet", article = "a", weight = 4200, armor = 2, slotPosition = SLOTP_HEAD},
	{id = 2459, name = "iron helmet", article = "an", weight = 3000, armor = 5, slotPosition = SLOTP_HEAD},
	{id = 2460, name = "brass helmet", article = "a", weight = 2700, armor = 3, slotPosition = SLOTP_HEAD},
	{id = 2461, name = "leather helmet", article = "a", weight = 2200, armor = 1, slotPosition = SLOTP_HEAD},
	{id = 2462, name = "devil helmet", article = "a", weight = 5000, armor = 7, slotPosition = SLOTP_HEAD},
	{id = 2463, name = "plate armor", article = "a", weight = 12000, armor = 10, slotPosition = SLOTP_ARMOR},
	{id = 2464, name = "chain armor", article = "a", weight = 10000, armor = 6, slotPosition = SLOTP_ARMOR},
	{id = 2465, name = "brass armor", article = "a", weight = 8000, armor = 8, slotPosition = SLOTP_ARMOR},
	{id = 2466, name = "golden armor", article = "a", weight = 8000, armor = 14, slotPosition = SLOTP_ARMOR},
	{id = 2467, name = "leather armor", article = "a", weight = 6000, armor = 4, slotPosition = SLOTP_ARMOR},
	{id = 2468, name = "studded legs", weight = 2600, armor = 2, slotPosition = SLOTP_LEGS},
	{id = 2469, name = "dragon scale legs", weight = 4800, armor = 10, slotPosition = SLOTP_LEGS},
	{id = 2470, name = "golden legs", weight = 5600, armor = 9, slotPosition = SLOTP_LEGS},
	{
		id = 2471,
		name = "golden helmet",
		article = "a",
		description = "It's the famous Helmet of the Stars.",
		weight = 3200,
		armor = 12,
		slotPosition = SLOTP_HEAD
	},
	{id = 2472, name = "magic plate armor", article = "a", weight = 8500, armor = 17, slotPosition = SLOTP_ARMOR},
	{id = 2473, name = "viking helmet", article = "a", weight = 3900, armor = 4, slotPosition = SLOTP_HEAD},
	{
		id = 2474,
		name = "winged helmet",
		article = "a",
		description = "It's the Helmet of Hermes.",
		weight = 1200,
		armor = 10,
		slotPosition = SLOTP_HEAD
	},
	{id = 2475, name = "warrior helmet", article = "a", weight = 6800, armor = 8, slotPosition = SLOTP_HEAD},
	{id = 2476, name = "knight armor", article = "a", weight = 12000, armor = 12, slotPosition = SLOTP_ARMOR},
	{id = 2477, name = "knight legs", weight = 7000, armor = 8, slotPosition = SLOTP_LEGS},
	{id = 2478, name = "brass legs", weight = 3800, armor = 5, slotPosition = SLOTP_LEGS},
	{id = 2479, name = "strange helmet", article = "a", weight = 4600, armor = 6, slotPosition = SLOTP_HEAD},
	{id = 2480, name = "legion helmet", article = "a", weight = 3100, armor = 4, slotPosition = SLOTP_HEAD},
	{id = 2481, name = "soldier helmet", article = "a", weight = 3200, armor = 5, slotPosition = SLOTP_HEAD},
	{id = 2482, name = "studded helmet", article = "a", weight = 2450, armor = 2, slotPosition = SLOTP_HEAD},
	{id = 2483, name = "scale armor", article = "a", weight = 10500, armor = 9, slotPosition = SLOTP_ARMOR},
	{id = 2484, name = "studded armor", article = "a", weight = 7100, armor = 5, slotPosition = SLOTP_ARMOR},
	{id = 2485, name = "doublet", article = "a", weight = 2500, armor = 2, slotPosition = SLOTP_ARMOR},
	{id = 2486, name = "noble armor", article = "a", weight = 12000, armor = 11, slotPosition = SLOTP_ARMOR},
	{id = 2487, name = "crown armor", article = "a", weight = 9900, armor = 13, slotPosition = SLOTP_ARMOR},
	{id = 2488, name = "crown legs", weight = 6500, armor = 8, slotPosition = SLOTP_LEGS},
	{id = 2489, name = "dark armor", article = "a", weight = 12000, armor = 10, slotPosition = SLOTP_ARMOR},
	{id = 2490, name = "dark helmet", article = "a", weight = 4600, armor = 6, slotPosition = SLOTP_HEAD},
	{id = 2491, name = "crown helmet", article = "a", weight = 2950, armor = 7, slotPosition = SLOTP_HEAD},
	{id = 2492, name = "dragon scale mail", article = "a", weight = 11400, armor = 15, slotPosition = SLOTP_ARMOR},
	{
		id = 2493,
		name = "demon helmet",
		article = "a",
		description = "You hear an evil whispering from inside.",
		weight = 2950,
		armor = 10,
		slotPosition = SLOTP_HEAD
	},
	{id = 2494, name = "demon armor", article = "a", weight = 8000, armor = 16, slotPosition = SLOTP_ARMOR},
	{id = 2495, name = "demon legs", weight = 7000, armor = 9, slotPosition = SLOTP_LEGS},
	{id = 2496, name = "horned helmet", article = "a", weight = 5100, armor = 11, slotPosition = SLOTP_HEAD},
	{id = 2497, name = "crusader helmet", article = "a", weight = 5200, armor = 8, slotPosition = SLOTP_HEAD},
	{
		id = 2498,
		name = "royal helmet",
		article = "a",
		description = "An excellent masterpiece of a smith.",
		weight = 4800,
		armor = 9,
		slotPosition = SLOTP_HEAD
	},
	{id = 2499, name = "amazon helmet", article = "an", weight = 2950, armor = 7, slotPosition = SLOTP_HEAD},
	{id = 2500, name = "amazon armor", article = "an", weight = 4500, armor = 13, skillDist = 3, slotPosition = SLOTP_ARMOR},
	{id = 2501, name = "ceremonial mask", article = "a", weight = 4000, armor = 9, slotPosition = SLOTP_HEAD},
	{
		id = 2502,
		name = "dwarven helmet",
		article = "a",
		weight = 4200,
		armor = 6,
		slotPosition = SLOTP_HEAD,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 2}
	},
	{
		id = 2503,
		name = "dwarven armor",
		article = "a",
		weight = 13000,
		armor = 10,
		slotPosition = SLOTP_ARMOR,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 5}
	},
	{
		id = 2504,
		name = "dwarven legs",
		weight = 4900,
		armor = 7,
		slotPosition = SLOTP_LEGS,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 3}
	},
	{id = 2505, name = "elven mail", article = "an", weight = 9000, armor = 9, slotPosition = SLOTP_ARMOR},
	{id = 2506, name = "dragon scale helmet", article = "a", weight = 3250, armor = 9, slotPosition = SLOTP_HEAD},
	{id = 2507, name = "elven legs", weight = 3300, armor = 4, slotPosition = SLOTP_LEGS},
	{id = 2508, name = "native armor", article = "a", weight = 8000, slotPosition = SLOTP_ARMOR, armor = 7},
	{id = 2509, name = "steel shield", article = "a", weight = 6900, defense = 21, weaponType = WEAPON_SHIELD},
	{id = 2510, name = "plate shield", article = "a", weight = 6500, defense = 17, weaponType = WEAPON_SHIELD},
	{id = 2511, name = "brass shield", article = "a", weight = 6000, defense = 16, weaponType = WEAPON_SHIELD},
	{id = 2512, name = "wooden shield", article = "a", weight = 4000, defense = 14, weaponType = WEAPON_SHIELD},
	{id = 2513, name = "battle shield", article = "a", weight = 6200, defense = 23, weaponType = WEAPON_SHIELD},
	{
		id = 2514,
		name = "mastermind shield",
		article = "a",
		description = "It's an enchanted shield.",
		weight = 5700,
		defense = 37,
		weaponType = WEAPON_SHIELD
	},
	{id = 2515, name = "guardian shield", article = "a", weight = 5500, defense = 30, weaponType = WEAPON_SHIELD},
	{id = 2516, name = "dragon shield", article = "a", weight = 6000, defense = 31, weaponType = WEAPON_SHIELD},
	{
		id = 2517,
		name = "shield of honour",
		article = "a",
		description = "A mighty shield awarded by the gods.",
		weight = 5400,
		defense = 33,
		weaponType = WEAPON_SHIELD
	},
	{id = 2518, name = "bonelord shield", article = "a", weight = 4700, defense = 28, weaponType = WEAPON_SHIELD},
	{id = 2519, name = "crown shield", article = "a", weight = 6200, defense = 32, weaponType = WEAPON_SHIELD},
	{
		id = 2520,
		name = "demon shield",
		article = "a",
		description = "This powerful shield seems to be as light as air.",
		weight = 2600,
		defense = 35,
		weaponType = WEAPON_SHIELD
	},
	{id = 2521, name = "dark shield", article = "a", weight = 5200, defense = 25, weaponType = WEAPON_SHIELD},
	{
		id = 2522,
		name = "great shield",
		article = "a",
		description = "The shield is made of dragon scales.",
		weight = 8400,
		defense = 38,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 2523,
		name = "blessed shield",
		article = "a",
		description = "The shield grants divine protection.",
		weight = 6800,
		defense = 40,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 2524,
		name = "ornamented shield",
		article = "an",
		description = "Many gems sparkle on the shield.",
		weight = 6700,
		defense = 22,
		weaponType = WEAPON_SHIELD
	},
	{id = 2525, name = "dwarven shield", article = "a", weight = 5500, defense = 26, weaponType = WEAPON_SHIELD},
	{id = 2526, name = "studded shield", article = "a", weight = 5800, defense = 15, weaponType = WEAPON_SHIELD},
	{id = 2527, name = "rose shield", article = "a", weight = 5200, defense = 27, weaponType = WEAPON_SHIELD},
	{id = 2528, name = "tower shield", article = "a", weight = 8200, defense = 32, weaponType = WEAPON_SHIELD},
	{
		id = 2529,
		name = "black shield",
		article = "a",
		description = "An unholy creature covers the shield.",
		weight = 4200,
		defense = 18,
		weaponType = WEAPON_SHIELD
	},
	{id = 2530, name = "copper shield", article = "a", weight = 6300, defense = 19, weaponType = WEAPON_SHIELD},
	{id = 2531, name = "viking shield", article = "a", weight = 6600, defense = 22, weaponType = WEAPON_SHIELD},
	{id = 2532, name = "ancient shield", article = "an", weight = 6100, defense = 27, weaponType = WEAPON_SHIELD},
	{id = 2533, name = "griffin shield", article = "a", weight = 5000, defense = 29, weaponType = WEAPON_SHIELD},
	{
		id = 2534,
		name = "vampire shield",
		article = "a",
		description = "Dark powers enchant this shield.",
		weight = 3800,
		defense = 34,
		weaponType = WEAPON_SHIELD
	},
	{id = 2535, name = "castle shield", article = "a", weight = 4900, defense = 28, weaponType = WEAPON_SHIELD},
	{id = 2536, name = "medusa shield", article = "a", weight = 5800, defense = 33, weaponType = WEAPON_SHIELD},
	{id = 2537, name = "amazon shield", article = "an", weight = 6200, defense = 32, weaponType = WEAPON_SHIELD},
	{id = 2538, name = "eagle shield", article = "an", weight = 6200, defense = 32, weaponType = WEAPON_SHIELD},
	{
		id = 2539,
		name = "phoenix shield",
		article = "a",
		description = "This shield feels warm to the touch.",
		weight = 3500,
		defense = 34,
		weaponType = WEAPON_SHIELD
	},
	{id = 2540, name = "scarab shield", article = "a", weight = 4700, defense = 25, weaponType = WEAPON_SHIELD},
	{id = 2541, name = "bone shield", article = "a", weight = 5500, defense = 20, weaponType = WEAPON_SHIELD},
	{id = 2542, name = "tempest shield", article = "a", weight = 5100, defense = 36, weaponType = WEAPON_SHIELD},
	{
		id = 2543,
		name = "bolt",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_AMMO,
		attack = 30,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_BOLT,
		shootType = CONST_ANI_BOLT,
		maxHitChance = 87
	},
	{
		id = 2544,
		name = "arrow",
		article = "an",
		weight = 70,
		slotPosition = SLOTP_AMMO,
		attack = 25,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_ARROW,
		maxHitChance = 91
	},
	{
		id = 2545,
		name = "poison arrow",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_AMMO,
		attack = 23,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_POISONARROW,
		maxHitChance = 91
	},
	{
		id = 2546,
		name = "burst arrow",
		article = "a",
		weight = 90,
		slotPosition = SLOTP_AMMO,
		attack = 27,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_BURSTARROW,
		maxHitChance = 100
	},
	{
		id = 2547,
		name = "power bolt",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_AMMO,
		attack = 40,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_BOLT,
		shootType = CONST_ANI_POWERBOLT,
		maxHitChance = 91
	},
	{id = 2548, name = "pitchfork", article = "a", weight = 2500},
	{id = 2549, name = "rake", article = "a", weight = 1500},
	{
		id = 2550,
		name = "scythe",
		article = "a",
		weight = 3000,
		defense = 3,
		attack = 8,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 2551, name = "broom", article = "a", weight = 1100},
	{id = 2552, name = "hoe", article = "a", weight = 2800},
	{id = 2553, name = "pick", article = "a", weight = 4500},
	{id = 2554, name = "shovel", article = "a", weight = 3500},
	{id = 2555, name = "anvil", article = "an"},
	{id = 2556, name = "wooden hammer", article = "a", weight = 600},
	{id = 2557, name = "hammer", article = "a", weight = 1150},
	{id = 2558, name = "saw", article = "a", weight = 1000},
	{id = 2559, name = "small axe", article = "a", weight = 2000},
	{id = 2560, name = "mirror", article = "a", weight = 950},
	{id = 2561, name = "baking tray", article = "a", weight = 1200},
	{id = 2562, name = "pot", article = "a", weight = 5250, pickupable = true},
	{id = 2563, name = "pan", article = "a", weight = 1800},
	{id = 2564, name = "fork", article = "a", weight = 100},
	{id = 2565, name = "spoon", article = "a", weight = 100},
	{id = 2566, name = "kitchen knife", article = "a", weight = 100},
	{id = 2567, name = "wooden spoon", article = "a", weight = 100},
	{id = 2568, name = "cleaver", article = "a", weight = 660},
	{id = 2569, name = "oven spatula", article = "an", weight = 1400},
	{id = 2570, name = "rolling pin", article = "a", weight = 500},
	{fromId = 2571, toId = 2573, name = "bowl", article = "a", weight = 1850},
	{id = 2574, name = "ewer", article = "a", weight = 1750, pickupable = true},
	{id = 2575, name = "ewer", article = "a", weight = 1750, pickupable = true},
	{id = 2576, name = "ewer", article = "a", weight = 1750, pickupable = true},
	{id = 2577, name = "ewer", article = "a", weight = 1750, pickupable = true},
	{id = 2578, name = "closed trap", article = "a", weight = 2100},
	{id = 2579, name = "trap", article = "a", weight = 2100},
	{id = 2580, name = "fishing rod", article = "a", weight = 850},
	{id = 2581, name = "telescope", article = "a", rotateTo = 2584, destroyTo = 2250},
	{id = 2582, name = "telescope", article = "a", rotateTo = 2583, destroyTo = 2250},
	{id = 2583, name = "telescope", article = "a", rotateTo = 2581, destroyTo = 2250},
	{id = 2584, name = "telescope", article = "a", rotateTo = 2582, destroyTo = 2250},
	{id = 2585, name = "ship's telescope", article = "a", rotateTo = 2588},
	{id = 2586, name = "ship's telescope", article = "a", rotateTo = 2587},
	{id = 2587, name = "ship's telescope", article = "a", rotateTo = 2585},
	{id = 2588, name = "ship's telescope", article = "a", rotateTo = 2586},
	{fromId = 2589, toId = 2592, name = "locker", article = "a", type = ITEM_TYPE_DEPOT, containerSize = 3},
	{id = 2593, name = "mailbox", article = "a", description = "Royal Mail.", type = ITEM_TYPE_MAILBOX},
	{id = 2594, name = "depot chest", article = "a", containerSize = 30},
	{
		id = 2595,
		name = "parcel",
		article = "a",
		type = ITEM_TYPE_CONTAINER,
		group = ITEM_GROUP_CONTAINER,
		weight = 1800,
		containerSize = 10
	},
	{id = 2596, name = "stamped parcel", article = "a", weight = 1800, containerSize = 10},
	{id = 2597, name = "letter", article = "a", weight = 50, writeable = true, maxTextLen = 1999},
	{id = 2598, name = "stamped letter", article = "a", readable = true, weight = 30},
	{id = 2599, name = "label", article = "a", weight = 10, writeable = true, maxTextLen = 79},
	{id = 2600, name = "inkwell", article = "an", weight = 200},
	{fromId = 2601, toId = 2604, name = "coal basin", article = "a", destroyTo = 2257},
	{id = 2605, name = "empty coal basin", article = "an", destroyTo = 2257},
	{fromId = 2606, toId = 2609, name = "altar", article = "an"},
	{fromId = 2610, toId = 2613, name = "sacrificial stone", article = "a"},
	{fromId = 2614, toId = 2615, name = "altar", article = "an"},
	{fromId = 2616, toId = 2623, name = "sacrificial stone", article = "a"},
	{id = 2624, name = "black token", article = "a", weight = 500},
	{id = 2625, name = "white token", article = "a", weight = 500},
	{id = 2626, name = "white pawn", article = "a", weight = 500},
	{id = 2627, name = "white castle", article = "a", weight = 500},
	{id = 2628, name = "white knight", article = "a", weight = 500},
	{id = 2629, name = "white bishop", article = "a", weight = 500},
	{id = 2630, name = "white queen", article = "the", weight = 500},
	{id = 2631, name = "white king", article = "the", weight = 500},
	{id = 2632, name = "black pawn", article = "a", weight = 500},
	{id = 2633, name = "black castle", article = "a", weight = 500},
	{id = 2634, name = "black knight", article = "a", weight = 500},
	{id = 2635, name = "black bishop", article = "a", weight = 500},
	{id = 2636, name = "black queen", article = "the", weight = 500},
	{id = 2637, name = "black king", article = "the", weight = 500},
	{fromId = 2638, toId = 2639, name = "tic-tac-toe token", article = "a", weight = 500},
	{
		id = 2640,
		name = "pair of soft boots",
		article = "a",
		weight = 800,
		slotPosition = SLOTP_FEET,
		decayTo = 10021,
		transformDeEquipTo = 6132,
		duration = 14400,
		healthGain = 3,
		healthTicks = 6000,
		manaGain = 12,
		manaTicks = 6000,
		showDuration = true,
		showAttributes = true
	},
	{id = 2641, name = "patched boots", weight = 1000, armor = 2, slotPosition = SLOTP_FEET},
	{id = 2642, name = "sandals", weight = 600, slotPosition = SLOTP_FEET},
	{id = 2643, name = "leather boots", weight = 900, armor = 1, slotPosition = SLOTP_FEET},
	{id = 2644, name = "bunnyslippers", weight = 600, slotPosition = SLOTP_FEET},
	{id = 2645, name = "steel boots", weight = 2900, armor = 3, slotPosition = SLOTP_FEET},
	{id = 2646, name = "golden boots", weight = 3100, armor = 4, slotPosition = SLOTP_FEET},
	{id = 2647, name = "plate legs", weight = 5000, armor = 7, slotPosition = SLOTP_LEGS},
	{id = 2648, name = "chain legs", weight = 3500, armor = 3, slotPosition = SLOTP_LEGS},
	{id = 2649, name = "leather legs", weight = 1800, armor = 1, slotPosition = SLOTP_LEGS},
	{id = 2650, name = "jacket", article = "a", weight = 2400, armor = 1, slotPosition = SLOTP_ARMOR},
	{id = 2651, name = "coat", article = "a", weight = 2700, armor = 1, slotPosition = SLOTP_ARMOR},
	{id = 2652, name = "green tunic", article = "a", weight = 930, armor = 1, slotPosition = SLOTP_ARMOR},
	{id = 2653, name = "red tunic", article = "a", weight = 1400, armor = 2, slotPosition = SLOTP_ARMOR},
	{id = 2654, name = "cape", article = "a", weight = 3200, armor = 1, slotPosition = SLOTP_ARMOR},
	{
		id = 2655,
		name = "red robe",
		article = "a",
		weight = 2600,
		description = "The robe is artfully embroideredy.",
		armor = 1,
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 2656,
		name = "blue robe",
		article = "a",
		description = "It is a magic robe.",
		weight = 2200,
		armor = 11,
		slotPosition = SLOTP_ARMOR
	},
	{id = 2657, name = "simple dress", article = "a", weight = 1000, slotPosition = SLOTP_ARMOR},
	{id = 2658, name = "white dress", article = "a", weight = 2400, slotPosition = SLOTP_ARMOR},
	{id = 2659, name = "ball gown", article = "a", weight = 2500, slotPosition = SLOTP_ARMOR},
	{id = 2660, name = "ranger's cloak", article = "a", weight = 4800, armor = 7, slotPosition = SLOTP_ARMOR},
	{id = 2661, name = "scarf", article = "a", weight = 200, armor = 1, slotPosition = SLOTP_NECKLACE},
	{id = 2662, name = "magician hat", article = "a", weight = 750, armor = 1, slotPosition = SLOTP_HEAD},
	{
		id = 2663,
		name = "mystic turban",
		article = "a",
		description = "Something is strange about this turban.",
		weight = 850,
		armor = 1,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 2664,
		name = "wood cape",
		article = "a",
		weight = 1100,
		armor = 3,
		skillDist = 1,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 4},
		slotPosition = SLOTP_HEAD
	},
	{
		id = 2665,
		name = "post officer's hat",
		article = "a",
		description = "This hat is the insignia of all post officers.",
		weight = 700,
		armor = 1,
		slotPosition = SLOTP_HEAD
	},
	{id = 2666, name = "meat", weight = 1300, showCount = false},
	{id = 2667, name = "fish", article = "a", plural = "fish", weight = 520},
	{id = 2668, name = "salmon", weight = 320, showCount = false},
	{id = 2669, name = "northern pike", article = "a", weight = 830},
	{id = 2670, name = "shrimp", weight = 50, showCount = false},
	{id = 2671, name = "ham", weight = 2000, showCount = false},
	{
		id = 2672,
		name = "dragon ham",
		description = "It still contains a small part of the power of a dragon.",
		weight = 3000,
		showCount = false
	},
	{id = 2673, name = "pear", article = "a", weight = 140},
	{id = 2674, name = "red apple", article = "a", weight = 150},
	{id = 2675, name = "orange", article = "an", weight = 110},
	{id = 2676, name = "banana", article = "a", weight = 180},
	{id = 2677, name = "blueberry", article = "a", plural = "blueberries", weight = 20},
	{id = 2678, name = "coconut", article = "a", weight = 480},
	{id = 2679, name = "cherry", article = "a", plural = "cherries", weight = 20},
	{id = 2680, name = "strawberry", article = "a", plural = "strawberries", weight = 20},
	{id = 2681, name = "grapes", plural = "grapes", weight = 250, showCount = false},
	{id = 2682, name = "melon", article = "a", weight = 950},
	{id = 2683, name = "pumpkin", article = "a", weight = 1350},
	{id = 2684, name = "carrot", article = "a", weight = 160},
	{id = 2685, name = "tomato", article = "a", plural = "tomatoes", weight = 100},
	{id = 2686, name = "corncob", article = "a", weight = 350},
	{id = 2687, name = "cookie", article = "a", weight = 10},
	{id = 2688, name = "candy cane", article = "a", weight = 50},
	{id = 2689, name = "bread", article = "a", weight = 500},
	{id = 2690, name = "roll", article = "a", weight = 100},
	{id = 2691, name = "brown bread", article = "a", weight = 400},
	{id = 2692, name = "flour", weight = 100},
	{id = 2693, name = "lump of dough", article = "a", plural = "lumps of dough", weight = 100},
	{id = 2694, name = "bunch of wheat", article = "a", plural = "bunches of wheat", weight = 1250},
	{id = 2695, name = "egg", article = "an", weight = 30},
	{id = 2696, name = "cheese", weight = 400, showCount = false},
	{id = 2697, name = "snowy dead tree", article = "a"},
	{id = 2698, name = "snowy fir tree", article = "a"},
	{id = 2699, name = "holy tree", article = "a"},
	{id = 2700, name = "fir tree", article = "a"},
	{id = 2701, name = "sycamore", article = "a"},
	{id = 2702, name = "willow", article = "a"},
	{id = 2703, name = "plum tree", article = "a"},
	{id = 2704, name = "red maple", article = "a"},
	{id = 2705, name = "pear tree", article = "a"},
	{id = 2706, name = "yellow maple", article = "a"},
	{id = 2707, name = "beech", article = "a"},
	{id = 2708, name = "poplar", article = "a"},
	{fromId = 2709, toId = 2710, name = "dead tree", article = "a"},
	{id = 2711, name = "dwarf tree", article = "a"},
	{id = 2712, name = "pine", article = "a"},
	{fromId = 2713, toId = 2720, name = "dead tree", article = "a"},
	{id = 2721, name = "old rush wood"},
	{id = 2722, name = "old tree", article = "an"},
	{fromId = 2723, toId = 2724, name = "cactus", article = "a"},
	{id = 2725, name = "palm", article = "a"},
	{id = 2726, name = "coconut palm", article = "a"},
	{fromId = 2727, toId = 2732, name = "cactus", article = "a"},
	{id = 2733, name = "sun adorer cactus", article = "a"},
	{fromId = 2734, toId = 2736, name = "cactus", article = "a"},
	{id = 2737, name = "wheat", decayTo = 2738, duration = 240},
	{id = 2738, name = "wheat", description = "It is not mature yet.", decayTo = 2739, duration = 240},
	{id = 2739, name = "wheat"},
	{id = 2740, name = "moon flowers"},
	{id = 2741, name = "moon flower", article = "a", weight = 10},
	{id = 2742, name = "white flower", article = "a"},
	{id = 2743, name = "heaven blossom", article = "a"},
	{id = 2744, name = "red rose", article = "a", weight = 80},
	{id = 2745, name = "blue rose", article = "a", weight = 80},
	{id = 2746, name = "yellow rose", article = "a", weight = 80},
	{id = 2747, name = "grave flower", article = "a", weight = 60},
	{id = 2748, name = "love flower", article = "a"},
	{fromId = 2749, toId = 2751, name = "royal blossom", article = "a"},
	{id = 2752, name = "some sunflowers"},
	{id = 2753, name = "sunflower", article = "a"},
	{id = 2754, name = "tulip", article = "a", weight = 50},
	{fromId = 2755, toId = 2758, name = "water lily", article = "a"},
	{id = 2759, name = "orange star", article = "an", weight = 70},
	{id = 2760, name = "goat grass", article = "a", weight = 80},
	{id = 2761, name = "orchid", article = "an"},
	{fromId = 2762, toId = 2766, name = "rosebush", article = "a"},
	{id = 2767, name = "bush", article = "a"},
	{id = 2768, name = "small fir tree", article = "a"},
	{id = 2769, name = "shadow plant", article = "a"},
	{id = 2770, name = "branch", article = "a"},
	{id = 2771, name = "mire sprout", article = "a"},
	{id = 2772, name = "moon herb", article = "a"},
	{id = 2773, name = "mud whip", article = "a"},
	{id = 2774, name = "swamp reed", article = "a"},
	{id = 2775, name = "swamp lilly", article = "a"},
	{id = 2776, name = "dusk catcher", article = "a"},
	{id = 2777, name = "bog fingers plant", article = "a"},
	{id = 2778, name = "lady in the fog plant", article = "a"},
	{id = 2779, name = "frog leaf", article = "a"},
	{id = 2780, name = "sludge fern", article = "a"},
	{id = 2781, name = "jungle grass", decayTo = 2782, duration = 300},
	{id = 2782, name = "jungle grass"},
	{id = 2783, name = "agave", article = "an"},
	{id = 2784, name = "dry bush", article = "a"},
	{id = 2785, name = "blueberry bush", article = "a"},
	{id = 2786, name = "blueberry bush", article = "a", decayTo = 2785, duration = 300},
	{id = 2787, name = "white mushroom", article = "a", weight = 40},
	{id = 2788, name = "red mushroom", article = "a", weight = 50},
	{id = 2789, name = "brown mushroom", article = "a", weight = 20},
	{id = 2790, name = "orange mushroom", article = "an", weight = 30},
	{id = 2791, name = "wood mushroom", article = "a", weight = 30},
	{id = 2792, name = "dark mushroom", article = "a", weight = 10},
	{fromId = 2793, toId = 2794, name = "some mushrooms", plural = "some mushrooms", weight = 10, showCount = false},
	{id = 2795, name = "fire mushroom", article = "a", weight = 10},
	{id = 2796, name = "green mushroom", article = "a", weight = 10},
	{id = 2797, name = "dark mushrooms"},
	{id = 2798, name = "blood herb", article = "a", weight = 120},
	{id = 2799, name = "stone herb", article = "a", weight = 20},
	{id = 2800, name = "star herb", article = "a", weight = 30},
	{id = 2801, name = "fern", article = "a", weight = 30},
	{id = 2802, name = "sling herb", article = "a", weight = 90},
	{id = 2803, name = "powder herb", article = "a", weight = 50},
	{id = 2804, name = "shadow herb", article = "a", weight = 20},
	{id = 2805, name = "troll green", article = "a", weight = 100},
	{
		id = 2806,
		name = "dead troll",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 2810,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2807,
		name = "dead spider",
		article = "a",
		weight = 4600,
		containerSize = 10,
		decayTo = 3068,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 2808,
		name = "dead cyclops",
		article = "a",
		containerSize = 30,
		decayTo = 3117,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2809,
		name = "slain skeleton",
		article = "a",
		weight = 60000,
		containerSize = 28,
		decayTo = 2922,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{
		id = 2810,
		name = "dead troll",
		article = "a",
		weight = 50000,
		containerSize = 24,
		decayTo = 2811,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 2811, name = "dead troll", article = "a", weight = 30000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2813,
		name = "dead rat",
		article = "a",
		weight = 6300,
		containerSize = 10,
		decayTo = 2814,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2814,
		name = "dead rat",
		article = "a",
		weight = 4400,
		containerSize = 10,
		decayTo = 2815,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{id = 2815, name = "dead rat", article = "a", weight = 3000, decayTo = 2816, duration = 30, corpseType = RACE_BLOOD},
	{id = 2816, name = "dead rat", article = "a", weight = 2000, decayTo = 0, duration = 30, corpseType = RACE_BLOOD},
	{id = 2817, name = "dead snake", article = "a", weight = 1200, decayTo = 2818, duration = 600, corpseType = RACE_BLOOD},
	{id = 2818, name = "dead snake", article = "a", weight = 840, decayTo = 2819, duration = 600, corpseType = RACE_BLOOD},
	{id = 2819, name = "dead snake", article = "a", weight = 620, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2820,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 3080,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2821, name = "dead orc", article = "a", decayTo = 2966, duration = 600, corpseType = RACE_BLOOD},
	{id = 2822, name = "dead spider", article = "a", weight = 1000, decayTo = 2823, duration = 600, corpseType = RACE_VENOM},
	{id = 2823, name = "dead spider", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{id = 2824, name = "dead rotworm", article = "a", containerSize = 20, decayTo = 3085, duration = 600, corpseType = RACE_BLOOD},
	{id = 2825, name = "dead rotworm", article = "a", decayTo = 2964, duration = 900, corpseType = RACE_BLOOD},
	{
		id = 2826,
		name = "dead wolf",
		article = "a",
		weight = 26000,
		containerSize = 10,
		decayTo = 2827,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 2827,
		name = "dead wolf",
		article = "a",
		weight = 20000,
		containerSize = 10,
		decayTo = 2828,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 2828, name = "dead wolf", article = "a", weight = 8000, decayTo = 2829, duration = 600, corpseType = RACE_BLOOD},
	{id = 2829, name = "dead wolf", article = "a", weight = 4000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2830,
		name = "dead minotaur",
		article = "a",
		weight = 130000,
		containerSize = 30,
		decayTo = 2831,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 2831,
		name = "dead minotaur",
		article = "a",
		weight = 105000,
		containerSize = 30,
		decayTo = 2832,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 2832,
		name = "dead minotaur",
		article = "a",
		weight = 85000,
		containerSize = 30,
		decayTo = 2833,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 2833, name = "dead minotaur", article = "a", weight = 60000, decayTo = 2834, duration = 900, corpseType = RACE_BLOOD},
	{id = 2834, name = "pile of bones", article = "a", weight = 60000, decayTo = 0, duration = 900, corpseType = RACE_BLOOD},
	{
		id = 2835,
		name = "dead deer",
		article = "a",
		weight = 68000,
		containerSize = 5,
		decayTo = 2836,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 2836,
		name = "dead deer",
		article = "a",
		weight = 68000,
		containerSize = 5,
		decayTo = 2837,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{
		id = 2837,
		name = "dead deer",
		article = "a",
		weight = 5000,
		containerSize = 5,
		decayTo = 2838,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2838, name = "pile of bones", article = "a", weight = 5000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2839,
		name = "dead dog",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 2840,
		duration = 10,
		corpseType = RACE_BLOOD
	},
	{
		id = 2840,
		name = "dead dog",
		article = "a",
		weight = 21000,
		containerSize = 5,
		decayTo = 2841,
		duration = 60,
		corpseType = RACE_BLOOD
	},
	{id = 2841, name = "dead dog", article = "a", weight = 1000, decayTo = 2842, duration = 600, corpseType = RACE_BLOOD},
	{id = 2842, name = "dead dog", article = "a", weight = 700, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2843,
		name = "slain skeleton",
		article = "a",
		weight = 40000,
		containerSize = 28,
		decayTo = 2975,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{id = 2844, name = "dead dragon", article = "a", containerSize = 52, decayTo = 3104, duration = 900},
	{id = 2845, name = "dead dragon", article = "a", containerSize = 52, corpseType = RACE_BLOOD},
	{id = 2846, name = "dead dragon", article = "a", containerSize = 24, corpseType = RACE_BLOOD},
	{id = 2847, name = "dead dragon", article = "a"},
	{
		id = 2848,
		name = "dead spider",
		article = "a",
		weight = 9000,
		containerSize = 10,
		decayTo = 2885,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 2849, name = "dead bear", article = "a", containerSize = 20, decayTo = 2850, duration = 900, corpseType = RACE_BLOOD},
	{id = 2850, name = "dead bear", article = "a", decayTo = 2851, duration = 600, corpseType = RACE_BLOOD},
	{id = 2851, name = "dead bear", article = "a", decayTo = 2852, duration = 600, corpseType = RACE_BLOOD},
	{id = 2852, name = "dead bear", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2853, name = "slain ghoul", article = "a", weight = 60200, containerSize = 24, corpseType = RACE_UNDEAD},
	{fromId = 2854, toId = 2856, name = "slain ghoul", article = "a", weight = 60200, corpseType = RACE_UNDEAD},
	{
		id = 2857,
		name = "dead giant spider",
		article = "a",
		containerSize = 30,
		decayTo = 2858,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 2858,
		name = "dead giant spider",
		article = "a",
		containerSize = 30,
		decayTo = 2859,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{id = 2859, name = "dead giant spider", article = "a", decayTo = 0, duration = 900, corpseType = RACE_VENOM},
	{
		id = 2860,
		name = "dead orc",
		article = "a",
		weight = 120000,
		containerSize = 20,
		decayTo = 2861,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2861, name = "dead orc", article = "a", weight = 120000, decayTo = 2966, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2862,
		name = "dead orc",
		article = "a",
		weight = 120000,
		containerSize = 20,
		decayTo = 2863,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2863, name = "dead orc", article = "a", weight = 120000, decayTo = 2966, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2864,
		name = "dead orc",
		article = "a",
		weight = 120000,
		containerSize = 20,
		decayTo = 2865,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2865, name = "dead orc", article = "a", weight = 120000, decayTo = 2966, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2866,
		name = "dead minotaur",
		article = "a",
		weight = 140000,
		containerSize = 30,
		decayTo = 2867,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2867,
		name = "dead minotaur",
		article = "a",
		weight = 110000,
		containerSize = 30,
		decayTo = 2868,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{id = 2868, name = "dead minotaur", article = "a", weight = 67520, containerSize = 30, decayTo = 0, duration = 900},
	{
		id = 2871,
		name = "dead minotaur",
		article = "a",
		weight = 140000,
		containerSize = 30,
		decayTo = 2872,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2872,
		name = "dead minotaur",
		article = "a",
		weight = 110000,
		containerSize = 30,
		decayTo = 2873,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{id = 2873, name = "dead minotaur", article = "a", weight = 67520, containerSize = 30, decayTo = 0, duration = 900},
	{
		id = 2876,
		name = "dead minotaur",
		article = "a",
		weight = 150000,
		containerSize = 30,
		decayTo = 2877,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2877,
		name = "dead minotaur",
		article = "a",
		weight = 110000,
		containerSize = 30,
		decayTo = 2873,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{
		id = 2881,
		name = "dead dragon",
		article = "a",
		containerSize = 28,
		decayTo = 2882,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2882, name = "dead dragon", article = "a", containerSize = 52, decayTo = 2883, duration = 600, corpseType = RACE_BLOOD},
	{id = 2883, name = "dead dragon", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2884, name = "dead dragon", article = "a"},
	{id = 2885, name = "dead spider", article = "a", weight = 1000, decayTo = 2944, duration = 900, corpseType = RACE_VENOM},
	{
		id = 2886,
		name = "dead fire devil",
		article = "a",
		weight = 100000,
		containerSize = 10,
		decayTo = 2887,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 2887, name = "dead fire devil", article = "a", weight = 100000, decayTo = 2888, duration = 600, corpseType = RACE_BLOOD},
	{id = 2888, name = "dead fire devil", article = "a", weight = 100000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2889,
		name = "dead lion",
		article = "a",
		containerSize = 20,
		decayTo = 2890,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2890, name = "dead lion", article = "a", decayTo = 2891, duration = 600, corpseType = RACE_BLOOD},
	{id = 2891, name = "dead lion", article = "a", decayTo = 2892, duration = 600, corpseType = RACE_BLOOD},
	{id = 2892, name = "dead lion", article = "a", decayTo = 0, duration = 900, corpseType = RACE_BLOOD},
	{
		id = 2893,
		name = "dead bear",
		article = "a",
		containerSize = 20,
		decayTo = 2894,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2894, name = "dead bear", article = "a", decayTo = 2895, duration = 600, corpseType = RACE_BLOOD},
	{id = 2895, name = "dead bear", article = "a", decayTo = 2896, duration = 600, corpseType = RACE_BLOOD},
	{id = 2896, name = "dead bear", article = "a", decayTo = 0, duration = 900, corpseType = RACE_BLOOD},
	{
		id = 2897,
		name = "dead scorpion",
		article = "a",
		weight = 1000,
		containerSize = 10,
		decayTo = 2898,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 2898, name = "dead scorpion", article = "a", weight = 1000, decayTo = 2965, duration = 600, corpseType = RACE_VENOM},
	{
		id = 2899,
		name = "dead wasp",
		article = "a",
		weight = 1000,
		containerSize = 10,
		decayTo = 2900,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 2900, name = "dead wasp", article = "a", weight = 1000, decayTo = 2901, duration = 600, corpseType = RACE_VENOM},
	{id = 2901, name = "dead wasp", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 2902,
		name = "dead bug",
		article = "a",
		weight = 10000,
		containerSize = 10,
		decayTo = 2903,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{id = 2903, name = "dead bug", article = "a", weight = 10000, decayTo = 2904, duration = 600, corpseType = RACE_VENOM},
	{id = 2904, name = "dead bug", article = "a", weight = 10000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 2905,
		name = "dead sheep",
		article = "a",
		weight = 70000,
		containerSize = 5,
		decayTo = 2906,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2906,
		name = "dead sheep",
		article = "a",
		weight = 60000,
		containerSize = 5,
		decayTo = 2907,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{id = 2907, name = "dead sheep", article = "a", weight = 35000, decayTo = 0, duration = 3600, corpseType = RACE_BLOOD},
	{
		id = 2908,
		name = "dead bonelord",
		article = "a",
		containerSize = 32,
		decayTo = 2909,
		duration = 600,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 2909, name = "dead bonelord", article = "a", containerSize = 32, decayTo = 2910, duration = 600, corpseType = RACE_VENOM},
	{id = 2910, name = "dead bonelord", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{fromId = 2911, toId = 2912, name = "dead cyclops", article = "a"},
	{
		id = 2913,
		name = "remains of a ghost",
		weight = 1000,
		containerSize = 30,
		decayTo = 2977,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 2914,
		name = "dead sheep",
		article = "a",
		weight = 70000,
		containerSize = 5,
		decayTo = 2915,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{
		id = 2915,
		name = "dead sheep",
		article = "a",
		weight = 60000,
		containerSize = 5,
		decayTo = 2907,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{id = 2916, name = "slain demon", article = "a", containerSize = 30, decayTo = 2917, duration = 900, corpseType = RACE_FIRE},
	{id = 2917, name = "slain demon", article = "a", containerSize = 30, decayTo = 2918, duration = 600, corpseType = RACE_FIRE},
	{id = 2918, name = "slain demon", article = "a", containerSize = 30, decayTo = 2919, duration = 600, corpseType = RACE_FIRE},
	{id = 2919, name = "slain demon", article = "a", decayTo = 0, duration = 600, corpseType = RACE_FIRE},
	{
		id = 2920,
		name = "dead orc",
		article = "a",
		weight = 90000,
		containerSize = 20,
		decayTo = 2921,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2921, name = "dead orc", article = "a", weight = 90000, decayTo = 2966, duration = 600, corpseType = RACE_BLOOD},
	{id = 2922, name = "slain skeleton", article = "a", weight = 60000, decayTo = 2923, duration = 600, corpseType = RACE_UNDEAD},
	{id = 2923, name = "slain skeleton", article = "a", weight = 60000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 2924,
		name = "dead wolf",
		article = "a",
		weight = 8000,
		containerSize = 10,
		decayTo = 2925,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2925,
		name = "dead wolf",
		article = "a",
		weight = 8000,
		containerSize = 10,
		decayTo = 2926,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2926, name = "dead wolf", article = "a", weight = 8000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2927, name = "dead wolf", article = "a", weight = 4000, corpseType = RACE_BLOOD},
	{
		id = 2928,
		name = "dead troll",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 2929,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2929,
		name = "dead troll",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 2930,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2930, name = "dead troll", article = "a", weight = 60000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2931, name = "dead behemoth", article = "a", containerSize = 50, decayTo = 2932, duration = 900, corpseType = RACE_BLOOD},
	{id = 2932, name = "dead behemoth", article = "a", containerSize = 50, decayTo = 2933, duration = 600, corpseType = RACE_BLOOD},
	{id = 2933, name = "dead behemoth", article = "a", decayTo = 2934, duration = 600, corpseType = RACE_BLOOD},
	{id = 2934, name = "dead behemoth", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2935,
		name = "dead pig",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 2936,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2936,
		name = "dead pig",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 2937,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2937, name = "dead pig", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2938,
		name = "dead orc",
		article = "a",
		weight = 120000,
		containerSize = 20,
		decayTo = 2939,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2939, name = "dead orc", article = "a", weight = 120000, decayTo = 2966, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2940,
		name = "dead goblin",
		article = "a",
		weight = 4000,
		containerSize = 24,
		decayTo = 2941,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2941,
		name = "dead goblin",
		article = "a",
		weight = 4000,
		containerSize = 24,
		decayTo = 2942,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2942, name = "dead goblin", article = "a", weight = 4000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2943, name = "dead goblin", article = "a", weight = 4000},
	{id = 2944, name = "dead spider", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 2945,
		name = "dead elf",
		article = "a",
		weight = 100000,
		containerSize = 20,
		decayTo = 2946,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2946,
		name = "dead elf",
		article = "a",
		weight = 100000,
		containerSize = 20,
		decayTo = 2947,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2947, name = "dead elf", article = "a", weight = 60000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2948, name = "dead elf", article = "a", weight = 50000},
	{
		id = 2949,
		name = "remains of a mummy",
		weight = 1000,
		containerSize = 10,
		decayTo = 2950,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{id = 2950, name = "remains of a mummy", weight = 1000, decayTo = 2951, duration = 600, corpseType = RACE_UNDEAD},
	{id = 2951, name = "remains of a mummy", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 2952,
		name = "split stone golem",
		article = "a",
		containerSize = 30,
		decayTo = 2953,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 2953,
		name = "split stone golem",
		article = "a",
		containerSize = 30,
		decayTo = 2954,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 2954, name = "split stone golem", article = "a", decayTo = 2955, duration = 600, corpseType = RACE_UNDEAD},
	{id = 2955, name = "split stone golem", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 2956,
		name = "slain vampire",
		article = "a",
		weight = 100000,
		containerSize = 28,
		decayTo = 2957,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 2957,
		name = "slain vampire",
		article = "a",
		weight = 100000,
		containerSize = 28,
		decayTo = 2958,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 2958, name = "slain vampire", article = "a", weight = 100000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 2959, name = "slain vampire", article = "a", weight = 60000},
	{
		id = 2960,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2961,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2961,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2962,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2962, name = "dead dwarf", article = "a", weight = 80000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2963, name = "dead dwarf", article = "a", weight = 80000},
	{id = 2964, name = "dead rotworm", article = "a", weight = 10000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2965, name = "dead scorpion", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{id = 2966, name = "dead orc", article = "a", weight = 10000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2967,
		name = "dead orc",
		article = "a",
		weight = 120000,
		containerSize = 20,
		decayTo = 2968,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2968,
		name = "dead orc",
		article = "a",
		weight = 120000,
		containerSize = 20,
		decayTo = 2966,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{
		id = 2969,
		name = "dead war wolf",
		article = "a",
		containerSize = 20,
		decayTo = 2970,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2970, name = "dead war wolf", article = "a", containerSize = 20, decayTo = 2971, duration = 600, corpseType = RACE_BLOOD},
	{id = 2971, name = "dead war wolf", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2972,
		name = "dead orc and wolf",
		article = "a",
		containerSize = 24,
		decayTo = 2973,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2973,
		name = "dead orc and wolf",
		article = "a",
		containerSize = 24,
		decayTo = 2974,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 2974, name = "dead orc and wolf", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2975,
		name = "slain skeleton",
		article = "a",
		weight = 10000,
		containerSize = 28,
		decayTo = 2976,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 2976, name = "slain skeleton", article = "a", weight = 10000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 2977,
		name = "remains of a ghost",
		weight = 1000,
		containerSize = 10,
		decayTo = 2978,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 2978, name = "remains of a ghost", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 2979,
		name = "dead elf",
		article = "a",
		weight = 100000,
		containerSize = 32,
		decayTo = 2980,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2980, name = "dead elf", article = "a", weight = 100000, containerSize = 32, decayTo = 2947, duration = 600},
	{
		id = 2981,
		name = "dead elf",
		article = "a",
		weight = 100000,
		containerSize = 20,
		decayTo = 2982,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2982,
		name = "dead elf",
		article = "a",
		weight = 100000,
		containerSize = 20,
		decayTo = 2947,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{
		id = 2983,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2984,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2984,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2962,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{
		id = 2985,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2986,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2986,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2962,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{
		id = 2987,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2988,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 2988,
		name = "dead dwarf",
		article = "a",
		weight = 80000,
		containerSize = 24,
		decayTo = 2962,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{
		id = 2989,
		name = "dead djinn",
		article = "a",
		containerSize = 36,
		decayTo = 2990,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 2990, name = "dead djinn", article = "a", containerSize = 36, decayTo = 2991, duration = 600, corpseType = RACE_BLOOD},
	{id = 2991, name = "dead djinn", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 2992, name = "dead rabbit", article = "a", weight = 1000, containerSize = 5, corpseType = RACE_BLOOD},
	{id = 2993, name = "dead rabbit", article = "a", weight = 3070},
	{id = 2994, name = "dead rabbit", article = "a", weight = 2070},
	{
		id = 2995,
		name = "dead swamp troll",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 2996,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 2996, name = "dead swamp troll", article = "a", weight = 60000, decayTo = 2997, duration = 600, corpseType = RACE_BLOOD},
	{id = 2997, name = "dead troll", article = "a", weight = 60000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 2998,
		name = "slain banshee",
		article = "a",
		weight = 1000,
		containerSize = 44,
		decayTo = 2999,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 2999,
		name = "slain banshee",
		article = "a",
		weight = 1000,
		containerSize = 44,
		decayTo = 3000,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 3000, name = "slain banshee", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3001, name = "dead djinn", article = "a", containerSize = 36, decayTo = 3002, duration = 600},
	{id = 3002, name = "dead djinn", article = "a", containerSize = 36, decayTo = 2991, duration = 600},
	{id = 3003, name = "dead djinn", article = "a"},
	{
		id = 3004,
		name = "dead scarab",
		article = "a",
		containerSize = 16,
		decayTo = 3005,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 3005, name = "dead scarab", article = "a", containerSize = 16, decayTo = 3006, duration = 600, corpseType = RACE_VENOM},
	{id = 3006, name = "dead scarab", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 3007,
		name = "dead cobra",
		article = "a",
		containerSize = 10,
		weight = 6000,
		decayTo = 3008,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 3008, name = "dead cobra", article = "a", weight = 6000, decayTo = 3009, duration = 600, corpseType = RACE_BLOOD},
	{id = 3009, name = "dead cobra", article = "a", weight = 6000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3010,
		name = "dead larva",
		article = "a",
		weight = 1000,
		containerSize = 6,
		decayTo = 3011,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 3011, name = "dead larva", article = "a", weight = 1000, decayTo = 3012, duration = 600, corpseType = RACE_VENOM},
	{id = 3012, name = "dead larva", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 3013,
		name = "dead scarab",
		article = "a",
		weight = 2000,
		containerSize = 32,
		decayTo = 3014,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 3014, name = "dead scarab", article = "a", weight = 2000, decayTo = 3015, duration = 600, corpseType = RACE_VENOM},
	{id = 3015, name = "dead scarab", article = "a", weight = 2000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{id = 3016, name = "dead pharaoh", article = "a", containerSize = 10, decayTo = 3017, duration = 900, corpseType = RACE_UNDEAD},
	{id = 3017, name = "dead pharaoh", article = "a", containerSize = 10, decayTo = 3018, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3018, name = "dead pharaoh", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 3019,
		name = "dead hyaena",
		article = "a",
		weight = 8000,
		containerSize = 14,
		decayTo = 3020,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 3020,
		name = "dead hyaena",
		article = "a",
		weight = 8000,
		containerSize = 14,
		decayTo = 3021,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 3021, name = "dead hyaena", article = "a", weight = 8000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 3022, name = "dead gargoyle", article = "a", containerSize = 28, decayTo = 3023, duration = 900, corpseType = RACE_UNDEAD},
	{id = 3023, name = "dead gargoyle", article = "a", decayTo = 3024, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3024, name = "dead gargoyle", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3025, name = "slain lich", article = "a", containerSize = 30, decayTo = 3026, duration = 900, corpseType = RACE_UNDEAD},
	{id = 3026, name = "slain lich", article = "a", decayTo = 3027, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3027, name = "slain lich", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 3028,
		name = "slain crypt shambler",
		article = "a",
		weight = 100000,
		containerSize = 24,
		decayTo = 3029,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 3029,
		name = "slain crypt shambler",
		article = "a",
		weight = 100000,
		decayTo = 3030,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 3030, name = "slain crypt shambler", article = "a", weight = 100000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 3031,
		name = "slain bonebeast",
		article = "a",
		containerSize = 24,
		decayTo = 3032,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 3032,
		name = "slain bonebeast",
		article = "a",
		containerSize = 24,
		decayTo = 3033,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 3033, name = "slain bonebeast", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3034, name = "dead pharaoh", article = "a", containerSize = 10, decayTo = 3035, duration = 900, corpseType = RACE_UNDEAD},
	{id = 3035, name = "dead pharaoh", article = "a", containerSize = 10, decayTo = 3036, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3036, name = "dead pharaoh", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 3037,
		name = "dead efreet",
		article = "a",
		containerSize = 36,
		decayTo = 3038,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3038, name = "dead efreet", article = "a", containerSize = 36, decayTo = 3039, duration = 600, corpseType = RACE_BLOOD},
	{id = 3039, name = "dead efreet", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3040,
		name = "dead marid",
		article = "a",
		containerSize = 36,
		decayTo = 3041,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3041, name = "dead marid", article = "a", containerSize = 36, decayTo = 3042, duration = 600, corpseType = RACE_BLOOD},
	{id = 3042, name = "dead marid", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3043,
		name = "dead badger",
		article = "a",
		weight = 1000,
		containerSize = 20,
		decayTo = 3044,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 3044,
		name = "dead badger",
		article = "a",
		weight = 1000,
		containerSize = 20,
		decayTo = 3045,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 3045, name = "dead badger", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3046,
		name = "dead skunk",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 3047,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3047, name = "dead skunk", article = "a", weight = 1000, decayTo = 3048, duration = 600, corpseType = RACE_BLOOD},
	{id = 3048, name = "dead skunk", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3049,
		name = "dead gazer",
		article = "a",
		weight = 1000,
		containerSize = 6,
		decayTo = 3050,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{id = 3050, name = "dead gazer", article = "a", weight = 1000, decayTo = 3051, duration = 600, corpseType = RACE_VENOM},
	{id = 3051, name = "dead gazer", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 3052,
		name = "dead elder bonelord",
		article = "a",
		containerSize = 38,
		decayTo = 3053,
		duration = 600,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 3053, name = "dead elder bonelord", article = "a", decayTo = 3054, duration = 600, corpseType = RACE_VENOM},
	{id = 3054, name = "dead elder bonelord", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 3055,
		name = "dead yeti",
		article = "a",
		containerSize = 10,
		decayTo = 3056,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3056, name = "dead yeti", article = "a", decayTo = 3057, duration = 600, corpseType = RACE_BLOOD},
	{id = 3057, name = "dead yeti", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3058,
		name = "dead human",
		article = "a",
		containerSize = 10,
		decayTo = 3059,
		duration = 1200,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3059, name = "dead human", article = "a", containerSize = 10, decayTo = 3060, duration = 1200, corpseType = RACE_BLOOD},
	{id = 3060, name = "dead human", article = "a", weight = 50000, decayTo = 0, duration = 1200, corpseType = RACE_BLOOD},
	{fromId = 3061, toId = 3063, name = "dead human", article = "a", weight = 60000},
	{id = 3064, name = "dead human", article = "a", weight = 50000, decayTo = 0, duration = 1200, corpseType = RACE_BLOOD},
	{id = 3065, name = "dead human", article = "a", containerSize = 10, decayTo = 3066, duration = 1200, corpseType = RACE_BLOOD},
	{id = 3066, name = "dead human", article = "a", containerSize = 10, decayTo = 3064, duration = 1200, corpseType = RACE_BLOOD},
	{
		id = 3067,
		name = "dead troll",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 2806,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 3068,
		name = "dead spider",
		article = "a",
		weight = 1000,
		containerSize = 10,
		decayTo = 2822,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{
		id = 3069,
		name = "dead cyclops",
		article = "a",
		containerSize = 30,
		decayTo = 2808,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3070, name = "dead troll", article = "a", weight = 25040, decayTo = 3071, duration = 600, corpseType = RACE_BLOOD},
	{id = 3071, name = "dead troll", article = "a", weight = 20040, decayTo = 3072, duration = 600, corpseType = RACE_BLOOD},
	{id = 3072, name = "dead troll", article = "a", weight = 20040, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3073,
		name = "dead rat",
		article = "a",
		weight = 6300,
		containerSize = 10,
		decayTo = 2813,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3074, name = "dead rat", article = "a", weight = 4400, decayTo = 3075, duration = 300, corpseType = RACE_BLOOD},
	{id = 3075, name = "dead rat", article = "a", weight = 3000, decayTo = 3076, duration = 30, corpseType = RACE_BLOOD},
	{id = 3076, name = "dead rat", article = "a", weight = 3000, decayTo = 0, duration = 30, corpseType = RACE_BLOOD},
	{id = 3077, name = "dead snake", article = "a", weight = 1200, decayTo = 3078, duration = 600},
	{id = 3078, name = "dead snake", article = "a", weight = 800, decayTo = 3079, duration = 600},
	{id = 3079, name = "dead snake", article = "a", weight = 500, decayTo = 0, duration = 600},
	{
		id = 3080,
		name = "dead orc",
		article = "a",
		weight = 16740,
		containerSize = 20,
		decayTo = 2821,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3081, name = "dead orc", article = "a", weight = 70000},
	{id = 3082, name = "dead spider", article = "a", containerSize = 10, weight = 4600},
	{id = 3083, name = "dead spider", article = "a", weight = 4000},
	{
		id = 3084,
		name = "dead rotworm",
		article = "a",
		weight = 8500,
		containerSize = 20,
		decayTo = 2824,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3085, name = "dead rotworm", article = "a", weight = 8000, containerSize = 20, decayTo = 2825, duration = 600},
	{
		id = 3086,
		name = "dead wolf",
		article = "a",
		weight = 11950,
		containerSize = 6,
		decayTo = 3087,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 3087,
		name = "dead wolf",
		article = "a",
		weight = 11500,
		containerSize = 6,
		decayTo = 3088,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 3088, name = "dead wolf", article = "a", weight = 8000, decayTo = 3089, duration = 600, corpseType = RACE_BLOOD},
	{id = 3089, name = "pile of bones", article = "a", weight = 8000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3090,
		name = "dead minotaur",
		article = "a",
		weight = 130000,
		containerSize = 30,
		decayTo = 3091,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3091, name = "dead minotaur", article = "a", weight = 105000, containerSize = 30, decayTo = 3092, duration = 300},
	{id = 3092, name = "dead minotaur", article = "a", weight = 85000, containerSize = 30, decayTo = 3093, duration = 300},
	{id = 3093, name = "dead minotaur", article = "a", weight = 85000, decayTo = 3094, duration = 300},
	{id = 3094, name = "dead minotaur", article = "a", weight = 85000, decayTo = 0, duration = 300},
	{
		id = 3095,
		name = "dead deer",
		article = "a",
		weight = 25000,
		containerSize = 5,
		decayTo = 3096,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3096, name = "dead deer", article = "a", weight = 24000, containerSize = 5, decayTo = 3097, duration = 600},
	{id = 3097, name = "dead deer", article = "a", weight = 21000, containerSize = 5, decayTo = 3098, duration = 600},
	{id = 3098, name = "dead deer", article = "a", weight = 21000, decayTo = 0, duration = 600},
	{
		id = 3099,
		name = "dead dog",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 2840,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3100, name = "dead dog", article = "a", weight = 1000, containerSize = 5},
	{id = 3101, name = "dead dog", article = "a", weight = 700},
	{fromId = 3102, toId = 3103, name = "pile of bones", article = "a"},
	{
		id = 3104,
		name = "dead dragon",
		article = "a",
		containerSize = 52,
		decayTo = 3105,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3105, name = "dead dragon", article = "a", containerSize = 52, decayTo = 3106, duration = 600, corpseType = RACE_BLOOD},
	{id = 3106, name = "dead dragon", article = "a", containerSize = 52, decayTo = 3107, duration = 600, corpseType = RACE_BLOOD},
	{id = 3107, name = "dead dragon", article = "a", decayTo = 0, duration = 600},
	{
		id = 3108,
		name = "remains of a ghost",
		weight = 1000,
		containerSize = 10,
		decayTo = 2977,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{
		id = 3109,
		name = "dead bear",
		article = "a",
		containerSize = 20,
		decayTo = 3110,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 3110, name = "dead bear", article = "a", containerSize = 20, decayTo = 3111, duration = 600},
	{id = 3111, name = "dead bear", article = "a", containerSize = 20, decayTo = 3112, duration = 600},
	{id = 3112, name = "pile of bones", article = "a", decayTo = 0, duration = 600},
	{
		id = 3113,
		name = "slain ghoul",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 3114,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 3114,
		name = "slain ghoul",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 3115,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 3115, name = "slain ghoul", article = "a", weight = 60000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 3116, name = "pile of bones", article = "a", weight = 60200},
	{id = 3117, name = "dead cyclops", article = "a", decayTo = 3118, duration = 600, corpseType = RACE_BLOOD},
	{id = 3118, name = "pile of bones", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 3119,
		name = "dead rabbit",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 3120,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 3120,
		name = "dead rabbit",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 3121,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 3121, name = "dead rabbit", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{fromId = 3122, toId = 3127, name = "pile of bones", article = "a"},
	{id = 3128, name = "dead human", article = "a", containerSize = 10, decayTo = 3129, duration = 300, corpseType = RACE_BLOOD},
	{id = 3129, name = "dead human", article = "a", containerSize = 8, decayTo = 3130, duration = 900, corpseType = RACE_BLOOD},
	{id = 3130, name = "corpse", article = "a", weight = 120000, decayTo = 3131, duration = 30, corpseType = RACE_BLOOD},
	{id = 3131, name = "corpse", article = "a", weight = 120000, decayTo = 3132, duration = 30, corpseType = RACE_BLOOD},
	{id = 3132, name = "skeleton", article = "a", weight = 120000, decayTo = 3133, duration = 30, corpseType = RACE_BLOOD},
	{id = 3133, name = "skeleton", article = "a", weight = 60000, decayTo = 3134, duration = 30, corpseType = RACE_BLOOD},
	{id = 3134, name = "some bones", weight = 60000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{fromId = 3135, toId = 3136, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 3137, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 3138, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 3139, toId = 3151, name = "wooden floor"},
	{fromId = 3152, toId = 3157, name = "stone floor"},
	{fromId = 3158, toId = 3165, name = "large stone carving", article = "a"},
	{fromId = 3166, toId = 3168, name = "carved stone tile", article = "a"},
	{id = 3169, name = "carved stone tile", article = "a", type = ITEM_TYPE_TELEPORT},
	{fromId = 3170, toId = 3172, name = "carved stone tile", article = "a"},
	{fromId = 3173, toId = 3181, name = "ornamented floor"},
	{fromId = 3182, toId = 3189, name = "stone floor"},
	{fromId = 3190, toId = 3198, name = "ornamented floor"},
	{fromId = 3199, toId = 3214, name = "snake ornament", article = "a"},
	{id = 3215, name = "stone floor"},
	{fromId = 3216, toId = 3217, name = "wooden floor", description = "It seems to be a switch.", walkStack = false},
	{id = 3218, name = "stone floor"},
	{fromId = 3219, toId = 3220, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 3221, toId = 3223, name = "stone floor"},
	{fromId = 3224, toId = 3225, name = "wooden floor"},
	{fromId = 3226, toId = 3241, name = "broken stone tile", article = "a"},
	{fromId = 3242, toId = 3245, name = "wooden floor"},
	{id = 3263, name = "jungle grass"},
	{fromId = 3264, toId = 3265, name = "earth"},
	{fromId = 3298, toId = 3309, name = "jungle grass"},
	{id = 3310, name = "pitfall", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 3311, name = "pitfall", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 3310, duration = 60},
	{id = 3312, name = "ant trail", article = "an"},
	{id = 3313, name = "bug tral", article = "a"},
	{fromId = 3314, toId = 3322, name = "ant trail", article = "an"},
	{id = 3323, name = "ant-hill", article = "an"},
	{id = 3324, name = "earth hole", article = "an", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 3325, toId = 3347, name = "stone", article = "a"},
	{fromId = 3348, toId = 3360, name = "dried grass roof", article = "a"},
	{fromId = 3361, toId = 3375, name = "stone wall", article = "a"},
	{id = 3376, name = "stone wall window", article = "a"},
	{fromId = 3377, toId = 3381, name = "stone wall", article = "a"},
	{id = 3382, name = "stone wall window", article = "a"},
	{fromId = 3383, toId = 3391, name = "stone wall", article = "a"},
	{id = 3392, name = "stone wall window", article = "a"},
	{fromId = 3393, toId = 3396, name = "stone wall", article = "a"},
	{id = 3397, name = "stone wall window", article = "a"},
	{fromId = 3398, toId = 3409, name = "stone wall", article = "a"},
	{fromId = 3410, toId = 3411, name = "stone wall window", article = "a"},
	{fromId = 3412, toId = 3422, name = "stone wall", article = "a"},
	{fromId = 3423, toId = 3433, name = "bamboo wall", article = "a"},
	{fromId = 3434, toId = 3436, name = "bamboo palisade", article = "a"},
	{fromId = 3437, toId = 3438, name = "bamboo fence", article = "a"},
	{fromId = 3439, toId = 3446, name = "archway", article = "an"},
	{fromId = 3447, toId = 3448, name = "bamboo wall", article = "a"},
	{id = 3449, name = "bamboo wall window", article = "a"},
	{fromId = 3450, toId = 3451, name = "bamboo wall", article = "a"},
	{id = 3452, name = "bamboo wall window", article = "a"},
	{id = 3453, name = "bamboo palisade", article = "a"},
	{fromId = 3454, toId = 3467, name = "stone wall", article = "a"},
	{id = 3468, name = "archway", article = "an"},
	{fromId = 3469, toId = 3471, name = "stone wall", article = "a"},
	{id = 3472, name = "archway", article = "an"},
	{fromId = 3473, toId = 3475, name = "stone wall", article = "a"},
	{fromId = 3476, toId = 3479, name = "archway", article = "an"},
	{fromId = 3480, toId = 3483, name = "stone wall", article = "a"},
	{fromId = 3484, toId = 3495, name = "broken stone wall", article = "a"},
	{fromId = 3496, toId = 3498, name = "grass wall", article = "a"},
	{id = 3499, name = "grass wall window", article = "a"},
	{fromId = 3500, toId = 3501, name = "grass wall", article = "a"},
	{id = 3502, name = "grass wall window", article = "a"},
	{id = 3503, name = "grass wall", article = "a"},
	{fromId = 3504, toId = 3505, name = "grass archway", article = "a"},
	{fromId = 3506, toId = 3507, name = "liane", article = "a"},
	{fromId = 3508, toId = 3528, name = "palisade", article = "a"},
	{id = 3529, name = "temple wall", article = "a"},
	{fromId = 3530, toId = 3532, name = "palisade", article = "a"},
	{fromId = 3533, toId = 3534, name = "stone wall", article = "a"},
	{id = 3535, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 3536, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 3537, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 3538, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 3539, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 3540, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 3541, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 3542, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 3543, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 3544, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 3545, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 3546, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 3547, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 3548, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 3549, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 3550, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 3551, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 3552, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 3569, toId = 3574, name = "waterfall", article = "a"},
	{id = 3587, name = "small boat", article = "a"},
	{fromId = 3588, toId = 3590, name = "small boat", article = "a", type = ITEM_TYPE_TELEPORT},
	{fromId = 3591, toId = 3592, name = "small boat", article = "a"},
	{fromId = 3593, toId = 3595, name = "small boat", article = "a", type = ITEM_TYPE_TELEPORT},
	{id = 3596, name = "small boat", article = "a"},
	{fromId = 3597, toId = 3598, name = "small sail", article = "a"},
	{fromId = 3599, toId = 3600, name = "paddle", article = "a"},
	{fromId = 3601, toId = 3602, name = "mast", article = "a"},
	{fromId = 3603, toId = 3606, name = "mossy stone", article = "a"},
	{id = 3607, name = "stone", article = "a"},
	{id = 3608, name = "stones"},
	{id = 3609, name = "stone", article = "a"},
	{fromId = 3610, toId = 3611, name = "stones"},
	{id = 3612, name = "stone", article = "a"},
	{fromId = 3613, toId = 3614, name = "stones"},
	{fromId = 3615, toId = 3631, name = "stone", article = "a"},
	{fromId = 3632, toId = 3647, name = "mossy stone", article = "a"},
	{fromId = 3648, toId = 3656, name = "debris"},
	{fromId = 3657, toId = 3670, name = "stone", article = "a"},
	{fromId = 3671, toId = 3677, name = "painted stone", article = "a"},
	{id = 3678, name = "ladder", article = "a"},
	{id = 3679, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_EAST},
	{id = 3680, name = "ramp", article = "a"},
	{id = 3681, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 3682, name = "ramp", article = "a"},
	{id = 3683, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH},
	{id = 3684, name = "ramp", article = "a"},
	{id = 3685, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 3686, name = "ramp", article = "a"},
	{id = 3687, name = "stone stairs", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 3688, name = "stone stairs", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{fromId = 3689, toId = 3696, name = "large cauldron", article = "a"},
	{fromId = 3697, toId = 3700, name = "sacred statue", article = "a"},
	{fromId = 3701, toId = 3704, name = "broken lizard statue", article = "a"},
	{fromId = 3705, toId = 3708, name = "lizard statue", article = "a"},
	{id = 3709, name = "small pagoda", article = "a"},
	{id = 3710, name = "small lit pagoda", article = "a"},
	{id = 3711, name = "stone snake wall", article = "a"},
	{id = 3712, name = "snake wall", article = "a"},
	{id = 3713, name = "stone snake wall", article = "a"},
	{id = 3714, name = "snake wall", article = "a"},
	{fromId = 3715, toId = 3722, name = "giant lizard head", article = "a"},
	{fromId = 3723, toId = 3726, name = "giant lizard claw", article = "a"},
	{id = 3727, name = "stone snake wall", article = "a"},
	{id = 3728, name = "stone snake pagoda", article = "a"},
	{fromId = 3729, toId = 3732, name = "dried well", article = "a"},
	{fromId = 3733, toId = 3736, name = "poison well", article = "a", fluidSource = FLUID_SLIME},
	{fromId = 3737, toId = 3738, name = "pagoda", article = "a"},
	{fromId = 3739, toId = 3742, name = "huntress statue", article = "a"},
	{id = 3743, name = "bamboo lamp", article = "a"},
	{id = 3744, name = "skull candle", article = "a"},
	{fromId = 3745, toId = 3751, name = "bamboo column", article = "a"},
	{fromId = 3752, toId = 3755, name = "bamboo pole", article = "a"},
	{fromId = 3756, toId = 3757, name = "rope bridge", article = "a"},
	{fromId = 3758, toId = 3761, name = "short pillar", article = "a"},
	{fromId = 3762, toId = 3765, name = "rope bridge", article = "a"},
	{id = 3766, name = "stone pillar", article = "a"},
	{id = 3767, name = "broken stone pillar", article = "a"},
	{fromId = 3768, toId = 3791, name = "rope railing", article = "a"},
	{id = 3792, name = "stone pillar", article = "a"},
	{id = 3793, name = "broken stone pillar", article = "a"},
	{fromId = 3794, toId = 3797, name = "wooden bars"},
	{id = 3798, name = "wooden bars", description = "They already have some cracks and look rather fragile.", destroyTo = 3959},
	{id = 3799, name = "wooden bars", description = "They already have some cracks and look rather fragile.", destroyTo = 3958},
	{fromId = 3800, toId = 3801, name = "wooden bars"},
	{id = 3802, name = "small totem pole", article = "a"},
	{id = 3803, name = "large totem pole", article = "a"},
	{id = 3804, name = "totem pole", article = "a"},
	{id = 3805, name = "carved stone table", article = "a", rotateTo = 3806, destroyTo = 2259},
	{id = 3806, name = "carved stone table", article = "a", rotateTo = 3805, destroyTo = 2259},
	{id = 3807, name = "tusk table", article = "a", rotateTo = 3808, destroyTo = 2253},
	{id = 3808, name = "tusk table", article = "a", rotateTo = 3807, destroyTo = 2253},
	{id = 3809, name = "bamboo table", article = "a", rotateTo = 3810, destroyTo = 2253},
	{id = 3810, name = "bamboo table", article = "a", rotateTo = 3809, destroyTo = 2253},
	{id = 3811, name = "thick trunk", article = "a"},
	{id = 3812, name = "ornamented stone table", article = "an"},
	{id = 3813, name = "tusk chair", article = "a", rotateTo = 3816, destroyTo = 2253},
	{id = 3814, name = "tusk chair", article = "a", rotateTo = 3815, destroyTo = 2253},
	{id = 3815, name = "tusk chair", article = "a", rotateTo = 3813, destroyTo = 2253},
	{id = 3816, name = "tusk chair", article = "a", rotateTo = 3814, destroyTo = 2253},
	{id = 3817, name = "ivory chair", article = "an", rotateTo = 3820, destroyTo = 2253},
	{id = 3818, name = "ivory chair", article = "an", rotateTo = 3819, destroyTo = 2253},
	{id = 3819, name = "ivory chair", article = "an", rotateTo = 3817, destroyTo = 2253},
	{id = 3820, name = "ivory chair", article = "an", rotateTo = 3818, destroyTo = 2253},
	{id = 3821, name = "small trunk", article = "a"},
	{fromId = 3822, toId = 3825, name = "bamboo wardrobe", article = "a", containerSize = 6},
	{fromId = 3826, toId = 3827, name = "bamboo shelf", article = "a", containerSize = 6},
	{fromId = 3828, toId = 3831, name = "small bamboo shelf", article = "a", containerSize = 6},
	{id = 3832, name = "bamboo drawer", article = "a", rotateTo = 3835, containerSize = 6},
	{id = 3833, name = "bamboo drawer", article = "a", rotateTo = 3832, containerSize = 6},
	{id = 3834, name = "bamboo drawer", article = "a", rotateTo = 3833, containerSize = 6},
	{id = 3835, name = "bamboo drawer", article = "a", rotateTo = 3834, containerSize = 6},
	{id = 3836, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 3840},
	{id = 3837, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 3841},
	{id = 3838, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 3842},
	{id = 3839, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 3843},
	{id = 3840, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 3836},
	{id = 3841, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 3837},
	{id = 3842, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 3838},
	{id = 3843, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 3839},
	{fromId = 3844, toId = 3847, name = "grass mat", article = "a"},
	{fromId = 3848, toId = 3851, name = "straw mat", article = "a"},
	{fromId = 3852, toId = 3855, name = "brown bear fur", article = "a"},
	{fromId = 3856, toId = 3859, name = "polar bear fur", article = "a"},
	{id = 3860, name = "badger fur", article = "a"},
	{fromId = 3861, toId = 3862, name = "feather decoration", article = "a"},
	{fromId = 3863, toId = 3866, name = "dried fur", article = "a"},
	{fromId = 3867, toId = 3868, name = "tanned brown bear fur"},
	{fromId = 3869, toId = 3870, name = "tanned polar bear fur"},
	{id = 3871, name = "pile of chopped wood", article = "a"},
	{id = 3872, name = "block of wood", article = "a", description = "It's a lumberjack's working place."},
	{id = 3873, name = "some pieces of wood"},
	{fromId = 3874, toId = 3881, name = "fishing net", article = "a"},
	{fromId = 3882, toId = 3895, name = "giant footprint", article = "a"},
	{fromId = 3896, toId = 3897, name = "tanned tiger fur"},
	{fromId = 3898, toId = 3899, name = "tiger fur", article = "a"},
	{id = 3900, name = "sundial", article = "a"},
	{
		id = 3901,
		name = "red cushioned chair kit",
		article = "a",
		description = "Use it in your house to construct a red cushioned chair.",
		weight = 2500
	},
	{
		id = 3902,
		name = "green cushioned chair kit",
		article = "a",
		description = "Use it in your house to construct a green cushioned chair.",
		weight = 2500
	},
	{
		id = 3903,
		name = "wooden chair kit",
		article = "a",
		description = "Use it in your house to construct a wooden chair.",
		weight = 2500
	},
	{
		id = 3904,
		name = "rocking chair kit",
		article = "a",
		description = "Use it in your house to construct a rocking chair.",
		weight = 2500
	},
	{
		id = 3905,
		name = "sofa chair kit",
		article = "a",
		description = "Use it in your house to construct a sofa chair.",
		weight = 2500
	},
	{
		id = 3906,
		name = "tusk chair kit",
		article = "a",
		description = "Use it in your house to construct a tusk chair.",
		weight = 2500
	},
	{
		id = 3907,
		name = "ivory chair kit",
		article = "an",
		description = "Use it in your house to construct an ivory chair.",
		weight = 2500
	},
	{
		id = 3908,
		name = "small table kit",
		article = "a",
		description = "Use it in your house to construct a small table.",
		weight = 2500
	},
	{
		id = 3909,
		name = "christmas tree package",
		article = "a",
		description = "Use it in your house to reveal a christmas tree.",
		weight = 3500
	},
	{id = 3910, name = "snowman package", article = "a", description = "Use it in your house to reveal a snowman.", weight = 3500},
	{id = 3911, name = "big table kit", article = "a", description = "Use it in your house to construct a big table.", weight = 3500},
	{
		id = 3912,
		name = "stone table kit",
		article = "a",
		description = "Use it in your house to construct a stone table.",
		weight = 3500
	},
	{
		id = 3913,
		name = "tusk table kit",
		article = "a",
		description = "Use it in your house to construct a tusk table.",
		weight = 3500
	},
	{
		id = 3914,
		name = "bamboo table kit",
		article = "a",
		description = "Use it in your house to construct a bamboo table.",
		weight = 3500
	},
	{id = 3915, name = "drawer kit", article = "a", description = "Use it in your house to construct a drawer.", weight = 2500},
	{id = 3916, name = "dresser kit", article = "a", description = "Use it in your house to construct a dresser.", weight = 2500},
	{id = 3917, name = "locker kit", article = "a", description = "Use it in your house to construct a locker.", weight = 3000},
	{id = 3918, name = "trough kit", article = "a", description = "Use it in your house to construct a trough.", weight = 3000},
	{id = 3919, name = "barrel kit", article = "a", description = "Use it in your house to construct a barrel.", weight = 3500},
	{id = 3920, name = "trunk kit", article = "a", description = "Use it in your house to construct a trunk.", weight = 3500},
	{
		id = 3921,
		name = "bamboo drawer kit",
		article = "a",
		description = "Use it in your house to construct a bamboo drawer.",
		weight = 3500
	},
	{id = 3922, name = "birdcage kit", article = "a", description = "Use it in your house to construct a birdcage.", weight = 2000},
	{id = 3923, name = "globe kit", article = "a", description = "Use it in your house to construct a globe.", weight = 2000},
	{
		id = 3924,
		name = "table lamp kit",
		article = "a",
		description = "Use it in your house to construct a table lamp.",
		weight = 2000
	},
	{id = 3925, name = "telescope kit", article = "a", description = "Use it in your house to construct a telescope.", weight = 2500},
	{
		id = 3926,
		name = "rocking horse kit",
		article = "a",
		description = "Use it in your house to construct a rocking horse.",
		weight = 3500
	},
	{
		id = 3927,
		name = "pendulum clock kit",
		article = "a",
		description = "Use it in your house to construct a pendulum clock.",
		weight = 3000
	},
	{
		id = 3928,
		name = "knight statue kit",
		article = "a",
		description = "Use it in your house to construct a knight statue.",
		weight = 3000
	},
	{
		id = 3929,
		name = "minotaur statue kit",
		article = "a",
		description = "Use it in your house to construct a minotaur statue.",
		weight = 3000
	},
	{
		id = 3930,
		name = "goblin statue kit",
		article = "a",
		description = "Use it in your house to construct a goblin statue.",
		weight = 2500
	},
	{
		id = 3931,
		name = "large amphora kit",
		article = "a",
		description = "Use it in your house to construct a large amphora.",
		weight = 3000
	},
	{
		id = 3932,
		name = "coal basin kit",
		article = "a",
		description = "Use it in your house to construct a coal basin.",
		weight = 3500
	},
	{id = 3933, name = "piano kit", article = "a", description = "Use it in your house to construct a piano.", weight = 3500},
	{id = 3934, name = "harp kit", article = "a", description = "Use it in your house to construct a harp.", weight = 3500},
	{
		id = 3935,
		name = "trunk chair kit",
		article = "a",
		description = "Use it in your house to construct a trunk chair.",
		weight = 3500
	},
	{
		id = 3936,
		name = "trunk table kit",
		article = "a",
		description = "Use it in your house to construct a trunk table.",
		weight = 3500
	},
	{
		id = 3937,
		name = "indoor plant kit",
		article = "an",
		description = "Use it in your house to reveal an indoor plant.",
		weight = 3000
	},
	{id = 3938, name = "unknown kit", article = "an", weight = 3000},
	{id = 3939, name = "camouflage bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 3940, name = "camouflage backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{fromId = 3941, toId = 3942, name = "cup", article = "a", weight = 200, pickupable = true},
	{id = 3943, name = "torch bearer", article = "a"},
	{id = 3944, name = "lit torch bearer", article = "a"},
	{id = 3945, name = "torch bearer", article = "a"},
	{id = 3946, name = "lit torch bearer", article = "a"},
	{id = 3947, name = "wall lamp", article = "a"},
	{id = 3948, name = "lit wall lamp", article = "a"},
	{id = 3949, name = "wall lamp", article = "a"},
	{id = 3950, name = "lit wall lamp", article = "a"},
	{id = 3951, name = "bongo drum", article = "a", weight = 2900},
	{id = 3952, name = "didgeridoo", article = "a", weight = 4200},
	{id = 3953, name = "war drum", article = "a", weight = 3000},
	{id = 3954, name = "bear doll", article = "a", weight = 590},
	{id = 3955, name = "voodoo doll", article = "a", weight = 650},
	{id = 3956, name = "tusk", article = "a", weight = 1000},
	{id = 3957, name = "cornucopia", article = "a", weight = 1400},
	{id = 3958, name = "trashed wooden bars", decayTo = 3799, duration = 120},
	{id = 3959, name = "trashed wooden bars", decayTo = 3798, duration = 120},
	{
		id = 3960,
		name = "old and used backpack",
		article = "an",
		description = "A label on the backpack reads: Property of Sam, Thais.",
		weight = 1800,
		containerSize = 20,
		slotPosition = SLOTP_BACKPACK
	},
	{
		id = 3961,
		name = "lich staff",
		article = "a",
		description = "A scent of death and decay sticks to this weapon.",
		weight = 4100,
		defense = 30,
		extraDefense = 2,
		attack = 40,
		weaponType = WEAPON_CLUB
	},
	{
		id = 3962,
		name = "beastslayer axe",
		article = "a",
		weight = 6150,
		defense = 12,
		attack = 35,
		weaponType = WEAPON_AXE,
		extraDefense = 1
	},
	{
		id = 3963,
		name = "templar scytheblade",
		article = "a",
		weight = 2900,
		defense = 15,
		attack = 23,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 3964,
		name = "ripper lance",
		article = "a",
		weight = 8000,
		defense = 7,
		attack = 28,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 3965,
		name = "hunting spear",
		article = "a",
		weight = 2200,
		attack = 32,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_HUNTINGSPEAR,
		maxHitChance = 80,
		range = 3
	},
	{
		id = 3966,
		name = "banana staff",
		article = "a",
		weight = 5000,
		defense = 15,
		attack = 25,
		weaponType = WEAPON_CLUB,
		extraDefense = 2
	},
	{id = 3967, name = "tribal mask", article = "a", weight = 2500, armor = 2, slotPosition = SLOTP_HEAD},
	{id = 3968, name = "leopard armor", article = "a", weight = 9500, armor = 9, slotPosition = SLOTP_ARMOR},
	{id = 3969, name = "horseman helmet", article = "a", weight = 4200, armor = 6, slotPosition = SLOTP_HEAD},
	{id = 3970, name = "feather headdress", article = "a", weight = 2100, armor = 2, slotPosition = SLOTP_HEAD},
	{id = 3971, name = "charmer's tiara", article = "a", weight = 2200, armor = 2, slotPosition = SLOTP_HEAD},
	{id = 3972, name = "bonelord helmet", article = "a", weight = 4600, armor = 7, slotPosition = SLOTP_HEAD},
	{id = 3973, name = "tusk shield", article = "a", weight = 6900, defense = 27, weaponType = WEAPON_SHIELD},
	{id = 3974, name = "sentinel shield", article = "a", weight = 4900, defense = 22, weaponType = WEAPON_SHIELD},
	{id = 3975, name = "salamander shield", article = "a", weight = 5900, defense = 26, weaponType = WEAPON_SHIELD},
	{id = 3976, name = "worm", article = "a", weight = 5},
	{fromId = 3977, toId = 3980, name = "crane", article = "a"},
	{id = 3981, name = "mailbox", article = "a", type = ITEM_TYPE_MAILBOX},
	{id = 3982, name = "crocodile boots", weight = 900, armor = 1, slotPosition = SLOTP_FEET},
	{id = 3983, name = "bast skirt", article = "a", weight = 350, slotPosition = SLOTP_LEGS},
	{id = 3984, name = "jungle grass", decayTo = 3985, duration = 300},
	{id = 3985, name = "jungle grass"},
	{fromId = 3986, toId = 4005, name = "thorn bush", article = "a"},
	{id = 4006, name = "orange tree", article = "an"},
	{id = 4007, name = "thread tree", article = "a"},
	{id = 4008, name = "jungle dweller bush", article = "a"},
	{id = 4009, name = "tower fern", article = "a"},
	{id = 4010, name = "snake nest bush", article = "a"},
	{id = 4011, name = "green wig bush", article = "a"},
	{id = 4012, name = "lizards tongue bush", article = "a"},
	{id = 4013, name = "jungle crown plant", article = "a"},
	{id = 4014, name = "green fountain bush", article = "a"},
	{id = 4015, name = "big fern", article = "a"},
	{id = 4016, name = "dragons nest tree", article = "a"},
	{id = 4017, name = "purple kiss bush", article = "a"},
	{id = 4018, name = "small fern", article = "a"},
	{fromId = 4019, toId = 4024, name = "jungle umbrella plant", article = "a"},
	{fromId = 4025, toId = 4034, name = "bamboo plant", article = "a"},
	{fromId = 4035, toId = 4067, name = "giant tree", article = "a"},
	{fromId = 4068, toId = 4072, name = "jungle vines"},
	{fromId = 4073, toId = 4112, name = "liana", article = "a"},
	{fromId = 4113, toId = 4133, name = "giant tree", article = "a"},
	{id = 4134, name = "chill nettle", article = "a"},
	{id = 4135, name = "monkey tail", article = "a"},
	{id = 4136, name = "fairy queen", article = "a"},
	{id = 4137, name = "crane plant", article = "a"},
	{id = 4138, name = "jungle bells plant", article = "a"},
	{id = 4139, name = "dawn singer", article = "a"},
	{id = 4140, name = "turtle sprouter", article = "a"},
	{id = 4141, name = "bees ballroom", article = "a"},
	{id = 4142, name = "giant jungle rose", article = "a"},
	{id = 4143, name = "jungle rose", article = "a"},
	{fromId = 4144, toId = 4147, name = "titans orchid", article = "a"},
	{id = 4148, name = "purple cardinal", article = "a"},
	{id = 4149, name = "witches' cauldron plant", article = "a"},
	{fromId = 4150, toId = 4151, name = "gold blossom", article = "a"},
	{fromId = 4152, toId = 4154, name = "meadow star", article = "a"},
	{id = 4155, name = "sneeze blossom", article = "a"},
	{fromId = 4156, toId = 4158, name = "dew kisser flower", article = "a"},
	{fromId = 4159, toId = 4162, name = "velvet petal", article = "a"},
	{id = 4163, name = "devil's tongue flower", article = "a"},
	{id = 4164, name = "small pearl flower", article = "a"},
	{fromId = 4165, toId = 4166, name = "large pearl flower", article = "a"},
	{fromId = 4167, toId = 4170, name = "dead man's saddle", article = "a"},
	{id = 4171, name = "dead man's saddles"},
	{fromId = 4172, toId = 4173, name = "moss cap mushroom", article = "a"},
	{fromId = 4174, toId = 4176, name = "slime table mushroom", article = "a"},
	{id = 4177, name = "slime table mushrooms"},
	{id = 4178, name = "giggle mushroom", article = "a"},
	{id = 4179, name = "giggle mushrooms"},
	{id = 4180, name = "cat's food mushroom", article = "a"},
	{id = 4181, name = "cat's food mushrooms"},
	{id = 4182, name = "glimmer cap mushroom", article = "a"},
	{id = 4183, name = "glimmer cap mushrooms"},
	{id = 4184, name = "giant glimmer cap mushroom", article = "a"},
	{id = 4185, name = "large pearl flower", article = "a"},
	{fromId = 4186, toId = 4201, name = "fallen tree", article = "a"},
	{fromId = 4202, toId = 4207, name = "jungle vines"},
	{id = 4208, name = "jungle maw", article = "a"},
	{id = 4209, name = "jungle maw", article = "a", decayTo = 4208, duration = 150},
	{fromId = 4210, toId = 4215, name = "fallen tree", article = "a"},
	{fromId = 4216, toId = 4222, name = "giant tree", article = "a"},
	{fromId = 4223, toId = 4238, name = "giant tree root", article = "a"},
	{fromId = 4239, toId = 4250, name = "mossy fallen tree", article = "a"},
	{
		id = 4251,
		name = "dead lizard templar",
		article = "a",
		containerSize = 28,
		decayTo = 4256,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4252, name = "dead elephant", article = "a", containerSize = 30},
	{
		id = 4253,
		name = "dead crab",
		article = "a",
		weight = 6300,
		containerSize = 10,
		decayTo = 4254,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4254, name = "dead crab", article = "a", weight = 400, decayTo = 4255, duration = 600, corpseType = RACE_BLOOD},
	{id = 4255, name = "dead crab", article = "a", weight = 3000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4256,
		name = "dead lizard templar",
		article = "a",
		containerSize = 28,
		decayTo = 4257,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 4257,
		name = "dead lizard templar",
		article = "a",
		containerSize = 28,
		decayTo = 4258,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 4258, name = "dead lizard templar", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4259,
		name = "dead lizard sentinel",
		article = "a",
		containerSize = 28,
		decayTo = 4260,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 4260,
		name = "dead lizard sentinel",
		article = "a",
		containerSize = 28,
		decayTo = 4261,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 4261, name = "dead lizard sentinel", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4262,
		name = "dead lizard snakecharmer",
		article = "a",
		containerSize = 7,
		decayTo = 4263,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 4263,
		name = "dead lizard snakecharmer",
		article = "a",
		containerSize = 10,
		decayTo = 4264,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 4264, name = "dead lizard snakecharmer", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4265,
		name = "dead chicken",
		article = "a",
		weight = 6300,
		containerSize = 5,
		decayTo = 4266,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4266, name = "dead chicken", article = "a", weight = 4400, decayTo = 4267, duration = 300, corpseType = RACE_BLOOD},
	{id = 4267, name = "dead chicken", article = "a", weight = 3000, decayTo = 0, duration = 60, corpseType = RACE_BLOOD},
	{
		id = 4268,
		name = "dead kongra",
		article = "a",
		containerSize = 24,
		decayTo = 4269,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4269, name = "dead kongra", article = "a", decayTo = 4270, duration = 600, corpseType = RACE_BLOOD},
	{id = 4270, name = "dead kongra", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4271,
		name = "dead merlkin",
		article = "a",
		containerSize = 24,
		decayTo = 4272,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4272, name = "dead merlkin", article = "a", decayTo = 4273, duration = 600, corpseType = RACE_BLOOD},
	{id = 4273, name = "dead merlkin", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4274,
		name = "dead sibang",
		article = "a",
		containerSize = 24,
		decayTo = 4275,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4275, name = "dead sibang", article = "a", decayTo = 4276, duration = 600, corpseType = RACE_BLOOD},
	{id = 4276, name = "dead sibang", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4277,
		name = "dead crocodile",
		article = "a",
		containerSize = 18,
		decayTo = 4278,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4278, name = "dead crocodile", article = "a", decayTo = 4279, duration = 600, corpseType = RACE_BLOOD},
	{id = 4279, name = "dead crocodile", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4280,
		name = "dead carniphila",
		article = "a",
		containerSize = 30,
		decayTo = 4281,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 4281, name = "dead carniphila", article = "a", decayTo = 4282, duration = 600, corpseType = RACE_VENOM},
	{id = 4282, name = "dead carniphila", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 4283,
		name = "dead hydra",
		article = "a",
		containerSize = 36,
		decayTo = 4284,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4284, name = "dead hydra", article = "a", containerSize = 36, decayTo = 4285, duration = 600, corpseType = RACE_BLOOD},
	{id = 4285, name = "dead hydra", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4286,
		name = "dead panda",
		article = "a",
		containerSize = 5,
		decayTo = 4287,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4287, name = "dead panda", article = "a", decayTo = 4288, duration = 600, corpseType = RACE_BLOOD},
	{id = 4288, name = "dead panda", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4289,
		name = "dead centipede",
		article = "a",
		containerSize = 10,
		decayTo = 4290,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 4290, name = "dead centipede", article = "a", decayTo = 4291, duration = 600, corpseType = RACE_VENOM},
	{id = 4291, name = "dead centipede", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 4292,
		name = "dead tiger",
		article = "a",
		containerSize = 24,
		decayTo = 4293,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4293, name = "dead tiger", article = "a", decayTo = 4294, duration = 600, corpseType = RACE_BLOOD},
	{id = 4294, name = "dead tiger", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4295,
		name = "dead elephant",
		article = "a",
		containerSize = 30,
		decayTo = 4296,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4296, name = "dead elephant", article = "a", containerSize = 30, decayTo = 4297, duration = 600, corpseType = RACE_BLOOD},
	{id = 4297, name = "dead elephant", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4298,
		name = "dead bat",
		article = "a",
		weight = 6300,
		containerSize = 14,
		decayTo = 4299,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4299, name = "dead bat", article = "a", weight = 4400, decayTo = 4300, duration = 600, corpseType = RACE_BLOOD},
	{id = 4300, name = "dead bat", article = "a", weight = 300, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4301,
		name = "dead flamingo",
		article = "a",
		containerSize = 5,
		decayTo = 4302,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4302, name = "dead flamingo", article = "a", decayTo = 4303, duration = 600, corpseType = RACE_BLOOD},
	{id = 4303, name = "dead flamingo", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4304,
		name = "dead dworc",
		article = "a",
		containerSize = 24,
		decayTo = 4305,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4305, name = "dead dworc", article = "a", decayTo = 4306, duration = 600, corpseType = RACE_BLOOD},
	{id = 4306, name = "dead dworc", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4307,
		name = "dead dworc",
		article = "a",
		containerSize = 24,
		decayTo = 4308,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4308, name = "dead dworc", article = "a", decayTo = 4309, duration = 600, corpseType = RACE_BLOOD},
	{id = 4309, name = "dead dworc", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4310,
		name = "dead dworc",
		article = "a",
		containerSize = 24,
		decayTo = 4311,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4311, name = "dead dworc", article = "a", decayTo = 4312, duration = 600, corpseType = RACE_BLOOD},
	{id = 4312, name = "dead dworc", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 4313, name = "dead butterfly", article = "a", weight = 20, corpseType = RACE_VENOM},
	{
		id = 4314,
		name = "dead parrot",
		article = "a",
		weight = 2000,
		containerSize = 5,
		decayTo = 4315,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4315, name = "dead parrot", article = "a", weight = 1500, decayTo = 4316, duration = 600, corpseType = RACE_BLOOD},
	{id = 4316, name = "dead parrot", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4317,
		name = "dead bird",
		article = "a",
		containerSize = 30,
		decayTo = 4318,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 4318, name = "dead bird", article = "a", decayTo = 4319, duration = 600, corpseType = RACE_BLOOD},
	{id = 4319, name = "dead bird", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4320,
		name = "dead tarantula",
		article = "a",
		containerSize = 16,
		decayTo = 4321,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 4321, name = "dead tarantula", article = "a", decayTo = 4322, duration = 600, corpseType = RACE_VENOM},
	{id = 4322, name = "dead tarantula", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 4323,
		name = "dead serpent spawn",
		article = "a",
		containerSize = 40,
		decayTo = 4324,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 4324,
		name = "dead serpent spawn",
		article = "a",
		containerSize = 40,
		decayTo = 4325,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 4325, name = "dead serpent spawn", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 4326,
		name = "lifeless nettle",
		article = "a",
		containerSize = 16,
		decayTo = 4327,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 4327, name = "lifeless nettle", article = "a", decayTo = 0, duration = 120},
	{fromId = 4394, toId = 4402, name = "red carpet", article = "a"},
	{id = 4403, name = "mast", article = "a"},
	{id = 4404, name = "bamboo lamp", article = "a"},
	{fromId = 4405, toId = 4421, name = "rock soil"},
	{fromId = 4456, toId = 4467, name = "rocks"},
	{fromId = 4468, toId = 4513, name = "mountain", article = "a"},
	{fromId = 4514, toId = 4525, name = "rock soil"},
	{fromId = 4526, toId = 4553, name = "grass"},
	{fromId = 4554, toId = 4566, name = "gravel"},
	{fromId = 4570, toId = 4579, name = "gravel"},
	{fromId = 4580, toId = 4594, name = "mossy spots"},
	{id = 4595, name = "gravel"},
	{fromId = 4596, toId = 4607, name = "sand"},
	{
		fromId = 4608,
		toId = 4616,
		name = "shallow water",
		description = "You see the silvery movement of fish.",
		type = ITEM_TYPE_TRASHHOLDER,
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{
		id = 4617,
		name = "shallow water",
		decayTo = 4608,
		duration = 1200,
		type = ITEM_TYPE_TRASHHOLDER,
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{
		id = 4618,
		name = "shallow water",
		decayTo = 4609,
		duration = 1200,
		type = ITEM_TYPE_TRASHHOLDER,
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{
		id = 4619,
		name = "shallow water",
		decayTo = 4610,
		duration = 1200,
		type = ITEM_TYPE_TRASHHOLDER,
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{
		fromId = 4620,
		toId = 4625,
		name = "shallow water",
		type = ITEM_TYPE_TRASHHOLDER,
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{fromId = 4632, toId = 4643, name = "shallow water", fluidSource = FLUID_WATER},
	{fromId = 4644, toId = 4663, name = "shallow water", ignoreBlocking = true, fluidSource = FLUID_WATER},
	{
		fromId = 4664,
		toId = 4666,
		name = "shallow water",
		type = ITEM_TYPE_TRASHHOLDER,
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{fromId = 4667, toId = 4690, name = "dirt"},
	{fromId = 4691, toId = 4712, name = "swamp", type = ITEM_TYPE_TRASHHOLDER, effect = CONST_ME_GREEN_RINGS, ignoreBlocking = true},
	{fromId = 4713, toId = 4736, name = "swamp"},
	{fromId = 4737, toId = 4748, name = "snow"},
	{fromId = 4749, toId = 4755, name = "swamp", type = ITEM_TYPE_TRASHHOLDER, effect = CONST_ME_GREEN_RINGS, ignoreBlocking = true},
	{fromId = 4760, toId = 4783, name = "sand"},
	{fromId = 4784, toId = 4795, name = "grass"},
	{fromId = 4796, toId = 4807, name = "dirt floor"},
	{fromId = 4808, toId = 4819, name = "lava"},
	{
		fromId = 4820,
		toId = 4825,
		name = "shallow water",
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{fromId = 4826, toId = 4827, name = "mountain", article = "a"},
	{
		fromId = 4828,
		toId = 4831,
		name = "shallow water",
		type = ITEM_TYPE_TRASHHOLDER,
		effect = CONST_ME_LOSEENERGY,
		ignoreBlocking = true,
		fluidSource = FLUID_WATER
	},
	{fromId = 4832, toId = 4833, name = "ploughed soil"},
	{fromId = 4834, toId = 4837, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 4838, name = "whisper moss", weight = 20},
	{id = 4839, name = "flask of cough syrup", article = "a", description = "It smells like herbs.", weight = 300},
	{id = 4840, name = "witches' cap spot", article = "a", decayTo = 0, duration = 86400, weight = 100},
	{id = 4842, name = "old parchment", article = "an", description = "It is covered with foreign symbols.", weight = 200},
	{id = 4843, name = "giant ape's hair", article = "a", weight = 2000},
	{
		id = 4845,
		name = "family brooch",
		article = "a",
		description = "The emblem of a dwarven family is engraved on it.",
		weight = 110
	},
	{id = 4846, name = "snake destroyer", article = "a", weight = 6600},
	{id = 4847, name = "spectral dress", article = "a", weight = 1000, slotPosition = SLOTP_ARMOR},
	{id = 4848, name = "icicle", article = "an", description = "It is melting rapidly.", weight = 1900, decayTo = 0, duration = 600},
	{id = 4849, name = "strange powder", weight = 500},
	{id = 4850, name = "hydra egg", article = "a", weight = 2000},
	{id = 4851, name = "spectral stone", article = "a", description = "It is pulsating with spectral energy.", weight = 250},
	{id = 4852, name = "memory stone", article = "a", weight = 250},
	{
		id = 4853,
		name = "sheet of tracing paper",
		article = "a",
		description = "It is blank.",
		weight = 100,
		writeable = true,
		maxTextLen = 1023,
		writeOnceItemId = 4854
	},
	{
		id = 4854,
		name = "sheet of tracing paper",
		article = "a",
		description = "It contains some strange symbols of the lizard language.",
		weight = 100
	},
	{
		id = 4855,
		name = "elven poetry book",
		article = "an",
		description = "It contains a collection of beautiful elven poems.",
		weight = 1300
	},
	{id = 4856, name = "ice pick", article = "an", description = "It might come in handy in cold regions.", weight = 7000},
	{id = 4857, name = "wrinkled parchment", article = "a", description = "It is covered with strange numbers.", weight = 200},
	{id = 4858, name = "funeral urn", article = "a", description = "It contains the ashes of a lizard high priest.", weight = 10000},
	{
		id = 4859,
		name = "small cask",
		article = "a",
		description = "It is filled with the blood of the snake god.",
		fluidSource = FLUID_BLOOD
	},
	{id = 4860, name = "wooden trash"},
	{id = 4861, name = "statue of the snake god", article = "the", description = "It is emitting an eerie light."},
	{
		id = 4862,
		name = "smashed stone head",
		article = "a",
		description = "It seems to repair itself rapidly.",
		decayTo = 4861,
		duration = 30
	},
	{id = 4863, name = "ectoplasm container", article = "an", description = "It is empty.", weight = 600},
	{id = 4864, name = "ectoplasm container", article = "an", description = "It is filled with a desecrated bone.", weight = 600},
	{id = 4865, name = "butterfly conservation kit", article = "a", description = "It is empty.", weight = 700},
	{id = 4866, name = "butterfly conservation kit", article = "a", description = "It contains a purple butterfly.", weight = 800},
	{id = 4867, name = "butterfly conservation kit", article = "a", description = "It contains a blue butterfly.", weight = 800},
	{id = 4868, name = "butterfly conservation kit", article = "a", description = "It contains a red butterfly.", weight = 800},
	{id = 4869, name = "botanist's container", article = "a", description = "It is empty.", weight = 1800},
	{
		id = 4870,
		name = "botanist's container",
		article = "a",
		description = "It holds a sample of the jungle bells plant.",
		weight = 2000
	},
	{
		id = 4871,
		name = "botanist's container",
		article = "a",
		description = "It holds a sample of the witches cauldron plant.",
		weight = 2000
	},
	{
		id = 4872,
		name = "botanist's container",
		article = "a",
		description = "It holds a sample of the giant jungle rose.",
		weight = 2000
	},
	{
		id = 4873,
		name = "explorer brooch",
		article = "an",
		description = "It is the official badge of the explorer society.",
		weight = 90
	},
	{
		id = 4874,
		name = "dwarven pickaxe",
		article = "a",
		description = "It is a masterpiece of dwarvish smithery and made of especially hard steel.",
		weight = 6000
	},
	{id = 4875, name = "hydra's nest", article = "a"},
	{id = 4876, name = "swamp"},
	{id = 4877, name = "mould", article = "a"},
	{fromId = 4878, toId = 4881, name = "swamp"},
	{id = 4882, name = "waterway", article = "a"},
	{fromId = 4883, toId = 4905, name = "ship", article = "a"},
	{fromId = 4906, toId = 4910, name = "ship cabin wall", article = "a"},
	{id = 4911, name = "ship rail", article = "a"},
	{id = 4912, name = "ship cabin wall", article = "a"},
	{id = 4913, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 4914, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 4915, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 4916, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 4917, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 4918, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 4919, name = "ship railing", article = "a"},
	{id = 4920, name = "ship rail", article = "a"},
	{id = 4921, name = "ship cabin wall", article = "a"},
	{fromId = 4922, toId = 4941, name = "ship railing", article = "a"},
	{fromId = 4942, toId = 4953, name = "mast", article = "a"},
	{fromId = 4954, toId = 4961, name = "sail", article = "a"},
	{fromId = 4962, toId = 4965, name = "steering wheel", article = "a"},
	{fromId = 4966, toId = 4971, name = "rudder blade", article = "a"},
	{id = 4972, name = "ventilation grille", article = "a"},
	{id = 4973, name = "bollard", article = "a"},
	{id = 4974, name = "anchor", article = "an"},
	{fromId = 4975, toId = 4976, name = "figurehead", article = "a"},
	{id = 4977, name = "anchor", article = "an"},
	{fromId = 4978, toId = 4987, name = "hawser", article = "a"},
	{id = 4988, name = "cleat", article = "a"},
	{id = 4989, name = "hawser", article = "a"},
	{id = 4990, name = "white flag", article = "a"},
	{id = 4991, name = "pirate flag", article = "a"},
	{id = 4992, name = "dead butterfly", article = "a", weight = 20, decayTo = 0, duration = 60},
	{fromId = 4993, toId = 4994, name = "dead butterfly", article = "a", weight = 20, decayTo = 4313, duration = 60},
	{id = 4995, name = "some sharp icicles"},
	{id = 4996, name = "canopic jar", article = "a", description = "You feel an eerie presence.", destroyTo = 4997},
	{id = 4997, name = "remains of a canopic jar", article = "the", decayTo = 4996, duration = 1800},
	{fromId = 4998, toId = 5001, name = "hawser", article = "a"},
	{id = 5002, name = "ship railing", article = "a"},
	{fromId = 5003, toId = 5008, name = "ship cabin wall", article = "a"},
	{id = 5009, name = "sandstone wall", article = "a"},
	{fromId = 5010, toId = 5011, name = "white stone wall", article = "a"},
	{fromId = 5012, toId = 5013, name = "lava wall", article = "a"},
	{id = 5014, name = "dead butterfly", article = "a", weight = 20, decayTo = 4313, duration = 60},
	{id = 5015, name = "mandrake", article = "a", description = "This rare root is often used for shamanic medicines.", weight = 180},
	{fromId = 5016, toId = 5017, name = "skull", article = "a"},
	{fromId = 5018, toId = 5019, name = "some skulls"},
	{fromId = 5020, toId = 5021, name = "burning skull", article = "a"},
	{id = 5022, name = "orichalcum pearl", article = "an", weight = 30},
	{
		fromId = 5023,
		toId = 5024,
		name = "magic forcefield",
		article = "a",
		type = ITEM_TYPE_TELEPORT,
		description = "You can see the other side trough it.",
		effect = CONST_ME_TELEPORT
	},
	{fromId = 5025, toId = 5044, name = "bamboo lamp", article = "a"},
	{id = 5045, name = "flat roof", article = "a"},
	{id = 5046, name = "monkey statue", article = "a", description = "The words 'See no evil' are engraved on it."},
	{fromId = 5047, toId = 5054, name = "flat roof", article = "a"},
	{id = 5055, name = "monkey statue", article = "a", description = "The words 'Hear no evil' are engraved on it."},
	{id = 5056, name = "monkey statue", article = "a", description = "The words 'Speak no evil' are engraved on it."},
	{id = 5057, name = "small snake head", article = "a", description = "It is emitting poisonous clouds."},
	{id = 5058, name = "small snake head", article = "a"},
	{id = 5059, name = "small snake head", article = "a", description = "It is emitting poisonous clouds."},
	{id = 5060, name = "small snake head", article = "a"},
	{fromId = 5061, toId = 5067, name = "burning wall", article = "a"},
	{fromId = 5068, toId = 5070, name = "electric sparks"},
	{fromId = 5071, toId = 5073, name = "energy fence", article = "an"},
	{fromId = 5074, toId = 5075, name = "lava fountain", article = "a"},
	{fromId = 5076, toId = 5079, name = "stony pond", article = "a", fluidSource = FLUID_WATER},
	{id = 5080, name = "panda teddy", article = "a", weight = 600},
	{id = 5081, name = "ladder", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 5082, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5083, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5084, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5085, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{
		id = 5086,
		name = "monkey statue 'see' kit",
		article = "a",
		description = "Use it in your house to construct a monkey statue.",
		weight = 2500
	},
	{
		id = 5087,
		name = "monkey statue 'hear' kit",
		article = "a",
		description = "Use it in your house to construct a monkey statue.",
		weight = 2500
	},
	{
		id = 5088,
		name = "monkey statue 'speak' kit",
		article = "a",
		description = "Use it in your house to construct a monkey statue.",
		weight = 2500
	},
	{id = 5089, name = "butterfly conservation kit", article = "a", description = "It contains a butterfly.", weight = 800},
	{
		id = 5091,
		name = "treasure map",
		article = "a",
		weight = 830,
		description = "It obviously shows Treasure Island including a big, red cross."
	},
	{fromId = 5092, toId = 5095, name = "banana tree", article = "a"},
	{id = 5096, name = "coconut palm", article = "a"},
	{id = 5097, name = "mango", article = "a", weight = 180},
	{id = 5098, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5099, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5100, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5101, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5102, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5103, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 5104, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 5105, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5106, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5107, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5108, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5109, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5110, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5111, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5112, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 5113, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 5114, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5115, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5116, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5117, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5118, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5119, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5120, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5121, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 5122, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 5123, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5124, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5125, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5126, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5127, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5128, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5129, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5130, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 5131, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 5132, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5133, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5134, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5135, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5136, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5137, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5138, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5139, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5140, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5141, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5142, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5143, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5144, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5145, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 5146, toId = 5155, name = "framework wall", article = "a"},
	{fromId = 5156, toId = 5157, name = "mango tree", article = "a"},
	{fromId = 5158, toId = 5205, name = "striped marquee", article = "a"},
	{fromId = 5206, toId = 5253, name = "marquee", article = "a"},
	{fromId = 5254, toId = 5255, name = "wooden railing", article = "a"},
	{fromId = 5256, toId = 5257, name = "stone wall window", article = "a"},
	{id = 5258, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 5259, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 5260, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{fromId = 5261, toId = 5275, name = "wooden wall", article = "a"},
	{id = 5276, name = "wooden wall window", article = "a"},
	{id = 5277, name = "wooden window", article = "a"},
	{id = 5278, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5279, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5280, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5281, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5282, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5283, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5284, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5285, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5286, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5287, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5288, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5289, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5290, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5291, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5292, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 5293, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 5294, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 5295, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 5296, name = "wooden plank", article = "a"},
	{id = 5297, name = "wooden planks"},
	{id = 5298, name = "wooden plank", article = "a"},
	{id = 5299, name = "wooden planks"},
	{fromId = 5300, toId = 5301, name = "wooden plank", article = "a"},
	{id = 5302, name = "wooden planks"},
	{fromId = 5303, toId = 5304, name = "white stone wall window", article = "a"},
	{fromId = 5305, toId = 5307, name = "white stone railing", article = "a"},
	{id = 5308, name = "white stone pillar", article = "a"},
	{fromId = 5309, toId = 5314, name = "white stone railing", article = "a"},
	{fromId = 5315, toId = 5320, name = "wooden railing", article = "a"},
	{fromId = 5321, toId = 5331, name = "wooden column", article = "a"},
	{fromId = 5332, toId = 5389, name = "sign", article = "a", allowDistRead = true},
	{fromId = 5390, toId = 5391, name = "pawpaw tree", article = "a"},
	{id = 5392, name = "dry mangrove", article = "a"},
	{fromId = 5393, toId = 5399, name = "mangrove", article = "a"},
	{fromId = 5400, toId = 5401, name = "stone wall window", article = "a"},
	{fromId = 5402, toId = 5404, name = "bamboo lamp", article = "a"},
	{fromId = 5405, toId = 5410, name = "ocean floor"},
	{fromId = 5411, toId = 5412, name = "stone", article = "a"},
	{fromId = 5413, toId = 5416, name = "coral", article = "a"},
	{id = 5417, name = "starfish", article = "a"},
	{id = 5418, name = "sea anemone", article = "a"},
	{fromId = 5419, toId = 5420, name = "bubbles"},
	{id = 5421, name = "kelp"},
	{fromId = 5422, toId = 5423, name = "coral", article = "a"},
	{fromId = 5424, toId = 5425, name = "water wheel", article = "a"},
	{id = 5426, name = "old steering wheel", article = "an"},
	{fromId = 5427, toId = 5438, name = "ocean floor"},
	{fromId = 5439, toId = 5441, name = "old steering wheel", article = "an"},
	{fromId = 5442, toId = 5443, name = "wrecked parts"},
	{id = 5444, name = "rusty anchor", article = "a"},
	{fromId = 5445, toId = 5446, name = "broken wood"},
	{fromId = 5447, toId = 5449, name = "wrecked parts"},
	{id = 5450, name = "wrecked ship cabin wall", article = "a"},
	{id = 5451, name = "wrecked parts"},
	{fromId = 5452, toId = 5453, name = "wrecked ship cabin wall", article = "a"},
	{fromId = 5454, toId = 5455, name = "wrecked ship railing", article = "a"},
	{fromId = 5456, toId = 5459, name = "wrecked ship hull", article = "a"},
	{id = 5460, name = "ruined ventilation grille", article = "a"},
	{
		id = 5461,
		name = "helmet of the deep",
		article = "a",
		weight = 21000,
		description = "Enables underwater exploration.",
		armor = 2,
		slotPosition = SLOTP_HEAD,
		absorbPercent = {[COMBAT_DROWNDAMAGE] = 100}
	},
	{id = 5462, name = "pirate boots", weight = 800, armor = 2, slotPosition = SLOTP_FEET},
	{id = 5463, name = "sugar cane", description = "It has just been harvested.", decayTo = 5471, duration = 240},
	{id = 5464, name = "sugar cane", description = "It can be harvested."},
	{id = 5465, name = "burning sugar cane", decayTo = 5464, duration = 10},
	{id = 5466, name = "sugar cane"},
	{id = 5467, name = "bunch of sugar cane", article = "a", weight = 2250},
	{
		id = 5468,
		name = "fire bug",
		article = "a",
		description = "This strange creature has the tendency to set certain things on fire.",
		weight = 3050
	},
	{fromId = 5469, toId = 5470, name = "distilling machine", article = "a"},
	{id = 5471, name = "young sugar cane", decayTo = 5466, duration = 240},
	{fromId = 5472, toId = 5473, name = "ball on chains", article = "a"},
	{fromId = 5474, toId = 5475, name = "iron maiden", article = "an"},
	{fromId = 5476, toId = 5477, name = "pillory", article = "a"},
	{fromId = 5478, toId = 5479, name = "barred window", article = "a"},
	{id = 5480, name = "cat's paw", article = "a", weight = 1000},
	{fromId = 5481, toId = 5482, name = "shackles"},
	{fromId = 5483, toId = 5484, name = "wall chains"},
	{fromId = 5485, toId = 5495, name = "straw"},
	{id = 5496, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 5502},
	{id = 5497, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 5503},
	{id = 5498, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 5500},
	{id = 5499, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 5501},
	{id = 5500, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 5498},
	{
		id = 5501,
		name = "straw mat",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_WEST,
		maleSleeper = 5499,
		femaleSleeper = 5499
	},
	{id = 5502, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 5496},
	{id = 5503, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 5497},
	{id = 5504, name = "wooden column", article = "a"},
	{fromId = 5505, toId = 5512, name = "pulley", article = "a"},
	{id = 5513, name = "distilling machine", article = "a", decayTo = 5469, duration = 15, fluidSource = FLUID_RUM},
	{id = 5514, name = "distilling machine", article = "a", decayTo = 5470, duration = 15, fluidSource = FLUID_RUM},
	{id = 5515, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5516, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5517, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5518, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 5519, toId = 5520, name = "stone wall", article = "a"},
	{id = 5521, name = "wooden railing", article = "a"},
	{
		id = 5522,
		name = "dead quara pincher",
		article = "a",
		containerSize = 26,
		decayTo = 5537,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5523,
		name = "dead quara mantassin",
		article = "a",
		containerSize = 36,
		decayTo = 5533,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5524,
		name = "dead quara constrictor",
		article = "a",
		containerSize = 28,
		decayTo = 5531,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5525,
		name = "dead quara hydromancer",
		article = "a",
		containerSize = 26,
		decayTo = 5529,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5526,
		name = "dead quara predator",
		article = "a",
		containerSize = 30,
		decayTo = 5535,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5527, name = "demon dust", containerSize = 24, decayTo = 5528, duration = 900, corpseType = RACE_UNDEAD},
	{id = 5528, name = "demon dust", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 5529,
		name = "dead quara hydromancer",
		article = "a",
		containerSize = 26,
		decayTo = 5530,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 5530, name = "dead quara hydromancer", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 5531,
		name = "dead quara constrictor",
		article = "a",
		containerSize = 28,
		decayTo = 5532,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 5532, name = "dead quara constrictor", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 5533,
		name = "dead quara mantassin",
		article = "a",
		containerSize = 36,
		decayTo = 5534,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 5534, name = "dead quara mantassin", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 5535, name = "dead quara predator", article = "a", containerSize = 30, decayTo = 5536, duration = 900},
	{id = 5536, name = "dead quara predator", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 5537,
		name = "dead quara pincher",
		article = "a",
		containerSize = 26,
		decayTo = 5538,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 5538, name = "dead quara pincher", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 5539, name = "rum cask", article = "a", fluidSource = FLUID_RUM},
	{
		id = 5540,
		name = "dead carrion worm",
		article = "a",
		containerSize = 10,
		decayTo = 5541,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5541, name = "dead carrion worm", article = "a", decayTo = 5542, duration = 600, corpseType = RACE_BLOOD},
	{id = 5542, name = "dead carrion worm", article = "a", weight = 4000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 5543, name = "rope-ladder", article = "a"},
	{id = 5544, name = "cart", article = "a"},
	{id = 5545, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 5546, toId = 5548, name = "cart", article = "a"},
	{fromId = 5549, toId = 5552, name = "pile of sugar cane", article = "a"},
	{id = 5553, name = "rum flask", article = "a", weight = 280, pickupable = true},
	{id = 5554, name = "small fish", article = "a"},
	{fromId = 5555, toId = 5556, name = "straw"},
	{fromId = 5557, toId = 5560, name = "mossy wall", article = "a"},
	{fromId = 5561, toId = 5562, name = "small branches"},
	{fromId = 5563, toId = 5564, name = "slimy wall", article = "a"},
	{id = 5565, name = "slain pirate skeleton", article = "a", weight = 40000, decayTo = 0, duration = 900, corpseType = RACE_UNDEAD},
	{
		id = 5566,
		name = "slain pirate ghost",
		article = "a",
		weight = 20000,
		containerSize = 20,
		decayTo = 5567,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{id = 5567, name = "slain pirate ghost", article = "a", weight = 20000, decayTo = 5568, duration = 600, corpseType = RACE_UNDEAD},
	{id = 5568, name = "slain pirate ghost", article = "a", weight = 20000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{fromId = 5569, toId = 5577, name = "blue carpet", article = "a"},
	{fromId = 5578, toId = 5586, name = "green carpet", article = "a"},
	{fromId = 5587, toId = 5595, name = "brown carpet", article = "a"},
	{fromId = 5596, toId = 5597, name = "crossed weapons"},
	{fromId = 5598, toId = 5613, name = "catapult", article = "a"},
	{fromId = 5614, toId = 5615, name = "pirate flag", article = "a"},
	{id = 5616, name = "pirate tapestry", article = "a", weight = 1000},
	{fromId = 5617, toId = 5618, name = "pirate flag", article = "a"},
	{fromId = 5619, toId = 5624, name = "rubble"},
	{
		id = 5625,
		name = "dead tortoise",
		article = "a",
		containerSize = 30,
		decayTo = 5626,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5626, name = "dead tortoise", article = "a", weight = 1000, decayTo = 5627, duration = 600, corpseType = RACE_BLOOD},
	{id = 5627, name = "dead tortoise", article = "a", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 5628,
		name = "dead tortoise",
		article = "a",
		containerSize = 36,
		decayTo = 5629,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5629, name = "dead tortoise", article = "a", decayTo = 5630, duration = 600, corpseType = RACE_BLOOD},
	{id = 5630, name = "dead tortoise", article = "a", weight = 6000, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{fromId = 5631, toId = 5638, name = "dirt wall", article = "a"},
	{fromId = 5639, toId = 5646, name = "stone wall", article = "a"},
	{id = 5647, name = "dirt wall", article = "a"},
	{id = 5648, name = "stone wall", article = "a"},
	{fromId = 5649, toId = 5651, name = "dirt wall", article = "a"},
	{fromId = 5652, toId = 5654, name = "stone wall", article = "a"},
	{fromId = 5655, toId = 5658, name = "map", article = "a"},
	{id = 5659, name = "blooming griffinclaw", article = "a"},
	{fromId = 5660, toId = 5665, name = "water trickle", article = "a"},
	{
		id = 5666,
		name = "dead mammoth",
		article = "a",
		containerSize = 30,
		decayTo = 5667,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5667, name = "dead mammoth", article = "a", containerSize = 30, decayTo = 5668, duration = 600, corpseType = RACE_BLOOD},
	{id = 5668, name = "dead mammoth", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 5669, name = "mysterious voodoo skull", article = "a", weight = 1400},
	{
		id = 5670,
		name = "enigmatic voodoo skull",
		article = "an",
		weight = 1400,
		decayTo = 5669,
		duration = 72000,
		description = "It is not time yet."
	},
	{fromId = 5671, toId = 5674, name = "pirate statue", article = "a"},
	{fromId = 5675, toId = 5676, name = "treasure chest", article = "a"},
	{id = 5677, name = "tortoise's nest", article = "a"},
	{id = 5678, name = "tortoise egg", article = "a", weight = 30},
	{id = 5679, name = "shell", article = "a"},
	{id = 5680, name = "spiral shell", article = "a"},
	{id = 5681, name = "some broken shells"},
	{id = 5682, name = "piece of a shell", article = "a"},
	{fromId = 5683, toId = 5684, name = "stone wall", article = "a"},
	{fromId = 5685, toId = 5686, name = "dirt wall", article = "a"},
	{id = 5687, name = "griffinclaw", article = "a"},
	{
		id = 5688,
		name = "dead blood crab",
		article = "a",
		containerSize = 20,
		decayTo = 5689,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5689, name = "dead blood crab", article = "a", containerSize = 20, decayTo = 5690, duration = 600, corpseType = RACE_BLOOD},
	{id = 5690, name = "dead blood crab", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 5691, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 5692, toId = 5703, name = "ballista", article = "a"},
	{fromId = 5704, toId = 5705, name = "shark fin", article = "a"},
	{
		id = 5706,
		name = "treasure map",
		article = "a",
		description = "It obviously shows Treasure Island including a big, red cross.",
		weight = 830
	},
	{fromId = 5707, toId = 5709, name = "rubble"},
	{id = 5710, name = "light shovel", article = "a", weight = 1500},
	{fromId = 5711, toId = 5726, name = "earth"},
	{
		id = 5727,
		name = "dead seagull",
		article = "a",
		weight = 1000,
		containerSize = 5,
		decayTo = 5728,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5728, name = "dead seagull", article = "a", weight = 800, decayTo = 5729, duration = 600, corpseType = RACE_BLOOD},
	{id = 5729, name = "dead seagull", article = "a", weight = 500, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 5731, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 5732, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5733, name = "closed door", article = "a", type = ITEM_TYPE_DOOR},
	{id = 5734, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5735, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 5736, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 5737, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 5738, name = "shark fin", article = "a"},
	{fromId = 5739, toId = 5740, name = "antic well", article = "an", fluidSource = FLUID_WATER},
	{id = 5741, name = "skull helmet", article = "a", weight = 4200, armor = 9, slotPosition = SLOTP_HEAD},
	{fromId = 5743, toId = 5744, name = "sunken ship", article = "a"},
	{
		id = 5745,
		name = "closed door",
		article = "a",
		type = ITEM_TYPE_DOOR,
		blockProjectile = true,
		description = "The door seems to be sealed against unwanted intruders."
	},
	{
		id = 5746,
		name = "open door",
		article = "an",
		type = ITEM_TYPE_DOOR,
		description = "The door seems to be sealed against unwanted intruders."
	},
	{id = 5747, name = "earth pile", article = "an"},
	{
		id = 5748,
		name = "closed door",
		article = "a",
		type = ITEM_TYPE_DOOR,
		blockProjectile = true,
		description = "The door seems to be sealed against unwanted intruders."
	},
	{
		id = 5749,
		name = "open door",
		article = "an",
		type = ITEM_TYPE_DOOR,
		description = "The door seems to be sealed against unwanted intruders."
	},
	{fromId = 5750, toId = 5754, name = "earth pile", article = "an"},
	{id = 5755, name = "turtle", article = "a"},
	{id = 5756, name = "turtle", article = "a", type = ITEM_TYPE_TELEPORT},
	{fromId = 5757, toId = 5761, name = "turtle", article = "a"},
	{id = 5762, name = "dead quara constrictor", article = "a", containerSize = 28, corpseType = RACE_BLOOD},
	{id = 5763, name = "opening", article = "an", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 5764, name = "intact ventilation grille", article = "an"},
	{
		id = 5765,
		name = "dead toad",
		article = "a",
		containerSize = 20,
		decayTo = 5766,
		duration = 600,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 5766, name = "dead toad", article = "a", containerSize = 20, decayTo = 5767, duration = 600, corpseType = RACE_VENOM},
	{id = 5767, name = "dead toad", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{fromId = 5768, toId = 5770, name = "drawbridge", article = "a"},
	{fromId = 5771, toId = 5774, name = "metal fittings"},
	{fromId = 5777, toId = 5778, name = "target board", article = "a"},
	{fromId = 5779, toId = 5784, name = "stuck arrow", article = "a"},
	{id = 5785, name = "medal of honour", article = "a", weight = 1000, writeable = true, maxTextLen = 128},
	{id = 5786, name = "wooden whistle", article = "a", weight = 100},
	{fromId = 5787, toId = 5788, name = "training dummy", article = "a"},
	{fromId = 5789, toId = 5790, name = "stuck axe", article = "a"},
	{id = 5791, name = "stuffed dragon", article = "a", weight = 850},
	{fromId = 5792, toId = 5797, name = "die", article = "a", weight = 200},
	{
		id = 5798,
		name = "abacus",
		article = "an",
		description = "If you use it wisely, you may write yourself into the history books.",
		weight = 1200
	},
	{id = 5799, name = "golden figurine", article = "a", weight = 1500, writeable = true, maxTextLen = 128},
	{id = 5800, name = "grappling hook", article = "a"},
	{id = 5801, name = "jewelled backpack", article = "a", weight = 1700, containerSize = 22, slotPosition = SLOTP_BACKPACK},
	{id = 5802, name = "message in a bottle", article = "a", weight = 1200},
	{
		id = 5803,
		name = "arbalest",
		article = "an",
		description = "It is a bit heavy due to the iron mounting, but very precise.",
		weight = 9500,
		weaponType = WEAPON_DISTANCE,
		slotPosition = SLOTP_TWO_HAND,
		ammoType = AMMO_BOLT,
		range = 6,
		hitChance = 2,
		attack = 2
	},
	{
		id = 5804,
		name = "nose ring",
		article = "a",
		description = "It was the favourite trinket of the famous Horned Fox.",
		weight = 500
	},
	{id = 5805, name = "golden goblet", article = "a", weight = 1500},
	{id = 5806, name = "silver goblet", article = "a", weight = 1500},
	{id = 5807, name = "bronze goblet", article = "a", weight = 1500},
	{id = 5808, name = "Orshabaal's brain", weight = 3500},
	{
		id = 5809,
		name = "soul stone",
		article = "a",
		description = "It contains the essence of countless tormented souls.",
		weight = 30
	},
	{id = 5810, name = "pirate voodoo doll", article = "a", weight = 650},
	{id = 5811, name = "mermaid", article = "a"},
	{
		id = 5812,
		name = "skull candle",
		article = "a",
		slotPosition = SLOTP_AMMO,
		weight = 2200,
		decayTo = 2229,
		showDuration = true,
		duration = 3000
	},
	{
		id = 5813,
		name = "skull candle",
		article = "a",
		slotPosition = SLOTP_AMMO,
		weight = 2200,
		stopDuration = true,
		showDuration = true
	},
	{fromId = 5814, toId = 5827, name = "small lava cracks", description = "The ground is steaming hot."},
	{fromId = 5828, toId = 5839, name = "lava"},
	{fromId = 5840, toId = 5851, name = "small lava cracks", description = "The ground is steaming hot."},
	{fromId = 5852, toId = 5853, name = "weapon rack", article = "a"},
	{fromId = 5854, toId = 5855, name = "lance", article = "a"},
	{fromId = 5856, toId = 5857, name = "sword", article = "a"},
	{fromId = 5858, toId = 5859, name = "scimitar", article = "a"},
	{fromId = 5860, toId = 5861, name = "armor rack", article = "an"},
	{fromId = 5862, toId = 5863, name = "armor", article = "an"},
	{id = 5865, name = "juice squeezer", article = "a", weight = 1500},
	{fromId = 5866, toId = 5868, name = "earth pile", article = "an"},
	{fromId = 5869, toId = 5874, name = "poison trickle", article = "a"},
	{id = 5875, name = "sniper gloves", description = "They are the pride of the paladin guild.", weight = 400},
	{id = 5876, name = "lizard leather", weight = 50, showCount = false},
	{id = 5877, name = "green dragon leather", weight = 60, showCount = false},
	{id = 5878, name = "minotaur leather", weight = 40, showCount = false},
	{id = 5879, name = "spider silk", weight = 10, showCount = false},
	{id = 5880, name = "iron ore", weight = 200, showCount = false},
	{id = 5881, name = "lizard scale", article = "a", weight = 80},
	{id = 5882, name = "red dragon scale", article = "a", weight = 90},
	{id = 5883, name = "ape fur", weight = 120, showCount = false},
	{id = 5884, name = "spirit container", article = "a", description = "It contains pure fighting spirit.", weight = 600},
	{
		id = 5885,
		name = "flask of warrior's sweat",
		article = "a",
		description = "It contains the sweat spilled in many battles and is said to be used for certain perfumes too.",
		weight = 300
	},
	{id = 5886, name = "spool of yarn", article = "a", description = "It is made from fine spider silk.", weight = 100},
	{
		id = 5887,
		name = "piece of royal steel",
		article = "a",
		description = "Even the king would be proud to wear an armour made of this refined steel.",
		weight = 500
	},
	{
		id = 5888,
		name = "piece of hell steel",
		article = "a",
		description = "This rare metal must have been refined in the depths.",
		weight = 500
	},
	{
		id = 5889,
		name = "piece of draconian steel",
		article = "a",
		description = "An armour made of this steel is said to protect against fiery dragon breath.",
		weight = 500
	},
	{
		id = 5890,
		name = "chicken feather",
		article = "a",
		weight = 10,
		description = "Some thousands of these would probably make an extremely comfortable pillow."
	},
	{id = 5891, name = "enchanted chicken wing", article = "an", description = "It is said to make your feet fly.", weight = 1000},
	{id = 5892, name = "huge chunk of crude iron", article = "a", weight = 5000},
	{
		id = 5893,
		name = "perfect behemoth fang",
		article = "a",
		description = "Collectors all around the world crave for this item.",
		weight = 500
	},
	{id = 5894, name = "bat wing", article = "a", weight = 100},
	{id = 5895, name = "fish fin", article = "a", description = "It once belonged to a mighty creature of the deep.", weight = 120},
	{id = 5896, name = "bear paw", article = "a", weight = 120},
	{id = 5897, name = "wolf paw", article = "a", weight = 80},
	{id = 5898, name = "bonelord eye", article = "a", description = "You could swear it just winked at you.", weight = 500},
	{id = 5899, name = "turtle shell", article = "a", weight = 500},
	{
		id = 5900,
		name = "dwarven beard",
		article = "a",
		description = "It was once worn proudly by a dwarfish warrior - or maiden.",
		weight = 50
	},
	{id = 5901, name = "wood", weight = 500, showCount = false},
	{id = 5902, name = "honeycomb", article = "a", description = "Some people swear it makes an excellent glue.", weight = 80},
	{
		id = 5903,
		name = "Ferumbras' hat",
		description = "It is the proof that Ferumbras has fallen. For now. The Edron Academy should be interested in this.",
		weight = 850,
		armor = 1,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 5904,
		name = "magic sulphur",
		description = "It smells rather badly but is said to be an important catalyst for magical rituals.",
		weight = 100,
		showCount = false
	},
	{
		id = 5905,
		name = "vampire dust",
		description = "Sun can be a merciless killer, but so can you.",
		weight = 100,
		showCount = false
	},
	{id = 5906, name = "demon dust", description = "It reeks of hatred and malice.", weight = 100},
	{
		id = 5907,
		name = "slingshot",
		article = "a",
		description = "A hermit near Carlin might be able to tell you more about it.",
		weight = 200
	},
	{
		id = 5908,
		name = "obsidian knife",
		article = "an",
		description = "Sharp and light, this is a useful tool for tanners, doctors and assassins.",
		weight = 100
	},
	{id = 5909, name = "white piece of cloth", article = "a", plural = "white pieces of cloth", weight = 500},
	{id = 5910, name = "green piece of cloth", article = "a", plural = "green pieces of cloth", weight = 500},
	{id = 5911, name = "red piece of cloth", article = "a", plural = "red pieces of cloth", weight = 500},
	{id = 5912, name = "blue piece of cloth", article = "a", plural = "blue pieces of cloth", weight = 500},
	{id = 5913, name = "brown piece of cloth", article = "a", plural = "brown pieces of cloth", weight = 500},
	{id = 5914, name = "yellow piece of cloth", article = "a", plural = "yellow pieces of cloth", weight = 500},
	{fromId = 5915, toId = 5916, name = "large throne", article = "a"},
	{
		id = 5917,
		name = "bandana",
		article = "a",
		description = "It is quite fashionable as well as useful for anyone spending huge amounts of time in the sun.",
		weight = 850,
		armor = 1,
		slotPosition = SLOTP_HEAD
	},
	{id = 5918, name = "pirate knee breeches", weight = 1200, armor = 1, slotPosition = SLOTP_LEGS},
	{id = 5919, name = "dragon claw", article = "a", description = "It is the claw of Demodras.", weight = 1250},
	{id = 5920, name = "green dragon scale", article = "a", weight = 80},
	{id = 5921, name = "heaven blossom", article = "a", weight = 210},
	{id = 5922, name = "holy orchid", article = "a", weight = 250},
	{
		id = 5924,
		name = "damaged steel helmet",
		article = "a",
		description = "The words 'Ramsay the Reckless' are engraved inside. It appears to be cracked and broken.",
		weight = 4600
	},
	{id = 5925, name = "hardened bone", article = "a", weight = 600},
	{id = 5926, name = "pirate backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 5927, name = "pirate bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 5928, name = "empty goldfish bowl", article = "an", weight = 3200},
	{id = 5929, name = "goldfish bowl", article = "a", weight = 3200},
	{id = 5930, name = "behemoth claw", article = "a", weight = 1250},
	{
		id = 5931,
		name = "remains of Ferumbras",
		article = "the",
		containerSize = 40,
		decayTo = 5932,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{
		id = 5932,
		name = "remains of Ferumbras",
		article = "the",
		containerSize = 40,
		decayTo = 5933,
		duration = 600,
		corpseType = RACE_VENOM
	},
	{id = 5933, name = "remains of Ferumbras", article = "the", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 5934,
		name = "dead frog",
		article = "a",
		weight = 1000,
		containerSize = 9,
		decayTo = 5935,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5935, name = "dead frog", article = "a", weight = 800, decayTo = 5936, duration = 600, corpseType = RACE_BLOOD},
	{id = 5936, name = "dead frog", article = "a", weight = 500, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 5937,
		name = "griffinclaw container",
		article = "a",
		description = "It holds a sample of the rare griffinclaw flower.",
		weight = 2000
	},
	{id = 5938, name = "Ceiron's waterskin", weight = 700},
	{id = 5939, name = "Ceiron's waterskin", weight = 700},
	{
		id = 5940,
		name = "Ceiron's wolf tooth chain",
		description = "It has the letter 'C' carved into one of the teeth.",
		weight = 330,
		slotPosition = SLOTP_NECKLACE
	},
	{id = 5941, name = "wooden stake", article = "a", description = "It is a simple wooden stake.", weight = 500},
	{
		id = 5942,
		name = "blessed wooden stake",
		article = "a",
		description = "Many mighty priests have blessed this stake.",
		weight = 500
	},
	{id = 5943, name = "Morgaroth's heart", weight = 3500},
	{
		id = 5944,
		name = "soul orb",
		article = "a",
		description = "This strange object seems to be made of half spirit, half metal. It is unknown to most smiths.",
		weight = 20
	},
	{id = 5945, name = "coral comb", article = "a", description = "It once belonged to a mermaid.", weight = 450},
	{id = 5946, name = "comb", article = "a", weight = 450},
	{id = 5947, name = "Elane's crossbow", description = "'For Elane, with Love' is engraved on it.", weight = 4000},
	{id = 5948, name = "red dragon leather", weight = 60, showCount = false},
	{id = 5949, name = "beach backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 5950, name = "beach bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 5951, name = "fish tail", article = "a", weight = 250},
	{id = 5952, name = "poem scroll", article = "a", weight = 120},
	{id = 5953, name = "raven herb", article = "a", weight = 100},
	{id = 5954, name = "demon horn", article = "a", weight = 1000},
	{id = 5956, name = "old parchment", article = "an", description = "It is covered with foreign symbols.", weight = 200},
	{id = 5957, name = "lottery ticket", article = "a", description = "It has not been used yet.", weight = 120},
	{
		id = 5958,
		name = "winning lottery ticket",
		article = "a",
		description = "You were lucky! Go claim your prize at the potion store in Edron.",
		weight = 120
	},
	{
		id = 5960,
		name = "dead troll",
		article = "a",
		containerSize = 24,
		decayTo = 3067,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5961,
		name = "dead spider",
		article = "a",
		containerSize = 10,
		decayTo = 2807,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 5962,
		name = "dead cyclops",
		article = "a",
		containerSize = 30,
		decayTo = 3069,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5963, name = "slain skeleton", article = "a", containerSize = 28, decayTo = 2809, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 5964,
		name = "dead rat",
		article = "a",
		containerSize = 10,
		decayTo = 3073,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5965, name = "dead human", article = "a", containerSize = 10},
	{
		id = 5966,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 3080,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5967,
		name = "dead rotworm",
		article = "a",
		containerSize = 20,
		decayTo = 3084,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5968,
		name = "dead wolf",
		article = "a",
		containerSize = 5,
		decayTo = 3086,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5969,
		name = "dead minotaur",
		article = "a",
		containerSize = 30,
		decayTo = 3090,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5970,
		name = "dead deer",
		article = "a",
		containerSize = 5,
		decayTo = 3095,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5971,
		name = "dead dog",
		article = "a",
		containerSize = 5,
		decayTo = 3099,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5972, name = "slain skeleton", article = "a", containerSize = 28, decayTo = 3103, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 5973,
		name = "dead dragon",
		article = "a",
		containerSize = 52,
		decayTo = 3104,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5974,
		name = "dead spider",
		article = "a",
		containerSize = 10,
		decayTo = 2848,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 5975,
		name = "dead bear",
		article = "a",
		containerSize = 20,
		decayTo = 3109,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5976, name = "slain ghoul", article = "a", containerSize = 24, decayTo = 3113, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 5977,
		name = "dead giant spider",
		article = "a",
		containerSize = 30,
		decayTo = 2857,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 5978,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 2860,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5979,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 2862,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5980,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 2864,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5981,
		name = "dead minotaur",
		article = "a",
		containerSize = 30,
		decayTo = 2866,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5982,
		name = "dead minotaur",
		article = "a",
		containerSize = 30,
		decayTo = 2871,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5983,
		name = "dead minotaur",
		article = "a",
		containerSize = 30,
		decayTo = 2876,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5984,
		name = "dead dragon",
		article = "a",
		containerSize = 52,
		decayTo = 2881,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5985, name = "dead fire devil", article = "a", containerSize = 10, decayTo = 2886, duration = 10, corpseType = RACE_BLOOD},
	{
		id = 5986,
		name = "dead lion",
		article = "a",
		containerSize = 20,
		decayTo = 2889,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5987,
		name = "dead bear",
		article = "a",
		containerSize = 20,
		decayTo = 2893,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5988,
		name = "dead scorpion",
		article = "a",
		containerSize = 10,
		decayTo = 2897,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 5989,
		name = "dead wasp",
		article = "a",
		containerSize = 10,
		decayTo = 2899,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 5990,
		name = "dead bug",
		article = "a",
		containerSize = 10,
		decayTo = 2902,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 5991,
		name = "dead sheep",
		article = "a",
		containerSize = 5,
		decayTo = 2905,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5992,
		name = "dead bonelord",
		article = "a",
		containerSize = 32,
		decayTo = 2908,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 5993, name = "remains of a ghost", containerSize = 10, decayTo = 3108, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 5994,
		name = "dead sheep",
		article = "a",
		containerSize = 5,
		decayTo = 2914,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 5995, name = "slain demon", article = "a", containerSize = 30, decayTo = 2916, duration = 10, corpseType = RACE_FIRE},
	{
		id = 5996,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 2920,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5997,
		name = "dead wolf",
		article = "a",
		containerSize = 5,
		decayTo = 2924,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5998,
		name = "dead troll",
		article = "a",
		containerSize = 24,
		decayTo = 2928,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 5999,
		name = "dead behemoth",
		article = "a",
		containerSize = 50,
		decayTo = 2931,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6000,
		name = "dead pig",
		article = "a",
		containerSize = 5,
		decayTo = 2935,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6001,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 2938,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6002,
		name = "dead goblin",
		article = "a",
		containerSize = 24,
		decayTo = 2940,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6003,
		name = "dead elf",
		article = "a",
		containerSize = 20,
		decayTo = 2945,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6004, name = "remains of a mummy", containerSize = 10, decayTo = 2949, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6005,
		name = "split stone golem",
		article = "a",
		containerSize = 30,
		decayTo = 2952,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{id = 6006, name = "slain vampire", article = "a", containerSize = 28, decayTo = 2956, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6007,
		name = "dead dwarf",
		article = "a",
		containerSize = 24,
		decayTo = 2960,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6008,
		name = "dead orc",
		article = "a",
		containerSize = 20,
		decayTo = 2967,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6009,
		name = "dead war wolf",
		article = "a",
		containerSize = 20,
		decayTo = 2969,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6010,
		name = "dead orc and wolf",
		article = "a",
		containerSize = 24,
		decayTo = 2972,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6011,
		name = "dead elf",
		article = "a",
		containerSize = 32,
		decayTo = 2979,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6012,
		name = "dead elf",
		article = "a",
		containerSize = 20,
		decayTo = 2981,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6013,
		name = "dead dwarf",
		article = "a",
		containerSize = 24,
		decayTo = 2983,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6014,
		name = "dead dwarf",
		article = "a",
		containerSize = 24,
		decayTo = 2985,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6015,
		name = "dead dwarf",
		article = "a",
		containerSize = 24,
		decayTo = 2987,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6016,
		name = "dead djinn",
		article = "a",
		containerSize = 36,
		decayTo = 2989,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6017,
		name = "dead rabbit",
		article = "a",
		containerSize = 5,
		decayTo = 3119,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6018,
		name = "dead swamp troll",
		article = "a",
		containerSize = 24,
		decayTo = 2995,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6019, name = "slain banshee", article = "a", containerSize = 44, decayTo = 2998, duration = 10, corpseType = RACE_UNDEAD},
	{id = 6020, name = "dead djinn", article = "a", containerSize = 36, decayTo = 3001, duration = 10, corpseType = RACE_BLOOD},
	{
		id = 6021,
		name = "dead scarab",
		article = "a",
		containerSize = 16,
		decayTo = 3004,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 6022, name = "dead human", article = "a", containerSize = 10},
	{
		id = 6023,
		name = "dead larva",
		article = "a",
		containerSize = 5,
		decayTo = 3010,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6024,
		name = "dead scarab",
		article = "a",
		containerSize = 20,
		decayTo = 3013,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 6025, name = "dead pharaoh", article = "a", containerSize = 10, decayTo = 3016, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6026,
		name = "dead hyaena",
		article = "a",
		containerSize = 14,
		decayTo = 3019,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6027, name = "dead gargoyle", article = "a", containerSize = 28, decayTo = 3022, duration = 10, corpseType = RACE_UNDEAD},
	{id = 6028, name = "slain lich", article = "a", containerSize = 30, decayTo = 3025, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6029,
		name = "slain crypt shambler",
		article = "a",
		containerSize = 24,
		decayTo = 3028,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{id = 6030, name = "slain bonebeast", article = "a", containerSize = 24, decayTo = 3031, duration = 10, corpseType = RACE_UNDEAD},
	{id = 6031, name = "dead pharaoh", article = "a", containerSize = 15, decayTo = 3034, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6032,
		name = "dead efreet",
		article = "a",
		containerSize = 36,
		decayTo = 3037,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6033,
		name = "dead marid",
		article = "a",
		containerSize = 36,
		decayTo = 3040,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6034,
		name = "dead badger",
		article = "a",
		containerSize = 20,
		decayTo = 3043,
		corpseType = RACE_BLOOD,
		duration = 10,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6035,
		name = "dead skunk",
		article = "a",
		containerSize = 5,
		decayTo = 3046,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6036,
		name = "dead gazer",
		article = "a",
		containerSize = 5,
		decayTo = 3049,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6037,
		name = "dead elder bonelord",
		article = "a",
		containerSize = 38,
		decayTo = 3052,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6038,
		name = "dead yeti",
		article = "a",
		containerSize = 15,
		decayTo = 3055,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6039,
		name = "dead crab",
		article = "a",
		containerSize = 10,
		decayTo = 4253,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6040,
		name = "dead lizard sentinel",
		article = "a",
		containerSize = 28,
		decayTo = 4259,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6041,
		name = "dead lizard snakecharmer",
		article = "a",
		containerSize = 7,
		decayTo = 4262,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6042,
		name = "dead chicken",
		article = "a",
		containerSize = 5,
		decayTo = 4265,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6043,
		name = "dead kongra",
		article = "a",
		containerSize = 24,
		decayTo = 4268,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6044,
		name = "dead merlkin",
		article = "a",
		containerSize = 24,
		decayTo = 4271,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6045,
		name = "dead sibang",
		article = "a",
		containerSize = 24,
		decayTo = 4274,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6046,
		name = "dead crocodile",
		article = "a",
		containerSize = 18,
		decayTo = 4277,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6047,
		name = "dead carniphila",
		article = "a",
		containerSize = 30,
		decayTo = 4280,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6048,
		name = "dead hydra",
		article = "a",
		containerSize = 36,
		decayTo = 4283,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6049,
		name = "dead panda",
		article = "a",
		containerSize = 5,
		decayTo = 4286,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6050,
		name = "dead centipede",
		article = "a",
		containerSize = 10,
		decayTo = 4289,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6051,
		name = "dead tiger",
		article = "a",
		containerSize = 24,
		decayTo = 4292,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6052,
		name = "dead elephant",
		article = "a",
		containerSize = 30,
		decayTo = 4295,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6053,
		name = "dead bat",
		article = "a",
		containerSize = 14,
		decayTo = 4298,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6054,
		name = "dead flamingo",
		article = "a",
		containerSize = 5,
		decayTo = 4301,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6055,
		name = "dead dworc",
		article = "a",
		containerSize = 24,
		decayTo = 4304,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6056,
		name = "dead parrot",
		article = "a",
		containerSize = 5,
		decayTo = 4314,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6057,
		name = "dead bird",
		article = "a",
		containerSize = 30,
		decayTo = 4317,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6058,
		name = "dead dworc",
		article = "a",
		containerSize = 24,
		decayTo = 4307,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6059,
		name = "dead dworc",
		article = "a",
		containerSize = 24,
		decayTo = 4310,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6060,
		name = "dead tarantula",
		article = "a",
		containerSize = 16,
		decayTo = 4320,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6061,
		name = "dead serpent spawn",
		article = "a",
		containerSize = 40,
		decayTo = 4323,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6062,
		name = "lifeless nettle",
		article = "a",
		containerSize = 16,
		decayTo = 4326,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6063,
		name = "dead quara pincher",
		article = "a",
		containerSize = 26,
		decayTo = 5522,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6064,
		name = "dead quara mantassin",
		article = "a",
		containerSize = 36,
		decayTo = 5523,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6065,
		name = "dead quara constrictor",
		article = "a",
		containerSize = 28,
		decayTo = 5524,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6066,
		name = "dead quara hydromancer",
		article = "a",
		containerSize = 26,
		decayTo = 5525,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6067,
		name = "dead quara predator",
		article = "a",
		containerSize = 30,
		decayTo = 5526,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6068, name = "demon dust", containerSize = 24, decayTo = 5527, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6069,
		name = "dead carrion worm",
		article = "a",
		containerSize = 10,
		decayTo = 5540,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6070,
		name = "slain pirate skeleton",
		article = "a",
		containerSize = 20,
		decayTo = 5565,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6071,
		name = "slain pirate ghost",
		article = "a",
		containerSize = 20,
		decayTo = 5566,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6072,
		name = "dead tortoise",
		article = "a",
		containerSize = 30,
		decayTo = 5625,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6073,
		name = "dead tortoise",
		article = "a",
		containerSize = 36,
		decayTo = 5628,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6074,
		name = "dead mammoth",
		article = "a",
		containerSize = 30,
		decayTo = 5666,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6075,
		name = "dead blood crab",
		article = "a",
		containerSize = 20,
		decayTo = 5688,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6076,
		name = "dead seagull",
		article = "a",
		containerSize = 5,
		decayTo = 5727,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6077,
		name = "dead toad",
		article = "a",
		containerSize = 20,
		decayTo = 5765,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6078,
		name = "remains of Ferumbras",
		article = "the",
		containerSize = 40,
		decayTo = 5931,
		duration = 10,
		corpseType = RACE_VENOM
	},
	{
		id = 6079,
		name = "dead frog",
		article = "a",
		containerSize = 9,
		decayTo = 5934,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6080,
		name = "dead human",
		article = "a",
		containerSize = 10,
		decayTo = 3058,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6081,
		name = "dead human",
		article = "a",
		containerSize = 10,
		decayTo = 3065,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6082, name = "dead human", article = "a"},
	{id = 6083, name = "dead human", article = "a", containerSize = 10},
	{id = 6084, name = "dead human", article = "a", containerSize = 10, decayTo = 6082, duration = 120},
	{id = 6085, name = "heavy trunk", article = "a"},
	{id = 6086, name = "faked label", article = "a", weight = 10},
	{id = 6087, name = "music sheet", article = "a", description = "It contains the first verse of a hymn.", weight = 50},
	{id = 6088, name = "music sheet", article = "a", description = "It contains the second verse of a hymn.", weight = 50},
	{id = 6089, name = "music sheet", article = "a", description = "It contains the third verse of a hymn.", weight = 50},
	{id = 6090, name = "music sheet", article = "a", description = "It contains the fourth and last verse of a hymn.", weight = 50},
	{id = 6091, name = "very noble-looking watch", article = "a", description = "Unfortunately it seems to be broken.", weight = 50},
	{id = 6092, name = "very noble-looking watch", article = "a", weight = 50, duration = 259200, decayTo = 6091},
	{id = 6093, name = "crystal ring", article = "a", description = "The initials E.S. are engraved on it.", weight = 90},
	{id = 6094, name = "thread tree", article = "a"},
	{id = 6095, name = "pirate shirt", article = "a", weight = 2000, armor = 3, slotPosition = SLOTP_ARMOR},
	{id = 6096, name = "pirate hat", article = "a", weight = 1250, armor = 3, slotPosition = SLOTP_HEAD},
	{id = 6097, name = "hook", article = "a", description = "It belonged once to a pirate.", weight = 500},
	{
		id = 6098,
		name = "eye patch",
		article = "an",
		plural = "eye patches",
		description = "It belonged once to a pirate.",
		weight = 150
	},
	{id = 6099, name = "Brutus Bloodbeard's hat", weight = 1250},
	{id = 6100, name = "Lethal Lissy's shirt", article = "the", weight = 2000},
	{id = 6101, name = "Ron the Ripper's sabre", weight = 2500, defense = 10, attack = 12, weaponType = WEAPON_SWORD},
	{id = 6102, name = "Deadeye Devious' eye patch", weight = 150},
	{id = 6103, name = "unholy book", article = "an", weight = 1300},
	{id = 6104, name = "jewel case", article = "a", weight = 170, containerSize = 1},
	{id = 6105, name = "Striker's favourite pillow", weight = 1700},
	{id = 6106, name = "bottle of whisper beer", article = "a", weight = 300},
	{
		id = 6107,
		name = "staff",
		article = "a",
		description = "It must be the one which Simon the Beggar talked about.",
		weight = 3800
	},
	{id = 6108, name = "atlas", article = "an", description = "It is filled with detailed maps.", weight = 1300},
	{id = 6109, name = "weapon rack", article = "a", rotateTo = 6110, containerSize = 20},
	{id = 6110, name = "weapon rack", article = "a", rotateTo = 6109, containerSize = 20},
	{id = 6111, name = "armor rack", article = "an", rotateTo = 6112, containerSize = 20},
	{id = 6112, name = "armor rack", article = "an", rotateTo = 6111, containerSize = 20},
	{id = 6113, name = "letter to Eremo", article = "a", weight = 50},
	{
		id = 6114,
		name = "armor rack kit",
		article = "an",
		description = "Use it in your house to construct an armor rack.",
		weight = 3500
	},
	{
		id = 6115,
		name = "weapon rack kit",
		article = "a",
		description = "Use it in your house to construct a weapon rack.",
		weight = 3500
	},
	{fromId = 6116, toId = 6117, name = "electric sparks"},
	{
		id = 6118,
		name = "treasure map",
		article = "a",
		weight = 830,
		description = "It obviously shows Treasure Island including a big, red cross."
	},
	{id = 6119, name = "scroll", article = "a", weight = 120},
	{
		id = 6120,
		name = "Dragha's spellbook",
		description = "It apparently belonged to someone called Dragha, the apprentice of a voodoomaster.",
		weight = 5800
	},
	{fromId = 6121, toId = 6122, name = "note pinned on the wall", article = "a", allowDistRead = true},
	{id = 6123, name = "strange piano", article = "a"},
	{
		id = 6124,
		name = "damaged logbook",
		article = "a",
		description = "It must be the one which the explorer society requested.",
		weight = 1100
	},
	{
		id = 6125,
		name = "tortoise egg from Nargor",
		article = "a",
		description = "Handle with care and don't try to eat it.",
		weight = 30
	},
	{id = 6126, name = "peg leg", article = "a", description = "It belonged once to a pirate.", weight = 500},
	{fromId = 6127, toId = 6130, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 6131, name = "tortoise shield", article = "a", weight = 5200, defense = 26, weaponType = WEAPON_SHIELD},
	{
		id = 6132,
		name = "pair of soft boots",
		article = "a",
		weight = 800,
		slotPosition = SLOTP_FEET,
		transformEquipTo = 2640,
		stopDuration = true,
		showDuration = true
	},
	{fromId = 6133, toId = 6159, name = "tree wall", article = "a"},
	{fromId = 6160, toId = 6172, name = "grass roof", article = "a"},
	{fromId = 6173, toId = 6174, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 6175, toId = 6176, name = "tree archway", article = "a"},
	{id = 6177, name = "branch", article = "a"},
	{fromId = 6178, toId = 6179, name = "tree hole", article = "a"},
	{fromId = 6180, toId = 6181, name = "tree", article = "a"},
	{fromId = 6182, toId = 6189, name = "large branch", article = "a"},
	{fromId = 6190, toId = 6191, name = "branch", article = "a"},
	{id = 6192, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 6193, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6194, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6195, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 6196, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6197, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6198, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6199, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6200, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6201, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6202, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6203, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6204, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6205, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6206, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 6207, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 6208, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 6209, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6210, toId = 6215, name = "rope bridge", article = "a"},
	{fromId = 6216, toId = 6219, name = "grass"},
	{fromId = 6220, toId = 6225, name = "twines"},
	{fromId = 6226, toId = 6231, name = "flowers"},
	{fromId = 6232, toId = 6233, name = "tree archway", article = "a"},
	{fromId = 6234, toId = 6237, name = "tendril archway", article = "a"},
	{fromId = 6238, toId = 6248, name = "tendril wall", article = "a"},
	{id = 6249, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 6250, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6251, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6252, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 6253, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6254, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6255, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6256, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6257, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6258, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6259, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6260, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6261, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6262, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6263, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 6264, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 6265, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 6266, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 6267, name = "smashed stone", article = "a"},
	{fromId = 6268, toId = 6270, name = "tendrils"},
	{fromId = 6271, toId = 6274, name = "leaves"},
	{id = 6275, name = "tree archway", article = "a"},
	{id = 6276, name = "tendrils"},
	{id = 6277, name = "lump of cake dough", article = "a", weight = 100},
	{id = 6278, name = "cake", article = "a", weight = 500},
	{id = 6279, name = "cake", article = "a", weight = 600, description = "It is nicely decorated with fruits and icing."},
	{
		id = 6280,
		name = "party cake",
		article = "a",
		weight = 700,
		description = "It is nicely decorated with fruits, icing and a candle. Someone is caring about you."
	},
	{fromId = 6281, toId = 6284, name = "broken brick wall", article = "a"},
	{fromId = 6285, toId = 6286, name = "some cracks"},
	{fromId = 6289, toId = 6290, name = "burning wall", article = "a"},
	{fromId = 6291, toId = 6299, name = "some cracks"},
	{
		id = 6300,
		name = "death ring",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		transformEquipTo = 6301,
		stopDuration = true,
		showDuration = true,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 5}
	},
	{
		id = 6301,
		name = "death ring",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_RING,
		armor = 1,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 5},
		decayTo = 0,
		transformDeEquipTo = 6300,
		duration = 480,
		skillShield = -10,
		showDuration = true,
		description = "Wearing it makes you feel a little weaker than usual."
	},
	{
		id = 6302,
		name = "dead wyvern",
		article = "a",
		containerSize = 20,
		decayTo = 6303,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6303, name = "dead wyvern", article = "a", containerSize = 20, decayTo = 6304, duration = 900, corpseType = RACE_BLOOD},
	{id = 6304, name = "dead wyvern", article = "a", containerSize = 20, decayTo = 6305, duration = 600, corpseType = RACE_BLOOD},
	{id = 6305, name = "dead wyvern", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 6306,
		name = "slain undead dragon",
		article = "a",
		containerSize = 48,
		decayTo = 6307,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6307,
		name = "slain undead dragon",
		article = "a",
		containerSize = 48,
		decayTo = 6308,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6308,
		name = "slain undead dragon",
		article = "a",
		containerSize = 48,
		decayTo = 6309,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 6309, name = "slain undead dragon", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 6310,
		name = "slain lost soul",
		article = "a",
		containerSize = 36,
		decayTo = 6319,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{id = 6311, name = "slain lost soul", article = "a", containerSize = 36, decayTo = 6310, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6312,
		name = "slain hand of cursed fate",
		article = "a",
		containerSize = 28,
		decayTo = 6313,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6313,
		name = "slain hand of cursed fate",
		article = "a",
		containerSize = 28,
		decayTo = 6314,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 6314,
		name = "slain hand of cursed fate",
		article = "a",
		containerSize = 28,
		decayTo = 6315,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 6315, name = "slain hand of cursed fate", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 6316,
		name = "slain betrayed wraith",
		article = "a",
		containerSize = 44,
		decayTo = 6317,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6317,
		name = "slain betrayed wraith",
		article = "a",
		containerSize = 44,
		decayTo = 6318,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{id = 6318, name = "slain betrayed wraith", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 6319, name = "slain betrayed wraith", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{
		id = 6320,
		name = "dead destroyer",
		article = "a",
		containerSize = 48,
		decayTo = 6321,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6321,
		name = "dead destroyer",
		article = "a",
		containerSize = 48,
		decayTo = 6322,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6322, name = "dead destroyer", article = "a", containerSize = 48, decayTo = 6323, duration = 600, corpseType = RACE_BLOOD},
	{id = 6323, name = "dead destroyer", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 6324, name = "elemental ashes", containerSize = 38, decayTo = 6325, duration = 10},
	{id = 6325, name = "elemental ashes", containerSize = 38, decayTo = 6326, duration = 900},
	{id = 6326, name = "elemental ashes", containerSize = 38, decayTo = 6327, duration = 600},
	{id = 6327, name = "elemental ashes", decayTo = 0, duration = 600},
	{id = 6328, name = "dead torturer", article = "a", containerSize = 26, decayTo = 6329, duration = 900, corpseType = RACE_BLOOD},
	{id = 6329, name = "dead torturer", article = "a", containerSize = 26, decayTo = 6330, duration = 600, corpseType = RACE_BLOOD},
	{id = 6330, name = "dead torturer", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 6331, name = "dead torturer", article = "a", containerSize = 26, decayTo = 6328, duration = 10, corpseType = RACE_BLOOD},
	{
		id = 6332,
		name = "dead hellhound",
		article = "a",
		containerSize = 20,
		decayTo = 6333,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6333, name = "dead hellhound", article = "a", containerSize = 20, decayTo = 6334, duration = 900, corpseType = RACE_BLOOD},
	{id = 6334, name = "dead hellhound", article = "a", containerSize = 20, decayTo = 6335, duration = 600, corpseType = RACE_BLOOD},
	{id = 6335, name = "dead hellhound", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 6336,
		name = "dead juggernaut",
		article = "a",
		containerSize = 40,
		decayTo = 6337,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6337, name = "dead juggernaut", article = "a", containerSize = 40, decayTo = 6338, duration = 900},
	{id = 6338, name = "dead juggernaut", article = "a", containerSize = 40, decayTo = 6339, duration = 600, corpseType = RACE_BLOOD},
	{id = 6339, name = "dead juggernaut", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 6340,
		name = "dead nightmare",
		article = "a",
		containerSize = 36,
		decayTo = 6341,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6341,
		name = "dead nightmare",
		article = "a",
		containerSize = 36,
		decayTo = 6342,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6342, name = "dead nightmare", article = "a", containerSize = 36, decayTo = 6343, duration = 600, corpseType = RACE_BLOOD},
	{id = 6343, name = "dead nightmare", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 6344, name = "remains of a phantasm", containerSize = 32, decayTo = 6345, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6345,
		name = "remains of a phantasm",
		weight = 10000,
		containerSize = 32,
		decayTo = 6346,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6346,
		name = "remains of a phantasm",
		weight = 8000,
		containerSize = 32,
		decayTo = 6347,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 6347, name = "remains of a phantasm", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 6348, name = "remains of a spectre", containerSize = 40, decayTo = 6349, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 6349,
		name = "remains of a spectre",
		weight = 10000,
		containerSize = 40,
		decayTo = 6350,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6350,
		name = "remains of a spectre",
		weight = 8000,
		containerSize = 40,
		decayTo = 6351,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 6351, name = "remains of a spectre", weight = 1000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 6353, name = "swamp", type = ITEM_TYPE_TRASHHOLDER, effect = CONST_ME_GREEN_RINGS},
	{
		id = 6354,
		name = "slain blightwalker",
		article = "a",
		containerSize = 40,
		decayTo = 6355,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 6355,
		name = "slain blightwalker",
		article = "a",
		containerSize = 40,
		weight = 10000,
		decayTo = 0,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 6356, name = "oven", article = "an", rotateTo = 6358},
	{id = 6357, name = "oven", article = "an", rotateTo = 6359},
	{id = 6358, name = "oven", article = "an", rotateTo = 6360},
	{id = 6359, name = "oven", article = "an", rotateTo = 6361},
	{id = 6360, name = "oven", article = "an", rotateTo = 6362},
	{id = 6361, name = "oven", article = "an", rotateTo = 6363},
	{id = 6362, name = "oven", article = "an", rotateTo = 6356},
	{id = 6363, name = "oven", article = "an", rotateTo = 6357},
	{
		id = 6364,
		name = "dead diabolic imp",
		article = "a",
		containerSize = 40,
		decayTo = 6365,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 6365,
		name = "dead diabolic imp",
		article = "a",
		containerSize = 40,
		decayTo = 6366,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6366, name = "dead diabolic imp", article = "a", decayTo = 6367, duration = 600, corpseType = RACE_BLOOD},
	{id = 6367, name = "dead diabolic imp", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 6368, name = "bookcase", article = "a", rotateTo = 6371, containerSize = 6},
	{id = 6369, name = "bookcase", article = "a", rotateTo = 6368, containerSize = 6},
	{id = 6370, name = "bookcase", article = "a", rotateTo = 6369, containerSize = 6},
	{id = 6371, name = "bookcase", article = "a", rotateTo = 6370, containerSize = 6},
	{id = 6372, name = "oven kit", article = "an", description = "Use it in your house to construct an oven.", weight = 2500},
	{id = 6373, name = "bookcase kit", article = "a", description = "Use it in your house to construct a bookcase.", weight = 2500},
	{fromId = 6374, toId = 6386, name = "debris"},
	{id = 6387, name = "greeting card", article = "a", weight = 100, writeable = true, maxTextLen = 1023},
	{id = 6388, name = "christmas card", article = "a", weight = 100, writeable = true, maxTextLen = 0},
	{id = 6389, name = "stony floor"},
	{id = 6390, name = "ornamented fountain", article = "an", fluidSource = FLUID_WATER},
	{
		id = 6391,
		name = "nightmare shield",
		article = "a",
		description = "It was crafted by the ancient order of the nightmare knights.",
		weight = 3200,
		defense = 37,
		weaponType = WEAPON_SHIELD
	},
	{id = 6392, name = "hawser", article = "a"},
	{id = 6393, name = "valentine's cake", article = "a", weight = 500},
	{id = 6394, name = "cream cake", article = "a", weight = 500},
	{fromId = 6395, toId = 6396, name = "bones"},
	{id = 6397, name = "bone", article = "a"},
	{fromId = 6398, toId = 6412, name = "bones"},
	{id = 6413, name = "bone pillar", article = "a"},
	{fromId = 6414, toId = 6421, name = "bones"},
	{id = 6422, name = "stone railing", article = "a"},
	{fromId = 6423, toId = 6430, name = "large branch", article = "a"},
	{fromId = 6431, toId = 6432, name = "branch", article = "a"},
	{
		id = 6433,
		name = "necromancer shield",
		article = "a",
		description = "It is enchanted with unholy, necromantic powers.",
		weight = 3200,
		defense = 37,
		weaponType = WEAPON_SHIELD
	},
	{id = 6434, name = "blue tapestry", article = "a"},
	{id = 6435, name = "demon trophy", article = "a"},
	{fromId = 6436, toId = 6437, name = "framework window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6438, toId = 6439, name = "framework window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6440, toId = 6441, name = "brick window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6442, toId = 6443, name = "brick window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6444, toId = 6445, name = "stone wall window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6446, toId = 6447, name = "stone wall window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6448, toId = 6449, name = "white stone wall window", article = "a"},
	{fromId = 6450, toId = 6451, name = "tree hole", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6452, toId = 6453, name = "tree hole", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6454, toId = 6455, name = "sandstone window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6456, toId = 6457, name = "sandstone window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6458, toId = 6459, name = "bamboo wall window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6460, toId = 6461, name = "bamboo wall window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6462, toId = 6463, name = "sandstone window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6464, toId = 6465, name = "sandstone window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6466, toId = 6467, name = "stone wall window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6468, toId = 6469, name = "stone wall window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6470, toId = 6471, name = "wooden wall window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6472, toId = 6473, name = "wooden wall window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 6474, toId = 6475, name = "wooden planks"},
	{fromId = 6476, toId = 6488, name = "debris"},
	{fromId = 6489, toId = 6490, name = "christmas branch", slotPosition = SLOTP_AMMO, weight = 1800},
	{id = 6491, name = "firefly", article = "a", decayTo = 6494, duration = 8},
	{id = 6492, name = "bat decoration", article = "a", weight = 200},
	{id = 6493, name = "bat decoration", article = "a"},
	{id = 6494, name = "firefly", article = "a", decayTo = 6491, duration = 8},
	{id = 6495, name = "firefly", article = "a", decayTo = 6498, duration = 8},
	{id = 6496, name = "bat decoration", article = "a"},
	{
		id = 6497,
		name = "christmas present bag",
		article = "a",
		description = "It contains presents which were stolen from Santa. Bring them back to Ruprecht on Vega.",
		weight = 8000
	},
	{id = 6498, name = "firefly", article = "a"},
	{
		id = 6499,
		name = "certificate",
		article = "a",
		description = "You have mastered the Dream Challenge and may apply for joining the order of the Nightmare Knights.",
		weight = 150
	},
	{id = 6500, name = "demonic essence", description = "Someone might be interested in trading this.", weight = 100},
	{id = 6501, name = "gingerbreadman", article = "a", weight = 500},
	{id = 6502, name = "christmas wreath", article = "a", weight = 1000},
	{id = 6503, name = "christmas garland", article = "a", weight = 500},
	{id = 6504, name = "red christmas garland", article = "a", weight = 500},
	{id = 6505, name = "blue christmas garland", article = "a", weight = 500},
	{id = 6506, name = "christmas present", article = "a", weight = 600, containerSize = 5},
	{
		id = 6507,
		name = "red christmas bundle",
		article = "a",
		description = "It contains random christmas decoration.",
		weight = 2500
	},
	{
		id = 6508,
		name = "blue christmas bundle",
		article = "a",
		description = "It contains random christmas decoration.",
		weight = 2500
	},
	{
		id = 6509,
		name = "green christmas bundle",
		article = "a",
		description = "It contains random christmas decoration.",
		weight = 2500
	},
	{fromId = 6510, toId = 6511, name = "christmas present", article = "a", weight = 600, containerSize = 5},
	{id = 6512, name = "santa doll", article = "a", weight = 750},
	{id = 6513, name = "christmas wreath", article = "a"},
	{fromId = 6514, toId = 6515, name = "christmas garland", article = "a"},
	{
		id = 6516,
		name = "dead plaguesmith",
		article = "a",
		containerSize = 32,
		decayTo = 6520,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 6517, name = "christmas wreath", article = "a"},
	{fromId = 6518, toId = 6519, name = "christmas garland", article = "a"},
	{
		id = 6520,
		name = "dead plaguesmith",
		article = "a",
		containerSize = 32,
		decayTo = 6521,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6521,
		name = "dead plaguesmith",
		article = "a",
		containerSize = 32,
		decayTo = 6522,
		duration = 600,
		corpseType = RACE_VENOM
	},
	{id = 6522, name = "dead plaguesmith", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 6523,
		name = "gingerbread recipe",
		article = "a",
		description = "Use it to learn how to make Gingerbreadman in the christmas bakery.",
		weight = 200
	},
	{fromId = 6524, toId = 6525, name = "skeleton", article = "a"},
	{id = 6526, name = "skeleton decoration", article = "a", weight = 1000},
	{
		id = 6527,
		name = "christmas token",
		article = "a",
		description = "Collect enough of these to trade them for valuable prizes.",
		weight = 5
	},
	{
		id = 6528,
		name = "the avenger",
		description = "This holy blade was forged of shattered dreams.",
		weight = 6400,
		defense = 38,
		attack = 50,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 6529,
		name = "infernal bolt",
		article = "an",
		weight = 90,
		slotPosition = SLOTP_AMMO,
		attack = 72,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_BOLT,
		shootType = CONST_ANI_INFERNALBOLT,
		maxHitChance = 91
	},
	{id = 6530, name = "worn leather boots", article = "a", weight = 900},
	{id = 6531, name = "santa hat", article = "a", weight = 750, armor = 1, slotPosition = SLOTP_HEAD},
	{
		id = 6532,
		name = "dead defiler",
		article = "a",
		containerSize = 36,
		decayTo = 6552,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 6533, name = "book", article = "a", weight = 750},
	{id = 6534, name = "the Imperor's trident", weight = 8000},
	{id = 6535, name = "the Plasmother's remains", weight = 3000},
	{id = 6536, name = "Countess Sorrow's frozen tear", weight = 1000},
	{id = 6537, name = "Mr. Punish's handcuffs", weight = 2500},
	{id = 6538, name = "valentine's card", article = "a", weight = 100, writeable = true, maxTextLen = 1023},
	{id = 6539, name = "the Handmaiden's protector", weight = 3500},
	{id = 6540, name = "piece of Massacre's shell", article = "a", weight = 6500},
	{fromId = 6541, toId = 6545, name = "coloured egg", article = "a", weight = 30},
	{id = 6546, name = "Dracola's eye", weight = 1500},
	{id = 6547, name = "yellow powder", weight = 50, showCount = false},
	{id = 6548, name = "purple powder", weight = 750},
	{id = 6549, name = "green powder", weight = 750},
	{id = 6550, name = "red powder", description = "It reeks of hatred and malice.", weight = 100},
	{id = 6551, name = "blue powder", description = "Sun can be a merciless killer, but so can you.", weight = 100},
	{
		id = 6552,
		name = "dead defiler",
		article = "a",
		decayTo = 0,
		duration = 360,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 6553,
		name = "ruthless axe",
		article = "a",
		weight = 5800,
		defense = 15,
		attack = 50,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		fromId = 6556,
		toId = 6557,
		name = "tic-tac-toe token",
		article = "a",
		description = "It seems to be rather fragile.",
		weight = 500
	},
	{id = 6558, name = "flask of demonic blood", description = "Shake it to create a potion.", weight = 200},
	{
		id = 6560,
		name = "dead human",
		article = "a",
		containerSize = 10,
		decayTo = 3065,
		duration = 180,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 6561, name = "ceremonial ankh", article = "a", weight = 500},
	{fromId = 6562, toId = 6565, name = "flat roof", article = "a"},
	{id = 6566, name = "stuffed dragon", article = "a", weight = 850, decayTo = 5791, duration = 3},
	{id = 6567, name = "santa doll", article = "a", weight = 750, decayTo = 6512, duration = 3},
	{id = 6568, name = "panda teddy", article = "a", weight = 600, decayTo = 5080, duration = 3},
	{id = 6569, name = "candy", article = "a", plural = "candies", weight = 5},
	{fromId = 6570, toId = 6571, name = "surprise bag", article = "a", weight = 1000},
	{id = 6572, name = "party trumpet", article = "a", weight = 50},
	{id = 6573, name = "party trumpet", article = "a", duration = 4, decayTo = 6572, weight = 50},
	{id = 6574, name = "bar of chocolate", article = "a", weight = 10},
	{id = 6575, name = "red balloons", weight = 10},
	{
		id = 6576,
		name = "fireworks rocket",
		article = "a",
		description = "Do not use in your backpack or while asleep. Keep away from animals or children.",
		weight = 100
	},
	{id = 6577, name = "green balloons", weight = 10},
	{id = 6578, name = "party hat", article = "a", weight = 750, armor = 1, slotPosition = SLOTP_HEAD},
	{id = 6579, name = "doll", article = "a", weight = 750},
	{fromId = 6580, toId = 6593, name = "snow"},
	{id = 6594, name = "snow", description = "Someone must have walked here recently.", decayTo = 670, duration = 10},
	{id = 6595, name = "snow", description = "Someone must have walked here recently.", decayTo = 6580, duration = 10},
	{id = 6596, name = "snow", description = "Someone must have walked here recently.", decayTo = 6581, duration = 10},
	{id = 6597, name = "snow", description = "Someone must have walked here recently.", decayTo = 6582, duration = 10},
	{id = 6598, name = "snow", description = "Someone must have walked here recently.", decayTo = 6583, duration = 10},
	{id = 6599, name = "snow", description = "Someone must have walked here recently.", decayTo = 6584, duration = 10},
	{id = 6600, name = "snow", description = "Someone must have walked here recently.", decayTo = 6585, duration = 10},
	{id = 6601, name = "snow", description = "Someone must have walked here recently.", decayTo = 6586, duration = 10},
	{id = 6602, name = "snow", description = "Someone must have walked here recently.", decayTo = 6587, duration = 10},
	{id = 6603, name = "snow", description = "Someone must have walked here recently.", decayTo = 6588, duration = 10},
	{id = 6604, name = "snow", description = "Someone must have walked here recently.", decayTo = 6589, duration = 10},
	{id = 6605, name = "snow", description = "Someone must have walked here recently.", decayTo = 6590, duration = 10},
	{id = 6606, name = "snow", description = "Someone must have walked here recently.", decayTo = 6591, duration = 10},
	{id = 6607, name = "snow", description = "Someone must have walked here recently.", decayTo = 6592, duration = 10},
	{id = 6608, name = "snow", description = "Someone must have walked here recently.", decayTo = 6593, duration = 10},
	{fromId = 6609, toId = 6626, name = "snow"},
	{fromId = 6627, toId = 6682, name = "shallow water"},
	{fromId = 6683, toId = 6686, name = "ice"},
	{fromId = 6687, toId = 6694, name = "shallow water"},
	{fromId = 6695, toId = 6718, name = "ice"},
	{fromId = 6719, toId = 6727, name = "icy mountain", article = "an"},
	{fromId = 6728, toId = 6729, name = "ice wall", article = "an"},
	{id = 6730, name = "ice pillar", article = "an"},
	{fromId = 6731, toId = 6738, name = "ice wall", article = "an"},
	{fromId = 6739, toId = 6740, name = "frozen wall", article = "a"},
	{id = 6741, name = "frozen pillar", article = "a"},
	{fromId = 6742, toId = 6749, name = "frozen wall", article = "a"},
	{fromId = 6750, toId = 6753, name = "ice hut", article = "an"},
	{fromId = 6754, toId = 6756, name = "ice hut", article = "an", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 6757, toId = 6760, name = "snow"},
	{fromId = 6761, toId = 6762, name = "icy mountain", article = "an"},
	{fromId = 6763, toId = 6767, name = "ice"},
	{fromId = 6768, toId = 6772, name = "icy mountain", article = "an"},
	{fromId = 6773, toId = 6774, name = "fur wall", article = "a"},
	{id = 6775, name = "fur pillar", article = "a"},
	{fromId = 6776, toId = 6787, name = "fur wall", article = "a"},
	{fromId = 6788, toId = 6789, name = "fur wall window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 6790, toId = 6791, name = "fur wall window", article = "a", type = ITEM_TYPE_DOOR},
	{id = 6792, name = "archway", article = "an"},
	{fromId = 6793, toId = 6794, name = "barbarian banner", article = "a"},
	{id = 6795, name = "entrance", article = "an", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6796, name = "entrance", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6797, name = "entrance", article = "an", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6798, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{
		id = 6799,
		name = "entrance",
		article = "an",
		description = "It seems tightly closed.",
		type = ITEM_TYPE_DOOR,
		blockProjectile = true
	},
	{id = 6800, name = "entrance", article = "an", type = ITEM_TYPE_DOOR},
	{
		id = 6801,
		name = "entrance",
		article = "an",
		description = "It seems tightly closed.",
		type = ITEM_TYPE_DOOR,
		blockProjectile = true
	},
	{id = 6802, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6803, name = "archway", article = "an"},
	{fromId = 6804, toId = 6821, name = "fur"},
	{fromId = 6822, toId = 6837, name = "frozen wall", article = "a"},
	{id = 6838, name = "snow"},
	{fromId = 6839, toId = 6840, name = "wooden wall", article = "a"},
	{id = 6841, name = "wooden pillar", article = "a"},
	{fromId = 6842, toId = 6849, name = "wooden wall", article = "a"},
	{id = 6850, name = "ornamented wall", article = "an"},
	{fromId = 6851, toId = 6852, name = "stone base", article = "a"},
	{id = 6853, name = "ornamented wall", article = "an"},
	{fromId = 6854, toId = 6867, name = "stone base", article = "a"},
	{fromId = 6869, toId = 6881, name = "ice"},
	{fromId = 6882, toId = 6885, name = "archway", article = "an"},
	{fromId = 6886, toId = 6888, name = "strut", article = "a"},
	{fromId = 6889, toId = 6890, name = "tusks"},
	{id = 6891, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 6892, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6893, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6894, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6895, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6896, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 6897, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 6898, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6899, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6900, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 6901, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6902, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6903, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6904, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6905, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 6906, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 6907, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 6908, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 6909, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_EAST},
	{id = 6910, name = "ramp", article = "a"},
	{id = 6911, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 6912, name = "ramp", article = "a"},
	{id = 6913, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH},
	{id = 6914, name = "ramp", article = "a"},
	{id = 6915, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 6916, name = "ramp", article = "a"},
	{fromId = 6917, toId = 6924, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 6925, toId = 6937, name = "ice"},
	{fromId = 6939, toId = 6952, name = "ice"},
	{fromId = 6953, toId = 6958, name = "ice railing", article = "an"},
	{id = 6959, name = "closed ice gate", article = "a"},
	{id = 6960, name = "open ice gate", article = "an"},
	{id = 6961, name = "closed ice gate", article = "a"},
	{id = 6962, name = "open ice gate", article = "an"},
	{fromId = 6963, toId = 6965, name = "ice railing", article = "an"},
	{id = 6966, name = "icicles"},
	{id = 6967, name = "ice floor"},
	{fromId = 6968, toId = 6969, name = "archway", article = "an"},
	{fromId = 6970, toId = 6971, name = "mammoth skull", article = "a"},
	{id = 6972, name = "bone totem", article = "a"},
	{id = 6973, name = "mammoth totem", article = "a"},
	{fromId = 6974, toId = 6977, name = "mammoth skull", article = "a"},
	{fromId = 6978, toId = 6980, name = "mammoth fur"},
	{fromId = 6981, toId = 6983, name = "rope", article = "a"},
	{fromId = 6984, toId = 6985, name = "fish"},
	{id = 6986, name = "pillar", article = "a"},
	{fromId = 6987, toId = 6988, name = "wooden dragon", article = "a"},
	{fromId = 6989, toId = 6990, name = "wooden bull", article = "a"},
	{fromId = 6991, toId = 6992, name = "wooden yeti", article = "a"},
	{fromId = 6993, toId = 6998, name = "wooden decoration"},
	{fromId = 6999, toId = 7019, name = "snowy stone", article = "a"},
	{fromId = 7020, toId = 7022, name = "snowy dead tree", article = "a"},
	{id = 7023, name = "snowy pine tree", article = "a"},
	{id = 7024, name = "pine", article = "a"},
	{fromId = 7025, toId = 7026, name = "nordic wall window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 7027, toId = 7028, name = "nordic wall window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 7029, toId = 7030, name = "ice wall window", article = "an", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 7031, toId = 7032, name = "ice wall window", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7033, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 7034, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7035, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7036, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7037, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7038, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 7039, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 7040, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7041, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7042, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 7043, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7044, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7045, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7046, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7047, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 7048, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 7049, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7050, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 7051, toId = 7052, name = "archway", article = "an"},
	{id = 7053, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 7054, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7055, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7056, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 7057, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 7058, name = "skull pillar", article = "a"},
	{id = 7059, name = "glowing skull pillar", article = "a"},
	{fromId = 7060, toId = 7061, name = "ice"},
	{fromId = 7062, toId = 7066, name = "rock"},
	{fromId = 7067, toId = 7090, name = "dark rock"},
	{
		id = 7091,
		name = "dead frost dragon",
		article = "a",
		containerSize = 50,
		decayTo = 7092,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 7092,
		name = "dead frost dragon",
		article = "a",
		containerSize = 50,
		decayTo = 7093,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 7093,
		name = "dead frost dragon",
		article = "a",
		containerSize = 50,
		decayTo = 7094,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 7094, name = "dead frost dragon", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{fromId = 7095, toId = 7101, name = "wooden railing", article = "a"},
	{fromId = 7102, toId = 7105, name = "frozen wall", article = "a"},
	{id = 7106, name = "inactive geyser", article = "an"},
	{id = 7107, name = "ice"},
	{fromId = 7108, toId = 7109, name = "geyser", article = "a"},
	{fromId = 7110, toId = 7120, name = "ice"},
	{fromId = 7121, toId = 7130, name = "rails"},
	{fromId = 7131, toId = 7132, name = "ore wagon", article = "an"},
	{fromId = 7133, toId = 7136, name = "buffer stop", article = "a"},
	{fromId = 7137, toId = 7139, name = "bloodspot", article = "a"},
	{id = 7140, name = "mead horn", article = "a", description = "It is empty.", weight = 1200},
	{id = 7141, name = "mead horn", article = "a", description = "It is filled to the rim.", weight = 1200},
	{id = 7142, name = "bucket", article = "a", description = "It is filled with mead."},
	{fromId = 7143, toId = 7144, name = "buttress", article = "a"},
	{fromId = 7145, toId = 7146, name = "ice"},
	{id = 7147, name = "debris"},
	{fromId = 7148, toId = 7154, name = "ice"},
	{id = 7155, name = "debris"},
	{fromId = 7156, toId = 7157, name = "ice"},
	{id = 7158, name = "rainbow trout", article = "a", weight = 1200},
	{id = 7159, name = "green perch", article = "a", weight = 800},
	{fromId = 7160, toId = 7161, name = "frozen chest", article = "a"},
	{id = 7162, name = "frozen chest of drawers", article = "a"},
	{fromId = 7163, toId = 7166, name = "frozen chair", article = "a"},
	{fromId = 7167, toId = 7168, name = "frozen pendulum clock", article = "a"},
	{fromId = 7169, toId = 7170, name = "frozen trough", article = "a"},
	{fromId = 7171, toId = 7173, name = "snowman", article = "a"},
	{id = 7174, name = "bear", article = "a", description = "It seems to be sleeping tightly."},
	{
		id = 7175,
		name = "bear",
		article = "a",
		description = "It seems to have fallen into a really deep sleep.",
		decayTo = 7174,
		duration = 10
	},
	{id = 7176, name = "mammoth", article = "a", description = "It is looking at you fiercely."},
	{
		id = 7177,
		name = "mammoth",
		article = "a",
		description = "It seems to be pretty much knocked out.",
		decayTo = 7176,
		duration = 10
	},
	{id = 7178, name = "baby seal", article = "a"},
	{id = 7183, name = "baby seal doll", article = "a", weight = 850},
	{id = 7184, name = "baby seal doll", article = "a", decayTo = 7183, duration = 3, weight = 850},
	{id = 7185, name = "small crack in the ice", article = "a", description = "This would be a good place to destroy the ice."},
	{id = 7186, name = "cracks in the ice"},
	{fromId = 7187, toId = 7188, name = "raft", article = "a"},
	{id = 7189, name = "stone shelf", article = "a", containerSize = 6},
	{fromId = 7190, toId = 7199, name = "raft", article = "a"},
	{id = 7200, name = "fragile ice"},
	{fromId = 7201, toId = 7212, name = "raft", article = "a"},
	{fromId = 7213, toId = 7214, name = "raft rudder", article = "a"},
	{fromId = 7215, toId = 7218, name = "ship rudder", article = "a"},
	{id = 7219, name = "ship rudder hole", article = "a"},
	{fromId = 7220, toId = 7227, name = "ship rudder", article = "a"},
	{fromId = 7228, toId = 7231, name = "figurehead", article = "a"},
	{fromId = 7232, toId = 7233, name = "spikes"},
	{fromId = 7234, toId = 7235, name = "shield", article = "a"},
	{id = 7236, name = "ice hole", article = "an", description = "You can see the movement of fish.", decayTo = 7200, duration = 300},
	{id = 7237, name = "ice hole", article = "an", decayTo = 7236, duration = 300},
	{fromId = 7238, toId = 7241, name = "shield", article = "a"},
	{id = 7242, name = "resonance crystal", article = "a", weight = 250},
	{id = 7243, name = "empty jug", article = "an", description = "It seems to be perfect for collecting ants.", weight = 750},
	{id = 7244, name = "jug", article = "a", description = "There are a lot of ants crawling in there.", weight = 750},
	{
		id = 7245,
		name = "piece of cactus",
		article = "a",
		description = "It has been cut from the sun adorer cactus which is said to have curing abilities.",
		weight = 100
	},
	{id = 7246, name = "Nilsor's waterskin", description = "It is filled with warm geyser water.", weight = 700},
	{id = 7247, name = "fine sulphur", description = "It has been extracted from an inactive lava hole.", weight = 50},
	{
		id = 7248,
		name = "frostbite herb",
		article = "a",
		description = "It has been cut from a plant which grows only in very cold regions.",
		weight = 100
	},
	{
		id = 7249,
		name = "purple kiss blossom",
		article = "a",
		description = "It has been cut from an exotic jungle flower.",
		weight = 20
	},
	{id = 7250, name = "hydra tongue", article = "a", description = "It is a common pest plant in warmer regions.", weight = 100},
	{id = 7251, name = "mushroom spores", description = "They come from a giant glimmercap mushroom.", weight = 1},
	{id = 7252, name = "baby seal", article = "a", description = "It is covered with paint."},
	{id = 7253, name = "flask with paint", article = "a", weight = 180},
	{fromId = 7254, toId = 7255, name = "stone shelf", article = "a", containerSize = 6},
	{
		id = 7256,
		name = "slain braindeath",
		article = "a",
		containerSize = 32,
		decayTo = 7260,
		duration = 10,
		fluidSource = FLUID_SLIME,
		corpseType = RACE_VENOM
	},
	{
		id = 7257,
		name = "slain braindeath",
		article = "a",
		containerSize = 32,
		decayTo = 7258,
		duration = 900,
		fluidSource = FLUID_SLIME,
		corpseType = RACE_VENOM
	},
	{id = 7258, name = "slain braindeath", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{id = 7259, name = "stone shelf", article = "a", containerSize = 10},
	{id = 7260, name = "slain braindeath", article = "a", containerSize = 32, decayTo = 7257, duration = 600},
	{id = 7261, name = "frostbite herb", article = "a"},
	{fromId = 7262, toId = 7263, name = "figurehead", article = "a"},
	{fromId = 7264, toId = 7267, name = "sled", article = "a"},
	{fromId = 7268, toId = 7271, name = "husky", article = "a"},
	{id = 7272, name = "raft", article = "a"},
	{fromId = 7273, toId = 7276, name = "stone table", article = "a"},
	{fromId = 7277, toId = 7280, name = "stone throne", article = "a"},
	{id = 7281, name = "memory crystal", article = "a", description = "It is able to store memories and thoughts.", weight = 250},
	{id = 7282, name = "slain ice golem", article = "a", containerSize = 30, decayTo = 7283, duration = 10, corpseType = RACE_UNDEAD},
	{
		id = 7283,
		name = "slain ice golem",
		article = "a",
		containerSize = 30,
		decayTo = 7284,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 7284,
		name = "slain ice golem",
		article = "a",
		containerSize = 30,
		decayTo = 7285,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 7285, name = "slain ice golem", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 7286, name = "Nilsor's waterskin", description = "It is empty.", weight = 700},
	{id = 7289, name = "frost charm", article = "a", weight = 1900},
	{id = 7290, name = "shard", article = "a", weight = 1900, description = "It is a shattered part of the Frostheart Spire."},
	{fromId = 7291, toId = 7292, name = "frozen demon", article = "a"},
	{fromId = 7293, toId = 7294, name = "frozen mammoth", article = "a"},
	{fromId = 7295, toId = 7296, name = "frozen dragon", article = "a"},
	{fromId = 7297, toId = 7298, name = "frozen behemoth", article = "a"},
	{fromId = 7299, toId = 7300, name = "frozen plaguesmith", article = "a"},
	{fromId = 7301, toId = 7302, name = "frozen creature", article = "a"},
	{fromId = 7303, toId = 7312, name = "frozen human", article = "a"},
	{
		id = 7314,
		name = "scale from a frozen dragon",
		article = "a",
		description = "This is the proof that there were once dragon lords on Okolnir which mutated into frost dragons.",
		weight = 90
	},
	{
		id = 7315,
		name = "resonance crystal",
		article = "a",
		description = "You have recorded beautiful ice music on it for the Explorer Society.",
		weight = 250
	},
	{
		id = 7316,
		name = "dead husky",
		article = "a",
		containerSize = 10,
		decayTo = 7317,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7317,
		name = "dead husky",
		article = "a",
		containerSize = 10,
		decayTo = 7318,
		duration = 900,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{id = 7318, name = "dead husky", article = "a", containerSize = 10, decayTo = 7319, duration = 600, corpseType = RACE_BLOOD},
	{id = 7319, name = "dead husky", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7320,
		name = "dead chakoya",
		article = "a",
		containerSize = 24,
		decayTo = 7321,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7321,
		name = "dead chakoya",
		article = "a",
		containerSize = 24,
		decayTo = 7322,
		duration = 900,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{id = 7322, name = "dead chakoya", article = "a", containerSize = 24, decayTo = 7323, duration = 600, corpseType = RACE_BLOOD},
	{id = 7323, name = "dead chakoya", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7324,
		name = "dead chakoya",
		article = "a",
		containerSize = 24,
		decayTo = 7325,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7325,
		name = "dead chakoya",
		article = "a",
		containerSize = 24,
		decayTo = 7326,
		duration = 900,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{id = 7326, name = "dead chakoya", article = "a", containerSize = 24, decayTo = 7323, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7327,
		name = "dead chakoya",
		article = "a",
		containerSize = 24,
		decayTo = 7328,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7328,
		name = "dead chakoya",
		article = "a",
		containerSize = 24,
		decayTo = 7329,
		duration = 900,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{id = 7329, name = "dead chakoya", article = "a", containerSize = 24, decayTo = 7323, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7330,
		name = "dead frost giant",
		article = "a",
		containerSize = 38,
		decayTo = 7331,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7331,
		name = "dead frost giant",
		article = "a",
		containerSize = 38,
		decayTo = 7332,
		duration = 900,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7332,
		name = "dead frost giant",
		article = "a",
		containerSize = 38,
		decayTo = 7333,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 7333, name = "dead frost giant", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7334,
		name = "dead penguin",
		article = "a",
		containerSize = 11,
		decayTo = 7335,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7335,
		name = "dead penguin",
		article = "a",
		containerSize = 11,
		decayTo = 7336,
		duration = 900,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{id = 7336, name = "dead penguin", article = "a", containerSize = 11, decayTo = 7337, duration = 600, corpseType = RACE_BLOOD},
	{id = 7337, name = "dead penguin", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7338,
		name = "dead silver rabbit",
		article = "a",
		containerSize = 10,
		decayTo = 7339,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7339,
		name = "dead silver rabbit",
		article = "a",
		containerSize = 10,
		decayTo = 7340,
		duration = 900,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 7340,
		name = "dead silver rabbit",
		article = "a",
		containerSize = 10,
		decayTo = 7341,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 7341, name = "dead silver rabbit", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 7342, name = "fur backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 7343, name = "fur bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{
		id = 7344,
		name = "slain crystal spider",
		article = "a",
		containerSize = 52,
		decayTo = 7345,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 7345,
		name = "slain crystal spider",
		article = "a",
		containerSize = 52,
		decayTo = 7346,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 7346,
		name = "slain crystal spider",
		article = "a",
		containerSize = 52,
		decayTo = 7347,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 7347, name = "slain crystal spider", article = "a", decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 7348, name = "stony floor"},
	{id = 7349, name = "ashes", decayTo = 0, duration = 5},
	{id = 7350, name = "sandstone tile", article = "a"},
	{id = 7351, name = "black marble floor"},
	{id = 7352, name = "dirt"},
	{id = 7353, name = "stone floor"},
	{id = 7354, name = "small lava cracks", description = "The ground is steaming hot."},
	{id = 7355, name = "stone floor"},
	{id = 7356, name = "rock soil"},
	{id = 7357, name = "wooden floor"},
	{id = 7358, name = "tiled floor"},
	{id = 7359, name = "flame of life", article = "a", decayTo = 7360, duration = 360, showDuration = true},
	{id = 7360, name = "flame of life", article = "a", decayTo = 0, duration = 60, showDuration = true},
	{fromId = 7361, toId = 7362, name = "sarcophagus", article = "a"},
	{
		id = 7363,
		name = "piercing bolt",
		article = "a",
		weight = 80,
		slotPosition = SLOTP_AMMO,
		attack = 33,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_BOLT,
		shootType = CONST_ANI_PIERCINGBOLT,
		maxHitChance = 87
	},
	{
		id = 7364,
		name = "sniper arrow",
		article = "a",
		weight = 70,
		slotPosition = SLOTP_AMMO,
		attack = 28,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_SNIPERARROW,
		maxHitChance = 100
	},
	{
		id = 7365,
		name = "onyx arrow",
		article = "an",
		weight = 70,
		slotPosition = SLOTP_AMMO,
		attack = 38,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_ONYXARROW,
		maxHitChance = 94
	},
	{
		id = 7366,
		name = "viper star",
		article = "a",
		weight = 200,
		attack = 28,
		hitChance = 80,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_GREENSTAR,
		maxHitChance = 76,
		range = 4
	},
	{
		id = 7367,
		name = "enchanted spear",
		article = "an",
		weight = 2000,
		attack = 38,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_ENCHANTEDSPEAR,
		maxHitChance = 80,
		range = 4
	},
	{
		id = 7368,
		name = "assassin star",
		article = "an",
		weight = 200,
		attack = 65,
		maxHitChance = 96,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_REDSTAR,
		range = 4
	},
	{id = 7369, name = "golden goblet", article = "a", weight = 3500},
	{id = 7370, name = "silver goblet", article = "a", weight = 3000},
	{id = 7371, name = "bronze goblet", article = "a", weight = 2500},
	{
		id = 7372,
		name = "ice cream cone",
		article = "an",
		description = "It's the famous \"crispy chocolate chips\" flavour.",
		weight = 100
	},
	{id = 7373, name = "ice cream cone", article = "an", description = "It's the famous \"velvet vanilla\" flavour.", weight = 100},
	{id = 7374, name = "ice cream cone", article = "an", description = "It's the famous \"sweet strawberry\" flavour.", weight = 100},
	{id = 7375, name = "ice cream cone", article = "an", description = "It's the famous \"chilly cherry\" flavour.", weight = 100},
	{id = 7376, name = "ice cream cone", article = "an", description = "It's the famous \"mellow melon\" flavour.", weight = 100},
	{id = 7377, name = "ice cream cone", article = "an", description = "It's the famous \"blue-barian\" flavour.", weight = 100},
	{
		id = 7378,
		name = "royal spear",
		article = "a",
		weight = 2500,
		attack = 35,
		weaponType = WEAPON_DISTANCE,
		shootType = CONST_ANI_ROYALSPEAR,
		maxHitChance = 80,
		range = 3
	},
	{
		id = 7379,
		name = "brutetamer's staff",
		article = "a",
		weight = 3800,
		defense = 15,
		attack = 35,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		description = "Barbarian women are said to use it for conjuring beasts."
	},
	{
		id = 7380,
		name = "headchopper",
		article = "a",
		description = "This axe is only granted to a greenhorn of the Svargrond arena.",
		weight = 4500,
		defense = 20,
		attack = 42,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_AXE
	},
	{
		id = 7381,
		name = "mammoth whopper",
		article = "a",
		description = "Made from a mammoth's legbones, it is one of the favoured weapons among barbarians.",
		weight = 4500,
		defense = 15,
		attack = 30,
		weaponType = WEAPON_CLUB
	},
	{
		id = 7382,
		name = "demonrage sword",
		article = "a",
		weight = 15000,
		defense = 22,
		attack = 47,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7383,
		name = "relic sword",
		article = "a",
		weight = 4800,
		defense = 24,
		attack = 42,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 7384,
		name = "mystic blade",
		article = "a",
		description = "This sword is only granted to a scrapper of the Svargrond arena.",
		weight = 3500,
		defense = 25,
		attack = 44,
		weaponType = WEAPON_SWORD,
		extraDefense = 2
	},
	{
		id = 7385,
		name = "crimson sword",
		article = "a",
		weight = 3600,
		defense = 20,
		attack = 28,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 7386,
		name = "mercenary sword",
		article = "a",
		weight = 6800,
		defense = 27,
		attack = 43,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7387,
		name = "diamond sceptre",
		article = "a",
		weight = 1500,
		defense = 18,
		attack = 34,
		weaponType = WEAPON_CLUB,
		description = "The beautiful jewel on the top of this sceptre is sharp enough to cut through glass."
	},
	{
		id = 7388,
		name = "vile axe",
		article = "a",
		weight = 5200,
		defense = 19,
		attack = 43,
		weaponType = WEAPON_AXE,
		extraDefense = 3
	},
	{
		id = 7389,
		name = "heroic axe",
		article = "a",
		weight = 6100,
		defense = 24,
		attack = 44,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		description = "This axe is only granted to a scrapper of the Svargrond arena."
	},
	{
		id = 7390,
		name = "the justice seeker",
		weight = 5000,
		defense = 24,
		attack = 47,
		weaponType = WEAPON_SWORD,
		extraDefense = 3,
		description = "This sword is only granted to a warlord of the Svargrond arena."
	},
	{
		id = 7391,
		name = "thaian sword",
		article = "a",
		weight = 6100,
		defense = 29,
		attack = 45,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7392,
		name = "orcish maul",
		article = "an",
		weight = 5400,
		defense = 18,
		attack = 42,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		description = "This club is only granted to a greenhorn of the Svargrond arena."
	},
	{id = 7393, name = "demon trophy", article = "a", weight = 500},
	{id = 7394, name = "wolf trophy", article = "a", weight = 500},
	{id = 7395, name = "orc trophy", article = "an", weight = 500},
	{id = 7396, name = "behemoth trophy", article = "a", weight = 500},
	{id = 7397, name = "deer trophy", article = "a", weight = 500},
	{id = 7398, name = "cyclops trophy", article = "a", weight = 500},
	{id = 7399, name = "dragon lord trophy", article = "a", weight = 500},
	{id = 7400, name = "lion trophy", article = "a", weight = 500},
	{id = 7401, name = "minotaur trophy", article = "a", weight = 500},
	{
		id = 7402,
		name = "dragon slayer",
		article = "a",
		weight = 8200,
		defense = 28,
		attack = 44,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7403,
		name = "berserker",
		article = "a",
		weight = 13000,
		defense = 21,
		attack = 48,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7404,
		name = "assassin dagger",
		article = "an",
		weight = 1700,
		defense = 12,
		attack = 40,
		weaponType = WEAPON_SWORD,
		extraDefense = -2
	},
	{
		id = 7405,
		name = "havoc blade",
		article = "a",
		weight = 7200,
		defense = 34,
		attack = 49,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7406,
		name = "blacksteel sword",
		article = "a",
		description = "This sword is only granted to a greenhorn of the Svargrond arena.",
		weight = 5900,
		defense = 22,
		attack = 42,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7407,
		name = "haunted blade",
		article = "a",
		weight = 3100,
		defense = 12,
		attack = 40,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7408,
		name = "wyvern fang",
		article = "a",
		weight = 2000,
		defense = 19,
		attack = 32,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{
		id = 7409,
		name = "northern star",
		article = "a",
		weight = 4200,
		defense = 15,
		attack = 42,
		weaponType = WEAPON_CLUB,
		extraDefense = 1
	},
	{id = 7410, name = "queen's sceptre", article = "a", weight = 2300, defense = 19, attack = 43, weaponType = WEAPON_CLUB},
	{
		id = 7411,
		name = "ornamented axe",
		article = "an",
		weight = 6150,
		defense = 22,
		attack = 42,
		weaponType = WEAPON_AXE,
		extraDefense = 2
	},
	{
		id = 7412,
		name = "butcher's axe",
		article = "a",
		weight = 6300,
		defense = 24,
		attack = 41,
		weaponType = WEAPON_AXE,
		extraDefense = -2
	},
	{
		id = 7413,
		name = "titan axe",
		article = "a",
		weight = 8100,
		defense = 30,
		attack = 43,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7414,
		name = "abyss hammer",
		article = "an",
		description = "Floating stones form the tip of this strange weapon, held in place by unspeakable magic.",
		weight = 5500,
		defense = 21,
		attack = 47,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7415,
		name = "cranial basher",
		article = "a",
		description = "This club is only granted to a scrapper of the Svargrond arena.",
		weight = 7800,
		defense = 20,
		attack = 44,
		weaponType = WEAPON_CLUB,
		extraDefense = -2
	},
	{
		id = 7416,
		name = "bloody edge",
		article = "a",
		weight = 5200,
		defense = 21,
		attack = 43,
		weaponType = WEAPON_SWORD,
		extraDefense = -3
	},
	{
		id = 7417,
		name = "runed sword",
		article = "a",
		weight = 4600,
		defense = 32,
		attack = 45,
		weaponType = WEAPON_SWORD,
		extraDefense = 2
	},
	{
		id = 7418,
		name = "nightmare blade",
		article = "a",
		weight = 4600,
		defense = 23,
		attack = 46,
		weaponType = WEAPON_SWORD,
		extraDefense = -3
	},
	{
		id = 7419,
		name = "dreaded cleaver",
		article = "a",
		weight = 3800,
		defense = 19,
		attack = 40,
		weaponType = WEAPON_AXE,
		extraDefense = -3
	},
	{
		id = 7420,
		name = "reaper's axe",
		article = "a",
		weight = 5900,
		defense = 25,
		attack = 46,
		weaponType = WEAPON_AXE,
		extraDefense = 2
	},
	{id = 7421, name = "onyx flail", article = "an", weight = 2600, defense = 18, attack = 45, weaponType = WEAPON_CLUB},
	{
		id = 7422,
		name = "jade hammer",
		article = "a",
		weight = 3200,
		defense = 20,
		attack = 46,
		weaponType = WEAPON_CLUB,
		extraDefense = 1
	},
	{
		id = 7423,
		name = "skullcrusher",
		article = "a",
		weight = 12000,
		defense = 20,
		attack = 51,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7424,
		name = "lunar staff",
		article = "a",
		weight = 3800,
		defense = 25,
		attack = 40,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7425,
		name = "taurus mace",
		article = "a",
		weight = 5100,
		defense = 18,
		attack = 30,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7426,
		name = "amber staff",
		article = "an",
		weight = 3500,
		defense = 25,
		attack = 43,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7427,
		name = "chaos mace",
		article = "a",
		description = "Only those who have descended to the deepest depths may wield this hammer without it cursing them.",
		weight = 6300,
		defense = 21,
		attack = 44,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7428,
		name = "bonebreaker",
		article = "a",
		description = "This weapon has to be swung in both hands and requires a lot of strength.",
		weight = 12000,
		defense = 15,
		attack = 46,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7429,
		name = "blessed sceptre",
		article = "a",
		description = "This spectre is only granted to a warlord of the Svarground arena.",
		weight = 3900,
		defense = 21,
		attack = 47,
		weaponType = WEAPON_CLUB,
		extraDefense = 3
	},
	{
		id = 7430,
		name = "dragonbone staff",
		article = "a",
		description = "Small flames are dancing around this strange weapon.",
		weight = 1800,
		defense = 18,
		attack = 35,
		weaponType = WEAPON_CLUB
	},
	{
		id = 7431,
		name = "demonbone",
		article = "a",
		weight = 18000,
		defense = 38,
		extraDefense = -2,
		attack = 48,
		weaponType = WEAPON_CLUB
	},
	{
		id = 7432,
		name = "furry club",
		article = "a",
		weight = 4200,
		defense = 19,
		attack = 31,
		weaponType = WEAPON_CLUB,
		extraDefense = 1
	},
	{
		id = 7433,
		name = "ravenwing",
		article = "a",
		weight = 5500,
		defense = 22,
		attack = 45,
		weaponType = WEAPON_AXE,
		extraDefense = 1
	},
	{
		id = 7434,
		name = "royal axe",
		article = "a",
		weight = 9200,
		defense = 25,
		attack = 47,
		weaponType = WEAPON_AXE,
		extraDefense = 3,
		description = "This axe is only granted to a warlord of the Svargrond arena."
	},
	{
		id = 7435,
		name = "impaler",
		article = "an",
		weight = 8200,
		defense = 25,
		attack = 49,
		weaponType = WEAPON_AXE,
		extraDefense = -2
	},
	{
		id = 7436,
		name = "angelic axe",
		article = "an",
		weight = 5600,
		defense = 24,
		attack = 44,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7437,
		name = "sapphire hammer",
		article = "a",
		description = "A beautiful gem is embedded in this weapon.",
		weight = 2100,
		defense = 18,
		attack = 37,
		weaponType = WEAPON_CLUB
	},
	{
		id = 7438,
		name = "elvish bow",
		article = "an",
		description = "This beautifully ornamented bow was made by a skilled elvish bowmaker.",
		weight = 3900,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_ARROW,
		range = 6,
		hitChance = 5
	},
	{
		id = 7439,
		name = "berserk potion",
		article = "a",
		description = "Drinking this potion increases temporarily your fighting skill while decreasing your defense.",
		weight = 200
	},
	{
		id = 7440,
		name = "mastermind potion",
		article = "a",
		description = "Drinking this potion temporarily increases your magic skill.",
		weight = 290
	},
	{id = 7441, name = "ice cube", article = "an", weight = 2000},
	{id = 7442, name = "ice cube", article = "an", description = "There is a rough shape of a head.", weight = 2000},
	{
		id = 7443,
		name = "bullseye potion",
		article = "a",
		description = "Drinking this potion increases temporarily your distance skill while decreasing your defense.",
		weight = 200
	},
	{id = 7444, name = "ice cube", article = "an", description = "There is a rough shape of a head with tusks.", weight = 2000},
	{id = 7445, name = "ice cube", article = "an", description = "There is a rough shape of a mammoth.", weight = 2000},
	{
		id = 7446,
		name = "ice mammoth",
		article = "an",
		description = "This small statue has been carefully shaped from an ice cube.",
		weight = 2000
	},
	{fromId = 7447, toId = 7448, name = "small ice statue", article = "a", weight = 1000},
	{
		id = 7449,
		name = "crystal sword",
		article = "a",
		weight = 6900,
		defense = 26,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7450,
		name = "hammer of prophecy",
		article = "a",
		weight = 11000,
		defense = 35,
		attack = 52,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 7451, name = "shadow sceptre", article = "a", weight = 4100, defense = 17, attack = 39, weaponType = WEAPON_CLUB},
	{
		id = 7452,
		name = "spiked squelcher",
		article = "a",
		weight = 6800,
		defense = 21,
		attack = 41,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7453,
		name = "executioner",
		article = "an",
		weight = 9900,
		defense = 20,
		attack = 51,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7454,
		name = "glorious axe",
		article = "a",
		weight = 9500,
		defense = 23,
		attack = 40,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 7455,
		name = "mythril axe",
		article = "a",
		weight = 5500,
		defense = 28,
		attack = 48,
		weaponType = WEAPON_AXE,
		extraDefense = 2
	},
	{id = 7456, name = "noble axe", article = "a", weight = 3800, defense = 22, attack = 39, weaponType = WEAPON_AXE},
	{
		id = 7457,
		name = "fur boots",
		description = "These boots keep your toes warm in even the iciest regions, but they feel kind of heavy.",
		weight = 1200,
		armor = 2,
		slotPosition = SLOTP_FEET,
		speed = -12
	},
	{
		id = 7458,
		name = "fur cap",
		article = "a",
		description = "It feels nice and warm on your ears.",
		weight = 1800,
		armor = 3,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 7459,
		name = "pair of earmuffs",
		article = "a",
		description = "They feel nice and warm on your ears.",
		weight = 500,
		slotPosition = SLOTP_HEAD,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 2}
	},
	{id = 7460, name = "norse shield", article = "a", weight = 4100, defense = 28, weaponType = WEAPON_SHIELD},
	{id = 7461, name = "krimhorn helmet", article = "a", weight = 5100, armor = 6, slotPosition = SLOTP_HEAD},
	{id = 7462, name = "ragnir helmet", article = "a", weight = 3100, armor = 6, slotPosition = SLOTP_HEAD},
	{
		id = 7463,
		name = "mammoth fur cape",
		article = "a",
		weight = 2000,
		armor = 10,
		slotPosition = SLOTP_ARMOR,
		description = "It is imbued with protective magic."
	},
	{
		id = 7464,
		name = "mammoth fur shorts",
		weight = 150,
		slotPosition = SLOTP_LEGS,
		description = "They offer little protection but will at least provide some comfort and warmth."
	},
	{
		fromId = 7465,
		toId = 7473,
		name = "flame of life",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		replaceable = false,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 300}
	},
	{fromId = 7474, toId = 7475, name = "sarcophagus", article = "a"},
	{id = 7476, name = "white flower", article = "a", weight = 10},
	{id = 7477, name = "special flask", article = "a", description = "It contains the smell of a freshly slain slime.", weight = 180},
	{
		id = 7478,
		name = "special flask",
		article = "a",
		description = "Bozo gave it to you to collect certain secret ingredients.",
		weight = 180
	},
	{id = 7479, name = "the dwarven emperor's beard", weight = 50},
	{id = 7480, name = "bed", article = "a", description = "The dwarven emperor is sleeping there."},
	{id = 7481, name = "crate", article = "a", description = "It contains the daily supply for Xodet's shop."},
	{id = 7482, name = "crate", article = "a", description = "It contains a lot of wine flasks.", weight = 8000},
	{id = 7483, name = "crate", article = "a", description = "You swapped it with Bozo's crate of wine flasks.", weight = 8000},
	{id = 7484, name = "box", article = "a", description = "It is filled with delicious cream pies.", weight = 4000},
	{id = 7485, name = "whoopee cushion", article = "a", description = "Bozo gave it to you.", weight = 1500},
	{id = 7486, name = "cat basket", article = "a"},
	{id = 7487, name = "toy mouse", article = "a", weight = 1250},
	{id = 7488, name = "special flask", article = "a", weight = 180},
	{id = 7489, name = "special flask", article = "a", weight = 180, description = "It contains the ink of a freshly slain quara."},
	{id = 7490, name = "magical inkwell", article = "a", weight = 200},
	{id = 7491, name = "signed contract", article = "a", weight = 200},
	{id = 7492, name = "contract", article = "a", weight = 200, description = "It is not signed yet."},
	{id = 7493, name = "scrying crystal ball", article = "a"},
	{
		id = 7494,
		name = "special flask",
		article = "a",
		description = "It contains holy water from the white raven monastery.",
		weight = 180
	},
	{
		id = 7495,
		name = "beer bottle",
		article = "a",
		weight = 250,
		description = "It is filled with the legendary dwarvish brown ale."
	},
	{
		id = 7496,
		name = "empty beer bottle",
		article = "an",
		weight = 250,
		description = "It is the bottle Boozer gave you for the brown ale."
	},
	{
		id = 7497,
		name = "mining helmet",
		article = "a",
		weight = 700,
		description = "This is Budrik's old mining helmet.",
		slotPosition = SLOTP_HEAD
	},
	{id = 7498, name = "package of potions", article = "a", description = "It contains 5 health and 5 mana potions.", weight = 3600},
	{id = 7499, name = "cigar", article = "a", weight = 120},
	{id = 7500, name = "bale of white cloth", article = "a", weight = 1000},
	{id = 7501, name = "bale of yellowed cloth", article = "a", weight = 1000},
	{id = 7502, name = "mummy disguise", article = "a", weight = 900},
	{id = 7503, name = "heavy package", article = "a", weight = 60000},
	{fromId = 7504, toId = 7507, name = "fire shrine", article = "a"},
	{fromId = 7508, toId = 7511, name = "ice shrine", article = "an"},
	{fromId = 7512, toId = 7515, name = "energy shrine", article = "an"},
	{fromId = 7516, toId = 7519, name = "earth shrine", article = "an"},
	{fromId = 7520, toId = 7523, name = "wooden coffin", article = "a"},
	{
		fromId = 7524,
		toId = 7525,
		name = "wooden coffin",
		article = "a",
		description = "You can see stairs leading down.",
		floorChange = TILESTATE_FLOORCHANGE_DOWN
	},
	{id = 7526, name = "fake dwarven beard", article = "a", weight = 50},
	{id = 7527, name = "coal basin", article = "a"},
	{
		id = 7528,
		name = "blank poetry parchment",
		article = "a",
		weight = 200,
		description = "Use your inkwell on it to try writing a poem."
	},
	{id = 7529, name = "parchment", article = "a", weight = 200, description = "It says 'Roses are red...'."},
	{
		id = 7530,
		name = "parchment",
		article = "a",
		weight = 200,
		description = "It says 'Roses are red, violets are blue...' Sounds good, but what now.."
	},
	{
		id = 7531,
		name = "parchment",
		article = "a",
		weight = 200,
		description = "It says 'Roses are red, violets are blue, sugar is sweet...' Very poetic, now for the final rhyme."
	},
	{
		id = 7532,
		name = "parchment",
		article = "a",
		weight = 200,
		description = "It says 'Roses are red, violets are blue, sugar is sweet and so are you.' Excellent!."
	},
	{
		id = 7533,
		name = "parchment",
		article = "a",
		weight = 200,
		description = "It says 'Roses are red, violets are blue, I love blood and carnage...' No, no, this is a war poem."
	},
	{
		id = 7534,
		name = "parchment",
		article = "a",
		weight = 200,
		description = "It says 'Roses are red, violets are blue, sugar is sweet, there's mud on my shoe.' You blew it."
	},
	{
		id = 7535,
		name = "parchment",
		article = "a",
		weight = 200,
		description = "It says 'Roses are red, and so is my blood.' Damn, that sounds stupid. You have to start over."
	},
	{id = 7536, name = "remains of a spider egg", article = "the", decayTo = 7537, duration = 300},
	{id = 7537, name = "spider egg", article = "a"},
	{id = 7538, name = "spider web", article = "a", destroyTo = 7544},
	{id = 7539, name = "spider web", article = "a", destroyTo = 7545},
	{fromId = 7540, toId = 7543, name = "spider web", article = "a"},
	{id = 7544, name = "the remains of a spider web", decayTo = 7538, duration = 60},
	{id = 7545, name = "remains of a spider web", article = "the", decayTo = 7539, duration = 60},
	{fromId = 7546, toId = 7548, name = "spider web", article = "a"},
	{fromId = 7549, toId = 7550, name = "something crawling"},
	{id = 7551, name = "seashell", article = "a"},
	{id = 7552, name = "large seashell", article = "a", description = "Maybe there's something inside of it."},
	{id = 7553, name = "large seashell", article = "a", description = "It is empty.", decayTo = 7552, duration = 300},
	{
		fromId = 7554,
		toId = 7555,
		name = "spider victim",
		article = "a",
		description = "This poor guy has been wrapped up in spider silk."
	},
	{fromId = 7556, toId = 7557, name = "cocooned victim", article = "a"},
	{fromId = 7558, toId = 7559, name = "stone", article = "a"},
	{fromId = 7560, toId = 7561, name = "sarcophagus", article = "a"},
	{fromId = 7562, toId = 7563, name = "stone", article = "a"},
	{fromId = 7564, toId = 7565, name = "sarcophagus", article = "a"},
	{id = 7566, name = "remains of a spider egg", article = "the"},
	{fromId = 7567, toId = 7568, name = "skeleton", article = "a"},
	{fromId = 7569, toId = 7570, name = "niche", article = "a"},
	{fromId = 7571, toId = 7574, name = "skeleton", article = "a"},
	{id = 7575, name = "buoy", article = "a"},
	{fromId = 7576, toId = 7581, name = "buoy line", article = "a"},
	{
		id = 7582,
		name = "fine vase",
		article = "a",
		description = "This vase looks incredibly fragile. Better make sure it won't move one bit, just don't touch it.",
		weight = 940
	},
	{id = 7583, name = "elven vase", article = "an", weight = 940},
	{id = 7584, name = "ship cabin wall", article = "a"},
	{id = 7586, name = "remains of a spider egg", article = "the"},
	{id = 7587, name = "bag", article = "a", weight = 40000, description = "It contains Ahmet's stolen property."},
	{
		id = 7588,
		name = "strong health potion",
		article = "a",
		weight = 290,
		description = "This potion can only be consumed by paladins and knights of level 50 or higher."
	},
	{
		id = 7589,
		name = "strong mana potion",
		article = "a",
		weight = 290,
		description = "This potion can only be consumed by sorcerers, druids and paladins of level 50 or higher."
	},
	{
		id = 7590,
		name = "great mana potion",
		article = "a",
		weight = 310,
		description = "This potion can only be consumed by sorcerers and druids of level 80 or higher."
	},
	{
		id = 7591,
		name = "great health potion",
		article = "a",
		weight = 310,
		description = "This potion can only be consumed by knights of level 80 or higher."
	},
	{fromId = 7592, toId = 7599, name = "linen"},
	{id = 7600, name = "wood"},
	{fromId = 7601, toId = 7604, name = "linen"},
	{fromId = 7605, toId = 7616, name = "tent", article = "a"},
	{id = 7617, name = "linen"},
	{id = 7618, name = "health potion", article = "a", weight = 270},
	{id = 7619, name = "linen"},
	{id = 7620, name = "mana potion", article = "a", weight = 270},
	{
		id = 7621,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7623,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7622,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7624,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7623,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7626,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7624,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7625,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		fromId = 7625,
		toId = 7626,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7627,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 7627, name = "dead dragon hatchling", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7628,
		name = "dead squirrel",
		article = "a",
		containerSize = 15,
		decayTo = 7629,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7629,
		name = "dead squirrel",
		article = "a",
		containerSize = 15,
		decayTo = 7630,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 7630, name = "dead squirrel", article = "a", containerSize = 15, decayTo = 7631, duration = 600, corpseType = RACE_BLOOD},
	{id = 7631, name = "dead squirrel", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{fromId = 7632, toId = 7633, name = "giant shimmering pearl", article = "a", weight = 80},
	{
		id = 7634,
		name = "empty potion flask",
		article = "an",
		weight = 160,
		description = "Return it to a potion store for your deposit."
	},
	{
		id = 7635,
		name = "empty potion flask",
		article = "an",
		weight = 180,
		description = "Return it to a potion store for your deposit."
	},
	{
		id = 7636,
		name = "empty potion flask",
		article = "an",
		weight = 150,
		description = "Return it to a potion store for your deposit."
	},
	{
		id = 7637,
		name = "dead cat",
		article = "a",
		containerSize = 5,
		decayTo = 7638,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7638,
		name = "dead cat",
		article = "a",
		containerSize = 5,
		decayTo = 7639,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 7639, name = "dead cat", article = "a", containerSize = 5, decayTo = 7640, duration = 600, corpseType = RACE_BLOOD},
	{id = 7640, name = "dead cat", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{fromId = 7641, toId = 7652, name = "rock soil"},
	{id = 7653, name = "grass"},
	{id = 7654, name = "dirt floor"},
	{id = 7655, name = "empty flower pot", article = "an", description = "Nothing is planted in there.", weight = 150},
	{fromId = 7656, toId = 7664, name = "grass"},
	{
		id = 7665,
		name = "flower pot",
		article = "a",
		description = "Something has been planted in there, but you cannot see what it is yet.",
		weight = 150
	},
	{fromId = 7666, toId = 7669, name = "dirt floor"},
	{
		id = 7670,
		name = "flower pot",
		article = "a",
		description = "The plant in there sprouted, but only gardeners might recognise what it will develop into.",
		weight = 150,
		decayTo = 7678,
		duration = 72000
	},
	{fromId = 7671, toId = 7672, name = "dirt floor"},
	{
		id = 7673,
		name = "flower pot",
		article = "a",
		description = "Something has been planted in there, but you cannot see what it is yet.",
		weight = 150,
		decayTo = 7679,
		duration = 72000
	},
	{
		fromId = 7674,
		toId = 7677,
		name = "withered plant",
		article = "a",
		description = "This plant urgently needs some water, else it will wither away and disappear completely.",
		weight = 150,
		decayTo = 7655,
		duration = 72000
	},
	{
		id = 7678,
		name = "flower pot",
		article = "a",
		description = "The plant in there sprouted, but only gardeners might recognise what it will develop into.",
		weight = 150
	},
	{id = 7679, name = "flower pot", article = "a", description = "Nothing is planted in there.", weight = 150},
	{
		id = 7680,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a lizard tongue fern.",
		weight = 150,
		decayTo = 7681,
		duration = 72000
	},
	{id = 7681, name = "flower pot", article = "a", description = "The plant in it seems to be a lizard tongue fern.", weight = 150},
	{
		id = 7682,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a dryad's heart flower.",
		weight = 150,
		decayTo = 7683,
		duration = 72000
	},
	{
		id = 7683,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a dryad's heart flower.",
		weight = 150
	},
	{
		id = 7684,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a midnight bloom flower.",
		weight = 150,
		decayTo = 7685,
		duration = 72000
	},
	{
		id = 7685,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a midnight bloom flower.",
		weight = 150
	},
	{
		id = 7686,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be an ember queen flower.",
		weight = 150,
		decayTo = 7687,
		duration = 72000
	},
	{id = 7687, name = "flower pot", article = "a", description = "The plant in it seems to be an ember queen flower.", weight = 150},
	{
		id = 7688,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown lizard tongue plant in it.",
		weight = 150,
		decayTo = 7689,
		duration = 72000
	},
	{
		id = 7689,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown lizard tongue plant in it.",
		weight = 150,
		decayTo = 7674,
		duration = 259200
	},
	{
		id = 7690,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown dryad's heart flower in it.",
		weight = 150,
		decayTo = 7691,
		duration = 72000
	},
	{
		id = 7691,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown dryad's heart flower in it.",
		weight = 150,
		decayTo = 7675,
		duration = 259200
	},
	{
		id = 7692,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown midnight bloom flower in it.",
		weight = 150,
		decayTo = 7693,
		duration = 72000
	},
	{
		id = 7693,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown midnight bloom flower in it.",
		weight = 150,
		decayTo = 7676,
		duration = 259200
	},
	{
		id = 7694,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown ember queen flower in it.",
		weight = 150,
		decayTo = 7695,
		duration = 72000
	},
	{
		id = 7695,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown ember queen flower in it.",
		weight = 150,
		decayTo = 7677,
		duration = 259200
	},
	{id = 7696, name = "parchment", article = "a", weight = 120},
	{id = 7697, name = "suspicious signet ring", article = "a", weight = 80, slotPosition = SLOTP_RING},
	{id = 7698, name = "case of rust bugs", article = "a", weight = 170, containerSize = 1},
	{id = 7699, name = "technomancer beard", article = "a", weight = 50},
	{
		id = 7700,
		name = "amazon disguise kit",
		article = "an",
		description = "It contains the clothes of a beautiful amazon.",
		weight = 1000
	},
	{id = 7701, name = "wooden trash"},
	{id = 7702, name = "building plans for a ship", weight = 100},
	{id = 7703, name = "suspicious documents", weight = 150},
	{id = 7704, name = "book", article = "a", description = "It is filled with family trees.", weight = 1300},
	{id = 7705, name = "File AH-X17L89", weight = 1300},
	{id = 7706, name = "barrel of beer", article = "a", weight = 8500},
	{id = 7707, name = "weapons crate", article = "a", weight = 7500},
	{id = 7708, name = "family signet ring", article = "a", weight = 80, slotPosition = SLOTP_RING},
	{fromId = 7709, toId = 7710, name = "grass"},
	{id = 7711, name = "waterball", article = "a"},
	{fromId = 7712, toId = 7715, name = "beach chair", article = "a"},
	{fromId = 7716, toId = 7718, name = "parasol", article = "a"},
	{id = 7719, name = "wooden floor", type = ITEM_TYPE_TELEPORT},
	{fromId = 7720, toId = 7721, name = "parchment", article = "a", weight = 100},
	{id = 7722, name = "paper", article = "a", weight = 100},
	{id = 7723, name = "blank paper", article = "a", weight = 100, writeable = true, maxTextLen = 1023, writeOnceItemId = 7722},
	{id = 7724, name = "scroll", article = "a", weight = 100, writeable = true},
	{id = 7725, name = "blank scroll", article = "a", weight = 100, writeable = true, maxTextLen = 1023, writeOnceItemId = 7724},
	{id = 7726, name = "piece of paper", article = "a", weight = 100},
	{id = 7727, name = "piece of paper", article = "a", weight = 100, writeable = true, maxTextLen = 1023, writeOnceItemId = 7726},
	{id = 7728, name = "crumpled piece of paper", article = "a", weight = 110},
	{id = 7729, name = "torn piece of paper", article = "a", weight = 50},
	{id = 7730, name = "blue legs", weight = 1800, armor = 8, slotPosition = SLOTP_LEGS},
	{id = 7731, name = "elvenhair rope", article = "an", weight = 600},
	{
		id = 7732,
		name = "seeds",
		description = "They might be worth keeping, who knows what will happen to them.",
		weight = 50,
		showCount = false
	},
	{id = 7733, name = "flower bouquet", article = "a", weight = 80},
	{id = 7734, name = "watering can", article = "a", weight = 850},
	{id = 7735, name = "spellwand", article = "a", description = "It might have some strange effects.", weight = 200},
	{id = 7736, name = "rotten heart of a tree", article = "a", weight = 4500},
	{id = 7737, name = "costume bag", article = "a", weight = 800},
	{id = 7738, name = "bag of screws", article = "a", weight = 1900},
	{id = 7739, name = "costume bag", article = "a", weight = 800},
	{
		id = 7740,
		name = "dead cyclops",
		article = "a",
		containerSize = 30,
		decayTo = 7741,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7741,
		name = "dead cyclops",
		article = "a",
		containerSize = 30,
		decayTo = 7742,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 7742, name = "dead cyclops", article = "a", containerSize = 30, decayTo = 7743, duration = 600, corpseType = RACE_BLOOD},
	{id = 7743, name = "dead cyclops", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7744,
		name = "fiery spike sword",
		article = "a",
		weight = 5000,
		defense = 21,
		attack = 20,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 4,
		charges = 1000,
		showCharges = true,
		decayTo = 2383
	},
	{
		id = 7745,
		name = "fiery relic sword",
		article = "a",
		weight = 4800,
		defense = 24,
		attack = 34,
		weaponType = WEAPON_SWORD,
		extraDefense = 1,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7383
	},
	{
		id = 7746,
		name = "fiery mystic blade",
		article = "a",
		weight = 3500,
		defense = 25,
		attack = 36,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7384
	},
	{
		id = 7747,
		name = "fiery blacksteel sword",
		article = "a",
		weight = 5900,
		defense = 22,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7406
	},
	{
		id = 7748,
		name = "fiery dragon slayer",
		article = "a",
		weight = 8200,
		defense = 28,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7402
	},
	{
		id = 7749,
		name = "fiery barbarian axe",
		article = "a",
		weight = 5100,
		defense = 18,
		attack = 23,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2429
	},
	{
		id = 7750,
		name = "fiery knight axe",
		article = "a",
		weight = 5900,
		defense = 21,
		attack = 27,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 6,
		charges = 1000,
		showCharges = true,
		decayTo = 2430
	},
	{
		id = 7751,
		name = "fiery heroic axe",
		article = "a",
		weight = 6100,
		defense = 24,
		attack = 35,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7389
	},
	{
		id = 7752,
		name = "fiery headchopper",
		article = "a",
		weight = 4500,
		defense = 20,
		attack = 34,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7380
	},
	{
		id = 7753,
		name = "fiery war axe",
		article = "a",
		weight = 6150,
		defense = 10,
		attack = 39,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2454
	},
	{
		id = 7754,
		name = "fiery clerical mace",
		article = "a",
		weight = 5800,
		defense = 15,
		attack = 23,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2423
	},
	{
		id = 7755,
		name = "fiery crystal mace",
		article = "a",
		weight = 8000,
		defense = 16,
		attack = 31,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 2445
	},
	{
		id = 7756,
		name = "fiery cranial basher",
		article = "a",
		weight = 7800,
		defense = 20,
		attack = 36,
		weaponType = WEAPON_CLUB,
		extraDefense = -2,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7415
	},
	{
		id = 7757,
		name = "fiery orcish maul",
		article = "a",
		weight = 5400,
		defense = 18,
		attack = 35,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7392
	},
	{
		id = 7758,
		name = "fiery war hammer",
		article = "a",
		weight = 8500,
		defense = 10,
		attack = 36,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2391
	},
	{id = 7759, name = "small enchanted sapphire", article = "a", weight = 10},
	{id = 7760, name = "small enchanted ruby", article = "a", weight = 10},
	{id = 7761, name = "small enchanted emerald", article = "a", weight = 10},
	{id = 7762, name = "small enchanted amethyst", article = "a", weight = 10},
	{
		id = 7763,
		name = "icy spike sword",
		article = "an",
		weight = 5000,
		defense = 21,
		attack = 20,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 4,
		charges = 1000,
		showCharges = true,
		decayTo = 2383
	},
	{
		id = 7764,
		name = "icy relic sword",
		article = "an",
		weight = 4800,
		defense = 24,
		attack = 34,
		weaponType = WEAPON_SWORD,
		extraDefense = 1,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7383
	},
	{
		id = 7765,
		name = "icy mystic blade",
		article = "an",
		weight = 3500,
		defense = 25,
		attack = 36,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7384
	},
	{
		id = 7766,
		name = "icy blacksteel sword",
		article = "an",
		weight = 5900,
		defense = 22,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7406
	},
	{
		id = 7767,
		name = "icy dragon slayer",
		article = "an",
		weight = 8200,
		defense = 28,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7402
	},
	{
		id = 7768,
		name = "icy barbarian axe",
		article = "an",
		weight = 5100,
		defense = 18,
		attack = 23,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2429
	},
	{
		id = 7769,
		name = "icy knight axe",
		article = "an",
		weight = 5900,
		defense = 21,
		attack = 27,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 6,
		charges = 1000,
		showCharges = true,
		decayTo = 2430
	},
	{
		id = 7770,
		name = "icy heroic axe",
		article = "an",
		weight = 6100,
		defense = 24,
		attack = 35,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7389
	},
	{
		id = 7771,
		name = "icy headchopper",
		article = "an",
		weight = 4500,
		defense = 20,
		attack = 34,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7380
	},
	{
		id = 7772,
		name = "icy war axe",
		article = "an",
		weight = 6150,
		defense = 10,
		attack = 39,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2454
	},
	{
		id = 7773,
		name = "icy clerical mace",
		article = "an",
		weight = 5800,
		defense = 15,
		attack = 23,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2423
	},
	{
		id = 7774,
		name = "icy crystal mace",
		article = "an",
		weight = 8000,
		defense = 16,
		attack = 31,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 2445
	},
	{
		id = 7775,
		name = "icy cranial basher",
		article = "an",
		weight = 7800,
		defense = 20,
		attack = 36,
		weaponType = WEAPON_CLUB,
		extraDefense = -2,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7415
	},
	{
		id = 7776,
		name = "icy orcish maul",
		article = "an",
		weight = 5400,
		defense = 18,
		attack = 35,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7392
	},
	{
		id = 7777,
		name = "icy war hammer",
		article = "an",
		weight = 8500,
		defense = 10,
		attack = 36,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2391
	},
	{id = 7778, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 1754},
	{id = 7779, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 1760},
	{id = 7780, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 1761},
	{id = 7781, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 1758},
	{id = 7782, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 1759},
	{id = 7783, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 1756},
	{id = 7784, name = "cot", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 1757},
	{id = 7785, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 3836},
	{id = 7786, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 3838},
	{id = 7787, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 7811},
	{id = 7788, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 7812},
	{id = 7789, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 7813},
	{id = 7790, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 7814},
	{id = 7791, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 7815},
	{id = 7792, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 7816},
	{id = 7793, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 7817},
	{id = 7794, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 7818},
	{id = 7795, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 7819},
	{id = 7796, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 7820},
	{id = 7797, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 7821},
	{id = 7798, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 7822},
	{id = 7799, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 7811},
	{id = 7800, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 7812},
	{id = 7801, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 7813},
	{id = 7802, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 7814},
	{id = 7803, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 7815},
	{id = 7804, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 7816},
	{id = 7805, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 7817},
	{id = 7806, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 7818},
	{id = 7807, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 7819},
	{id = 7808, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 7820},
	{id = 7809, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 7821},
	{id = 7810, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 7822},
	{
		id = 7811,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_SOUTH,
		maleSleeper = 7787,
		femaleSleeper = 7799
	},
	{
		id = 7812,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_NORTH,
		maleSleeper = 7788,
		femaleSleeper = 7800
	},
	{
		id = 7813,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_EAST,
		maleSleeper = 7789,
		femaleSleeper = 7801
	},
	{
		id = 7814,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_WEST,
		maleSleeper = 7790,
		femaleSleeper = 7802
	},
	{
		id = 7815,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_SOUTH,
		maleSleeper = 7791,
		femaleSleeper = 7803
	},
	{
		id = 7816,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_NORTH,
		maleSleeper = 7792,
		femaleSleeper = 7804
	},
	{
		id = 7817,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_EAST,
		maleSleeper = 7793,
		femaleSleeper = 7805
	},
	{
		id = 7818,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_WEST,
		maleSleeper = 7794,
		femaleSleeper = 7806
	},
	{
		id = 7819,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_SOUTH,
		maleSleeper = 7795,
		femaleSleeper = 7807
	},
	{
		id = 7820,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_NORTH,
		maleSleeper = 7796,
		femaleSleeper = 7808
	},
	{
		id = 7821,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_EAST,
		maleSleeper = 7797,
		femaleSleeper = 7809
	},
	{
		id = 7822,
		name = "bed",
		article = "a",
		type = ITEM_TYPE_BED,
		partnerDirection = DIRECTION_WEST,
		maleSleeper = 7798,
		femaleSleeper = 7810
	},
	{id = 7823, name = "obsidian statue", article = "an"},
	{id = 7824, name = "dragon statue", article = "a"},
	{id = 7825, name = "shadowy statue", article = "a"},
	{id = 7826, name = "strange statue", article = "a"},
	{id = 7827, name = "huge telescope", article = "a"},
	{id = 7828, name = "astro clock", article = "an"},
	{fromId = 7829, toId = 7832, name = "celestial map", article = "a"},
	{fromId = 7833, toId = 7837, name = "dirt floor"},
	{
		id = 7838,
		name = "flash arrow",
		article = "a",
		weight = 70,
		slotPosition = SLOTP_AMMO,
		attack = 14,
		elementType = COMBAT_ENERGYDAMAGE,
		elementDamage = 14,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_FLASHARROW,
		maxHitChance = 91
	},
	{
		id = 7839,
		name = "shiver arrow",
		article = "a",
		weight = 70,
		slotPosition = SLOTP_AMMO,
		attack = 14,
		elementType = COMBAT_ICEDAMAGE,
		elementDamage = 14,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_SHIVERARROW,
		maxHitChance = 91
	},
	{
		id = 7840,
		name = "flaming arrow",
		article = "a",
		weight = 70,
		slotPosition = SLOTP_AMMO,
		attack = 14,
		elementType = COMBAT_FIREDAMAGE,
		elementDamage = 14,
		weaponType = WEAPON_AMMO,
		ammoType = AMMO_ARROW,
		shootType = CONST_ANI_FLAMMINGARROW,
		maxHitChance = 91
	},
	{id = 7841, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_SOUTH, maleSleeper = 5502},
	{id = 7842, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 5503},
	{id = 7843, name = "straw mat", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_EAST, maleSleeper = 5500},
	{id = 7844, name = "document of the follower", article = "a", weight = 200},
	{id = 7845, name = "document of the officer", article = "a", weight = 200},
	{id = 7846, name = "document of the leader", article = "a", weight = 200},
	{id = 7847, name = "dead cyclops", article = "a", containerSize = 30, decayTo = 7848, duration = 10},
	{id = 7848, name = "dead cyclops", article = "a", containerSize = 30, decayTo = 7849, duration = 900},
	{id = 7849, name = "dead cyclops", article = "a", containerSize = 30, decayTo = 7743, duration = 600},
	{
		id = 7850,
		name = "earth arrow",
		article = "an",
		weight = 70,
		slotPosition = SLOTP_AMMO,
		attack = 14,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 14,
		weaponType = WEAPON_AMMO,
		shootType = CONST_ANI_EARTHARROW,
		ammoType = AMMO_ARROW,
		maxHitChance = 91
	},
	{fromId = 7851, toId = 7853, name = "buttress", article = "a"},
	{
		id = 7854,
		name = "earth spike sword",
		article = "an",
		weight = 5000,
		defense = 21,
		attack = 20,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 4,
		charges = 1000,
		showCharges = true,
		decayTo = 2383
	},
	{
		id = 7855,
		name = "earth relic sword",
		article = "an",
		weight = 4800,
		defense = 24,
		attack = 34,
		weaponType = WEAPON_SWORD,
		extraDefense = 1,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7383
	},
	{
		id = 7856,
		name = "earth mystic blade",
		article = "an",
		weight = 3500,
		defense = 25,
		attack = 36,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7384
	},
	{
		id = 7857,
		name = "earth blacksteel sword",
		article = "an",
		weight = 5900,
		defense = 22,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7406
	},
	{
		id = 7858,
		name = "earth dragon slayer",
		article = "an",
		weight = 8200,
		defense = 28,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7402
	},
	{
		id = 7859,
		name = "earth barbarian axe",
		article = "an",
		weight = 5100,
		defense = 18,
		attack = 23,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2429
	},
	{
		id = 7860,
		name = "earth knight axe",
		article = "an",
		weight = 5900,
		defense = 21,
		attack = 27,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 6,
		charges = 1000,
		showCharges = true,
		decayTo = 2430
	},
	{
		id = 7861,
		name = "earth heroic axe",
		article = "an",
		weight = 6100,
		defense = 24,
		attack = 35,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7389
	},
	{
		id = 7862,
		name = "earth headchopper",
		article = "an",
		weight = 4500,
		defense = 20,
		attack = 34,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7380
	},
	{
		id = 7863,
		name = "earth war axe",
		article = "an",
		weight = 6150,
		defense = 10,
		attack = 39,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2454
	},
	{
		id = 7864,
		name = "earth clerical mace",
		article = "an",
		weight = 5800,
		defense = 15,
		attack = 23,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2423
	},
	{
		id = 7865,
		name = "earth crystal mace",
		article = "an",
		weight = 8000,
		defense = 16,
		attack = 31,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 2445
	},
	{
		id = 7866,
		name = "earth cranial basher",
		article = "an",
		weight = 7800,
		defense = 20,
		attack = 36,
		weaponType = WEAPON_CLUB,
		extraDefense = -2,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7415
	},
	{
		id = 7867,
		name = "earth orcish maul",
		article = "an",
		weight = 5400,
		defense = 18,
		attack = 35,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7392
	},
	{
		id = 7868,
		name = "earth war hammer",
		article = "an",
		weight = 8500,
		defense = 10,
		attack = 36,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementType = COMBAT_EARTHDAMAGE,
		elementDamage = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2391
	},
	{
		id = 7869,
		name = "energy spike sword",
		article = "an",
		weight = 5000,
		defense = 21,
		attack = 20,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementType = COMBAT_ENERGYDAMAGE,
		elementDamage = 4,
		charges = 1000,
		showCharges = true,
		decayTo = 2383
	},
	{
		id = 7870,
		name = "energy relic sword",
		article = "an",
		weight = 4800,
		defense = 24,
		attack = 34,
		weaponType = WEAPON_SWORD,
		extraDefense = 1,
		elementEnergy = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7383
	},
	{
		id = 7871,
		name = "energy mystic blade",
		article = "an",
		weight = 3500,
		defense = 25,
		attack = 36,
		weaponType = WEAPON_SWORD,
		extraDefense = 2,
		elementEnergy = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7384
	},
	{
		id = 7872,
		name = "energy blacksteel sword",
		article = "an",
		weight = 5900,
		defense = 22,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementEnergy = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7406
	},
	{
		id = 7873,
		name = "energy dragon slayer",
		article = "an",
		weight = 8200,
		defense = 28,
		attack = 35,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND,
		elementEnergy = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7402
	},
	{
		id = 7874,
		name = "energy barbarian axe",
		article = "an",
		weight = 5100,
		defense = 18,
		attack = 23,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementEnergy = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2429
	},
	{
		id = 7875,
		name = "energy knight axe",
		article = "an",
		weight = 5900,
		defense = 21,
		attack = 27,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementEnergy = 6,
		charges = 1000,
		showCharges = true,
		decayTo = 2430
	},
	{
		id = 7876,
		name = "energy heroic axe",
		article = "an",
		weight = 6100,
		defense = 24,
		attack = 35,
		weaponType = WEAPON_AXE,
		extraDefense = 1,
		elementEnergy = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 7389
	},
	{
		id = 7877,
		name = "energy headchopper",
		article = "an",
		weight = 4500,
		defense = 20,
		attack = 34,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementEnergy = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7380
	},
	{
		id = 7878,
		name = "energy war axe",
		article = "an",
		weight = 6150,
		defense = 10,
		attack = 39,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		elementEnergy = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2454
	},
	{
		id = 7879,
		name = "energy clerical mace",
		article = "an",
		weight = 5800,
		defense = 15,
		attack = 23,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementEnergy = 5,
		charges = 1000,
		showCharges = true,
		decayTo = 2423
	},
	{
		id = 7880,
		name = "energy crystal mace",
		article = "an",
		weight = 8000,
		defense = 16,
		attack = 31,
		weaponType = WEAPON_CLUB,
		extraDefense = 1,
		elementEnergy = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 2445
	},
	{
		id = 7881,
		name = "energy cranial basher",
		article = "an",
		weight = 7800,
		defense = 20,
		attack = 36,
		weaponType = WEAPON_CLUB,
		extraDefense = -2,
		elementEnergy = 8,
		charges = 1000,
		showCharges = true,
		decayTo = 7415
	},
	{
		id = 7882,
		name = "energy orcish maul",
		article = "an",
		weight = 5400,
		defense = 18,
		attack = 35,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementEnergy = 7,
		charges = 1000,
		showCharges = true,
		decayTo = 7392
	},
	{
		id = 7883,
		name = "energy war hammer",
		article = "an",
		weight = 8500,
		defense = 10,
		attack = 36,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND,
		elementEnergy = 9,
		charges = 1000,
		showCharges = true,
		decayTo = 2391
	},
	{
		id = 7884,
		name = "terra mantle",
		article = "a",
		weight = 2250,
		armor = 11,
		slotPosition = SLOTP_ARMOR,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 8, [COMBAT_FIREDAMAGE] = -8}
	},
	{
		id = 7885,
		name = "terra legs",
		weight = 1900,
		armor = 8,
		slotPosition = SLOTP_LEGS,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 6, [COMBAT_FIREDAMAGE] = -6}
	},
	{
		id = 7886,
		name = "terra boots",
		weight = 750,
		armor = 2,
		slotPosition = SLOTP_FEET,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 5, [COMBAT_FIREDAMAGE] = -5}
	},
	{
		id = 7887,
		name = "terra amulet",
		article = "a",
		weight = 500,
		slotPosition = SLOTP_NECKLACE,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 20, [COMBAT_FIREDAMAGE] = -10},
		charges = 200,
		showCharges = true,
		showAttributes = true
	},
	{
		id = 7888,
		name = "glacier amulet",
		article = "a",
		weight = 500,
		slotPosition = SLOTP_NECKLACE,
		charges = 200,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 20, [COMBAT_ENERGYDAMAGE] = -10},
		showCharges = true,
		showAttributes = true
	},
	{
		id = 7889,
		name = "lightning pendant",
		article = "a",
		weight = 500,
		slotPosition = SLOTP_NECKLACE,
		charges = 200,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -10, [COMBAT_ENERGYDAMAGE] = 20},
		showCharges = true,
		showAttributes = true
	},
	{
		id = 7890,
		name = "magma amulet",
		article = "a",
		weight = 500,
		slotPosition = SLOTP_NECKLACE,
		charges = 200,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -10, [COMBAT_FIREDAMAGE] = 20},
		showCharges = true,
		showAttributes = true
	},
	{
		id = 7891,
		name = "magma boots",
		weight = 750,
		armor = 2,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -5, [COMBAT_FIREDAMAGE] = 5},
		slotPosition = SLOTP_FEET
	},
	{id = 7892, name = "glacier shoes", weight = 750, armor = 2, slotPosition = SLOTP_FEET, absorbPercent = {[COMBAT_ICEDAMAGE] = 5}},
	{
		id = 7893,
		name = "lightning boots",
		weight = 750,
		armor = 2,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -5, [COMBAT_ENERGYDAMAGE] = 5},
		slotPosition = SLOTP_FEET
	},
	{
		id = 7894,
		name = "magma legs",
		weight = 1900,
		armor = 8,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -6, [COMBAT_FIREDAMAGE] = 6},
		slotPosition = SLOTP_LEGS
	},
	{
		id = 7895,
		name = "lightning legs",
		weight = 1900,
		armor = 8,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -6, [COMBAT_ENERGYDAMAGE] = 6},
		slotPosition = SLOTP_LEGS
	},
	{
		id = 7896,
		name = "glacier kilt",
		article = "a",
		weight = 1900,
		armor = 8,
		slotPosition = SLOTP_LEGS,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 6, [COMBAT_ENERGYDAMAGE] = -6}
	},
	{
		id = 7897,
		name = "glacier robe",
		article = "a",
		weight = 2250,
		armor = 11,
		slotPosition = SLOTP_ARMOR,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 8, [COMBAT_ENERGYDAMAGE] = -8}
	},
	{
		id = 7898,
		name = "lightning robe",
		article = "a",
		weight = 2250,
		armor = 11,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -8, [COMBAT_ENERGYDAMAGE] = 8},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 7899,
		name = "magma coat",
		article = "a",
		weight = 2250,
		armor = 11,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -8, [COMBAT_FIREDAMAGE] = 8},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 7900,
		name = "magma monocle",
		article = "a",
		weight = 1000,
		armor = 5,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -5, [COMBAT_FIREDAMAGE] = 4},
		slotPosition = SLOTP_HEAD
	},
	{
		id = 7901,
		name = "lightning headband",
		article = "a",
		weight = 1000,
		armor = 5,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -5, [COMBAT_ENERGYDAMAGE] = 4},
		slotPosition = SLOTP_HEAD
	},
	{
		id = 7902,
		name = "glacier mask",
		article = "a",
		weight = 1000,
		armor = 5,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 4, [COMBAT_ENERGYDAMAGE] = -5},
		slotPosition = SLOTP_HEAD
	},
	{
		id = 7903,
		name = "terra hood",
		article = "a",
		weight = 1000,
		armor = 5,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 4, [COMBAT_FIREDAMAGE] = -5},
		slotPosition = SLOTP_HEAD
	},
	{id = 7904, name = "green bed kit", article = "a", description = "Use it on your bed to change the bed to green.", weight = 3500},
	{
		id = 7905,
		name = "yellow bed kit",
		article = "a",
		description = "Use it on your bed to change the bed to yellow.",
		weight = 3500
	},
	{id = 7906, name = "red bed kit", article = "a", description = "Use it on your bed to change the bed to red.", weight = 3500},
	{id = 7907, name = "blue bed kit", article = "a", description = "Use it on your bed to change the bed to blue.", weight = 3500},
	{id = 7908, name = "dead cyclops", article = "a"},
	{id = 7909, name = "walnut", article = "a", weight = 10},
	{id = 7910, name = "peanut", article = "a", weight = 10},
	{fromId = 7911, toId = 7918, name = "mysterious machine", article = "a"},
	{id = 7919, name = "armillary sphere", article = "an"},
	{fromId = 7920, toId = 7923, name = "chalk board", article = "a"},
	{id = 7924, name = "stone stairs", floorChange = TILESTATE_FLOORCHANGE_SOUTH_ALT},
	{id = 7925, name = "stone stairs", floorChange = TILESTATE_FLOORCHANGE_EAST_ALT},
	{
		id = 7926,
		name = "dead troll",
		article = "a",
		containerSize = 24,
		decayTo = 7927,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7927,
		name = "dead troll",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 7928,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 7928, name = "dead troll", article = "a", decayTo = 7929, duration = 600, corpseType = RACE_BLOOD},
	{id = 7929, name = "pile of bones", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 7930,
		name = "dead troll",
		article = "a",
		containerSize = 24,
		decayTo = 7931,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7931,
		name = "dead troll",
		article = "a",
		weight = 60000,
		containerSize = 24,
		decayTo = 7928,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 7932, name = "large hole", article = "a", description = "It is loosely covered by some stones and earth."},
	{id = 7933, name = "large hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 7932, duration = 600},
	{id = 7934, name = "test-tube holder", article = "a"},
	{id = 7935, name = "potion stand", article = "a"},
	{id = 7936, name = "trophy stand", article = "a", weight = 970},
	{id = 7937, name = "potion stand", article = "a"},
	{id = 7938, name = "large hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{
		id = 7939,
		name = "mining helmet",
		article = "a",
		weight = 700,
		armor = 1,
		slotPosition = SLOTP_HEAD,
		description = "This is your personal mining helmet."
	},
	{id = 7940, name = "blocked cave entrance", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 7941, name = "wooden floor", type = ITEM_TYPE_TELEPORT},
	{fromId = 7943, toId = 7954, name = "shallow water", ignoreBlocking = true, fluidSource = FLUID_WATER},
	{
		id = 7955,
		name = "parcel",
		article = "a",
		description = "It is the parcel for the watchtower on the Femor Hills.",
		weight = 1800
	},
	{id = 7956, name = "waterball", article = "a", weight = 200},
	{id = 7957, name = "jester hat", article = "a", weight = 1000, armor = 1, slotPosition = SLOTP_HEAD},
	{id = 7958, name = "jester staff", article = "a", weight = 725},
	{id = 7959, name = "Firlefanz", weight = 1000},
	{id = 7960, name = "mysterious package", article = "a", description = "It bears the seal of the TBI.", weight = 1000},
	{id = 7961, name = "mysterious package", article = "a", description = "It bears the seal of the CGB.", weight = 1000},
	{id = 7962, name = "mysterious package", article = "a", description = "It bears the seal of the AVIN.", weight = 1000},
	{
		id = 7963,
		name = "marlin",
		article = "a",
		description = "This rare fish is almost too precious to simply be eaten. Maybe you can find a collector.",
		weight = 1800
	},
	{id = 7964, name = "marlin trophy", article = "a", weight = 500},
	{id = 7965, name = "badger fur", article = "a", weight = 1000},
	{id = 7966, name = "throwing cake", article = "a", weight = 500},
	{
		fromId = 7967,
		toId = 7968,
		name = "shapeshifter ring",
		article = "a",
		description = "It will only work for a few days after the challenge of Kurik has been won.",
		weight = 80,
		slotPosition = SLOTP_RING
	},
	{
		id = 7969,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7970,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7970,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7971,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 7971,
		name = "dead dragon hatchling",
		article = "a",
		containerSize = 30,
		decayTo = 7627,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{fromId = 7975, toId = 7976, name = "earth"},
	{fromId = 7977, toId = 7986, name = "sparkling gems"},
	{fromId = 7987, toId = 8004, name = "earth"},
	{fromId = 8005, toId = 8008, name = "earth"},
	{fromId = 8009, toId = 8010, name = "bone", article = "a"},
	{fromId = 8011, toId = 8014, name = "plants"},
	{id = 8015, name = "earth"},
	{id = 8016, name = "ant trail", article = "an"},
	{id = 8017, name = "earth"},
	{fromId = 8018, toId = 8019, name = "buttress", article = "a"},
	{id = 8020, name = "jagged stones"},
	{fromId = 8021, toId = 8028, name = "rifty earth"},
	{fromId = 8030, toId = 8032, name = "rifty earth"},
	{fromId = 8033, toId = 8045, name = "sand"},
	{fromId = 8046, toId = 8047, name = "something sparkling"},
	{fromId = 8048, toId = 8057, name = "earth"},
	{
		id = 8058,
		name = "mystic flame",
		article = "a",
		description = "You feel drawn to the mesmerizing light.",
		type = ITEM_TYPE_TELEPORT,
		effect = CONST_ME_TELEPORT
	},
	{id = 8059, name = "sanctified grave", article = "a"},
	{id = 8062, name = "poison gas", article = "a", decayTo = 0, duration = 2},
	{id = 8072, name = "yellow pillow", article = "a", weight = 1600},
	{id = 8075, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH},
	{id = 8076, name = "bed", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 1761},
	{id = 8077, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_NORTH, maleSleeper = 3837},
	{id = 8078, name = "hammock", article = "a", type = ITEM_TYPE_BED, partnerDirection = DIRECTION_WEST, maleSleeper = 3839},
	{id = 8109, name = "some special leaves", description = "They have an aromatic smell.", weight = 80},
	{id = 8110, name = "present", article = "a", weight = 600},
	{id = 8111, name = "exploding cookie", article = "an", weight = 10},
	{
		id = 8112,
		name = "scarab cheese",
		description = "It smells horrible and should not be in the sun for too long.",
		weight = 400,
		decayTo = 2235,
		duration = 1800
	},
	{fromId = 8117, toId = 8133, name = "earth"},
	{fromId = 8135, toId = 8138, name = "earth"},
	{id = 8139, name = "snowy birch tree", article = "a"},
	{fromId = 8140, toId = 8159, name = "grass"},
	{fromId = 8166, toId = 8167, name = "grass"},
	{fromId = 8168, toId = 8169, name = "earth"},
	{id = 8170, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 8174, name = "burning wall", article = "a"},
	{id = 8175, name = "straw mat", article = "a", description = "Someone is sleeping there."},
	{id = 8176, name = "cask of brown ale", article = "a", description = "It contains the legendary dwarvish brew."},
	{id = 8182, name = "ectoplasm container", article = "an", description = "It is filled with ectoplasm.", weight = 600},
	{id = 8186, name = "dead human", article = "a", containerSize = 10},
	{id = 8187, name = "magical watch", article = "a", weight = 50},
	{id = 8188, name = "stamped letter", article = "a", weight = 50},
	{
		id = 8189,
		name = "poem scroll",
		article = "a",
		description = "It contains a love poem, written by an unknown elven poet.",
		weight = 120
	},
	{
		id = 8190,
		name = "nature magic spellbook",
		article = "a",
		description = "It contains the arcane secrets of nature magic.",
		weight = 5800
	},
	{id = 8194, name = "cream cake", article = "a", weight = 500},
	{id = 8201, name = "broken pottery", weight = 180},
	{fromId = 8202, toId = 8203, name = "cave entrance", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 8204, name = "easily inflammable sulphur", weight = 50},
	{
		id = 8205,
		name = "special flask",
		article = "a",
		description = "It contains highly intensified poison against vermin.",
		weight = 180
	},
	{
		id = 8208,
		name = "ice cream cone",
		article = "an",
		description = "It's the famous Venorean Dream flavour, but the ice cream is melting rapidly.",
		weight = 100,
		decayTo = 0,
		duration = 120
	},
	{
		id = 8209,
		name = "crimson sword",
		article = "a",
		description = "Its blade is very notchy",
		weight = 3600,
		defense = 10,
		attack = 18,
		weaponType = WEAPON_SWORD
	},
	{fromId = 8210, toId = 8213, name = "cave entrance", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 8214, toId = 8219, name = "jagged stones"},
	{id = 8220, name = "jagged stone", article = "a"},
	{fromId = 8221, toId = 8226, name = "jagged stones"},
	{fromId = 8227, toId = 8228, name = "strange stone", article = "a"},
	{id = 8229, name = "demonic head", article = "a"},
	{fromId = 8230, toId = 8231, name = "strange stone", article = "a"},
	{id = 8232, name = "demonic head", article = "a"},
	{fromId = 8233, toId = 8236, name = "dragon head", article = "a"},
	{fromId = 8237, toId = 8240, name = "jagged stones"},
	{fromId = 8241, toId = 8242, name = "ornamented stone pillar", article = "an"},
	{fromId = 8243, toId = 8244, name = "archway", article = "an"},
	{fromId = 8245, toId = 8248, name = "ornamented stone"},
	{
		fromId = 8249,
		toId = 8252,
		name = "hole",
		article = "a",
		description = "It seems too narrow to crawl trough.",
		floorChange = TILESTATE_FLOORCHANGE_DOWN
	},
	{id = 8253, name = "something crawling"},
	{
		fromId = 8254,
		toId = 8255,
		name = "hole",
		article = "a",
		description = "It seems too narrow to crawl trough.",
		floorChange = TILESTATE_FLOORCHANGE_DOWN
	},
	{id = 8256, name = "large hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 8257, name = "grass"},
	{id = 8258, name = "stones"},
	{id = 8260, name = "mountain", article = "a"},
	{
		id = 8261,
		name = "jewel case",
		article = "a",
		description = "It contains a secret treasure from the nomads. You don't dare open it.",
		weight = 170
	},
	{fromId = 8262, toId = 8265, name = "piece of a broken amulet", article = "a", weight = 100},
	{
		id = 8266,
		name = "Koshei's ancient amulet",
		weight = 550,
		slotPosition = SLOTP_NECKLACE,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 8, [COMBAT_HOLYDAMAGE] = -50},
		showAttributes = true
	},
	{
		id = 8267,
		name = "nomad parchment",
		article = "a",
		description = "It seems to be a list of people to be eliminated. The first name on the list is 'Arito'.",
		weight = 200
	},
	{id = 8268, name = "sundial", article = "a", description = "It seems strangely out of place in this surrounding."},
	{
		id = 8269,
		name = "remains of Koshei",
		article = "the",
		containerSize = 7,
		decayTo = 8272,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8271,
		name = "remains of Koshei",
		article = "the",
		containerSize = 7,
		decayTo = 8272,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8272,
		name = "remains of Koshei",
		article = "the",
		containerSize = 7,
		decayTo = 8273,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8273,
		name = "remains of Koshei",
		article = "the",
		containerSize = 7,
		decayTo = 8274,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 8274, name = "remains of Koshei", article = "the", decayTo = 0, corpseType = RACE_UNDEAD},
	{id = 8275, name = "void"},
	{fromId = 8276, toId = 8277, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 8278, name = "dirt floor", description = "There is a hole in the ceiling."},
	{fromId = 8279, toId = 8281, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 8282, toId = 8283, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 8284, toId = 8286, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 8287, name = "wooden floor"},
	{fromId = 8288, toId = 8291, name = "demon oak", article = "the"},
	{id = 8292, name = "dirt floor"},
	{id = 8293, name = "hallowed axe", article = "a", weight = 40},
	{fromId = 8294, toId = 8295, name = "stone railing", article = "a"},
	{id = 8296, name = "ship's telescope", article = "a"},
	{id = 8297, name = "bait", article = "a", weight = 800},
	{id = 8298, name = "natural soil", weight = 250, showCount = false},
	{id = 8299, name = "glimmering soil", weight = 250, showCount = false},
	{id = 8300, name = "flawless ice crystal", article = "a", weight = 250},
	{id = 8301, name = "holy soil", weight = 250, showCount = false},
	{id = 8302, name = "iced soil", weight = 250, showCount = false},
	{id = 8303, name = "energy soil", weight = 250, showCount = false},
	{id = 8304, name = "eternal flames", weight = 250},
	{id = 8305, name = "mother soil", weight = 250, showCount = false},
	{id = 8306, name = "pure energy", weight = 250},
	{
		id = 8307,
		name = "dead sea serpent",
		article = "a",
		weight = 60000,
		containerSize = 40,
		decayTo = 8308,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 8308,
		name = "dead sea serpent",
		article = "a",
		weight = 55000,
		containerSize = 40,
		decayTo = 8311,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 8309, name = "nail", article = "a", weight = 5},
	{id = 8310, name = "neutral matter", weight = 250, showCount = false},
	{
		id = 8311,
		name = "dead sea serpent",
		article = "a",
		weight = 45000,
		containerSize = 40,
		decayTo = 8312,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 8312, name = "dead sea serpent", article = "a", weight = 30000, duration = 600, decayTo = 0},
	{id = 8313, name = "birch", article = "a"},
	{id = 8314, name = "dead tree", article = "a"},
	{fromId = 8315, toId = 8323, name = "sand"},
	{fromId = 8324, toId = 8325, name = "heap of sand", article = "a"},
	{fromId = 8326, toId = 8334, name = "dried grass"},
	{fromId = 8335, toId = 8346, name = "sand"},
	{fromId = 8347, toId = 8348, name = "dried grass"},
	{fromId = 8349, toId = 8359, name = "dry grass"},
	{id = 8360, name = "grass"},
	{id = 8361, name = "jagged stones"},
	{fromId = 8362, toId = 8364, name = "earth"},
	{id = 8365, name = "rifty earth"},
	{fromId = 8366, toId = 8367, name = "earth"},
	{id = 8368, name = "cheese", weight = 400, showCount = false},
	{id = 8369, name = "earth"},
	{id = 8370, name = "letter to Eremo", article = "a", weight = 50},
	{id = 8371, name = "earth"},
	{id = 8372, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_EAST},
	{id = 8373, name = "ramp", article = "a"},
	{id = 8374, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 8375, name = "ramp", article = "a"},
	{id = 8376, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH},
	{id = 8377, name = "ramp", article = "a"},
	{id = 8378, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 8379, name = "ramp", article = "a"},
	{fromId = 8380, toId = 8385, name = "grass"},
	{fromId = 8386, toId = 8387, name = "bone", article = "a"},
	{id = 8388, name = "skull", article = "a"},
	{fromId = 8389, toId = 8392, name = "bone", article = "a"},
	{id = 8393, name = "skull", article = "a"},
	{fromId = 8394, toId = 8397, name = "bone", article = "a"},
	{fromId = 8398, toId = 8399, name = "skull", article = "a"},
	{fromId = 8400, toId = 8403, name = "bone claw", article = "a"},
	{fromId = 8404, toId = 8405, name = "skull", article = "a"},
	{fromId = 8406, toId = 8415, name = "bones"},
	{fromId = 8416, toId = 8417, name = "heap of sand", article = "a"},
	{fromId = 8418, toId = 8421, name = "hydra statue", article = "a"},
	{id = 8422, name = "druid statue", article = "a"},
	{id = 8423, name = "brown pavement"},
	{id = 8424, name = "stony pavement"},
	{fromId = 8425, toId = 8431, name = "brown pavement"},
	{fromId = 8432, toId = 8434, name = "stony pavement"},
	{fromId = 8435, toId = 8458, name = "cobbled pavement"},
	{id = 8459, name = "strange statue", article = "a"},
	{fromId = 8460, toId = 8471, name = "earth"},
	{
		id = 8472,
		name = "great spirit potion",
		article = "a",
		weight = 310,
		description = "This potion can only be consumed by paladins of level 80 or higher."
	},
	{
		id = 8473,
		name = "ultimate health potion",
		article = "an",
		weight = 310,
		description = "This potion can only be consumed by knights of level 130 or higher."
	},
	{id = 8474, name = "antidote potion", article = "an", weight = 265},
	{fromId = 8475, toId = 8525, name = "stone wall", article = "a"},
	{fromId = 8526, toId = 8533, name = "gem", article = "a"},
	{fromId = 8534, toId = 8537, name = "buttress", article = "a"},
	{fromId = 8538, toId = 8540, name = "stone pillar", article = "a"},
	{id = 8541, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 8542, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 8543, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 8544, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 8545, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 8546, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 8547, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 8548, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 8549, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 8550, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 8551, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 8552, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 8553, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 8554, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 8555, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 8556, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 8557, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 8558, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 8559, toId = 8566, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 8567, toId = 8568, name = "sand"},
	{id = 8569, name = "rock"},
	{id = 8570, name = "ice"},
	{id = 8571, name = "ice cube", article = "an"},
	{id = 8572, name = "dead man's saddle", article = "a"},
	{id = 8573, name = "lava hole", article = "a"},
	{id = 8574, name = "small ice statue", article = "a", decayTo = 8571, duration = 120},
	{id = 8575, name = "lava hole", article = "a", decayTo = 8573, duration = 120},
	{id = 8576, name = "dead man's saddle", article = "a", decayTo = 8572, duration = 120},
	{id = 8577, name = "void"},
	{id = 8578, name = "jungle grass"},
	{
		id = 8579,
		name = "loose stone pile",
		article = "a",
		description = "Rightclick on your shovel, select 'Use' and then leftclick on this stonepile to dig."
	},
	{id = 8580, name = "sewer grate", article = "a"},
	{id = 8581, name = "cart", article = "a"},
	{
		id = 8582,
		name = "branch",
		article = "a",
		description = "Push it back to Zirella by holding the left mousebutton down on it and pushing it over the grass.",
		weight = 100000
	},
	{
		id = 8583,
		name = "dead tree",
		article = "a",
		description = "It is one of those Zirella mentioned. Rightclick it and select 'Use' to break a branch from it."
	},
	{id = 8584, name = "Jerom's family necklace", weight = 630},
	{id = 8585, name = "hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN, decayTo = 8579, duration = 600},
	{id = 8586, name = "dirt floor"},
	{id = 8587, name = "chest", article = "a", containerSize = 8},
	{fromId = 8588, toId = 8589, name = "bone claw", article = "a"},
	{id = 8590, name = "tiled floor"},
	{id = 8591, name = "grass"},
	{
		id = 8592,
		name = "dirt floor",
		description = "Rightclick your rope and select 'Use', then leftclick on this spot to climb up again."
	},
	{
		id = 8593,
		name = "dead cockroach",
		article = "a",
		description = "If you killed this cockroach, rightclick it and select 'Open' to see what it carried.",
		weight = 60000,
		containerSize = 8,
		decayTo = 0,
		duration = 90,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 8594, name = "dirt"},
	{fromId = 8595, toId = 8596, name = "trapdoor", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 8597, name = "wooden floor"},
	{id = 8598, name = "stone floor"},
	{id = 8599, name = "ladder", article = "a"},
	{
		id = 8600,
		name = "branch",
		article = "a",
		weight = 100000,
		description = "Push it back to Zirella by holding the left mousebutton down on it and pushing it over the grass."
	},
	{id = 8601, name = "steel axe", article = "a", weight = 4100, defense = 10, attack = 21, weaponType = WEAPON_AXE},
	{
		id = 8602,
		name = "jagged sword",
		article = "a",
		weight = 2900,
		defense = 14,
		attack = 21,
		weaponType = WEAPON_SWORD,
		extraDefense = 1
	},
	{fromId = 8603, toId = 8604, name = "wheel", article = "a"},
	{fromId = 8605, toId = 8612, name = "brick window", article = "a"},
	{
		id = 8613,
		name = "bricklayers' kit",
		article = "a",
		weight = 1800,
		description = "Use it on destroyed brick walls to repair them."
	},
	{id = 8614, name = "orc tusk", article = "an", weight = 1000},
	{fromId = 8615, toId = 8616, name = "dwarven statue", article = "a"},
	{fromId = 8617, toId = 8622, name = "orcish banner", article = "an"},
	{id = 8623, name = "orcish totem pole", article = "an"},
	{id = 8624, name = "orcish pole", article = "an"},
	{fromId = 8625, toId = 8626, name = "dwarven statue", article = "a"},
	{fromId = 8627, toId = 8630, name = "bones"},
	{id = 8631, name = "fire"},
	{id = 8632, name = "water vortex", article = "a"},
	{fromId = 8633, toId = 8636, name = "large crystal", article = "a"},
	{fromId = 8637, toId = 8638, name = "crystal", article = "a"},
	{fromId = 8639, toId = 8640, name = "large crystal", article = "a"},
	{fromId = 8641, toId = 8642, name = "crucible", article = "a"},
	{fromId = 8643, toId = 8648, name = "mould", article = "a"},
	{fromId = 8649, toId = 8652, name = "steaming hot lava"},
	{fromId = 8653, toId = 8662, name = "empty pipe", article = "an"},
	{fromId = 8663, toId = 8668, name = "steaming hot lava"},
	{fromId = 8669, toId = 8670, name = "bellow", article = "a"},
	{id = 8671, name = "anvil", article = "an"},
	{fromId = 8672, toId = 8673, name = "steaming hot lava"},
	{fromId = 8674, toId = 8677, name = "muzzle", article = "a"},
	{fromId = 8678, toId = 8679, name = "armor parts"},
	{fromId = 8680, toId = 8681, name = "tool parts"},
	{fromId = 8682, toId = 8683, name = "armor parts"},
	{fromId = 8684, toId = 8687, name = "chimney", article = "a"},
	{id = 8688, name = "chimney", article = "a", rotateTo = 8690},
	{id = 8689, name = "chimney", article = "a", rotateTo = 8691},
	{id = 8690, name = "chimney", article = "a", rotateTo = 8688},
	{id = 8691, name = "chimney", article = "a", rotateTo = 8689},
	{id = 8692, name = "chimney kit", article = "a", description = "Use it in your house to construct a chimney.", weight = 8000},
	{id = 8693, name = "dwarf disguise kit", article = "a", description = "It contains the clothes of a dwarf.", weight = 1000},
	{
		id = 8694,
		name = "deed of ownership",
		article = "a",
		description = "It declares the ownership of the dwarf bridge, but is obviously a fake.",
		weight = 150
	},
	{id = 8695, name = "wooden floor"},
	{id = 8696, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 8697, name = "open door", article = "an", description = "It can't be closed.", type = ITEM_TYPE_DOOR},
	{id = 8698, name = "stolen golden goblet", article = "a", description = "It looks incredibly valuable.", weight = 1500},
	{id = 8699, name = "famous Mina Losa painting", article = "the", weight = 1000},
	{id = 8700, name = "note pinned on the wall", article = "a", allowDistRead = true},
	{id = 8701, name = "note from the thieves guild", article = "a", description = "It is a warning.", weight = 150},
	{id = 8702, name = "witches' grimoire", article = "the", weight = 1300},
	{id = 8703, name = "buried coffin", article = "a", containerSize = 6, weight = 1300},
	{id = 8704, name = "small health potion", article = "a", weight = 265},
	{fromId = 8705, toId = 8706, name = "balloons"},
	{id = 8707, name = "your student book", description = "Write down important notes in here.", weight = 900},
	{id = 8708, name = "rock soil"},
	{id = 8709, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{
		id = 8710,
		name = "cockroach leg",
		article = "a",
		weight = 10,
		description = "This is proof for Santiago that you have killed a cockroach."
	},
	{id = 8711, name = "shovel", article = "a", weight = 3500},
	{id = 8712, name = "rope", article = "a", weight = 1800},
	{id = 8713, name = "fish", article = "a", weight = 520},
	{id = 8714, name = "wooden floor", description = "This is the border to the village of Rookgaard."},
	{id = 8715, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 8716, name = "stone stairs", floorChange = TILESTATE_FLOORCHANGE_SOUTH_ALT},
	{id = 8717, name = "lock pick", article = "a", weight = 85},
	{id = 8718, name = "vines"},
	{id = 8719, name = "window", article = "a"},
	{id = 8720, name = "sturdy chest", article = "a"},
	{id = 8721, name = "demonic residue", containerSize = 24, decayTo = 0, duration = 180, corpseType = RACE_UNDEAD},
	{id = 8722, name = "shovel", article = "a", weight = 3500},
	{id = 8723, name = "rope", article = "a", weight = 1800},
	{fromId = 8724, toId = 8727, name = "battering ram", article = "a"},
	{fromId = 8728, toId = 8729, name = "wagon", article = "a"},
	{id = 8730, name = "drawbar", article = "a"},
	{fromId = 8731, toId = 8732, name = "wagon", article = "a"},
	{id = 8733, name = "drawbar", article = "a"},
	{fromId = 8734, toId = 8737, name = "covered wagon", article = "a"},
	{fromId = 8738, toId = 8739, name = "drawbars"},
	{fromId = 8740, toId = 8743, name = "stones"},
	{fromId = 8744, toId = 8747, name = "wood"},
	{fromId = 8748, toId = 8751, name = "coal"},
	{id = 8752, name = "the ring of the count", weight = 75, slotPosition = SLOTP_RING},
	{id = 8753, name = "shadow nexus", article = "the"},
	{id = 8754, name = "shadow nexus", article = "the", decayTo = 8755, duration = 30},
	{id = 8755, name = "shadow nexus", article = "the", decayTo = 8753, duration = 20},
	{id = 8756, name = "shadow nexus", article = "the", decayTo = 8757, duration = 30},
	{id = 8757, name = "shadow nexus", article = "the", decayTo = 8753, duration = 20},
	{id = 8758, name = "shadow nexus", article = "the", decayTo = 8759, duration = 30},
	{id = 8759, name = "shadow nexus", article = "the", decayTo = 8753, duration = 20},
	{id = 8760, name = "valuable vase", article = "a", weight = 1000},
	{id = 8761, name = "invitation", article = "an", weight = 10, description = "It is the invitation to the king's ball."},
	{id = 8762, name = "Theodore Loveless' key", weight = 100, description = "It is the key to his private room."},
	{
		id = 8763,
		name = "compromising letter",
		article = "a",
		description = "The letter from Carlin proves that Arnold is a born Bonecrusher.",
		weight = 10
	},
	{id = 8764, name = "goldfish bowl", article = "a"},
	{id = 8765, name = "note pinned on the wall", article = "a", allowDistRead = true},
	{id = 8766, name = "fishnapped goldfish", article = "a", weight = 3200, description = "It belongs to Theodore Loveless."},
	{id = 8767, name = "precious necklace", article = "a", weight = 500},
	{
		id = 8768,
		name = "letter to Chantalle",
		article = "a",
		description = "Carina from Venore tells Chantalle that the 'precious necklace' she loved so much is still for sale.",
		weight = 10
	},
	{id = 8769, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 8770, toId = 8776, name = "demon oak", article = "the"},
	{fromId = 8777, toId = 8778, name = "sorcerer statue", article = "a"},
	{fromId = 8779, toId = 8780, name = "statue", article = "a"},
	{fromId = 8781, toId = 8784, name = "cage", article = "a"},
	{id = 8785, name = "fallen tree", article = "a"},
	{id = 8786, name = "tree stump", article = "a"},
	{id = 8787, name = "branch", article = "a"},
	{id = 8788, name = "fallen tree", article = "a"},
	{id = 8789, name = "branch", article = "a"},
	{fromId = 8790, toId = 8791, name = "fallen tree", article = "a"},
	{id = 8792, name = "palm tree stump", article = "a"},
	{fromId = 8793, toId = 8796, name = "fallen palm", article = "a"},
	{fromId = 8797, toId = 8818, name = "tree", article = "a"},
	{
		id = 8819,
		name = "magician's robe",
		article = "a",
		description = "This robe feels soft and light as a feather.",
		weight = 2500,
		armor = 6,
		slotPosition = SLOTP_ARMOR
	},
	{id = 8820, name = "mage hat", article = "a", weight = 900, armor = 3, slotPosition = SLOTP_HEAD},
	{
		id = 8821,
		name = "witchhunter's coat",
		article = "a",
		weight = 2500,
		armor = 11,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 2, [COMBAT_HOLYDAMAGE] = -2},
		slotPosition = SLOTP_ARMOR
	},
	{fromId = 8822, toId = 8823, name = "toolbox", article = "a"},
	{fromId = 8824, toId = 8833, name = "sparkling gems"},
	{fromId = 8834, toId = 8835, name = "sorcerer statue", article = "a"},
	{fromId = 8836, toId = 8837, name = "guardian statue", article = "a"},
	{id = 8838, name = "potato", article = "a", plural = "potatoes", weight = 170},
	{id = 8839, name = "plum", article = "a", weight = 130},
	{id = 8840, name = "raspberry", article = "a", plural = "raspberries", weight = 20},
	{id = 8841, name = "lemon", article = "a", weight = 20},
	{id = 8842, name = "cucumber", article = "a", weight = 200},
	{id = 8843, name = "onion", article = "an", weight = 140},
	{id = 8844, name = "jalapeno pepper", article = "a", weight = 30},
	{id = 8845, name = "beetroot", article = "a", weight = 130},
	{id = 8846, name = "lump of chocolate dough", article = "a", weight = 100},
	{id = 8847, name = "chocolate cake", article = "a", weight = 500},
	{id = 8848, name = "baking tray", article = "a", description = "There is cookie dough on it.", weight = 1200},
	{
		id = 8849,
		name = "modified crossbow",
		article = "a",
		weight = 3500,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_BOLT,
		range = 5,
		hitChance = 1
	},
	{
		id = 8850,
		name = "chain bolter",
		article = "a",
		weight = 5500,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_BOLT,
		range = 3,
		attack = 4
	},
	{
		id = 8851,
		name = "royal crossbow",
		article = "a",
		weight = 12000,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_BOLT,
		range = 6,
		hitChance = 3,
		attack = 5
	},
	{
		id = 8852,
		name = "the devileye",
		weight = 5500,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_BOLT,
		range = 6,
		hitChance = -20,
		attack = 20
	},
	{
		id = 8853,
		name = "the ironworker",
		weight = 5500,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_BOLT,
		range = 5,
		attack = 4
	},
	{
		id = 8854,
		name = "warsinger bow",
		article = "a",
		weight = 4500,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_ARROW,
		range = 7,
		hitChance = 5,
		attack = 3
	},
	{
		id = 8855,
		name = "composite hornbow",
		article = "a",
		weight = 5200,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_ARROW,
		range = 6,
		hitChance = 2,
		attack = 3
	},
	{
		id = 8856,
		name = "Yol's bow",
		weight = 3500,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_ARROW,
		range = 7,
		hitChance = 7
	},
	{
		id = 8857,
		name = "silkweaver bow",
		article = "a",
		weight = 2200,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_ARROW,
		range = 6,
		hitChance = 3
	},
	{
		id = 8858,
		name = "Elethriel's elemental bow",
		weight = 4400,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_ARROW,
		range = 4,
		attack = 7
	},
	{id = 8859, name = "spider fangs", showCount = false, weight = 50},
	{id = 8860, name = "spiderwebs", weight = 5, description = "You can hang these on your walls."},
	{fromId = 8861, toId = 8862, name = "energy fence", article = "an"},
	{id = 8863, name = "shallow water"},
	{id = 8864, name = "dead tree", article = "a"},
	{
		id = 8865,
		name = "dark lord's cape",
		article = "a",
		description = "There is a dark aura surrounding it.",
		weight = 2900,
		armor = 11,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 8, [COMBAT_HOLYDAMAGE] = -8},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8866,
		name = "robe of the ice queen",
		article = "a",
		description = "The soft tissue shimmers.",
		weight = 2950,
		armor = 12,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 12, [COMBAT_ENERGYDAMAGE] = -12},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8867,
		name = "dragon robe",
		article = "a",
		description = "It is covered with runic symbols.",
		weight = 2850,
		slotPosition = SLOTP_ARMOR,
		armor = 12,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -12, [COMBAT_FIREDAMAGE] = 12}
	},
	{
		id = 8868,
		name = "velvet mantle",
		article = "a",
		description = "The smooth tissue seems to sparkle.",
		weight = 2850,
		armor = 12,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -12, [COMBAT_ENERGYDAMAGE] = 12},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8869,
		name = "greenwood coat",
		article = "a",
		weight = 2850,
		armor = 12,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 12, [COMBAT_FIREDAMAGE] = -12},
		slotPosition = SLOTP_ARMOR
	},
	{id = 8870, name = "spirit cloak", article = "a", armor = 8, slotPosition = SLOTP_ARMOR, weight = 2650, magicLevelPoints = 1},
	{id = 8871, name = "focus cape", article = "a", weight = 2100, armor = 9, slotPosition = SLOTP_ARMOR, magicLevelPoints = 1},
	{id = 8872, name = "belted cape", article = "a", weight = 3500, armor = 10, slotPosition = SLOTP_ARMOR},
	{id = 8873, name = "hibiscus dress", article = "a", weight = 1900, slotPosition = SLOTP_ARMOR},
	{
		id = 8874,
		name = "summer dress",
		article = "a",
		weight = 1000,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 5},
		slotPosition = SLOTP_ARMOR
	},
	{id = 8875, name = "tunic", article = "a", weight = 1500, slotPosition = SLOTP_ARMOR},
	{id = 8876, name = "girl's dress", article = "a", weight = 1300, slotPosition = SLOTP_ARMOR},
	{
		id = 8877,
		name = "lavos armor",
		article = "a",
		weight = 8500,
		armor = 13,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -3, [COMBAT_FIREDAMAGE] = 3},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8878,
		name = "crystalline armor",
		article = "a",
		weight = 8450,
		armor = 13,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 3, [COMBAT_ENERGYDAMAGE] = -3},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8879,
		name = "voltage armor",
		article = "a",
		weight = 8450,
		armor = 13,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -3, [COMBAT_ENERGYDAMAGE] = 3},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8880,
		name = "swamplair armor",
		article = "a",
		weight = 8450,
		armor = 13,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 3, [COMBAT_FIREDAMAGE] = -3},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8881,
		name = "fireborn giant armor",
		article = "a",
		weight = 12000,
		armor = 15,
		skillSword = 2,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -5, [COMBAT_FIREDAMAGE] = 5},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8882,
		name = "earthborn titan armor",
		article = "an",
		weight = 12000,
		slotPosition = SLOTP_ARMOR,
		armor = 15,
		skillAxe = 2,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 5, [COMBAT_FIREDAMAGE] = -5}
	},
	{
		id = 8883,
		name = "windborn colossus armor",
		article = "a",
		weight = 12000,
		armor = 15,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -5, [COMBAT_ENERGYDAMAGE] = 5},
		skillClub = 2,
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8884,
		name = "oceanborn leviathan armor",
		article = "an",
		weight = 10000,
		armor = 15,
		skillShield = 1,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 5, [COMBAT_ENERGYDAMAGE] = -5},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8885,
		name = "divine plate",
		article = "a",
		armor = 13,
		slotPosition = SLOTP_ARMOR,
		weight = 7500,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 10, [COMBAT_HOLYDAMAGE] = -10}
	},
	{
		id = 8886,
		name = "molten plate",
		article = "a",
		armor = 13,
		slotPosition = SLOTP_ARMOR,
		weight = 7500,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -7, [COMBAT_FIREDAMAGE] = 7}
	},
	{
		id = 8887,
		name = "frozen plate",
		article = "a",
		armor = 13,
		slotPosition = SLOTP_ARMOR,
		weight = 7500,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 7, [COMBAT_ENERGYDAMAGE] = -7}
	},
	{id = 8888, name = "master archer's armor", article = "a", armor = 15, slotPosition = SLOTP_ARMOR, weight = 6900, skillDist = 3},
	{
		id = 8889,
		name = "skullcracker armor",
		article = "a",
		weight = 11000,
		armor = 14,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 5, [COMBAT_HOLYDAMAGE] = -5},
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 8890,
		name = "robe of the underworld",
		article = "a",
		weight = 3100,
		armor = 12,
		slotPosition = SLOTP_ARMOR,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 12, [COMBAT_HOLYDAMAGE] = -12}
	},
	{id = 8891, name = "paladin armor", article = "a", armor = 12, slotPosition = SLOTP_ARMOR, weight = 6500, skillDist = 2},
	{id = 8892, name = "ethno coat", article = "an", armor = 7, slotPosition = SLOTP_ARMOR, weight = 2550, magicLevelPoints = 1},
	{fromId = 8894, toId = 8897, name = "mysterious machine", article = "a"},
	{fromId = 8898, toId = 8899, name = "chalk board", article = "a"},
	{
		id = 8900,
		name = "spellbook of enlightenment",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 1950,
		magicLevelPoints = 1,
		defense = 18,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 8901,
		name = "spellbook of warding",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 2100,
		magicLevelPoints = 1,
		defense = 22,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 8902,
		name = "spellbook of mind control",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 2450,
		magicLevelPoints = 2,
		defense = 16,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 8903,
		name = "spellbook of lost souls",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 2560,
		magicLevelPoints = 2,
		defense = 20,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 8904,
		name = "spellscroll of prophecies",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 2650,
		magicLevelPoints = 3,
		defense = 12,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 8905,
		name = "rainbow shield",
		article = "a",
		description = "Strange elemental magic flows over this shield.",
		weight = 6900,
		defense = 30,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 8906,
		name = "fiery rainbow shield",
		article = "a",
		description = "It has been temporarily imbued with fire magic and boosts your shielding skill.",
		weight = 6900,
		defense = 36,
		weaponType = WEAPON_SHIELD,
		duration = 900,
		decayTo = 8905,
		skillShield = 3
	},
	{
		id = 8907,
		name = "icy rainbow shield",
		article = "an",
		description = "It has been temporarily imbued with ice magic and has a greatly increased shielding value.",
		weight = 6900,
		defense = 39,
		weaponType = WEAPON_SHIELD,
		duration = 900,
		decayTo = 8905
	},
	{
		id = 8908,
		name = "sparking rainbow shield",
		article = "a",
		description = "It has been temporarily imbued with energy magic and increases your speed.",
		weight = 6900,
		defense = 36,
		weaponType = WEAPON_SHIELD,
		duration = 900,
		decayTo = 8905,
		speed = 20
	},
	{
		id = 8909,
		name = "terran rainbow shield",
		article = "a",
		description = "It has been temporarily imbued with earth magic and boosts your regeneration.",
		weight = 6900,
		defense = 37,
		weaponType = WEAPON_SHIELD,
		duration = 900,
		decayTo = 8905,
		healthGain = 1,
		healthTicks = 3000,
		manaGain = 4,
		manaTicks = 3000
	},
	{
		id = 8910,
		name = "underworld rod",
		article = "an",
		description = "No one knows which hell this unholy rod comes from.",
		weight = 2900,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_DEATH,
		range = 3
	},
	{
		id = 8911,
		name = "northwind rod",
		article = "a",
		description = "It was made by one of the shamans in Svargrond and symbolises an icy mammoth.",
		weight = 2900,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_ICE,
		range = 3
	},
	{
		id = 8912,
		name = "springsprout rod",
		article = "a",
		description = "It is filled with the energy of growing plants.",
		weight = 2700,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_SMALLEARTH,
		range = 3
	},
	{fromId = 8913, toId = 8917, name = "earth"},
	{
		id = 8918,
		name = "spellbook of dark mysteries",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 2850,
		magicLevelPoints = 3,
		defense = 16,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 8919,
		name = "spell rune",
		article = "a",
		description = "It is Yandur's healing rune. You can't remove it from his house, but you may use it."
	},
	{
		id = 8920,
		name = "wand of starstorm",
		article = "a",
		description = "It is sparkling with universal energy.",
		weight = 2550,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_ENERGY,
		range = 3
	},
	{
		id = 8921,
		name = "wand of draconia",
		article = "a",
		description = "This wand holds the spirit and soul of a dragon lord.",
		weight = 2700,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_FIRE,
		range = 3
	},
	{
		id = 8922,
		name = "wand of voodoo",
		article = "a",
		description = "It is filled with the dark hatred and rage of a tormented demonic being.",
		weight = 2850,
		weaponType = WEAPON_WAND,
		shootType = CONST_ANI_DEATH,
		range = 3
	},
	{id = 8923, name = "ranger legs", weight = 3500, armor = 4, slotPosition = SLOTP_LEGS},
	{
		id = 8924,
		name = "hellforged axe",
		article = "a",
		weight = 8800,
		defense = 28,
		attack = 51,
		weaponType = WEAPON_AXE,
		extraDefense = 2
	},
	{
		id = 8925,
		name = "solar axe",
		article = "a",
		weight = 11000,
		defense = 29,
		attack = 52,
		weaponType = WEAPON_AXE,
		extraDefense = 3
	},
	{
		id = 8926,
		name = "demonwing axe",
		article = "a",
		weight = 12000,
		defense = 20,
		attack = 53,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 8927,
		name = "dark trinity mace",
		article = "a",
		weight = 9900,
		defense = 32,
		attack = 51,
		weaponType = WEAPON_CLUB,
		extraDefense = -1
	},
	{
		id = 8928,
		name = "obsidian truncheon",
		article = "an",
		weight = 6500,
		defense = 30,
		attack = 50,
		weaponType = WEAPON_CLUB,
		extraDefense = 2
	},
	{
		id = 8929,
		name = "the stomper",
		weight = 11500,
		defense = 20,
		attack = 51,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 8930,
		name = "emerald sword",
		article = "an",
		weight = 4100,
		defense = 33,
		attack = 49,
		weaponType = WEAPON_SWORD,
		extraDefense = 3
	},
	{id = 8931, name = "the epiphany", weight = 4500, defense = 35, attack = 50, weaponType = WEAPON_SWORD, extraDefense = 3},
	{
		id = 8932,
		name = "the calamity",
		weight = 6800,
		defense = 35,
		attack = 51,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 8933,
		name = "remains of an earth elemental",
		weight = 50000,
		containerSize = 32,
		decayTo = 8934,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8934,
		name = "remains of an earth elemental",
		weight = 40000,
		containerSize = 32,
		decayTo = 8935,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8935,
		name = "remains of an earth elemental",
		weight = 30000,
		containerSize = 32,
		decayTo = 8936,
		duration = 500,
		corpseType = RACE_UNDEAD
	},
	{id = 8936, name = "remains of an earth elemental", weight = 20000, decayTo = 0, duration = 300, corpseType = RACE_UNDEAD},
	{
		id = 8937,
		name = "remains of a vampire lord",
		weight = 50000,
		containerSize = 10,
		decayTo = 8938,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8938,
		name = "remains of a vampire lord",
		weight = 35000,
		containerSize = 15,
		decayTo = 8939,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8939,
		name = "remains of a vampire lord",
		weight = 20000,
		containerSize = 15,
		decayTo = 8940,
		duration = 500,
		corpseType = RACE_UNDEAD
	},
	{id = 8940, name = "remains of a vampire lord", weight = 5000, decayTo = 0, duration = 300, corpseType = RACE_UNDEAD},
	{
		id = 8941,
		name = "dead wyrm",
		article = "a",
		weight = 50000,
		containerSize = 36,
		decayTo = 8942,
		duration = 10,
		corpseType = RACE_BLOOD
	},
	{
		id = 8942,
		name = "dead wyrm",
		article = "a",
		weight = 35000,
		containerSize = 36,
		decayTo = 8943,
		duration = 500,
		corpseType = RACE_BLOOD
	},
	{
		id = 8943,
		name = "dead wyrm",
		article = "a",
		weight = 20000,
		containerSize = 36,
		decayTo = 8944,
		duration = 300,
		corpseType = RACE_BLOOD
	},
	{id = 8944, name = "dead wyrm", article = "a", weight = 5000, decayTo = 0, duration = 150, corpseType = RACE_BLOOD},
	{
		id = 8945,
		name = "textbook",
		article = "a",
		description = "It contains the script to a piece performed in the theatre of Carlin.",
		weight = 1300
	},
	{id = 8946, name = "remains of a wisp", article = "the", decayTo = 0, duration = 60},
	{
		id = 8947,
		name = "dead giant worm",
		article = "a",
		weight = 50000,
		containerSize = 8,
		decayTo = 8948,
		duration = 10,
		corpseType = RACE_BLOOD
	},
	{
		id = 8948,
		name = "dead giant worm",
		article = "a",
		weight = 40000,
		containerSize = 10,
		decayTo = 8949,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 8949,
		name = "dead giant worm",
		article = "a",
		weight = 30000,
		containerSize = 10,
		decayTo = 8950,
		duration = 500,
		corpseType = RACE_BLOOD
	},
	{id = 8950, name = "dead giant worm", article = "a", weight = 20000, decayTo = 0, duration = 300, corpseType = RACE_BLOOD},
	{
		id = 8951,
		name = "slain bog raider",
		article = "a",
		weight = 50000,
		containerSize = 20,
		decayTo = 8952,
		duration = 10,
		corpseType = RACE_VENOM
	},
	{
		id = 8952,
		name = "slain bog raider",
		article = "a",
		weight = 35000,
		containerSize = 20,
		decayTo = 8953,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{
		id = 8953,
		name = "slain bog raider",
		article = "a",
		weight = 20000,
		containerSize = 20,
		decayTo = 8954,
		duration = 500,
		corpseType = RACE_VENOM
	},
	{id = 8954, name = "slain bog raider", article = "a", weight = 10000, decayTo = 0, duration = 300, corpseType = RACE_VENOM},
	{
		id = 8955,
		name = "slain reaper",
		article = "a",
		weight = 50000,
		containerSize = 40,
		decayTo = 8956,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8956,
		name = "slain reaper",
		article = "a",
		weight = 40000,
		containerSize = 40,
		decayTo = 8957,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 8957,
		name = "slain reaper",
		article = "a",
		weight = 30000,
		containerSize = 40,
		decayTo = 8958,
		duration = 500,
		corpseType = RACE_UNDEAD
	},
	{id = 8958, name = "slain reaper", article = "a", weight = 20000, decayTo = 0, duration = 300, corpseType = RACE_UNDEAD},
	{id = 8959, name = "white marble floor"},
	{
		id = 8960,
		name = "slain mutated pumpkin",
		article = "a",
		weight = 40000,
		containerSize = 10,
		decayTo = 8961,
		duration = 10,
		corpseType = RACE_VENOM
	},
	{
		id = 8961,
		name = "slain mutated pumpkin",
		article = "a",
		weight = 30000,
		containerSize = 10,
		decayTo = 8962,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{
		id = 8962,
		name = "slain mutated pumpkin",
		article = "a",
		weight = 30000,
		containerSize = 10,
		decayTo = 8963,
		duration = 500,
		corpseType = RACE_VENOM
	},
	{id = 8963, name = "slain mutated pumpkin", article = "a", weight = 30000, decayTo = 0, duration = 300, corpseType = RACE_VENOM},
	{
		id = 8964,
		name = "remains of an elemental",
		article = "the",
		weight = 25000,
		containerSize = 11,
		decayTo = 8969,
		duration = 10,
		corpseType = RACE_FIRE
	},
	{id = 8965, name = "remains of an elemental", article = "the", weight = 25000, containerSize = 14, decayTo = 8968, duration = 10},
	{id = 8966, name = "remains of an elemental", article = "the", weight = 25000, containerSize = 14, decayTo = 8967, duration = 10},
	{
		fromId = 8967,
		toId = 8968,
		name = "remains of an elemental",
		article = "the",
		weight = 10000,
		containerSize = 14,
		decayTo = 0,
		duration = 500
	},
	{
		id = 8969,
		name = "remains of an elemental",
		article = "the",
		containerSize = 11,
		weight = 10000,
		decayTo = 0,
		duration = 500,
		corpseType = RACE_FIRE
	},
	{id = 8970, name = "Santiago's piano"},
	{id = 8971, name = "gland", article = "a", description = "It is the pheromone gland of a rotworm queen.", weight = 50},
	{id = 8972, name = "large hole", article = "a", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{id = 8973, name = "archway", article = "an"},
	{id = 8974, name = "oracle figurine", article = "an", weight = 800},
	{id = 8975, name = "oracle figurine", article = "an", weight = 800, decayTo = 8974, duration = 3},
	{
		id = 8976,
		name = "golden falcon",
		article = "a",
		description = "It is a token of honour granted only by the gods.",
		weight = 2000
	},
	{id = 8977, name = "Worldcity encyclopedia", description = "It contains all the knowledge of the world.", weight = 1337},
	{id = 8978, name = "key of numerous locks", article = "a", description = "It opens every locked forum thread.", weight = 150},
	{id = 8979, name = "Worldiano emblem", weight = 1000, description = "Only a brave and true hero can possess it."},
	{id = 8980, name = "Mexcalibur", article = "the", description = "Your name is carved on this mighty sword.", weight = 1200},
	{
		id = 8981,
		name = "golden newspaper",
		article = "a",
		weight = 2400,
		description = "The worlds most amazing news can be read in it. It was awarded for winning a contest."
	},
	{id = 8982, name = "norseman doll", article = "a", description = "It is given to the winners of competitions.", weight = 1000},
	{
		id = 8983,
		name = "heavily bound book",
		article = "a",
		description = "It contains the scribings of many knowledgeable.",
		weight = 7800,
		writeable = true,
		maxTextLen = 199
	},
	{
		id = 8984,
		name = "abacus",
		article = "an",
		weight = 1200,
		description = "If you use it wisely, you may write yourself into the history books."
	},
	{
		id = 8985,
		name = "norseman doll",
		article = "a",
		weight = 1000,
		description = "It is given to the winners of competitions.",
		decayTo = 8982,
		duration = 3
	},
	{fromId = 8986, toId = 9001, name = "tree", article = "a"},
	{
		id = 9002,
		name = "Worldcity encyclopedia",
		weight = 1337,
		description = "It contains all the knowledge.",
		decayTo = 8977,
		duration = 5
	},
	{
		id = 9003,
		name = "golden falcon",
		article = "a",
		description = "It is a token of honour granted only by the gods.",
		weight = 2000
	},
	{
		id = 9004,
		name = "golden newspaper",
		article = "a",
		weight = 2400,
		description = "The most amazing news can be read in it. It was awarded for winning a contest.",
		decayTo = 8981,
		duration = 5
	},
	{id = 9005, name = "yummy gummy worm", article = "a", weight = 20},
	{id = 9006, name = "toy spider", article = "a", weight = 20},
	{id = 9007, name = "toy spider", article = "a", weight = 20, duration = 3, decayTo = 9006},
	{id = 9008, name = "something crawling", weight = 100},
	{
		id = 9009,
		name = "overlord's ashes",
		article = "the",
		containerSize = 8,
		decayTo = 9010,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 9010,
		name = "overlord's ashes",
		article = "the",
		description = "Use an obsidian knife on it to get neutral matter.",
		decayTo = 9011,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{id = 9011, name = "overlord's ashes", article = "the", decayTo = 9012, duration = 500, corpseType = RACE_UNDEAD},
	{id = 9012, name = "overlord's ashes", article = "the", decayTo = 0, duration = 300, corpseType = RACE_UNDEAD},
	{fromId = 9013, toId = 9018, name = "fallen tree", article = "a"},
	{id = 9019, name = "vampire doll", article = "a", weight = 940},
	{
		id = 9020,
		name = "vampire lord token",
		article = "a",
		description = "It proves that you have killed a vampire lord.",
		weight = 5
	},
	{fromId = 9021, toId = 9025, name = "dirt floor"},
	{fromId = 9026, toId = 9042, name = "earth"},
	{fromId = 9043, toId = 9058, name = "grass"},
	{id = 9059, name = "sand"},
	{fromId = 9060, toId = 9066, name = "wooden pillar", article = "a"},
	{id = 9067, name = "wooden floor"},
	{fromId = 9068, toId = 9073, name = "rock"},
	{id = 9074, name = "present", article = "a", weight = 600},
	{id = 9075, name = "costume bag", article = "a", weight = 800},
	{id = 9076, name = "costume bag", article = "a", weight = 800},
	{id = 9077, name = "costume bag", article = "a", weight = 800},
	{id = 9078, name = "special flask", article = "a", weight = 170},
	{id = 9079, name = "blue bottle", article = "a", weight = 250},
	{
		id = 9080,
		name = "hat of the mad",
		article = "a",
		description = "You have a vague feeling that it looks somewhat silly.",
		weight = 700,
		armor = 3,
		magicLevelPoints = 1,
		slotPosition = SLOTP_HEAD
	},
	{id = 9081, name = "parcel", article = "a", weight = 1800, containerSize = 10},
	{id = 9082, name = "dead troll", article = "a", weight = 50000, containerSize = 24},
	{id = 9083, name = "mummy disguise", weight = 900},
	{id = 9084, name = "iron pillar", article = "an"},
	{id = 9085, name = "iron construction", article = "an"},
	{fromId = 9086, toId = 9089, name = "screw", article = "a"},
	{id = 9090, name = "nut", article = "a"},
	{id = 9091, name = "thread of screw", article = "a"},
	{id = 9092, name = "roof", article = "a", floorChange = TILESTATE_FLOORCHANGE_EAST},
	{id = 9093, name = "roof", article = "a"},
	{id = 9094, name = "roof", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 9095, name = "roof", article = "a"},
	{id = 9096, name = "roof", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 9097, name = "roof", article = "a"},
	{id = 9098, name = "roof", article = "a", floorChange = TILESTATE_FLOORCHANGE_SOUTH},
	{id = 9099, name = "roof", article = "a"},
	{fromId = 9100, toId = 9101, name = "stone ledge", article = "a"},
	{fromId = 9102, toId = 9103, name = "oriel window", article = "an"},
	{id = 9104, name = "stone ledge", article = "a"},
	{id = 9105, name = "pillar", article = "a"},
	{id = 9106, name = "chimney", article = "a"},
	{
		id = 9107,
		name = "dead mutated human",
		article = "a",
		containerSize = 28,
		decayTo = 10007,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 9108,
		name = "suspicious surprise bag",
		article = "a",
		weight = 800,
		description = "It's from an undead jester, so open at own risk."
	},
	{id = 9109, name = "Ceiron's waterskin", weight = 700},
	{id = 9110, name = "strange whirl", article = "a", type = ITEM_TYPE_TELEPORT, effect = CONST_ME_TELEPORT},
	{
		id = 9111,
		name = "garlic bread",
		article = "a",
		weight = 500,
		description = "It is made of holy water and smells lightly of garlic. Sounds better than it actually tastes."
	},
	{
		id = 9112,
		name = "lump of holy water dough",
		article = "a",
		weight = 500,
		description = "This could be turned into a great weapon against vampires."
	},
	{
		id = 9113,
		name = "lump of garlic dough",
		article = "a",
		weight = 500,
		description = "It was made with holy water and garlic. You should be able to bake garlic bread - eww."
	},
	{id = 9114, name = "bulb of garlic", article = "a", plural = "bulbs of garlic", weight = 140},
	{id = 9115, name = "baking tray", article = "a", weight = 1200, description = "There is garlic cookie dough on it."},
	{
		id = 9116,
		name = "garlic cookie",
		article = "a",
		weight = 10,
		description = "The garlic in it is well hidden. Nevertheless, you don't want to eat those. Yuck."
	},
	{
		id = 9117,
		name = "Julius' map",
		weight = 790,
		description = "Julius gave it to you to have at least five unusual spots on Vengoth marked."
	},
	{fromId = 9118, toId = 9133, name = "stone wall", article = "a"},
	{id = 9134, name = "chimney", article = "a"},
	{fromId = 9135, toId = 9139, name = "stone wall", article = "a"},
	{id = 9140, name = "archway", article = "an"},
	{
		id = 9141,
		name = "blood crystal",
		article = "a",
		weight = 890,
		decayTo = 9369,
		duration = 604800,
		description = "It is charged with magic energy, but that won't last forever."
	},
	{fromId = 9142, toId = 9143, name = "stone wall", article = "a"},
	{fromId = 9144, toId = 9146, name = "white marble floor"},
	{fromId = 9147, toId = 9158, name = "stone wall", article = "a"},
	{fromId = 9159, toId = 9164, name = "archway", article = "an"},
	{id = 9165, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9166, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9167, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9168, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9169, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9170, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9171, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9172, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9173, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9174, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9175, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9176, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9177, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9178, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9179, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 9180, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 9181, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 9182, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 9183, toId = 9188, name = "stone wall", article = "a"},
	{fromId = 9189, toId = 9190, name = "window", article = "a"},
	{id = 9191, name = "torn book", article = "a", weight = 1100},
	{fromId = 9192, toId = 9206, name = "iron floor"},
	{fromId = 9207, toId = 9223, name = "iron wall", article = "an"},
	{fromId = 9224, toId = 9234, name = "wooden floor"},
	{fromId = 9235, toId = 9238, name = "sundial", article = "a"},
	{fromId = 9239, toId = 9240, name = "statue", article = "a"},
	{id = 9241, name = "vampire lord statue", article = "a"},
	{id = 9242, name = "vampire lord", article = "a"},
	{fromId = 9243, toId = 9244, name = "statue", article = "a"},
	{fromId = 9245, toId = 9248, name = "nails"},
	{fromId = 9249, toId = 9251, name = "golden ornament", article = "a"},
	{fromId = 9252, toId = 9262, name = "copper pipes"},
	{fromId = 9263, toId = 9266, name = "iron wall", article = "an"},
	{id = 9267, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9268, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9269, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9270, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9271, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9272, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9273, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9274, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9275, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 9276, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9277, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9278, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9279, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 9280, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 9281, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 9282, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 9283, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 9284, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 9285, toId = 9287, name = "archway", article = "an"},
	{fromId = 9288, toId = 9293, name = "stone wall", article = "a"},
	{fromId = 9294, toId = 9299, name = "broken stone wall", article = "a"},
	{fromId = 9300, toId = 9303, name = "stone railing", article = "a"},
	{id = 9304, name = "stone pillar", article = "a"},
	{id = 9305, name = "broken stone pillar", article = "a"},
	{id = 9306, name = "statue", article = "a"},
	{fromId = 9307, toId = 9319, name = "golden ornament", article = "a"},
	{fromId = 9320, toId = 9326, name = "archway", article = "an"},
	{fromId = 9327, toId = 9330, name = "copper pipes"},
	{fromId = 9331, toId = 9332, name = "steam"},
	{fromId = 9333, toId = 9334, name = "slime"},
	{fromId = 9335, toId = 9336, name = "archway", article = "an"},
	{fromId = 9337, toId = 9340, name = "golden ornament", article = "a"},
	{fromId = 9341, toId = 9342, name = "steam"},
	{fromId = 9343, toId = 9346, name = "copper pipes"},
	{fromId = 9347, toId = 9348, name = "copper wheel", article = "a"},
	{fromId = 9349, toId = 9350, name = "boiler", article = "a"},
	{fromId = 9351, toId = 9352, name = "copper pipe", article = "a"},
	{fromId = 9353, toId = 9368, name = "golden ornament", article = "a"},
	{id = 9369, name = "blood crystal", article = "a", weight = 890, description = "It has the power to store magic energy."},
	{fromId = 9370, toId = 9386, name = "stone wall", article = "a"},
	{fromId = 9387, toId = 9392, name = "stone railing", article = "a"},
	{fromId = 9393, toId = 9398, name = "small tower", article = "a"},
	{id = 9399, name = "pillar", article = "a"},
	{fromId = 9400, toId = 9404, name = "roof", article = "a"},
	{fromId = 9405, toId = 9414, name = "stone wall", article = "a"},
	{fromId = 9415, toId = 9416, name = "moss"},
	{fromId = 9417, toId = 9418, name = "stone railing", article = "a"},
	{fromId = 9419, toId = 9422, name = "stone pile", article = "a"},
	{id = 9423, name = "stone railing", article = "a"},
	{fromId = 9424, toId = 9433, name = "tapestry", article = "a"},
	{id = 9434, name = "stone wall", article = "a"},
	{fromId = 9435, toId = 9438, name = "heavy wooden chair", article = "a"},
	{id = 9439, name = "large candelabrum", article = "a"},
	{id = 9440, name = "fire basin", article = "a"},
	{id = 9441, name = "blood basin", article = "a"},
	{id = 9442, name = "family banner", article = "a"},
	{id = 9443, name = "old clock", article = "an", rotateTo = 9444},
	{id = 9444, name = "old clock", article = "an", rotateTo = 9443},
	{fromId = 9445, toId = 9446, name = "brass throne", article = "a"},
	{id = 9447, name = "blood goblet", article = "a", weight = 490},
	{id = 9448, name = "blood skull", article = "a", weight = 490},
	{fromId = 9449, toId = 9459, name = "tapestry", article = "a"},
	{fromId = 9460, toId = 9465, name = "eaves gutter", article = "an"},
	{fromId = 9466, toId = 9469, name = "rain barrel", article = "a"},
	{id = 9470, name = "palisade", article = "a"},
	{fromId = 9471, toId = 9475, name = "gate", article = "a"},
	{fromId = 9476, toId = 9477, name = "stone column", article = "a"},
	{fromId = 9478, toId = 9482, name = "gate", article = "a"},
	{fromId = 9483, toId = 9484, name = "stone column", article = "a"},
	{fromId = 9485, toId = 9486, name = "gate", article = "a"},
	{fromId = 9487, toId = 9494, name = "stone gargoyle", article = "a"},
	{fromId = 9495, toId = 9502, name = "banner", article = "a"},
	{fromId = 9503, toId = 9504, name = "orc trophy", article = "an"},
	{fromId = 9505, toId = 9506, name = "trophy of a strange fish", article = "a"},
	{fromId = 9507, toId = 9508, name = "trophy of a strange being", article = "a"},
	{fromId = 9509, toId = 9510, name = "bat", article = "a"},
	{fromId = 9511, toId = 9512, name = "candle", article = "a"},
	{fromId = 9513, toId = 9514, name = "shield and sword"},
	{fromId = 9515, toId = 9520, name = "shield", article = "a"},
	{fromId = 9521, toId = 9522, name = "skeleton", article = "a"},
	{fromId = 9523, toId = 9530, name = "archway", article = "an"},
	{id = 9531, name = "mechanism", article = "a"},
	{fromId = 9532, toId = 9533, name = "gate", article = "a"},
	{id = 9534, name = "mechanism", article = "a"},
	{fromId = 9535, toId = 9560, name = "roof", article = "a"},
	{id = 9561, name = "piano", article = "a"},
	{fromId = 9562, toId = 9566, name = "large glowing gem", article = "a"},
	{fromId = 9567, toId = 9568, name = "small glowing gems"},
	{fromId = 9569, toId = 9570, name = "wooden floor"},
	{fromId = 9571, toId = 9572, name = "statue", article = "a"},
	{id = 9573, name = "corkscrew stairs", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 9574, name = "corkscrew stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 9575, toId = 9582, name = "street lamp", article = "a"},
	{id = 9583, name = "wall mirror", article = "a"},
	{fromId = 9584, toId = 9585, name = "painting", article = "a"},
	{fromId = 9586, toId = 9587, name = "water"},
	{fromId = 9588, toId = 9595, name = "large well", article = "a"},
	{id = 9596, name = "stone pedestal", article = "a"},
	{fromId = 9597, toId = 9599, name = "statue", article = "a"},
	{id = 9600, name = "water"},
	{fromId = 9601, toId = 9604, name = "large well", article = "a"},
	{id = 9605, name = "wall mirror", article = "a"},
	{id = 9606, name = "stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 9607, toId = 9610, name = "small balcony", article = "a"},
	{fromId = 9611, toId = 9623, name = "old carpet", article = "an"},
	{id = 9624, name = "closed trapdoor", article = "a"},
	{id = 9625, name = "open trapdoor", article = "an", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 9626, toId = 9630, name = "old carpet", article = "an"},
	{id = 9631, name = "coffin", article = "a"},
	{id = 9632, name = "swamp", type = ITEM_TYPE_TRASHHOLDER, effect = CONST_ME_GREEN_RINGS, ignoreBlocking = true},
	{
		id = 9633,
		name = "dust of Boreth",
		article = "the",
		description = "Julius might be interested in the ashes of this vampire lord.",
		weight = 100
	},
	{
		id = 9634,
		name = "dust of Lersatio",
		article = "the",
		description = "Julius might be interested in the ashes of this vampire lord.",
		weight = 100
	},
	{
		id = 9635,
		name = "dust of Marziel",
		article = "the",
		description = "Julius might be interested in the ashes of this vampire lord.",
		weight = 100
	},
	{
		id = 9636,
		name = "dust of Arthei",
		article = "the",
		description = "Julius might be interested in the ashes of this vampire lord.",
		weight = 100
	},
	{fromId = 9637, toId = 9638, name = "wall mirror", article = "a"},
	{fromId = 9639, toId = 9642, name = "small balcony", article = "a"},
	{fromId = 9643, toId = 9646, name = "jutty", article = "a"},
	{fromId = 9647, toId = 9652, name = "balcony", article = "a"},
	{
		id = 9653,
		name = "CM token",
		article = "a",
		description = "It was a gift from a community manager.",
		weight = 1000,
		writeable = true,
		maxTextLen = 128
	},
	{
		id = 9654,
		name = "dead vampire bride",
		article = "a",
		containerSize = 10,
		decayTo = 9658,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{id = 9655, name = "wooden pole", article = "a"},
	{fromId = 9656, toId = 9657, name = "wall mirror", article = "a"},
	{
		id = 9658,
		name = "dead vampire bride",
		article = "a",
		containerSize = 10,
		decayTo = 9659,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 9659, name = "dead vampire bride", article = "a", containerSize = 10, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 9660,
		name = "dead vampire bride",
		article = "a",
		containerSize = 10,
		decayTo = 9654,
		duration = 10,
		corpseType = RACE_BLOOD
	},
	{id = 9661, name = "crate", article = "a"},
	{id = 9662, name = "ghost's tear", article = "a", weight = 1000},
	{fromId = 9663, toId = 9668, name = "old piece of paper", article = "an", weight = 200},
	{fromId = 9669, toId = 9670, name = "wall mirror", article = "a"},
	{id = 9671, name = "sandstone floor"},
	{id = 9672, name = "white marble floor"},
	{id = 9673, name = "stone floor"},
	{id = 9674, name = "bottle of bug milk", article = "a", weight = 280},
	{id = 9675, name = "sample of venorean spice", article = "a", weight = 500},
	{id = 9676, name = "sample of sand wasp honey", article = "a", weight = 80},
	{id = 9677, name = "jug of embalming fluid", article = "a", weight = 750},
	{id = 9678, name = "piece of royal satin", article = "a", weight = 500},
	{id = 9679, name = "flower bowl", article = "a", weight = 1100},
	{id = 9680, name = "research notes", weight = 200},
	{id = 9681, name = "archway", article = "an"},
	{fromId = 9682, toId = 9685, name = "drawbridge", article = "a"},
	{id = 9686, name = "crate", article = "a", description = "It contains food."},
	{id = 9687, name = "food crate", article = "a", weight = 10000},
	{id = 9688, name = "Iriana's chest", weight = 12000},
	{
		id = 9689,
		name = "cask of brown ale",
		article = "a",
		weight = 30000,
		description = "It contains dwarven brown ale brewed by a human."
	},
	{id = 9690, name = "gear wheel", article = "a", weight = 5},
	{id = 9691, name = "large crystal", article = "a", weight = 235},
	{id = 9692, name = "Rerun's ring", weight = 90},
	{id = 9693, name = "jester doll", article = "a", weight = 1200},
	{id = 9694, name = "head of a jester doll", article = "the", weight = 400},
	{id = 9695, name = "torso of a jester doll", article = "the", weight = 400},
	{id = 9696, name = "part of a jester doll", article = "a", description = "It seems to be the left arm.", weight = 100},
	{id = 9697, name = "part of a jester doll", article = "a", description = "It seems to be the right arm.", weight = 100},
	{id = 9698, name = "part of a jester doll", article = "a", description = "It seems to be the left leg.", weight = 100},
	{id = 9699, name = "part of a jester doll", article = "a", description = "It seems to be the right leg.", weight = 100},
	{fromId = 9700, toId = 9707, name = "acid"},
	{fromId = 9708, toId = 9713, name = "burnt wall", article = "a"},
	{fromId = 9714, toId = 9719, name = "mosaik", article = "a"},
	{fromId = 9720, toId = 9725, name = "window", article = "a"},
	{id = 9726, name = "pitch black gap", article = "a"},
	{fromId = 9727, toId = 9728, name = "stone", article = "a"},
	{fromId = 9729, toId = 9730, name = "small window", article = "a"},
	{fromId = 9731, toId = 9732, name = "bloodspot", article = "a"},
	{id = 9733, name = "alchemists' formulas", article = "the", weight = 200},
	{id = 9734, name = "animal cure", weight = 180},
	{id = 9735, name = "Morik's helmet", description = "It belonged to a famous gladiator.", weight = 4600},
	{id = 9736, name = "armor", article = "an", weight = 900},
	{fromId = 9737, toId = 9740, name = "ghost charm", article = "a", weight = 900},
	{id = 9741, name = "ghost residue", weight = 2200},
	{id = 9742, name = "charged ghost charm", article = "a", slotPosition = SLOTP_AMMO, weight = 900},
	{id = 9743, name = "weapon matrix crystal", article = "a", description = "It contains patterns to create weapons.", weight = 250},
	{id = 9744, name = "food matrix crystal", article = "a", description = "It contains patterns to create food.", weight = 250},
	{id = 9745, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 9746, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_WEST},
	{id = 9747, name = "lit wall lamp", article = "a"},
	{id = 9748, name = "wall lamp", article = "a"},
	{id = 9749, name = "lit wall lamp", article = "a"},
	{id = 9750, name = "wall lamp", article = "a"},
	{fromId = 9751, toId = 9752, name = "statue", article = "a"},
	{fromId = 9753, toId = 9758, name = "tree", article = "a"},
	{fromId = 9759, toId = 9766, name = "roof", article = "a"},
	{id = 9767, name = "strange apparatus", article = "a"},
	{fromId = 9768, toId = 9769, name = "street lamp", article = "a"},
	{fromId = 9770, toId = 9771, name = "wall lamp", article = "a"},
	{id = 9772, name = "inactive teleporter", article = "an"},
	{id = 9773, name = "magic forcefield", article = "a", description = "You can see the other side through it."},
	{id = 9774, name = "brocade backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 9775, name = "brocade bag", article = "a", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{
		id = 9776,
		name = "yalahari armor",
		article = "a",
		weight = 7000,
		armor = 16,
		slotPosition = SLOTP_ARMOR,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 3}
	},
	{
		id = 9777,
		name = "yalahari leg piece",
		article = "a",
		weight = 6500,
		armor = 8,
		slotPosition = SLOTP_LEGS,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 5},
		skillDist = 2
	},
	{id = 9778, name = "yalahari mask", article = "a", weight = 3500, armor = 5, slotPosition = SLOTP_HEAD, magicLevelPoints = 2},
	{id = 9779, name = "crystal column", article = "a"},
	{
		id = 9780,
		name = "dead tortoise",
		article = "a",
		weight = 120000,
		containerSize = 10,
		decayTo = 9781,
		duration = 60,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 9781,
		name = "dead tortoise",
		article = "a",
		weight = 120000,
		containerSize = 10,
		decayTo = 9782,
		duration = 60,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 9782,
		name = "dead tortoise",
		article = "a",
		weight = 120000,
		containerSize = 10,
		decayTo = 9783,
		duration = 60,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 9783,
		name = "dead tortoise",
		article = "a",
		weight = 120000,
		containerSize = 10,
		decayTo = 0,
		duration = 60,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{fromId = 9784, toId = 9791, name = "crystal column", article = "a"},
	{fromId = 9792, toId = 9799, name = "earth"},
	{id = 9800, name = "rock"},
	{
		id = 9801,
		name = "dead worker golem",
		article = "a",
		containerSize = 20,
		decayTo = 9802,
		duration = 10,
		corpseType = RACE_ENERGY
	},
	{
		id = 9802,
		name = "dead worker golem",
		article = "a",
		containerSize = 20,
		decayTo = 9803,
		duration = 900,
		corpseType = RACE_ENERGY
	},
	{
		id = 9803,
		name = "dead worker golem",
		article = "a",
		containerSize = 20,
		decayTo = 9804,
		duration = 600,
		corpseType = RACE_ENERGY
	},
	{id = 9804, name = "dead worker golem", article = "a", containerSize = 20, decayTo = 0, duration = 600, corpseType = RACE_ENERGY},
	{
		fromId = 9805,
		toId = 9807,
		name = "rusty weapon",
		article = "a",
		description = "If you can remove the rust layer and dirt from the weapon you will be able to see what it is.",
		weight = 4500
	},
	{
		fromId = 9808,
		toId = 9810,
		name = "rusty armor",
		article = "a",
		description = "If you can remove the rust layer and dirt from the armor you will be able to see what it is.",
		weight = 12000
	},
	{
		fromId = 9811,
		toId = 9813,
		name = "rusty legs",
		article = "a",
		description = "If you can remove the rust layer and dirt from the legs you will be able to see what it is.",
		weight = 7000
	},
	{
		fromId = 9814,
		toId = 9816,
		name = "rusty shield",
		article = "a",
		description = "If you can remove the rust layer and dirt from the shield you will be able to see what it is.",
		weight = 2800,
		defense = 1,
		weaponType = WEAPON_SHIELD
	},
	{
		fromId = 9817,
		toId = 9819,
		name = "rusty boots",
		description = "If you can remove the rust layer and dirt from the boots you will be able to see what it is.",
		weight = 2800,
		armor = 1,
		slotPosition = SLOTP_FEET
	},
	{
		fromId = 9820,
		toId = 9822,
		name = "rusty helmet",
		article = "a",
		description = "If you can remove the rust layer and dirt from the helmet you will be able to see what it is.",
		weight = 2800,
		armor = 1,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 9823,
		name = "slain undead gladiator",
		article = "a",
		containerSize = 36,
		decayTo = 9824,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 9824,
		name = "slain undead gladiator",
		article = "a",
		containerSize = 36,
		decayTo = 0,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{fromId = 9825, toId = 9828, name = "lever", article = "a"},
	{id = 9829, name = "dead mutated bat", article = "a", containerSize = 42, decayTo = 9830, duration = 10, corpseType = RACE_BLOOD},
	{
		id = 9830,
		name = "dead mutated bat",
		article = "a",
		containerSize = 42,
		decayTo = 9831,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 9831,
		name = "dead mutated bat",
		article = "a",
		containerSize = 42,
		decayTo = 9832,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 9832, name = "dead mutated bat", article = "a", containerSize = 42, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{fromId = 9833, toId = 9834, name = "old carpet", article = "an"},
	{fromId = 9835, toId = 9836, name = "tapestry", article = "a"},
	{id = 9837, name = "velvet tapestry", article = "a", weight = 1000},
	{id = 9838, name = "wall lamp", article = "a"},
	{id = 9839, name = "lit wall lamp", article = "a"},
	{id = 9840, name = "wall lamp", article = "a"},
	{id = 9841, name = "lit wall lamp", article = "a"},
	{id = 9842, name = "wall lamp", article = "a"},
	{id = 9843, name = "lit wall lamp", article = "a"},
	{id = 9844, name = "wall lamp", article = "a"},
	{id = 9845, name = "lit wall lamp", article = "a"},
	{id = 9846, name = "corkscrew stairs", floorChange = TILESTATE_FLOORCHANGE_DOWN},
	{fromId = 9847, toId = 9866, name = "stone carving", article = "a"},
	{id = 9867, name = "slain treeling", article = "a", containerSize = 24, decayTo = 9868, duration = 10, corpseType = RACE_UNDEAD},
	{id = 9868, name = "slain treeling", article = "a", containerSize = 24, decayTo = 9869, duration = 900, corpseType = RACE_UNDEAD},
	{id = 9869, name = "slain treeling", article = "a", containerSize = 24, decayTo = 9870, duration = 600, corpseType = RACE_UNDEAD},
	{id = 9870, name = "slain treeling", article = "a", containerSize = 24, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 9871, name = "dead mutated rat", article = "a", containerSize = 32, decayTo = 9872, duration = 10, corpseType = RACE_BLOOD},
	{
		id = 9872,
		name = "dead mutated rat",
		article = "a",
		containerSize = 32,
		decayTo = 9873,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 9873,
		name = "dead mutated rat",
		article = "a",
		containerSize = 32,
		decayTo = 9874,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 9874, name = "dead mutated rat", article = "a", containerSize = 32, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 9875, name = "slain zombie", article = "a", containerSize = 24, decayTo = 9876, duration = 10, corpseType = RACE_BLOOD},
	{id = 9876, name = "slain zombie", article = "a", containerSize = 24, decayTo = 9877, duration = 900, corpseType = RACE_BLOOD},
	{id = 9877, name = "slain zombie", article = "a", containerSize = 24, decayTo = 9878, duration = 600, corpseType = RACE_BLOOD},
	{id = 9878, name = "slain zombie", article = "a", containerSize = 24, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 9879,
		name = "dead young sea serpent",
		article = "a",
		containerSize = 30,
		decayTo = 9880,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 9880,
		name = "dead young sea serpent",
		article = "a",
		containerSize = 30,
		decayTo = 9881,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 9881, name = "dead young sea serpent", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 9882,
		name = "dead young sea serpent",
		article = "a",
		containerSize = 30,
		decayTo = 9879,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 9883, name = "lava", type = ITEM_TYPE_TRASHHOLDER, ignoreBlocking = true, effect = CONST_ME_HITBYFIRE},
	{fromId = 9884, toId = 9885, name = "strange apparatus", article = "a"},
	{id = 9886, name = "broken apparatus", article = "a"},
	{fromId = 9887, toId = 9890, name = "strange apparatus", article = "a"},
	{id = 9891, name = "broken apparatus", article = "a"},
	{fromId = 9892, toId = 9893, name = "strange apparatus", article = "a"},
	{id = 9894, name = "broken apparatus", article = "a"},
	{fromId = 9895, toId = 9896, name = "strange machine", article = "a"},
	{id = 9897, name = "broken machine", article = "a"},
	{fromId = 9898, toId = 9899, name = "strange machine", article = "a"},
	{id = 9900, name = "broken machine", article = "a"},
	{fromId = 9901, toId = 9902, name = "strange machine", article = "a"},
	{id = 9903, name = "broken machine", article = "a"},
	{fromId = 9904, toId = 9905, name = "strange machine", article = "a"},
	{id = 9906, name = "broken machine", article = "a"},
	{fromId = 9907, toId = 9908, name = "weird machine", article = "a"},
	{fromId = 9909, toId = 9910, name = "alchemical apparatus", article = "an"},
	{fromId = 9911, toId = 9912, name = "suspicious cauldron", article = "a"},
	{id = 9913, name = "dead tiger", article = "a", containerSize = 10, decayTo = 9914, duration = 10, corpseType = RACE_BLOOD},
	{id = 9914, name = "dead tiger", article = "a", containerSize = 10, decayTo = 0, duration = 900, corpseType = RACE_BLOOD},
	{
		id = 9915,
		name = "slain nightstalker",
		article = "a",
		containerSize = 24,
		decayTo = 9916,
		duration = 10,
		corpseType = RACE_BLOOD
	},
	{
		id = 9916,
		name = "slain nightstalker",
		article = "a",
		containerSize = 24,
		decayTo = 9917,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 9917,
		name = "slain nightstalker",
		article = "a",
		containerSize = 24,
		decayTo = 9918,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 9918, name = "slain nightstalker", article = "a", containerSize = 24, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 9919,
		name = "dead nightmare scion",
		article = "a",
		containerSize = 36,
		decayTo = 9920,
		duration = 10,
		corpseType = RACE_BLOOD
	},
	{
		id = 9920,
		name = "dead nightmare scion",
		article = "a",
		containerSize = 36,
		decayTo = 9921,
		duration = 900,
		corpseType = RACE_BLOOD
	},
	{
		id = 9921,
		name = "dead nightmare scion",
		article = "a",
		containerSize = 36,
		decayTo = 9922,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{
		id = 9922,
		name = "dead nightmare scion",
		article = "a",
		containerSize = 36,
		decayTo = 0,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 9923, name = "dead hellspawn", article = "a", containerSize = 44, decayTo = 9924, duration = 10, corpseType = RACE_BLOOD},
	{id = 9924, name = "dead hellspawn", article = "a", containerSize = 44, decayTo = 9925, duration = 900, corpseType = RACE_BLOOD},
	{id = 9925, name = "dead hellspawn", article = "a", containerSize = 44, decayTo = 9926, duration = 600, corpseType = RACE_BLOOD},
	{id = 9926, name = "dead hellspawn", article = "a", containerSize = 44, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 9927, name = "flower wreath", article = "a", slotPosition = SLOTP_HEAD, weight = 500},
	{id = 9928, name = "leaf legs", slotPosition = SLOTP_LEGS, weight = 1200},
	{id = 9929, name = "flower dress", article = "a", slotPosition = SLOTP_ARMOR, weight = 1900},
	{
		id = 9930,
		name = "flask of rust remover",
		article = "a",
		description = "It can be used to clean and polish old and rusty armors.",
		weight = 90
	},
	{id = 9931, name = "coconut shoes", slotPosition = SLOTP_FEET, weight = 600},
	{
		id = 9932,
		name = "firewalker boots",
		description = "Wearing these boots reduces the damage gotten from fiery ground.",
		weight = 950,
		armor = 2,
		slotPosition = SLOTP_FEET,
		decayTo = 10022,
		transformDeEquipTo = 9933,
		fieldabsorbpercentfire = 90,
		duration = 3600,
		showDuration = true,
		showAttributes = true
	},
	{
		id = 9933,
		name = "firewalker boots",
		description = "Wearing these boots reduces the damage gotten from fiery ground.",
		weight = 950,
		armor = 2,
		slotPosition = SLOTP_FEET,
		transformEquipTo = 9932,
		stopDuration = true,
		showDuration = true
	},
	{id = 9934, name = "worn leather boots", article = "a", weight = 900},
	{id = 9935, name = "dead gozzler", article = "a", containerSize = 24, decayTo = 9936, duration = 900, corpseType = RACE_BLOOD},
	{id = 9936, name = "dead gozzler", article = "a", containerSize = 24, decayTo = 9937, duration = 600, corpseType = RACE_BLOOD},
	{id = 9937, name = "dead gozzler", article = "a", containerSize = 24, decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 9938, name = "dead gozzler", article = "a", containerSize = 24, decayTo = 9935, duration = 10, corpseType = RACE_BLOOD},
	{fromId = 9939, toId = 9940, name = "gate", article = "a"},
	{
		id = 9941,
		name = "crystal of focus",
		article = "a",
		description = "It is said to increase your ability to concentrate and take the right decisions.",
		weight = 800
	},
	{
		id = 9942,
		name = "crystal of balance",
		article = "a",
		description = "It is said to make your calmer and less afflicted by anger and anxiety.",
		weight = 850
	},
	{id = 9943, name = "gate", article = "a"},
	{fromId = 9944, toId = 9945, name = "wooden pillar", article = "a"},
	{fromId = 9946, toId = 9947, name = "gate", article = "a"},
	{
		id = 9948,
		name = "dracoyle statue",
		article = "a",
		slotPosition = SLOTP_AMMO,
		description = "This rare treasure is said to protect its owner from misery and curses.",
		weight = 1500,
		rotateTo = 9953,
		duration = 604800,
		decayTo = 9949
	},
	{
		id = 9949,
		name = "dracoyle statue",
		article = "a",
		slotPosition = SLOTP_AMMO,
		description = "This rare treasure can be charged with an enchanted emerald.",
		weight = 1500,
		rotateTo = 9954
	},
	{id = 9950, name = "gate", article = "a"},
	{fromId = 9951, toId = 9952, name = "wooden pillar", article = "a"},
	{
		id = 9953,
		name = "dracoyle statue",
		article = "a",
		slotPosition = SLOTP_AMMO,
		description = "This rare treasure is said to protect its owner from misery and curses.",
		weight = 1500,
		rotateTo = 9948,
		duration = 604800,
		decayTo = 9954
	},
	{
		id = 9954,
		name = "dracoyle statue",
		article = "a",
		slotPosition = SLOTP_AMMO,
		description = "This rare treasure can be charged with an enchanted emerald.",
		weight = 1500,
		rotateTo = 9949
	},
	{
		id = 9955,
		name = "vampiric crest",
		article = "a",
		description = "This crest seems important. You shouldn't lose it.",
		weight = 500
	},
	{
		id = 9956,
		name = "magical torch",
		article = "a",
		slotPosition = SLOTP_AMMO,
		description = "Light all important locations given to you by Lucius before one of the basins stops burning.",
		weight = 1800,
		defense = 25,
		speed = 50,
		decayTo = 0,
		duration = 86400,
		showDuration = true
	},
	{id = 9957, name = "lightbringer's basin", article = "a"},
	{id = 9958, name = "royal tapestry", article = "a", weight = 1000},
	{id = 9959, name = "silky tapestry", article = "a", weight = 1000},
	{
		id = 9960,
		name = "remains of a death blob",
		article = "the",
		containerSize = 20,
		decayTo = 9963,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 9961,
		name = "remains of a mercury blob",
		article = "the",
		containerSize = 20,
		decayTo = 9964,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 9962,
		name = "remains of a acid blob",
		article = "the",
		containerSize = 20,
		decayTo = 9965,
		duration = 10,
		corpseType = RACE_VENOM
	},
	{
		id = 9963,
		name = "remains of a death blob",
		article = "the",
		containerSize = 20,
		decayTo = 0,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 9964,
		name = "remains of a mercury blob",
		article = "the",
		containerSize = 20,
		decayTo = 0,
		duration = 900,
		corpseType = RACE_UNDEAD
	},
	{
		id = 9965,
		name = "remains of an acid blob",
		article = "the",
		containerSize = 20,
		decayTo = 0,
		duration = 900,
		corpseType = RACE_VENOM
	},
	{id = 9966, name = "glob of mercury", article = "a", weight = 10},
	{id = 9967, name = "glob of acid slime", article = "a", weight = 10},
	{id = 9968, name = "glob of tar", article = "a", weight = 10},
	{id = 9969, name = "black skull", article = "a", slotPosition = SLOTP_AMMO, weight = 2400},
	{id = 9970, name = "small topaz", article = "a", plural = "small topazes", weight = 10},
	{id = 9971, name = "gold ingot", article = "a", plural = "gold ingots", weight = 1800},
	{id = 9972, name = "small lamp", article = "a", weight = 1000},
	{id = 9973, name = "lit small lamp", article = "a"},
	{
		id = 9974,
		name = "crystal table kit",
		article = "a",
		description = "Use it in your house to construct a crystal table.",
		weight = 2500
	},
	{id = 9975, name = "crystal table", article = "a", weight = 2500},
	{id = 9976, name = "crystal pedestal", article = "a", weight = 4000},
	{id = 9977, name = "crystal pedestal", article = "a", weight = 4000},
	{id = 9978, name = "crystal pedestal", article = "a", weight = 4000},
	{id = 9979, name = "crystal pedestal", article = "a", weight = 4000},
	{
		id = 9980,
		name = "crystal of power",
		article = "a",
		description = "It is said to make you more resistant to weaknesses and to supply you with energy.",
		weight = 850
	},
	{id = 9981, name = "yalahari figurine", article = "a", weight = 800},
	{
		id = 9982,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a finger snapper plant.",
		weight = 150,
		decayTo = 9984,
		duration = 432000
	},
	{
		id = 9983,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a finger snapper plant.",
		weight = 150,
		decayTo = 9982,
		duration = 72000
	},
	{
		fromId = 9984,
		toId = 9985,
		name = "withered plant",
		article = "a",
		description = "This plant urgently needs some water, else it will wither away and disappear completely.",
		weight = 150,
		decayTo = 7679,
		duration = 172800
	},
	{
		id = 9986,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a fairy dancer flower.",
		weight = 150,
		decayTo = 9985,
		duration = 432000
	},
	{
		id = 9987,
		name = "flower pot",
		article = "a",
		description = "The plant in it seems to be a fairy dancer flower.",
		weight = 150,
		decayTo = 9986,
		duration = 72000
	},
	{
		id = 9988,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown fairy dancer flower in it.",
		weight = 150,
		decayTo = 9985,
		duration = 432000
	},
	{
		id = 9989,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown fairy dancer flower in it.",
		weight = 150,
		decayTo = 9988,
		duration = 72000
	},
	{
		id = 9990,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown finger snapper plant in it.",
		weight = 150,
		decayTo = 9984,
		duration = 432000
	},
	{
		id = 9991,
		name = "flower pot",
		article = "a",
		description = "There is a fully grown finger snapper plant in it.",
		weight = 150,
		decayTo = 9990,
		duration = 72000
	},
	{id = 9992, name = "rotworm stew", description = "It's hot, beefy and delicious. The perfect food for knights.", weight = 1200},
	{
		id = 9993,
		name = "hydra tongue salad",
		description = "Though the hydra tongue is commonly considered a pest plant it tastes surprisingly aromatic.",
		weight = 550
	},
	{
		id = 9994,
		name = "roasted dragon wings",
		description = "You know why it's called 'dragon' when you feel the fire in your throat.",
		weight = 850
	},
	{id = 9995, name = "tropical fried terrorbird", description = "It's the ideal snack for a beach barbeque.", weight = 780},
	{id = 9996, name = "banana chocolate shake", article = "a", description = "Sweetness.", weight = 300},
	{
		id = 9997,
		name = "veggie casserole",
		article = "a",
		description = "This one would be quite healthy if it wasn't for all the melted cheese on top.",
		weight = 1100
	},
	{
		id = 9998,
		name = "filled jalapeno peppers",
		description = "The creamy cheese makes a great combination with the spicy peppers.",
		weight = 650
	},
	{id = 9999, name = "blessed steak", article = "a", description = "It's nicely decorated with plums and pumpkin.", weight = 950},
	{
		id = 10000,
		name = "carrot cake",
		article = "a",
		description = "This spicy-sweet cake will probably put you into a sugar rush.",
		weight = 680
	},
	{
		id = 10001,
		name = "northern fishburger",
		article = "a",
		description = "It's only suited for those who like maritime food.",
		weight = 460
	},
	{
		id = 10002,
		name = "dead war golem",
		article = "a",
		containerSize = 38,
		decayTo = 10003,
		duration = 900,
		corpseType = RACE_ENERGY
	},
	{
		id = 10003,
		name = "dead war golem",
		article = "a",
		containerSize = 38,
		decayTo = 10004,
		duration = 600,
		corpseType = RACE_ENERGY
	},
	{id = 10004, name = "dead war golem", article = "a", decayTo = 0, duration = 600, corpseType = RACE_ENERGY},
	{
		id = 10005,
		name = "dead war golem",
		article = "a",
		containerSize = 38,
		decayTo = 10002,
		duration = 10,
		corpseType = RACE_ENERGY
	},
	{
		id = 10006,
		name = "Jean Pierre's Cookbook I",
		description = "It was given to you by the djinn mantre and contains the collection of recipes you cooked.",
		weight = 1500
	},
	{
		id = 10007,
		name = "dead mutated human",
		article = "a",
		containerSize = 28,
		decayTo = 10008,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 10008,
		name = "dead mutated human",
		article = "a",
		containerSize = 28,
		decayTo = 10009,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 10009,
		name = "dead mutated human",
		article = "a",
		containerSize = 28,
		decayTo = 0,
		duration = 600,
		corpseType = RACE_BLOOD
	},
	{id = 10010, name = "swamp tentacles"},
	{fromId = 10011, toId = 10012, name = "black candle", article = "a"},
	{id = 10013, name = "mystic flame", article = "a"},
	{id = 10014, name = "stand", article = "a"},
	{id = 10015, name = "dead rift creature", article = "a"},
	{id = 10016, name = "batwing hat", article = "a", weight = 600, armor = 3, slotPosition = SLOTP_HEAD, magicLevelPoints = 1},
	{id = 10017, name = "football", article = "a"},
	{id = 10019, name = "ocean floor"},
	{id = 10020, name = "dragon claw", article = "a", weight = 1250},
	{
		id = 10021,
		name = "worn soft boots",
		description = "Someone specialised in shoes might be able to repair them for you.",
		weight = 800,
		slotPosition = SLOTP_FEET
	},
	{
		id = 10022,
		name = "worn firewalker boots",
		description = "They can be recharged with an enchanted ruby.",
		weight = 950,
		slotPosition = SLOTP_FEET
	},
	{id = 10024, name = "crystal ball", article = "a", weight = 3400},
	{id = 10025, name = "molten wax", weight = 50},
	{
		id = 10026,
		name = "special polish",
		article = "a",
		description = "You can use it to polish Eclesius' crystal ball.",
		weight = 60
	},
	{
		id = 10027,
		name = "magical blending device",
		article = "a",
		description = "Place ingredients in bowl, then pull lever to grind and blend them. Only for smart magical recipes."
	},
	{
		id = 10028,
		name = "fish flakes",
		description = "Not simple fish flakes, but magical fish flakes supporting linguistic development.",
		weight = 70
	},
	{fromId = 10029, toId = 10030, name = "lever", article = "a"},
	{
		id = 10031,
		name = "flask with magical oil",
		article = "a",
		description = "Eclesius made it for you to oil the door of the demon cage.",
		weight = 180
	},
	{id = 10032, name = "pink key", article = "a", type = ITEM_TYPE_KEY, weight = 100},
	{id = 10033, name = "wooden ties", weight = 500},
	{id = 10034, name = "metal fitting", weight = 250},
	{id = 10035, name = "rope-ladder", article = "a"},
	{id = 10037, name = "ore wagon", article = "an"},
	{id = 10038, name = "crucible", article = "a"},
	{fromId = 10039, toId = 10040, name = "bellow", article = "a"},
	{fromId = 10041, toId = 10043, name = "crucible", article = "a"},
	{fromId = 10044, toId = 10045, name = "lever", article = "a"},
	{fromId = 10046, toId = 10048, name = "hat for Eclesius", article = "a", weight = 110},
	{
		id = 10050,
		name = "Eclesius' sandals",
		description = "There is a tag on them which says 'Do not wear! Those are mine!' As if you had wanted to wear them.",
		weight = 600
	},
	{id = 10051, name = "frost cannon", article = "a"},
	{id = 10052, name = "crystal column", article = "a", decayTo = 10056, duration = 10},
	{id = 10053, name = "crystal column", article = "a", decayTo = 10057, duration = 10},
	{id = 10054, name = "crystal column", article = "a", decayTo = 10058, duration = 10},
	{id = 10055, name = "crystal column", article = "a", decayTo = 10059, duration = 10},
	{id = 10056, name = "crystal column", article = "a", decayTo = 10052, duration = 10},
	{id = 10057, name = "crystal column", article = "a", decayTo = 10053, duration = 10},
	{id = 10058, name = "crystal column", article = "a", decayTo = 10054, duration = 10},
	{id = 10059, name = "crystal column", article = "a", decayTo = 10055, duration = 10},
	{id = 10060, name = "frost cannon", article = "a"},
	{id = 10061, name = "Grodrik's favourite axe", weight = 2500},
	{id = 10062, name = "Amarie's favourite book", weight = 800},
	{
		id = 10063,
		name = "Epaminondas doll",
		article = "an",
		description = "He talks, moves and sings just like a real person.",
		weight = 777
	},
	{
		id = 10064,
		name = "Epaminondas doll",
		article = "an",
		description = "He talks, moves and sings just like a real person.",
		weight = 777,
		decayTo = 10063,
		duration = 3
	},
	{id = 10065, name = "iron floor", weight = 260},
	{id = 10066, name = "glob of grease", article = "a", weight = 100},
	{id = 10067, name = "giant screwdriver", article = "a", weight = 2000},
	{id = 10068, name = "flask with paint", article = "a", weight = 180},
	{id = 10069, name = "energy net", article = "an", weight = 100},
	{id = 10070, name = "bag of screws", article = "a", weight = 1900},
	{id = 10071, name = "v-belt", article = "a", weight = 540},
	{id = 10072, name = "yalahari gear wheel", article = "a", weight = 5},
	{id = 10073, name = "spare part", article = "a", weight = 150},
	{id = 10074, name = "red power core", article = "a", weight = 100},
	{id = 10075, name = "green power core", article = "a", weight = 100},
	{id = 10076, name = "chaos matter", weight = 100},
	{id = 10077, name = "vortex of elemental water", article = "a", description = "It contains the raw elemental force of water."},
	{id = 10078, name = "pile of chaos matter", description = "The chaos matter is sizzeling."},
	{id = 10079, name = "metal locker", article = "a", description = "It is a storage for glowing red power cores."},
	{id = 10080, name = "glue dispenser", article = "a", description = "The machine is constantly creating wonder glue."},
	{id = 10081, name = "storage chest", article = "a", description = "The chest is filled with crackling green power cores."},
	{id = 10082, name = "amphora of grease", article = "an", description = "The amphora is filled with thick and fetid grease."},
	{id = 10083, name = "storage box", article = "a", description = "It contains numerous bags of screws."},
	{id = 10084, name = "toolbox", article = "a", description = "Only some spare parts are left in this toolbox."},
	{id = 10085, name = "screwdriver holder", article = "a", description = "Some giant screwdrivers are held by this frame."},
	{
		id = 10086,
		name = "energy generator",
		article = "an",
		description = "This machine is constantly producing glowing energy nets."
	},
	{id = 10087, name = "dusty box", article = "a", description = "The box contains an assortment of v-belts."},
	{id = 10088, name = "old crate", article = "an", description = "This is a box full of yalahari gear wheels."},
	{id = 10089, name = "wonder glue", article = "a", weight = 180},
	{
		id = 10090,
		name = "parchment",
		article = "a",
		description = "There's a questionnaire for potential lovers on it.",
		weight = 200
	},
	{id = 10091, name = "prison cell key", article = "a", weight = 100},
	{
		id = 10092,
		name = "love potion",
		article = "a",
		description = "You better be careful with this or you might get unwanted results.",
		weight = 180
	},
	{id = 10094, name = "skull", article = "a"},
	{id = 10095, name = "campfire", article = "a"},
	{
		id = 10096,
		name = "voodoo doll",
		article = "a",
		description = "You read the numbers 3613 on the back of the doll.",
		weight = 650
	},
	{
		id = 10097,
		name = "voodoo doll",
		article = "a",
		description = "You read the numbers 5261 on the back of the doll.",
		weight = 650
	},
	{id = 10098, name = "remains of a pirate", article = "the"},
	{id = 10099, name = "top right part of a map", article = "the", weight = 790},
	{id = 10100, name = "top left part of a map", article = "the", weight = 790},
	{id = 10101, name = "lower right part of a map", article = "the", weight = 790},
	{id = 10102, name = "lower left part of a map", article = "the", weight = 790},
	{
		id = 10103,
		name = "very old piece of paper",
		article = "a",
		description = "You have the slight impression that it bears a secret.",
		weight = 200
	},
	{
		id = 10104,
		name = "old encrypted text",
		article = "an",
		description = "Maybe a sorcerer can help you with the decryption.",
		weight = 200
	},
	{
		id = 10105,
		name = "Xodet's first wand",
		description = "This could just help to remind him of his old friendship.",
		weight = 1900
	},
	{
		id = 10106,
		name = "crumpled piece of paper",
		article = "a",
		description = "It contains the formula for the memory potion Eclesius invented.",
		weight = 110
	},
	{fromId = 10107, toId = 10108, name = "hand puppets", description = "They were awarded by the gods.", weight = 5},
	{
		id = 10109,
		name = "bundle of rags",
		article = "a",
		description = "It also contains an old dress of Queen Eloise.",
		weight = 900
	},
	{id = 10110, name = "yalahari inkwell", article = "a"},
	{id = 10111, name = "yalahari folio", article = "a", weight = 100},
	{id = 10112, name = "wormhole", article = "a", decayTo = 10115, duration = 7},
	{id = 10113, name = "wormhole", article = "a", decayTo = 10114, duration = 4},
	{id = 10114, name = "wormhole", article = "a", decayTo = 10112, duration = 2},
	{id = 10115, name = "wormhole", article = "a", decayTo = 10113, duration = 2},
	{id = 10116, name = "wormhole", article = "a", decayTo = 10112, duration = 9},
	{id = 10117, name = "wormhole", article = "a", decayTo = 10113, duration = 13},
	{id = 10118, name = "wormhole", article = "a", decayTo = 10114, duration = 17},
	{
		id = 10119,
		name = "heated worm punisher",
		article = "a",
		weight = 6450,
		duration = 10,
		decayTo = 10152,
		description = "This hammer is a worm's worst nightmare."
	},
	{id = 10122, name = "old pirate poem", article = "an", weight = 200, readable = true},
	{
		id = 10123,
		name = "pirate treasure map",
		article = "a",
		weight = 830,
		description = "The location on the map is not familiar to you."
	},
	{id = 10124, name = "champion's cup", article = "a", weight = 1800, writeable = true, maxTextLen = 128},
	{id = 10125, name = "silver cup of honour", article = "a", weight = 1600, writeable = true, maxTextLen = 128},
	{id = 10126, name = "bronze cup of honour", article = "a", weight = 1600, writeable = true, maxTextLen = 128},
	{id = 10127, name = "golden warrior trophy", article = "a", weight = 1900, writeable = true, maxTextLen = 128},
	{id = 10128, name = "silver warrior trophy", article = "a", weight = 1850, writeable = true, maxTextLen = 128},
	{id = 10129, name = "bronze warrior trophy", article = "a", weight = 1800, writeable = true, maxTextLen = 128},
	{id = 10130, name = "golden trophy of excellence", article = "a", weight = 1300, writeable = true, maxTextLen = 128},
	{id = 10131, name = "silver trophy of excellence", article = "a", weight = 1300, writeable = true, maxTextLen = 128},
	{id = 10132, name = "bronze trophy of excellence", article = "a", weight = 1300, writeable = true, maxTextLen = 128},
	{id = 10133, name = "gold medal", article = "a", weight = 1240, writeable = true, maxTextLen = 128},
	{id = 10134, name = "silver medal", article = "a", weight = 1220, writeable = true, maxTextLen = 128},
	{id = 10135, name = "bronze medal", article = "a", weight = 1200, writeable = true, maxTextLen = 128},
	{id = 10136, name = "badge of glory", article = "a", weight = 1550, writeable = true, maxTextLen = 128},
	{id = 10137, name = "arcane insignia", article = "an", weight = 1350, writeable = true, maxTextLen = 128},
	{id = 10138, name = "hero's medal", article = "a", weight = 1670, writeable = true, maxTextLen = 128},
	{id = 10139, name = "laurel wreath", article = "a", weight = 900, writeable = true, maxTextLen = 128},
	{id = 10140, name = "royal medal", article = "a", weight = 1600, writeable = true, maxTextLen = 128},
	{id = 10141, name = "heavy medal", article = "a", weight = 5500, writeable = true, maxTextLen = 128},
	{id = 10142, name = "elven trophy", article = "an", weight = 900, writeable = true, maxTextLen = 128},
	{id = 10143, name = "cherry blossom tree", article = "a"},
	{id = 10144, name = "honey flower", article = "a", weight = 1000},
	{id = 10145, name = "potted flower", article = "a", weight = 2300},
	{id = 10146, name = "blood herb", article = "a", weight = 120},
	{id = 10147, name = "exotic flowers", weight = 1100},
	{id = 10148, name = "flower bouquet", article = "a", weight = 80},
	{id = 10149, name = "god flowers", weight = 1100},
	{id = 10150, name = "cocktail glass", article = "a", weight = 200, pickupable = true},
	{id = 10151, name = "golem part", article = "a", weight = 35},
	{
		id = 10152,
		name = "worm punisher",
		article = "a",
		description = "The hammer would be more effective when heated.",
		weight = 6450
	},
	{
		id = 10153,
		name = "golem disassembler",
		article = "a",
		description = "It looks suspiciously similar to a crowbar.",
		weight = 1500
	},
	{id = 10154, name = "animal fetish", article = "an", weight = 245},
	{id = 10155, name = "shadow orb", article = "a", weight = 400},
	{id = 10156, name = "dark essence", article = "a", weight = 260},
	{id = 10157, name = "worm queen tooth", article = "a", weight = 850},
	{id = 10158, name = "deep crystal", article = "a", description = "It is pulsating with spectral energy.", weight = 310},
	{id = 10159, name = "bloodkiss flower", article = "a", weight = 95},
	{id = 10160, name = "crucible", article = "a", decayTo = 10161, duration = 60},
	{id = 10161, name = "crucible", article = "a", decayTo = 10160, duration = 60},
	{id = 10162, name = "crucible", article = "a", decayTo = 10160, duration = 30},
	{id = 10164, name = "earth"},
	{id = 10165, name = "golem blueprint", article = "a", weight = 120},
	{id = 10166, name = "stabilizer", article = "a", weight = 115},
	{id = 10167, name = "mago mechanic core", article = "a", weight = 135},
	{id = 10168, name = "core dispenser", article = "a"},
	{id = 10169, name = "elemental crystal", article = "an", weight = 320},
	{id = 10170, name = "old power core", article = "an", description = "This power core has seen better days.", weight = 780},
	{id = 10171, name = "old machine", article = "an"},
	{id = 10172, name = "button", article = "a"},
	{id = 10173, name = "golem head", article = "a", weight = 3000},
	{id = 10174, name = "unfinished golem", article = "an"},
	{id = 10175, name = "rock soil"},
	{id = 10176, name = "dirt"},
	{fromId = 10177, toId = 10187, name = "limestone wall", article = "a"},
	{fromId = 10188, toId = 10189, name = "broken limestone wall", article = "a"},
	{fromId = 10190, toId = 10191, name = "limestone railing", article = "a"},
	{fromId = 10192, toId = 10193, name = "stone wall", article = "a"},
	{id = 10194, name = "limestone railing", article = "a"},
	{fromId = 10195, toId = 10196, name = "stone wall", article = "a"},
	{id = 10197, name = "limestone railing", article = "a"},
	{fromId = 10198, toId = 10203, name = "limestone pillar", article = "a"},
	{fromId = 10204, toId = 10207, name = "limestone wall", article = "a"},
	{id = 10208, name = "iron floor"},
	{id = 10209, name = "Carlin banner", article = "a"},
	{fromId = 10210, toId = 10212, name = "limestone wall", article = "a"},
	{fromId = 10213, toId = 10217, name = "limestone pedestal", article = "a"},
	{
		id = 10218,
		name = "bonfire amulet",
		article = "a",
		description = "It engulfs you in flames - fire against fire.",
		weight = 700,
		slotPosition = SLOTP_NECKLACE,
		charges = 5,
		showCharges = true,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 60, [COMBAT_FIREDAMAGE] = 40},
		showAttributes = true
	},
	{
		id = 10219,
		name = "sacred tree amulet",
		article = "a",
		description = "Its leaves stretch out to cover your whole body if you receive earth damage.",
		weight = 700,
		slotPosition = SLOTP_NECKLACE,
		charges = 5,
		showCharges = true,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 40, [COMBAT_PHYSICALDAMAGE] = 60},
		showAttributes = true
	},
	{
		id = 10220,
		name = "leviathan's amulet",
		description = "It holds the last breath of Leviathan.",
		weight = 700,
		slotPosition = SLOTP_NECKLACE,
		charges = 5,
		showCharges = true,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 60, [COMBAT_ICEDAMAGE] = 40}
	},
	{
		id = 10221,
		name = "shockwave amulet",
		article = "a",
		description = "It tickles your neck in a rather pleasant way and absorbs loads of damage.",
		weight = 700,
		slotPosition = SLOTP_NECKLACE,
		charges = 5,
		showCharges = true,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 60, [COMBAT_ENERGYDAMAGE] = 40}
	},
	{id = 10222, name = "tiled floor"},
	{id = 10223, name = "mechanical fishing rod", article = "a", weight = 920},
	{id = 10224, name = "mechanical fish", article = "a", weight = 750},
	{id = 10225, name = "nautical map", article = "a", weight = 820},
	{fromId = 10226, toId = 10248, name = "framework wall", article = "a"},
	{fromId = 10249, toId = 10261, name = "stone wall", article = "a"},
	{fromId = 10262, toId = 10263, name = "framework window", article = "a"},
	{fromId = 10264, toId = 10265, name = "framework window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 10266, toId = 10267, name = "framework window", article = "a", type = ITEM_TYPE_DOOR},
	{id = 10268, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 10269, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10270, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10271, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 10272, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10273, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10274, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10275, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10276, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10277, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10278, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10279, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10280, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10281, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10282, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 10283, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 10284, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 10285, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 10286, toId = 10287, name = "stone wall", article = "a"},
	{id = 10288, name = "violet flame", article = "a", decayTo = 7359, duration = 600, showDuration = true},
	{
		id = 10289,
		name = "meat shield",
		article = "a",
		weight = 500,
		defense = 10,
		weaponType = WEAPON_SHIELD,
		description = "A sturdy shield made of old meat."
	},
	{
		id = 10290,
		name = "glutton's mace",
		description = "It would be an awesome weapon if the handle weren't that greasy.",
		weight = 1300,
		defense = 10,
		attack = 16,
		weaponType = WEAPON_CLUB
	},
	{
		id = 10291,
		name = "odd hat",
		article = "an",
		description = "It has to be one of the fabled helmets of light.",
		weight = 700,
		armor = 5,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 10292,
		name = "pointed rabbitslayer",
		article = "a",
		description = "Someone has sharpened this carrot to inflict some nasty damage especially on rabbits.",
		weight = 160,
		defense = 8,
		attack = 16,
		weaponType = WEAPON_SWORD
	},
	{
		id = 10293,
		name = "stale bread of ancientness",
		article = "a",
		description = "This bread is so old that it has become unbreakable and a formidable weapon.",
		weight = 500,
		defense = 8,
		attack = 18,
		weaponType = WEAPON_CLUB
	},
	{
		id = 10294,
		name = "shield of the white knight",
		article = "a",
		description = "It seems a bit chunky, but what was good enough for a white knight should be good for everyone.",
		weight = 500,
		defense = 8,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 10295,
		name = "musician's bow",
		article = "a",
		description = "If you could only figure out how you are supposed to fire more arrows at once.",
		weight = 1250,
		slotPosition = SLOTP_TWO_HAND,
		weaponType = WEAPON_DISTANCE,
		ammoType = AMMO_ARROW,
		range = 4
	},
	{
		id = 10296,
		name = "heavy metal t-shirt",
		article = "a",
		description = "Oddly enough it is not made of metal at all, but years without washing grant it added protection.",
		weight = 800,
		armor = 6,
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 10297,
		name = "shield of care",
		article = "a",
		description = "This shield will surely care for anyone who can bear it.",
		weight = 1700,
		defense = 8,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 10298,
		name = "helmet of ultimate terror",
		article = "a",
		description = "There is evil inside.",
		weight = 1250,
		armor = 3,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 10299,
		name = "helmet of nature",
		article = "a",
		description = "One can only hope nobody will ever insist on wearing that.",
		weight = 1100,
		armor = 3,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 10300,
		name = "trousers of the ancients",
		description = "These atavistic trousers already served the forefathers of mankind.",
		weight = 30,
		armor = 2,
		slotPosition = SLOTP_LEGS
	},
	{
		id = 10301,
		name = "scythe of the reaper",
		article = "a",
		description = "This scythe has harvested countless souls and still hungers for more.",
		weight = 3000,
		defense = 6,
		attack = 16,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 10302,
		name = "club of the fury",
		article = "a",
		description = "It's ready to unleash a fury's wrath on its enemies.",
		weight = 500,
		defense = 8,
		attack = 16,
		weaponType = WEAPON_CLUB
	},
	{
		id = 10303,
		name = "farmer's avenger",
		article = "a",
		description = "A weapon forged to fight oppression of the poor underdogs.",
		weight = 2500,
		defense = 7,
		attack = 17,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 10304,
		name = "poet's fencing quill",
		article = "a",
		description = "This feather is mightier than a sword.",
		weight = 200,
		defense = 8,
		attack = 10,
		weaponType = WEAPON_SWORD
	},
	{
		id = 10305,
		name = "holy icon",
		article = "a",
		description = "It is said that you can break a mighty evil spell with it.",
		weight = 500
	},
	{
		id = 10306,
		name = "fan doll of King Worldianus",
		article = "a",
		description = "The small label reads: For my greatest admirer.",
		weight = 650
	},
	{id = 10307, name = "machine crate", article = "a", description = "It contains a mysterious machine.", weight = 8000},
	{
		id = 10308,
		name = "fan club membership card",
		article = "a",
		description = "The kings fan club premium membership card is issued to 'The Evil Mastermind'.",
		weight = 150
	},
	{
		id = 10309,
		name = "claw of 'The Noxious Spawn'",
		description = "It feels tight and uncomfortable on your hand.",
		weight = 500,
		slotPosition = SLOTP_RING,
		transformDeEquipTo = 10310
	},
	{
		id = 10310,
		name = "claw of 'The Noxious Spawn'",
		article = "a",
		description = "It's like a glove and you can't wear a ring on it. You are not sure if you should really put it on.",
		weight = 500,
		slotPosition = SLOTP_RING,
		transformEquipTo = 10309
	},
	{
		id = 10311,
		name = "claw of 'The Noxious Spawn'",
		description = "Its power is depleted at the moment.",
		weight = 500,
		decayTo = 10309,
		duration = 10,
		transformDeEquipTo = 10315
	},
	{
		id = 10312,
		name = "claw of 'The Noxious Spawn'",
		description = "Its power is depleted at the moment.",
		weight = 500,
		decayTo = 10310,
		duration = 86400
	},
	{
		id = 10313,
		name = "incredible mumpiz slayer",
		article = "an",
		description = "This magnificent weapon was forged to slay arch mumpiz demons with a single blow.",
		weight = 4200,
		defense = 14,
		attack = 17,
		weaponType = WEAPON_SWORD
	},
	{
		id = 10314,
		name = "claw of 'The Noxious Spawn'",
		article = "a",
		description = "Its power is depleted at the moment.",
		weight = 500,
		slotPosition = SLOTP_RING,
		transformDeEquipTo = 10315
	},
	{
		id = 10315,
		name = "claw of 'The Noxious Spawn'",
		article = "a",
		description = "Its power is depleted at the moment.",
		weight = 500,
		decayTo = 10310,
		duration = 10
	},
	{
		id = 10316,
		name = "mighty helm of green sparks",
		article = "a",
		description = "This helmet spawns green stars. Awesome.",
		weight = 4600,
		armor = 6,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 10317,
		name = "rain coat",
		article = "the",
		description = "The wearer of this cape commands the forces of heaven.",
		weight = 3200,
		armor = 1,
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 10318,
		name = "shield Nevermourn",
		article = "the",
		description = "It is said that the wearer of Nevermourn will never mourn. What a powerful shield.",
		weight = 5200,
		defense = 25,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 10319,
		name = "dead Doctor Perhaps",
		article = "the",
		containerSize = 10,
		decayTo = 3058,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 10320,
		name = "dead Dirtbeard",
		article = "the",
		containerSize = 10,
		decayTo = 3058,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 10321,
		name = "dead evil mastermind",
		article = "the",
		containerSize = 8,
		decayTo = 7260,
		duration = 10,
		fluidSource = FLUID_BLOOD,
		corpseType = RACE_BLOOD
	},
	{
		id = 10322,
		name = "dead monstor",
		article = "the",
		containerSize = 25,
		decayTo = 6337,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 10323,
		name = "dead mephiles",
		article = "the",
		containerSize = 10,
		decayTo = 6365,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 10324,
		name = "slain boogey",
		article = "the",
		weight = 50000,
		containerSize = 8,
		decayTo = 8956,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{fromId = 10325, toId = 10340, name = "roof", article = "a"},
	{fromId = 10341, toId = 10342, name = "funnel", article = "a"},
	{id = 10343, name = "pillar", article = "a"},
	{id = 10344, name = "stone ledge", article = "a"},
	{fromId = 10345, toId = 10348, name = "pillar", article = "a"},
	{fromId = 10349, toId = 10354, name = "statue", article = "a"},
	{fromId = 10355, toId = 10356, name = "statue of Fafnar", article = "a"},
	{fromId = 10357, toId = 10358, name = "spider webs"},
	{id = 10359, name = "dirt"},
	{fromId = 10360, toId = 10361, name = "spider webs"},
	{id = 10362, name = "dirt"},
	{
		id = 10363,
		name = "rain coat",
		article = "the",
		description = "The wearer of this cape commands the forces of heaven.",
		weight = 3200,
		decayTo = 10317,
		duration = 300,
		armor = 1,
		slotPosition = SLOTP_ARMOR
	},
	{
		id = 10364,
		name = "shield Nevermourn",
		article = "the",
		description = "It is said that the wearer of Nevermourn will never mourn. What a powerful shield.",
		weight = 5200,
		decayTo = 10318,
		duration = 300,
		defense = 25,
		weaponType = WEAPON_SHIELD
	},
	{fromId = 10365, toId = 10368, name = "goddess statue", article = "a"},
	{fromId = 10369, toId = 10372, name = "sun emblem", article = "a"},
	{fromId = 10373, toId = 10377, name = "limestone railing", article = "a"},
	{fromId = 10378, toId = 10382, name = "banner", article = "a"},
	{id = 10383, name = "Carlin banner", article = "a"},
	{fromId = 10384, toId = 10392, name = "banner", article = "a"},
	{id = 10393, name = "Carlin banner", article = "a"},
	{fromId = 10394, toId = 10397, name = "banner", article = "a"},
	{fromId = 10398, toId = 10404, name = "pavement"},
	{fromId = 10405, toId = 10416, name = "wooden floor"},
	{fromId = 10417, toId = 10428, name = "pavement"},
	{fromId = 10429, toId = 10430, name = "Carlin shield", article = "a"},
	{fromId = 10431, toId = 10432, name = "serpent shield", article = "a"},
	{fromId = 10433, toId = 10434, name = "stone ledge", article = "a"},
	{id = 10435, name = "limestone wall", article = "a"},
	{fromId = 10436, toId = 10440, name = "stone pedestal"},
	{fromId = 10441, toId = 10448, name = "sand"},
	{id = 10449, name = "stone pedestal", article = "a"},
	{fromId = 10450, toId = 10453, name = "coloured limestone pillar", article = "a"},
	{id = 10454, name = "headache pill", article = "a", weight = 20},
	{
		id = 10455,
		name = "pigeon trophy",
		article = "a",
		description = "It's a symbol of peace handed out by the gods.",
		weight = 400,
		writeable = true,
		maxTextLen = 128
	},
	{fromId = 10456, toId = 10467, name = "dark sand"},
	{id = 10468, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 10469, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10470, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10471, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10472, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10473, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 10474, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 10475, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10476, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10477, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 10478, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10479, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10480, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10481, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10482, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 10483, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 10484, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10485, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 10486, toId = 10487, name = "limestone window", article = "a"},
	{fromId = 10488, toId = 10489, name = "limestone window", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{fromId = 10490, toId = 10491, name = "limestone window", article = "a", type = ITEM_TYPE_DOOR},
	{fromId = 10492, toId = 10498, name = "pavement"},
	{
		id = 10499,
		name = "remains of a water elemental",
		description = "Something is wobbling inside. Maybe with a fishing rod you could reach it.",
		containerSize = 20,
		decayTo = 10500,
		duration = 300,
		fluidSource = FLUID_WATER,
		corpseType = RACE_UNDEAD
	},
	{
		id = 10500,
		name = "remains of a water elemental",
		description = "It has already been emptied of the treasure it held.",
		decayTo = 0,
		duration = 45,
		corpseType = RACE_UNDEAD
	},
	{id = 10501, name = "dead tree", article = "a"},
	{id = 10502, name = "engraved wedding ring", article = "an", weight = 40, slotPosition = SLOTP_RING},
	{id = 10503, name = "wedding outfit box", article = "a", weight = 2500},
	{id = 10504, name = "druid tree", article = "a"},
	{fromId = 10505, toId = 10506, name = "dead tree", article = "a"},
	{id = 10507, name = "carving", article = "a", weight = 40},
	{
		id = 10508,
		name = "remains of a wisp",
		article = "the",
		containerSize = 10,
		decayTo = 8946,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{id = 10509, name = "limestone pedestal", article = "a"},
	{
		id = 10510,
		name = "broken wedding ring",
		article = "a",
		description = "It is a memory of a lost love.",
		weight = 40,
		slotPosition = SLOTP_RING
	},
	{
		id = 10511,
		name = "sneaky stabber of eliteness",
		article = "a",
		description = "This nifty gadget can be used for many vital and less vital purposes. If it's not jammed, that is.",
		weight = 300
	},
	{
		id = 10512,
		name = "sneaky stabber of eliteness",
		article = "a",
		description = "Argh! It's jammed right now! Should hopefully work again within a short time though.",
		weight = 300,
		decayTo = 10511,
		duration = 60
	},
	{
		id = 10513,
		name = "squeezing gear of girlpower",
		article = "a",
		description = "This nifty gadget can be used for many vital and less vital purposes. If it's not jammed, that is.",
		weight = 300
	},
	{
		id = 10514,
		name = "squeezing gear of girlpower",
		article = "a",
		description = "Argh! It's jammed right now! Should hopefully work again within a short time though.",
		weight = 300,
		decayTo = 10513,
		duration = 60
	},
	{
		id = 10515,
		name = "whacking driller of fate",
		article = "a",
		description = "This nifty gadget can be used for many vital and less vital purposes. If it's not jammed, that is.",
		weight = 300
	},
	{
		id = 10516,
		name = "whacking driller of fate",
		article = "a",
		description = "Argh! It's jammed right now! Should hopefully work again within a short time though.",
		weight = 300,
		decayTo = 10515,
		duration = 60
	},
	{id = 10518, name = "demon backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 10519, name = "orange backpack", article = "an", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 10520, name = "orange bag", article = "an", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 10521, name = "moon backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 10522, name = "crown backpack", article = "a", weight = 1700, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 10523, name = "egg of The Many", article = "an", weight = 5000},
	{
		id = 10524,
		name = "dead medusa",
		article = "a",
		containerSize = 32,
		decayTo = 10525,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 10525,
		name = "dead medusa",
		article = "a",
		containerSize = 32,
		decayTo = 10526,
		duration = 600,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 10526, name = "dead medusa", article = "a", decayTo = 10527, duration = 600, corpseType = RACE_BLOOD},
	{id = 10527, name = "dead medusa", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{id = 10529, name = "sea serpent trophy", article = "a", weight = 500},
	{
		id = 10530,
		name = "famous golden bug",
		article = "the",
		description = "It's given to skilled discoverers of extra nasty bugs and to great scholars writing useful reports.",
		weight = 1250,
		writeable = true,
		maxTextLen = 64
	},
	{id = 10531, name = "midnight shard", article = "a", description = "Lucius might be interested in those shards.", weight = 300},
	{
		id = 10532,
		name = "bejeweled ship's telescope",
		article = "a",
		description = "It's the only left-over from a famous pirate treasure.",
		weight = 4500,
		rotateTo = 2584
	},
	{
		id = 10533,
		name = "bejeweled ship's telescope",
		article = "a",
		description = "It's the only left-over from a famous pirate treasure.",
		weight = 4500,
		rotateTo = 2582
	},
	{
		id = 10534,
		name = "bejeweled ship's telescope",
		article = "a",
		description = "It's the only left-over from a famous pirate treasure.",
		weight = 4500,
		rotateTo = 2583
	},
	{
		id = 10535,
		name = "bejeweled ship's telescope",
		article = "a",
		description = "It's the only left-over from a famous pirate treasure.",
		weight = 4500,
		rotateTo = 2581
	},
	{fromId = 10536, toId = 10537, name = "coal"},
	{fromId = 10538, toId = 10539, name = "residue of darkness", article = "a", containerSize = 10},
	{id = 10540, name = "limestone railing", article = "a"},
	{id = 10541, name = "statue of Fafnar", article = "a"},
	{
		id = 10542,
		name = "golden Fafnar trophy",
		article = "a",
		description = "You read: |PLAYERNAME| kept all ten fire basins burning and is one of the true lightbearers of this world.",
		weight = 900
	},
	{
		id = 10543,
		name = "silver Fafnar trophy",
		article = "a",
		description = "You read: |PLAYERNAME| helped to keep the fire basins burning and is one of the lightbearers of this world.",
		weight = 900
	},
	{fromId = 10544, toId = 10545, name = "elemental cannon", article = "an"},
	{id = 10546, name = "magic wall", article = "a"},
	{id = 10547, name = "energy field", article = "an"},
	{id = 10548, name = "scarab pincers", plural = "scarab pincers", weight = 230},
	{id = 10549, name = "ancient stone", article = "an", weight = 160},
	{id = 10550, name = "bloody pincers", weight = 120},
	{id = 10551, name = "cobra tongue", article = "a", weight = 75},
	{id = 10552, name = "elvish talisman", article = "an", weight = 110},
	{id = 10553, name = "fiery heart", article = "a", weight = 115},
	{id = 10554, name = "hellhound slobber", weight = 75},
	{id = 10555, name = "cultish mask", article = "a", weight = 165},
	{id = 10556, name = "cultish robe", article = "a", weight = 200},
	{id = 10557, name = "poisonous slime", weight = 80},
	{id = 10558, name = "piece of scarab shell", article = "a", plural = "pieces of scarab shell", weight = 142},
	{id = 10559, name = "spooky blue eye", article = "a", weight = 86},
	{id = 10560, name = "thorn", article = "a", weight = 120},
	{id = 10561, name = "wyvern talisman", article = "a", weight = 225},
	{id = 10562, name = "black hood", article = "a", weight = 175},
	{id = 10563, name = "book of prayers", article = "a", plural = "books of prayers", weight = 150},
	{id = 10564, name = "demonic skeletal hand", article = "a", weight = 132},
	{id = 10565, name = "frosty ear of a troll", article = "a", weight = 180},
	{id = 10566, name = "gauze bandage", article = "a", weight = 97},
	{id = 10567, name = "polar bear paw", article = "a", weight = 150},
	{id = 10568, name = "scorpion tail", article = "a", weight = 120},
	{id = 10569, name = "witch broom", article = "a", weight = 333},
	{
		id = 10570,
		name = "witch hat",
		article = "a",
		weight = 780,
		armor = 3,
		absorbPercent = {[COMBAT_MANADRAIN] = 5},
		slotPosition = SLOTP_HEAD
	},
	{id = 10571, name = "war crystal", article = "a", weight = 145},
	{id = 10572, name = "gear crystal", article = "a", weight = 95},
	{id = 10573, name = "broken gladiator shield", article = "a", weight = 640},
	{id = 10574, name = "cyclops toe", article = "a", weight = 111},
	{id = 10575, name = "frost giant pelt", article = "a", weight = 248},
	{id = 10576, name = "half-eaten brain", article = "a", weight = 64},
	{id = 10577, name = "mystical hourglass", article = "a", plural = "mystical hourglasses", weight = 96},
	{id = 10578, name = "frosty heart", article = "a", weight = 186},
	{id = 10579, name = "mutated bat ear", article = "a", weight = 175},
	{id = 10580, name = "piece of dead brain", article = "a", plural = "pieces of dead brain", weight = 132},
	{id = 10581, name = "piece of hellfire armor", article = "a", plural = "pieces of hellfire armor", weight = 250},
	{id = 10582, name = "wyrm scale", article = "a", weight = 180},
	{id = 10583, name = "sea serpent scale", article = "a", weight = 146},
	{id = 10584, name = "boggy dreads", plural = "boggy's dreads", weight = 169},
	{id = 10585, name = "mutated rat tail", article = "a", weight = 143},
	{fromId = 10586, toId = 10587, name = "grass garland", article = "a"},
	{fromId = 10588, toId = 10589, name = "flowery garland", article = "a"},
	{fromId = 10590, toId = 10591, name = "flower wreath", article = "a"},
	{fromId = 10592, toId = 10593, name = "leaf wreath", article = "a"},
	{fromId = 10594, toId = 10595, name = "moonlight flower wreath", article = "a"},
	{fromId = 10596, toId = 10597, name = "spring flower wreath", article = "a"},
	{fromId = 10598, toId = 10599, name = "swamp wreath", article = "a"},
	{id = 10600, name = "haunted piece of wood", article = "a", weight = 226},
	{id = 10601, name = "tattered piece of robe", article = "a", plural = "tattered pieces of robe", weight = 70},
	{id = 10602, name = "vampire teeth", plural = "vampire's teeth", weight = 50},
	{id = 10603, name = "swamp grass", weight = 94},
	{id = 10604, name = "dead cobra", article = "a"},
	{id = 10605, name = "bundle of cursed straw", article = "a", plural = "bundles of cursed straw", weight = 227},
	{id = 10606, name = "bunch of troll hair", article = "a", plural = "bunches of troll hair", weight = 85},
	{id = 10607, name = "ghostly tissue", article = "a", weight = 50},
	{id = 10608, name = "lion's mane", article = "a", weight = 180},
	{id = 10609, name = "lump of dirt", article = "a", plural = "lumps of dirt", weight = 68},
	{id = 10610, name = "pig foot", article = "a", plural = "pig feet", weight = 98},
	{id = 10611, name = "snake skin", article = "a", weight = 100},
	{
		id = 10612,
		name = "Collector's body",
		article = "the",
		containerSize = 30,
		decayTo = 0,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{id = 10613, name = "plans for a strange device", description = "You should bring them to Spectulus in Edron.", weight = 250},
	{
		id = 10614,
		name = "rare crystal",
		article = "a",
		description = "An extremely rare crystal you recovered from the Lost Mines.",
		weight = 310
	},
	{
		id = 10615,
		name = "carrying device",
		article = "a",
		description = "The astronomer Spectulus gave you this device to safely transport the mirror crystal.",
		weight = 3500
	},
	{
		id = 10616,
		name = "filled carrying device",
		article = "a",
		description = "The special carrying device Spectulus gave you now contains a mirror crystal.",
		weight = 3500
	},
	{fromId = 10617, toId = 10624, name = "sand"},
	{fromId = 10625, toId = 10636, name = "dark sand"},
	{fromId = 10637, toId = 10649, name = "sand"},
	{fromId = 10650, toId = 10690, name = "stone wall", article = "a"},
	{fromId = 10691, toId = 10699, name = "snake railing", article = "a"},
	{id = 10700, name = "snake pillar", article = "a"},
	{id = 10701, name = "pillar", article = "a"},
	{fromId = 10702, toId = 10704, name = "archway", article = "an"},
	{fromId = 10705, toId = 10708, name = "pedestal", article = "a"},
	{fromId = 10709, toId = 10710, name = "snake statue", article = "a"},
	{fromId = 10711, toId = 10712, name = "dragon statue", article = "a"},
	{fromId = 10713, toId = 10718, name = "snake decoration", article = "a"},
	{
		id = 10719,
		name = "friendship amulet",
		article = "a",
		description = "It shines as beautifully as a good friendship.",
		weight = 520
	},
	{
		id = 10720,
		name = "friendship amulet",
		article = "a",
		description = "It shines as beautifully as a good friendship.",
		weight = 520,
		decayTo = 10719,
		duration = 2
	},
	{id = 10721, name = "snake archway", article = "a"},
	{fromId = 10722, toId = 10723, name = "skull archway", article = "a"},
	{fromId = 10724, toId = 10725, name = "figure", article = "a"},
	{fromId = 10726, toId = 10727, name = "snake archway", article = "a"},
	{id = 10728, name = "dragonbone tree", article = "a"},
	{id = 10729, name = "sunholder tree", article = "a"},
	{id = 10730, name = "cocoon tree", article = "a"},
	{id = 10731, name = "blooming cocoon tree", article = "a"},
	{id = 10732, name = "jade spike plant", article = "a"},
	{id = 10733, name = "blooming jade spike plant", article = "a"},
	{id = 10734, name = "thornpeak grass"},
	{fromId = 10735, toId = 10736, name = "pepper root grass"},
	{fromId = 10737, toId = 10740, name = "dry grass"},
	{id = 10741, name = "desertfire plant", article = "a"},
	{fromId = 10742, toId = 10743, name = "trollhair plants"},
	{fromId = 10744, toId = 10751, name = "hedge", article = "a"},
	{fromId = 10752, toId = 10755, name = "blackened hedge", article = "a"},
	{fromId = 10756, toId = 10757, name = "diabolic hedge", article = "a"},
	{fromId = 10758, toId = 10759, name = "blackened hedge", article = "a"},
	{
		id = 10760,
		name = "flask of poison",
		article = "a",
		description = "This poison is meant to weaken the enemy and should be used on the rice fields near Chaochai.",
		weight = 180
	},
	{fromId = 10761, toId = 10762, name = "wild vine"},
	{id = 10763, name = "pepper root grass"},
	{id = 10764, name = "trollhair plants"},
	{fromId = 10765, toId = 10774, name = "stone floor"},
	{id = 10775, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 10776, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10777, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10778, name = "caramel candy mushroom", article = "a"},
	{id = 10779, name = "aquarius fungius", article = "an"},
	{id = 10780, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 10781, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 10782, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10783, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10784, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 10785, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10786, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10787, name = "golden fairy mushroom", article = "a"},
	{id = 10788, name = "corrupted plant", article = "a"},
	{id = 10789, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR, levelDoor = 1000, blockProjectile = true},
	{id = 10790, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 10791, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 10792, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 10793, name = "tainted plant", article = "a"},
	{fromId = 10794, toId = 10797, name = "foul flower", article = "a"},
	{fromId = 10798, toId = 10801, name = "blackened flower", article = "a"},
	{id = 10802, name = "putrid plant", article = "a"},
	{id = 10803, name = "rotten plant", article = "a"},
	{id = 10804, name = "festered rose", article = "a"},
	{id = 10805, name = "addled flower", article = "an"},
	{id = 10806, name = "pestilent fern", article = "a"},
	{fromId = 10807, toId = 10809, name = "necrotic grass"},
	{id = 10810, name = "ruined stone wall", article = "a"},
	{id = 10811, name = "apocalypse mushroom", article = "an"},
	{id = 10812, name = "ruined stone wall", article = "a"},
	{id = 10813, name = "mourning mushroom", article = "a"},
	{fromId = 10814, toId = 10815, name = "ruined stone wall", article = "a"},
	{id = 10816, name = "infected throne", article = "an"},
	{id = 10817, name = "pestbringer", article = "a"},
	{fromId = 10818, toId = 10827, name = "ruined stone wall", article = "a"},
	{fromId = 10828, toId = 10829, name = "snake railing", article = "a"},
	{fromId = 10830, toId = 10845, name = "ruined stone wall", article = "a"},
	{fromId = 10846, toId = 10868, name = "stone floor"},
	{id = 10869, name = "throatslitter", article = "a"},
	{fromId = 10870, toId = 10871, name = "rattleleaf bush", article = "a"},
	{fromId = 10872, toId = 10875, name = "radical roots"},
	{id = 10876, name = "throatslitter", article = "a"},
	{fromId = 10877, toId = 10878, name = "rattleleaf bush", article = "a"},
	{id = 10879, name = "flies"},
	{fromId = 10880, toId = 10883, name = "defence construction", article = "a"},
	{fromId = 10884, toId = 10896, name = "scale roof", article = "a"},
	{fromId = 10897, toId = 10904, name = "snake decoration", article = "a"},
	{fromId = 10905, toId = 10911, name = "decoration", article = "a"},
	{id = 10912, name = "solstice tree", article = "a"},
	{id = 10913, name = "dry solstice tree", article = "a"},
	{fromId = 10914, toId = 10916, name = "high grass"},
	{id = 10917, name = "screaming cherry tree", article = "a"},
	{fromId = 10918, toId = 10925, name = "dragon decoration", article = "a"},
	{id = 10926, name = "flask of crown polisher", article = "a", description = "Ideal to polish crowns.", weight = 110},
	{id = 10927, name = "dragon decoration", article = "a"},
	{
		id = 10928,
		name = "map to the unknown",
		article = "a",
		description = "Treasured by adventurers and explorers alike.",
		weight = 680
	},
	{fromId = 10929, toId = 10930, name = "dragon decoration", article = "a"},
	{id = 10931, name = "snake decoration", article = "a"},
	{fromId = 10932, toId = 10933, name = "draconian statue", article = "a"},
	{fromId = 10934, toId = 10935, name = "lizard statue", article = "a"},
	{fromId = 10936, toId = 10937, name = "stone claw", article = "a"},
	{fromId = 10938, toId = 10939, name = "lizard statue", article = "a"},
	{fromId = 10940, toId = 10941, name = "spike", article = "a"},
	{id = 10942, name = "almanac of magic", article = "an", description = "Invaluable for all magic research.", weight = 5555},
	{id = 10943, name = "baby rotworm", article = "a", description = "It looks hungry.", weight = 45},
	{id = 10944, name = "universal tool", article = "a", description = "The tool of choice for any gadgeteer.", weight = 300},
	{
		id = 10945,
		name = "soul contract",
		article = "a",
		description = "A contract in which some desperate person has sold his soul.",
		weight = 150
	},
	{fromId = 10946, toId = 10949, name = "statue", article = "a"},
	{fromId = 10950, toId = 10951, name = "dragon throne", article = "a"},
	{fromId = 10952, toId = 10953, name = "dragon banner", article = "a"},
	{fromId = 10954, toId = 10955, name = "red banner", article = "a"},
	{fromId = 10956, toId = 10959, name = "dragon banner", article = "a"},
	{id = 10960, name = "huge spear", article = "a"},
	{fromId = 10961, toId = 10962, name = "large spear", article = "a"},
	{fromId = 10963, toId = 10964, name = "dragon banner", article = "a"},
	{fromId = 10965, toId = 10966, name = "red banner", article = "a"},
	{fromId = 10967, toId = 10970, name = "table", article = "a"},
	{fromId = 10971, toId = 10974, name = "wall lamp", article = "a"},
	{fromId = 10975, toId = 10978, name = "decoration", article = "a"},
	{fromId = 10979, toId = 10984, name = "weapon rack", article = "a", weight = 5500},
	{
		id = 10986,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, initDamage = 20, ticks = 10000}
	},
	{
		id = 10987,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, ticks = 10000}
	},
	{
		id = 10988,
		name = "fire",
		article = "a",
		type = ITEM_TYPE_MAGICFIELD,
		group = ITEM_GROUP_MAGICFIELD,
		field = {type = CONDITION_FIRE, combatType = COMBAT_FIREDAMAGE, damage = 10, count = 7, initDamage = 5, ticks = 10000}
	},
	{fromId = 10989, toId = 10991, name = "gate", article = "a"},
	{fromId = 10992, toId = 10993, name = "column", article = "a"},
	{fromId = 10994, toId = 10996, name = "gate", article = "a"},
	{fromId = 10997, toId = 10998, name = "column", article = "a"},
	{fromId = 10999, toId = 11002, name = "magical dragon statue", article = "a"},
	{fromId = 11003, toId = 11006, name = "dragon statue", article = "a"},
	{fromId = 11007, toId = 11012, name = "dragon banner", article = "a"},
	{id = 11013, name = "spiky pole", article = "a"},
	{id = 11015, name = "high grass"},
	{fromId = 11016, toId = 11027, name = "dry earth"},
	{id = 11028, name = "dragon decoration", article = "a"},
	{id = 11029, name = "strange grass mat", article = "a"},
	{fromId = 11030, toId = 11042, name = "shallow water"},
	{fromId = 11043, toId = 11050, name = "rice"},
	{fromId = 11051, toId = 11056, name = "stone", article = "a"},
	{id = 11057, name = "pile of chaos matter"},
	{fromId = 11058, toId = 11061, name = "column", article = "a"},
	{fromId = 11062, toId = 11063, name = "glowing switch", article = "a", walkStack = false},
	{fromId = 11064, toId = 11075, name = "window", article = "a"},
	{
		id = 11076,
		name = "skull of a caveman",
		article = "a",
		description = "It once belonged to an ancestor of Lazaran. Obviously he had really bad teeth.",
		weight = 2180
	},
	{id = 11077, name = "dry earth"},
	{fromId = 11078, toId = 11088, name = "dry riverbed", article = "a"},
	{fromId = 11089, toId = 11096, name = "dragon statue", article = "a"},
	{id = 11097, name = "stone floor"},
	{id = 11098, name = "magic wall", article = "a", type = ITEM_TYPE_MAGICFIELD, decayTo = 0, minDuration = 14, maxDuration = 20},
	{id = 11099, name = "rush wood", article = "a", type = ITEM_TYPE_MAGICFIELD, decayTo = 0, minDuration = 38, maxDuration = 45},
	{
		id = 11100,
		name = "flask with beaver bait",
		article = "a",
		description = "It smells like a mixture of wood and fish. Phew.",
		weight = 180
	},
	{
		id = 11101,
		name = "tactical map",
		article = "a",
		description = "A map showing recent troop movements and tactical instructions of parts of the Emperor's army.",
		weight = 200
	},
	{id = 11102, name = "lever", article = "a"},
	{id = 11103, name = "scrying ball", article = "a"},
	{
		id = 11104,
		name = "shattered crystal ball",
		article = "a",
		weight = 5500,
		description = "An extremely rare crystal you recovered from the Lost Mines."
	},
	{
		id = 11106,
		name = "flask of extra greasy oil",
		article = "a",
		weight = 180,
		description = "Extra greasy oil from Zalamon's storage."
	},
	{
		id = 11107,
		name = "dead draken warmaster",
		article = "a",
		containerSize = 28,
		decayTo = 11108,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11108,
		name = "dead draken warmaster",
		article = "a",
		containerSize = 28,
		decayTo = 11109,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11109, name = "dead draken warmaster", article = "a", decayTo = 11110, duration = 300, corpseType = RACE_BLOOD},
	{id = 11110, name = "dead draken warmaster", article = "a", decayTo = 0, duration = 60, corpseType = RACE_BLOOD},
	{id = 11111, name = "small bamboo shelf", article = "a", rotateTo = 3833, containerSize = 6},
	{id = 11112, name = "leaves"},
	{id = 11113, name = "orc tooth", article = "an", plural = "orc teeth", weight = 100},
	{id = 11114, name = "jungle grass"},
	{
		id = 11115,
		name = "tribal crest",
		article = "a",
		description = "This crest seems important. You shouldn't lose it.",
		weight = 500
	},
	{
		id = 11116,
		name = "serpent crest",
		article = "a",
		description = "This crest seems important. You shouldn't lose it.",
		weight = 500
	},
	{
		id = 11117,
		name = "crystal boots",
		armor = 3,
		absorbPercent = {[COMBAT_ICEDAMAGE] = 3, [COMBAT_ENERGYDAMAGE] = -3},
		slotPosition = SLOTP_FEET,
		weight = 1850
	},
	{
		id = 11118,
		name = "dragon scale boots",
		armor = 3,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -3, [COMBAT_FIREDAMAGE] = 3},
		slotPosition = SLOTP_FEET,
		weight = 1850
	},
	{id = 11119, name = "heart backpack", article = "a", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 11122, name = "bone pile", article = "a"},
	{id = 11123, name = "stone stairs", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 11124, name = "snowman package", article = "a", description = "Use it in your house to reveal a snowman.", weight = 3500},
	{id = 11125, name = "snowman", article = "a", description = "Someone seems to have had a lot of fun decorating it."},
	{
		id = 11126,
		name = "lizard weapon rack kit",
		article = "a",
		description = "Use it in your house to construct lizard weapon rack.",
		weight = 5500
	},
	{id = 11127, name = "weapon rack", article = "a", rotateTo = 11128},
	{id = 11128, name = "weapon rack", article = "a", rotateTo = 11127},
	{id = 11129, name = "dragon statue", article = "a", rotateTo = 11131},
	{id = 11130, name = "dragon statue", article = "a", rotateTo = 11129},
	{id = 11131, name = "dragon statue", article = "a", rotateTo = 11132},
	{id = 11132, name = "dragon statue", article = "a", rotateTo = 11130},
	{
		id = 11133,
		name = "dragon statue kit",
		article = "a",
		description = "Use it in your house to construct a dragon statue.",
		weight = 6500
	},
	{
		id = 11134,
		name = "Tome of Knowledge",
		article = "a",
		description = "Bring this encrypted book to a sage in Farmine to gain wisdom or unlock more of Zao's culture.",
		weight = 1500
	},
	{
		id = 11135,
		name = "corned fish",
		article = "a",
		description = "This fish has been salted and already prepared as provision for soldiers.",
		weight = 510
	},
	{id = 11136, name = "salmon", weight = 320},
	{id = 11137, name = "evil tree spirit", article = "an"},
	{
		id = 11138,
		name = "dead crocodile",
		article = "a",
		containerSize = 30,
		decayTo = 11139,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11139,
		name = "dead crocodile",
		article = "a",
		containerSize = 30,
		decayTo = 11140,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11140, name = "dead crocodile", article = "a", decayTo = 11141, duration = 600, corpseType = RACE_BLOOD},
	{id = 11141, name = "dead crocodile", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{fromId = 11142, toId = 11143, name = "shrine", article = "a"},
	{id = 11144, name = "nightmare doll", article = "a", weight = 1800},
	{fromId = 11145, toId = 11152, name = "muddy floor"},
	{id = 11153, name = "dry riverbed", article = "a"},
	{fromId = 11154, toId = 11160, name = "muddy floor"},
	{id = 11161, name = "bonebeast trophy", article = "a", weight = 500},
	{fromId = 11162, toId = 11163, name = "corned fish"},
	{id = 11164, name = "weapons crate", article = "a", description = "This crate contains a set of weapons.", weight = 8000},
	{fromId = 11165, toId = 11188, name = "mud"},
	{id = 11189, name = "crab pincers", weight = 175},
	{id = 11190, name = "terrorbird beak", article = "a", weight = 117},
	{id = 11191, name = "skunk tail", article = "a", weight = 105},
	{id = 11192, name = "carrion worm fang", article = "a", weight = 88},
	{id = 11193, name = "elder bonelord tentacle", article = "an", weight = 75},
	{id = 11194, name = "bony tail", article = "a", weight = 92},
	{id = 11195, name = "stone wing", article = "a", weight = 153},
	{id = 11196, name = "piece of crocodile leather", article = "a", plural = "pieces of crocodile leather", weight = 104},
	{id = 11197, name = "giant eye", article = "a", weight = 120},
	{
		id = 11198,
		name = "tarantula egg",
		article = "a",
		description = "Looking quite poisonous, so no good choice for a meal.",
		weight = 40
	},
	{id = 11199, name = "hydra head", article = "a", weight = 1300},
	{id = 11200, name = "half-digested piece of meat", article = "a", plural = "half-digested pieces of meat", weight = 124},
	{fromId = 11201, toId = 11202, name = "stone wall", article = "a"},
	{id = 11203, name = "dragon throne", article = "a", rotateTo = 11204},
	{id = 11204, name = "dragon throne", article = "a", rotateTo = 11203},
	{
		id = 11205,
		name = "dragon throne kit",
		article = "a",
		description = "Use it in your house to construct a dragon throne.",
		weight = 7500
	},
	{id = 11206, name = "red lantern", article = "a", weight = 300},
	{id = 11207, name = "mini mummy", article = "a", weight = 450},
	{id = 11208, name = "rotten piece of cloth", article = "a", plural = "rotten pieces of cloth", weight = 60},
	{id = 11209, name = "silky fur", weight = 115},
	{id = 11210, name = "striped fur", weight = 120},
	{id = 11211, name = "stuffed toad", article = "a", weight = 450},
	{id = 11212, name = "winter wolf fur", weight = 110},
	{id = 11213, name = "acorn", article = "an", plural = "acorns", weight = 50},
	{id = 11214, name = "antlers", weight = 90},
	{id = 11215, name = "metal spike", article = "a", weight = 50},
	{id = 11216, name = "badger fur", weight = 65},
	{id = 11217, name = "carniphila seeds", plural = "carniphila's seeds", weight = 35},
	{id = 11218, name = "centipede leg", article = "a", weight = 68},
	{id = 11219, name = "compass", article = "a", plural = "compasses", weight = 80},
	{id = 11220, name = "dark rosary", article = "a", plural = "dark rosaries", weight = 90},
	{id = 11221, name = "hellspawn tail", article = "a", weight = 125},
	{id = 11222, name = "lump of earth", article = "a", plural = "lumps of earth", weight = 116},
	{id = 11223, name = "essence of a bad dream", article = "an", plural = "essences of a bad dream", weight = 95},
	{id = 11224, name = "thick fur", weight = 125},
	{id = 11225, name = "mutated flesh", weight = 250},
	{id = 11226, name = "strand of medusa hair", article = "a", plural = "strands of medusa hair", weight = 230},
	{id = 11227, name = "shiny stone", article = "a", weight = 156},
	{id = 11228, name = "sabretooth", article = "a", plural = "sabreteeth", weight = 128},
	{id = 11229, name = "scythe leg", article = "a", weight = 150},
	{id = 11230, name = "winged tail", article = "a", weight = 450},
	{id = 11231, name = "nettle blossom", article = "a", weight = 88},
	{id = 11232, name = "sulphurous stone", article = "a", weight = 142},
	{id = 11233, name = "unholy bone", article = "an", weight = 125},
	{id = 11234, name = "werewolf fur", weight = 113},
	{id = 11235, name = "warwolf fur", weight = 105},
	{id = 11236, name = "wool", weight = 118},
	{id = 11237, name = "book of necromantic rituals", article = "a", plural = "books of necromantic rituals", weight = 358},
	{id = 11238, name = "mammoth tusk", article = "a", weight = 600},
	{id = 11239, name = "statue", article = "a", allowDistRead = true},
	{
		id = 11240,
		name = "guardian boots",
		armor = 3,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 2, [COMBAT_HOLYDAMAGE] = -2},
		slotPosition = SLOTP_FEET,
		weight = 2250
	},
	{id = 11241, name = "expedition backpack", article = "an", weight = 1800, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 11242, name = "expedition bag", article = "an", weight = 800, containerSize = 8, slotPosition = SLOTP_BACKPACK},
	{id = 11243, name = "dragon backpack", article = "a", weight = 1700, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 11244, name = "minotaur backpack", article = "a", weight = 1850, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 11245, name = "bunch of ripe rice", article = "a", plural = "bunches of ripe rice", weight = 750},
	{id = 11246, name = "rice ball", article = "a", weight = 30},
	{
		id = 11247,
		name = "dead gnarlhound",
		article = "a",
		weight = 31000,
		containerSize = 7,
		decayTo = 11248,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11248, name = "dead gnarlhound", article = "a", weight = 31000, decayTo = 11249, duration = 300, corpseType = RACE_BLOOD},
	{id = 11249, name = "dead gnarlhound", article = "a", weight = 31000, decayTo = 0, duration = 60, corpseType = RACE_BLOOD},
	{
		id = 11250,
		name = "dead gnarlhound",
		article = "a",
		containerSize = 7,
		decayTo = 11247,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11251,
		name = "dead orc marauder",
		article = "a",
		containerSize = 20,
		decayTo = 11252,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11252, name = "dead orc marauder", article = "a", decayTo = 11249, duration = 300, corpseType = RACE_BLOOD},
	{id = 11253, name = "large pile of bones", article = "a"},
	{
		id = 11254,
		name = "dead orc marauder",
		article = "a",
		containerSize = 20,
		decayTo = 11251,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11255, name = "santa teddy", article = "a", weight = 550},
	{id = 11256, name = "snowman doll", article = "a", weight = 620},
	{id = 11257, name = "heavy ball", article = "a", weight = 670},
	{id = 11258, name = "phoenix charm", article = "a", weight = 1000, description = "The Spark of the Phoenix is contained in it."},
	{id = 11259, name = "unity charm", article = "a", weight = 1000, description = "The Embrace of the World is contained in it."},
	{id = 11260, name = "spiritual charm", article = "a", weight = 1000, description = "The Spiritual Shielding is contained in it."},
	{id = 11261, name = "twin sun charm", article = "a", weight = 1000, description = "The Fire of the Suns is contained in it."},
	{id = 11262, name = "solitude charm", article = "a", weight = 1000, description = "The Wisdom of Solitude is contained in it."},
	{id = 11263, name = "santa backpack", article = "a", weight = 1650, containerSize = 20, slotPosition = SLOTP_BACKPACK},
	{id = 11264, name = "dragon tapestry", article = "a", weight = 1000},
	{fromId = 11265, toId = 11268, name = "withered plants"},
	{
		id = 11269,
		name = "dead lizard high guard",
		article = "a",
		containerSize = 38,
		decayTo = 11270,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11270, name = "dead lizard high guard", article = "a", decayTo = 11271, duration = 600, corpseType = RACE_BLOOD},
	{id = 11271, name = "dead lizard high guard", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 11272,
		name = "dead lizard high guard",
		article = "a",
		containerSize = 10,
		decayTo = 11269,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11273,
		name = "dead lizard legionnaire",
		article = "a",
		containerSize = 10,
		decayTo = 11274,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11274, name = "dead lizard legionnaire", article = "a", decayTo = 11275, duration = 600, corpseType = RACE_BLOOD},
	{id = 11275, name = "dead lizard legionnaire", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 11276,
		name = "dead lizard legionnaire",
		article = "a",
		containerSize = 10,
		decayTo = 11273,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11277,
		name = "dead lizard dragon priest",
		article = "a",
		containerSize = 10,
		decayTo = 11278,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11278, name = "dead lizard dragon priest", article = "a", decayTo = 11279, duration = 600, corpseType = RACE_BLOOD},
	{id = 11279, name = "dead lizard dragon priest", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 11280,
		name = "dead lizard dragon priest",
		article = "a",
		containerSize = 10,
		decayTo = 11277,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11281,
		name = "dead lizard zaogun",
		article = "a",
		containerSize = 10,
		decayTo = 11282,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11282, name = "dead lizard zaogun", article = "a", decayTo = 11283, duration = 600, corpseType = RACE_BLOOD},
	{id = 11283, name = "dead lizard zaogun", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 11284,
		name = "dead lizard zaogun",
		article = "a",
		containerSize = 38,
		decayTo = 11281,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11285,
		name = "dead lizard chosen",
		article = "a",
		containerSize = 38,
		decayTo = 11286,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11286, name = "dead lizard chosen", article = "a", decayTo = 11287, duration = 600, corpseType = RACE_BLOOD},
	{id = 11287, name = "dead lizard chosen", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 11288,
		name = "dead lizard chosen",
		article = "a",
		containerSize = 38,
		decayTo = 11285,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{fromId = 11289, toId = 11298, name = "corrupted dragon banner", article = "a"},
	{
		id = 11299,
		name = "dead eternal guardian",
		article = "a",
		containerSize = 15,
		decayTo = 0,
		duration = 600,
		corpseType = RACE_UNDEAD
	},
	{
		id = 11300,
		name = "dead eternal guardian",
		article = "a",
		containerSize = 15,
		decayTo = 11299,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{id = 11301, name = "Zaoan armor", article = "a", weight = 9550, armor = 13, slotPosition = SLOTP_ARMOR, speed = 20},
	{
		id = 11302,
		name = "Zaoan helmet",
		article = "a",
		weight = 6600,
		armor = 9,
		slotPosition = SLOTP_HEAD,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 5}
	},
	{id = 11303, name = "Zaoan shoes", weight = 700, armor = 1, slotPosition = SLOTP_FEET, speed = 10},
	{
		id = 11304,
		name = "Zaoan legs",
		weight = 6600,
		armor = 8,
		slotPosition = SLOTP_LEGS,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 2}
	},
	{
		id = 11305,
		name = "drakinata",
		article = "a",
		weight = 5400,
		defense = 20,
		attack = 47,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 11306, name = "sai", weight = 5000, defense = 27, attack = 45, weaponType = WEAPON_SWORD, slotPosition = SLOTP_TWO_HAND},
	{
		id = 11307,
		name = "Zaoan sword",
		article = "a",
		weight = 4900,
		defense = 18,
		attack = 43,
		weaponType = WEAPON_SWORD,
		extraDefense = 2
	},
	{
		id = 11308,
		name = "drachaku",
		article = "a",
		weight = 6000,
		defense = 25,
		attack = 46,
		weaponType = WEAPON_CLUB,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 11309,
		name = "twin hooks",
		weight = 5000,
		defense = 22,
		attack = 32,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND
	},
	{
		id = 11310,
		name = "dead wailing widow",
		article = "a",
		containerSize = 10,
		decayTo = 11311,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 11311,
		name = "dead wailing widow",
		article = "a",
		containerSize = 10,
		decayTo = 11312,
		duration = 300,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 11312, name = "dead wailing widow", article = "a", decayTo = 11313, duration = 300, corpseType = RACE_VENOM},
	{id = 11313, name = "dead wailing widow", article = "a", decayTo = 0, duration = 60, corpseType = RACE_VENOM},
	{id = 11314, name = "weaver's wandtip", article = "a", plural = "weaver's wandtips", weight = 170},
	{id = 11315, name = "draken trophy", article = "a", weight = 600},
	{
		id = 11316,
		name = "dead draken spellweaver",
		article = "a",
		containerSize = 30,
		decayTo = 11317,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11317,
		name = "dead draken spellweaver",
		article = "a",
		containerSize = 30,
		decayTo = 11318,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11318, name = "dead draken spellweaver", article = "a", decayTo = 11319, duration = 300, corpseType = RACE_BLOOD},
	{id = 11319, name = "dead draken spellweaver", article = "a", decayTo = 0, duration = 60, corpseType = RACE_BLOOD},
	{id = 11320, name = "dead insect swarm", article = "a", duration = 1, decayTo = 0},
	{id = 11321, name = "bone shoulderplate", article = "a", weight = 220},
	{id = 11322, name = "warmaster's wristguards", weight = 120},
	{
		id = 11323,
		name = "Zaoan halberd",
		article = "a",
		defense = 15,
		attack = 37,
		weaponType = WEAPON_AXE,
		slotPosition = SLOTP_TWO_HAND,
		weight = 8700
	},
	{id = 11324, name = "shaggy tail", article = "a", weight = 112},
	{id = 11325, name = "spiked iron ball", article = "a", weight = 125},
	{id = 11326, name = "corrupted flag", article = "a", weight = 112},
	{id = 11327, name = "cursed shoulder spikes", weight = 97},
	{id = 11328, name = "widow's mandibles", weight = 105},
	{id = 11329, name = "wailing widow's necklace", article = "a", weight = 540, slotPosition = SLOTP_NECKLACE},
	{id = 11330, name = "zaogun flag", article = "a", weight = 98},
	{id = 11331, name = "zaogun shoulderplates", weight = 103},
	{id = 11332, name = "high guard flag", article = "a", weight = 112},
	{id = 11333, name = "high guard shoulderplates", weight = 103},
	{id = 11334, name = "legionnaire flags", weight = 110},
	{id = 11335, name = "broken halberd", article = "a", weight = 210},
	{id = 11336, name = "lizard trophy", article = "a", weight = 1200},
	{id = 11337, name = "petrified scream", article = "a", weight = 150},
	{id = 11338, name = "disgusting trophy", article = "a", weight = 700},
	{
		id = 11339,
		name = "clay lump",
		article = "a",
		description = "You could use it and try to form a statue out for it.",
		weight = 1000
	},
	{id = 11340, name = "rough clay statue", article = "a", weight = 1000},
	{id = 11341, name = "clay statue", article = "a", weight = 1000},
	{id = 11342, name = "pretty clay statue", article = "a", weight = 1000},
	{
		id = 11343,
		name = "piece of marble rock",
		article = "a",
		description = "It seems just perfect to try and create something out of it with a sharp obsidian knife.",
		weight = 1000
	},
	{id = 11344, name = "rough marble statue", article = "a", weight = 1000},
	{id = 11345, name = "marble statue", article = "a", weight = 1000},
	{id = 11346, name = "beautiful marble statue", article = "a", weight = 1000},
	{
		id = 11347,
		name = "dead terramite",
		article = "a",
		containerSize = 20,
		decayTo = 11348,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 11348,
		name = "dead terramite",
		article = "a",
		containerSize = 20,
		decayTo = 11349,
		duration = 300,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 11349, name = "dead terramite", article = "a", decayTo = 11350, duration = 300, corpseType = RACE_VENOM},
	{id = 11350, name = "dead terramite", article = "a", decayTo = 0, duration = 60, corpseType = RACE_VENOM},
	{fromId = 11351, toId = 11354, name = "large pile of bones", article = "a"},
	{
		id = 11355,
		name = "spellweaver's robe",
		article = "a",
		armor = 11,
		weight = 2350,
		slotPosition = SLOTP_ARMOR,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = -10, [COMBAT_ENERGYDAMAGE] = 10}
	},
	{
		id = 11356,
		name = "Zaoan robe",
		article = "a",
		armor = 11,
		weight = 2450,
		slotPosition = SLOTP_ARMOR,
		absorbPercent = {[COMBAT_ICEDAMAGE] = -10, [COMBAT_FIREDAMAGE] = 10}
	},
	{
		id = 11357,
		name = "dead sandcrawler",
		article = "a",
		containerSize = 8,
		weight = 6300,
		decayTo = 11358,
		duration = 300,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 11358,
		name = "dead sandcrawler",
		article = "a",
		containerSize = 8,
		weight = 6300,
		decayTo = 11359,
		duration = 300,
		corpseType = RACE_VENOM
	},
	{id = 11359, name = "dead sandcrawler", article = "a", weight = 6300, decayTo = 0, duration = 60},
	{
		id = 11360,
		name = "dead sandcrawler",
		article = "a",
		containerSize = 8,
		decayTo = 11357,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 11361, name = "dragon priest's wandtip", article = "a", plural = "dragon priest's wandtips", weight = 155},
	{
		id = 11362,
		name = "slain ghastly dragon",
		article = "a",
		containerSize = 36,
		decayTo = 11363,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 11363,
		name = "slain ghastly dragon",
		article = "a",
		containerSize = 36,
		decayTo = 11364,
		duration = 300,
		corpseType = RACE_UNDEAD
	},
	{
		id = 11364,
		name = "slain ghastly dragon",
		article = "a",
		containerSize = 36,
		decayTo = 11365,
		duration = 300,
		corpseType = RACE_UNDEAD
	},
	{id = 11365, name = "slain ghastly dragon", article = "a", decayTo = 0, duration = 60, corpseType = RACE_UNDEAD},
	{id = 11366, name = "ghastly dragon head", article = "a", weight = 1200},
	{id = 11367, name = "undead heart", article = "an", weight = 80},
	{id = 11368, name = "jade hat", article = "a", weight = 900, armor = 4, magicLevelPoints = 1, slotPosition = SLOTP_HEAD},
	{id = 11369, name = "terramite shell", article = "a", weight = 150},
	{id = 11370, name = "terramite eggs", weight = 20, showCount = false},
	{id = 11371, name = "terramite legs", weight = 115},
	{id = 11372, name = "lancer beetle shell", article = "a", weight = 107},
	{id = 11373, name = "sandcrawler shell", article = "a", weight = 75},
	{
		id = 11374,
		name = "beetle necklace",
		article = "a",
		speed = 4,
		weight = 820,
		slotPosition = SLOTP_NECKLACE,
		showAttributes = true
	},
	{
		id = 11375,
		name = "dead lancer beetle",
		article = "a",
		containerSize = 10,
		decayTo = 11376,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 11376,
		name = "dead lancer beetle",
		article = "a",
		containerSize = 10,
		decayTo = 11377,
		duration = 300,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{id = 11377, name = "dead lancer beetle", article = "a", decayTo = 11378, duration = 300, corpseType = RACE_VENOM},
	{id = 11378, name = "dead lancer beetle", article = "a", decayTo = 0, duration = 60, corpseType = RACE_VENOM},
	{fromId = 11379, toId = 11384, name = "dark spikes"},
	{id = 11385, name = "giant stone dragon", article = "a"},
	{fromId = 11386, toId = 11392, name = "part of a giant stone dragon"},
	{
		id = 11393,
		name = "lucky clover amulet",
		article = "a",
		description = "It is rumoured to bring you good luck!",
		weight = 150,
		slotPosition = SLOTP_NECKLACE
	},
	{
		id = 11394,
		name = "dragon goblet",
		article = "a",
		weight = 1800,
		description = "A goblet forged by the dragon Khax that represents all the knowledge and wisdom."
	},
	{
		id = 11395,
		name = "crimson sword",
		article = "a",
		description = "Its blade is very notchy",
		weight = 3600,
		defense = 10,
		attack = 18,
		weaponType = WEAPON_SWORD
	},
	{id = 11396, name = "special flask", weight = 180},
	{id = 11397, name = "empty beer bottle", weight = 250},
	{id = 11398, name = "empty jug", weight = 750},
	{id = 11399, name = "Ceiron's waterskin", weight = 700},
	{id = 11400, name = "phoenix egg", article = "a", description = "It seems to be burning from inside.", weight = 30},
	{
		id = 11401,
		name = "Tibiora's box",
		description = "It contains all the knowledge of the lands gathered arduosly.",
		weight = 4200
	},
	{
		id = 11402,
		name = "Tibiora's box",
		description = "It contains all the knowledge of the lands gathered arduosly.",
		weight = 4200,
		decayTo = 11401,
		duration = 2
	},
	{fromId = 11404, toId = 11405, name = "dead serpent spawn", article = "a"},
	{id = 11406, name = "dead draken", article = "a"},
	{id = 11407, name = "dead lizard", article = "a"},
	{id = 11409, name = "slain ghoul", article = "a", weight = 60000, decayTo = 0, duration = 600, corpseType = RACE_UNDEAD},
	{id = 11421, name = "ice pick", article = "an", description = "It might come in handy in cold regions.", weight = 7000},
	{
		id = 11422,
		name = "damaged steel helmet",
		article = "a",
		description = "The words 'Ramsay the Reckless' are engraved inside. It appears to be cracked and broken.",
		weight = 4600
	},
	{id = 11423, name = "coral comb", article = "a", description = "It once belonged to a mermaid.", weight = 450},
	{id = 11424, name = "the Brutus Bloodbeard's hat", weight = 1250},
	{id = 11425, name = "the Lethal Lissy's shirt", weight = 2000},
	{id = 11426, name = "the Ron the Ripper's sabre", weight = 2500, defense = 10, attack = 12, weaponType = WEAPON_SWORD},
	{id = 11427, name = "Striker's favourite pillow", weight = 1700},
	{id = 11428, name = "bowl of evergreen flowers", article = "a", weight = 1100},
	{id = 11429, name = "crocodile steak", weight = 440},
	{
		id = 11430,
		name = "dead caiman",
		article = "a",
		containerSize = 10,
		decayTo = 11431,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 11431,
		name = "dead caiman",
		article = "a",
		containerSize = 10,
		decayTo = 11432,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 11432, name = "dead caiman", article = "a", decayTo = 11433, duration = 300, corpseType = RACE_BLOOD},
	{id = 11433, name = "dead caiman", article = "a", decayTo = 0, duration = 60, corpseType = RACE_BLOOD},
	{id = 11434, name = "buttress lamp", article = "a"},
	{id = 11435, name = "buttress", article = "a"},
	{id = 11436, name = "dirt floor"},
	{fromId = 11437, toId = 11444, name = "rice"},
	{id = 11445, name = "buttress lamp", article = "a"},
	{fromId = 11446, toId = 11447, name = "buttress", article = "a"},
	{fromId = 11448, toId = 11449, name = "buttress lamp", article = "a"},
	{fromId = 11450, toId = 11462, name = "muddy water"},
	{id = 11463, name = "buttress", article = "a"},
	{fromId = 11464, toId = 11475, name = "pavement"},
	{fromId = 11476, toId = 11477, name = "closed door", article = "a"},
	{fromId = 11478, toId = 11489, name = "corrupted soil"},
	{fromId = 11490, toId = 11491, name = "earth"},
	{fromId = 11492, toId = 11501, name = "corrupted soil"},
	{id = 11502, name = "corrupted soil clip"},
	{id = 11503, name = "corrupted soil"},
	{id = 11504, name = "purple soil"},
	{fromId = 11505, toId = 11509, name = "rock"},
	{fromId = 11510, toId = 11533, name = "corrupted rock"},
	{fromId = 11534, toId = 11543, name = "sulphur stone", article = "a"},
	{fromId = 11544, toId = 11547, name = "timber wall", article = "a"},
	{fromId = 11548, toId = 11560, name = "sulphur"},
	{id = 11561, name = "mud"},
	{fromId = 11562, toId = 11571, name = "corrupted bamboo plant", article = "a"},
	{fromId = 11572, toId = 11577, name = "giant verminous", article = "a"},
	{fromId = 11578, toId = 11604, name = "giant tree", article = "a"},
	{fromId = 11605, toId = 11609, name = "verminous slime"},
	{fromId = 11610, toId = 11630, name = "verminous liana", article = "a"},
	{fromId = 11631, toId = 11637, name = "small mudpit", article = "a"},
	{fromId = 11638, toId = 11646, name = "black blisters"},
	{fromId = 11647, toId = 11649, name = "sulphur puddle", article = "a"},
	{fromId = 11650, toId = 11661, name = "giant verminous", article = "a"},
	{fromId = 11662, toId = 11666, name = "sulphur puddle", article = "a"},
	{fromId = 11667, toId = 11668, name = "bitter calyx", article = "a"},
	{fromId = 11669, toId = 11670, name = "doomato", article = "a"},
	{id = 11671, name = "witherstem", article = "a"},
	{id = 11672, name = "carnivortex", article = "a"},
	{id = 11673, name = "toxic tulip", article = "a"},
	{id = 11674, name = "sprocketwhip", article = "a"},
	{id = 11675, name = "small sprocketwhip", article = "a"},
	{id = 11676, name = "wraithtongue", article = "a"},
	{fromId = 11677, toId = 11678, name = "acid foxglove", article = "an"},
	{id = 11679, name = "dark delight", article = "a"},
	{fromId = 11680, toId = 11681, name = "grappletackle", article = "a"},
	{id = 11682, name = "small grappletackles"},
	{fromId = 11683, toId = 11690, name = "dreadcoil", article = "a"},
	{fromId = 11691, toId = 11693, name = "giant dreadcoil", article = "a"},
	{fromId = 11694, toId = 11695, name = "giant verminous", article = "a"},
	{id = 11696, name = "giant dreadcoil", article = "a"},
	{fromId = 11697, toId = 11699, name = "blister tendril", article = "a"},
	{id = 11700, name = "timber wall", article = "a"},
	{id = 11701, name = "dreadcoil", article = "a"},
	{id = 11702, name = "timber wall", article = "a"},
	{id = 11703, name = "dreadcoil", article = "a"},
	{id = 11704, name = "insectoid pore", article = "an"},
	{fromId = 11705, toId = 11706, name = "putrid growth"},
	{id = 11707, name = "acid"},
	{fromId = 11708, toId = 11711, name = "putrid growth"},
	{fromId = 11712, toId = 11717, name = "slimy growth"},
	{fromId = 11718, toId = 11721, name = "putrid growth"},
	{fromId = 11722, toId = 11723, name = "slimy growth"},
	{fromId = 11724, toId = 11726, name = "blisters"},
	{fromId = 11727, toId = 11728, name = "tackleweed"},
	{fromId = 11729, toId = 11752, name = "purple soil"},
	{id = 11753, name = "large black crystal", article = "a"},
	{id = 11754, name = "ferumbras doll", article = "a", description = "It was awarded by the gods.", weight = 1700},
	{
		id = 11755,
		name = "ferumbras doll",
		article = "a",
		description = "It was awarded by the gods.",
		weight = 1700,
		decayTo = 11754,
		duration = 2
	},
	{
		id = 11756,
		name = "orc's jaw shredder",
		article = "an",
		description = "There is no better way to get rid of top secret data.",
		weight = 2500
	},
	{
		id = 11757,
		name = "orc's jaw shredder",
		article = "an",
		description = "There is no better way to get rid of top secret data.",
		weight = 2500,
		decayTo = 11756,
		duration = 2
	},
	{id = 11758, name = "pitch black gap", article = "a"},
	{fromId = 11759, toId = 11760, name = "branch"},
	{fromId = 11761, toId = 11765, name = "putrid growth"},
	{id = 11766, name = "acid"},
	{fromId = 11767, toId = 11772, name = "putrid growth"},
	{
		id = 11773,
		name = "bag of oriental spices",
		article = "a",
		description = "Those spices were gathered all around the world.",
		weight = 1508
	},
	{
		id = 11774,
		name = "bag of oriental spices",
		article = "a",
		description = "Those spices were gathered all around the world.",
		weight = 1508,
		decayTo = 11773,
		duration = 2
	},
	{fromId = 11775, toId = 11778, name = "mud"},
	{fromId = 11779, toId = 11780, name = "slimy growth"},
	{fromId = 11781, toId = 11782, name = "blisters"},
	{fromId = 11783, toId = 11784, name = "tackleweed"},
	{fromId = 11785, toId = 11792, name = "mud"},
	{fromId = 11793, toId = 11795, name = "skull pillar", article = "a"},
	{id = 11796, name = "energy gate", article = "an", type = ITEM_TYPE_TELEPORT},
	{id = 11797, name = "skull pillar", article = "a"},
	{id = 11798, name = "energy gate", article = "an", type = ITEM_TYPE_TELEPORT},
	{id = 11799, name = "black crystals"},
	{id = 11800, name = "small black crystals"},
	{fromId = 11801, toId = 11803, name = "black crystals"},
	{fromId = 11804, toId = 11808, name = "some tentacles"},
	{id = 11809, name = "pillar maw", article = "a"},
	{id = 11810, name = "pillar leech", article = "a"},
	{id = 11811, name = "pillar tendril", article = "a"},
	{id = 11812, name = "pillar vine", article = "a"},
	{id = 11813, name = "pillar growth", article = "a"},
	{id = 11814, name = "pillar pads"},
	{id = 11815, name = "pillar mustardcup", article = "a"},
	{id = 11816, name = "velvet spruce", article = "a"},
	{id = 11817, name = "tangerine tail", article = "a"},
	{id = 11818, name = "buttercut", article = "a"},
	{id = 11819, name = "wrigglecoil", article = "a"},
	{id = 11820, name = "hairy violet", article = "a"},
	{id = 11821, name = "leechbloom", article = "a"},
	{fromId = 11822, toId = 11825, name = "black blisters"},
	{id = 11826, name = "black crystal", article = "a"},
	{fromId = 11827, toId = 11831, name = "sulphur steam"},
	{id = 11832, name = "skull", article = "a", plural = "skulls", weight = 2180},
	{fromId = 11833, toId = 11855, name = "dragon scales"},
	{fromId = 11856, toId = 11907, name = "bridge", article = "a"},
	{fromId = 11908, toId = 11909, name = "dragon scales"},
	{id = 11910, name = "pillar", article = "a"},
	{fromId = 11911, toId = 11914, name = "archway", article = "an"},
	{fromId = 11915, toId = 11916, name = "dragon basin", article = "a"},
	{fromId = 11917, toId = 11920, name = "banner", article = "a"},
	{fromId = 11921, toId = 11922, name = "crossed spears"},
	{fromId = 11923, toId = 11924, name = "spiky shield", article = "a"},
	{fromId = 11925, toId = 11926, name = "ornament", article = "an"},
	{id = 11927, name = "giant stone dragon", article = "a"},
	{id = 11928, name = "part of a giant stone dragon"},
	{fromId = 11929, toId = 11930, name = "dark ornament", article = "a"},
	{fromId = 11931, toId = 11932, name = "pillar", article = "a"},
	{id = 11933, name = "sapphire stand", article = "a"},
	{fromId = 11934, toId = 11935, name = "chair", article = "a"},
	{id = 11936, name = "blood cask", article = "a"},
	{fromId = 11937, toId = 11939, name = "jade"},
	{id = 11940, name = "jade"},
	{id = 11941, name = "jade"},
	{id = 11942, name = "marble floor"},
	{fromId = 11943, toId = 11944, name = "jade ornaments"},
	{id = 11945, name = "marble floor"},
	{id = 11946, name = "jade ornaments"},
	{id = 11947, name = "marble floor"},
	{id = 11948, name = "jade"},
	{id = 11949, name = "dragon scales"},
	{id = 11950, name = "jade"},
	{id = 11951, name = "dragon scales"},
	{id = 11952, name = "jade"},
	{fromId = 11953, toId = 11958, name = "marble floor"},
	{fromId = 11959, toId = 11961, name = "jade archway", article = "a"},
	{id = 11962, name = "timber wall", article = "a"},
	{fromId = 11963, toId = 11964, name = "pillar", article = "a"},
	{id = 11965, name = "chair", article = "a"},
	{fromId = 11966, toId = 11969, name = "jade chair", article = "a"},
	{fromId = 11970, toId = 11971, name = "timber wall", article = "a"},
	{fromId = 11972, toId = 11982, name = "jade ornaments"},
	{fromId = 11983, toId = 11993, name = "marble ornaments"},
	{id = 11994, name = "jade ornament", article = "a"},
	{fromId = 11995, toId = 11998, name = "jade lamp", article = "a"},
	{fromId = 11999, toId = 12002, name = "jade dragon statue", article = "a"},
	{id = 12003, name = "glowing jade pillar", article = "a"},
	{fromId = 12004, toId = 12006, name = "jade basin", article = "a"},
	{fromId = 12007, toId = 12008, name = "jade floor lamp", article = "a"},
	{id = 12009, name = "bloodfire torch", article = "a"},
	{fromId = 12010, toId = 12011, name = "skull torch", article = "a"},
	{id = 12012, name = "jade table", article = "a"},
	{id = 12013, name = "pillar", article = "a"},
	{fromId = 12014, toId = 12017, name = "mystic floor lamp", article = "a"},
	{fromId = 12018, toId = 12023, name = "jade ornaments"},
	{id = 12024, name = "timbers"},
	{fromId = 12025, toId = 12030, name = "jade ornaments"},
	{id = 12031, name = "inclosures"},
	{id = 12032, name = "jade ornaments"},
	{id = 12033, name = "inclosures"},
	{fromId = 12034, toId = 12035, name = "small crystals"},
	{id = 12036, name = "crystals"},
	{id = 12037, name = "jade ornaments"},
	{id = 12038, name = "crystals"},
	{fromId = 12039, toId = 12040, name = "dragon fountain", article = "a"},
	{id = 12041, name = "jade ornaments"},
	{fromId = 12042, toId = 12043, name = "dragon fountain", article = "a"},
	{fromId = 12044, toId = 12045, name = "heavy weapon rack", article = "a"},
	{id = 12046, name = "halberd", article = "a"},
	{fromId = 12047, toId = 12048, name = "halberds"},
	{fromId = 12049, toId = 12050, name = "heavy weapon rack", article = "a"},
	{id = 12051, name = "halberd", article = "a"},
	{fromId = 12052, toId = 12053, name = "halberds"},
	{fromId = 12054, toId = 12055, name = "embedded jade"},
	{fromId = 12056, toId = 12057, name = "iron case"},
	{fromId = 12058, toId = 12061, name = "inclosures"},
	{id = 12062, name = "emerald", article = "an"},
	{id = 12063, name = "embedded emerald", article = "an"},
	{id = 12064, name = "emerald", article = "an"},
	{id = 12065, name = "embedded emerald", article = "an"},
	{fromId = 12066, toId = 12067, name = "small crystals"},
	{fromId = 12068, toId = 12069, name = "crystals"},
	{fromId = 12070, toId = 12072, name = "sphere", article = "a"},
	{fromId = 12073, toId = 12079, name = "jade"},
	{fromId = 12080, toId = 12091, name = "small crystals"},
	{id = 12092, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 12093, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12094, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 12095, name = "gate of expertise", article = "a", levelDoor = 1000, type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12096, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 12097, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12098, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 12099, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 12100, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12101, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 12102, name = "gate of expertise", article = "a", levelDoor = 1000, type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12103, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 12104, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12105, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 12106, toId = 12107, name = "dragon scale decoration", article = "a"},
	{id = 12108, name = "dragon spikes"},
	{id = 12109, name = "dragon spike", article = "a"},
	{id = 12110, name = "snake decoration", article = "a"},
	{id = 12111, name = "dragon spike", article = "a"},
	{id = 12112, name = "dragon plates"},
	{id = 12113, name = "timbers"},
	{id = 12114, name = "dragon plates"},
	{fromId = 12115, toId = 12137, name = "carpet"},
	{fromId = 12138, toId = 12141, name = "decorative spear", article = "a"},
	{fromId = 12142, toId = 12143, name = "dragon scale table", article = "a"},
	{fromId = 12144, toId = 12148, name = "dragon bone rack", article = "a"},
	{fromId = 12149, toId = 12150, name = "dragon bone table", article = "a"},
	{fromId = 12151, toId = 12152, name = "dragon bone rack", article = "a"},
	{fromId = 12153, toId = 12155, name = "dragon bone table", article = "a"},
	{fromId = 12156, toId = 12157, name = "bone throne", article = "a"},
	{fromId = 12158, toId = 12164, name = "dragon scales"},
	{id = 12165, name = "timber", article = "a"},
	{id = 12166, name = "dragon bone statue", article = "a"},
	{fromId = 12167, toId = 12168, name = "pillar", article = "a"},
	{id = 12169, name = "dragon plates"},
	{fromId = 12170, toId = 12175, name = "dragon standard", article = "a"},
	{id = 12176, name = "dragon plates"},
	{fromId = 12177, toId = 12187, name = "carpet"},
	{id = 12188, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 12189, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 12190, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 12191, toId = 12192, name = "dragon claw lamp", article = "a"},
	{id = 12193, name = "gate of expertise", article = "a", levelDoor = 1000, type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12194, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 12195, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12196, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{id = 12197, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 12198, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true, description = "It is locked."},
	{id = 12199, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 12200, toId = 12201, name = "dragon claw lamp", article = "a"},
	{id = 12202, name = "gate of expertise", article = "a", levelDoor = 1000, type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12203, name = "gate of expertise", article = "a", type = ITEM_TYPE_DOOR},
	{id = 12204, name = "closed door", article = "a", type = ITEM_TYPE_DOOR, blockProjectile = true},
	{id = 12205, name = "open door", article = "an", type = ITEM_TYPE_DOOR},
	{fromId = 12206, toId = 12207, name = "wall mirror", article = "a"},
	{fromId = 12208, toId = 12211, name = "wall lamp", article = "a"},
	{id = 12212, name = "jade ornaments"},
	{fromId = 12213, toId = 12214, name = "observation slit", article = "an"},
	{fromId = 12215, toId = 12220, name = "banner", article = "a"},
	{id = 12221, name = "dragon bone statue", article = "a"},
	{fromId = 12222, toId = 12227, name = "part of a giant stone dragon"},
	{id = 12228, name = "jade"},
	{fromId = 12229, toId = 12233, name = "jade ornaments"},
	{fromId = 12234, toId = 12236, name = "rutted stone"},
	{id = 12237, name = "rutted stone floor"},
	{fromId = 12238, toId = 12253, name = "rutted earth"},
	{fromId = 12254, toId = 12265, name = "rutted stone"},
	{fromId = 12266, toId = 12271, name = "observation slit", article = "an"},
	{id = 12272, name = "dirt floor"},
	{id = 12273, name = "slain incarnation", article = "a"},
	{id = 12274, name = "observation slit", article = "an"},
	{fromId = 12275, toId = 12283, name = "slain incarnation", article = "a"},
	{
		id = 12284,
		name = "marked crate",
		article = "a",
		description = "This crate has been marked with lizard symbols. It is large enough for a grown person to fit in.",
		weight = 8000
	},
	{
		id = 12285,
		name = "lump of clay",
		article = "a",
		description = "This clay has been dug from the temple grounds.",
		weight = 1000
	},
	{id = 12286, name = "timber archway", article = "a"},
	{
		id = 12287,
		name = "sacred bowl",
		article = "a",
		description = "This bowl was made from sacred wood and is currently untreated.",
		weight = 1000
	},
	{id = 12288, name = "timber archway", article = "a"},
	{
		id = 12289,
		name = "bowl with sacred water",
		article = "a",
		description = "The water in this bowl has been purified.",
		weight = 1000
	},
	{
		id = 12290,
		name = "sacred coal",
		description = "Purified by sacred fires, this coal has the power to cleanse a significant amount of impure water.",
		weight = 1000
	},
	{id = 12291, name = "big table", article = "a"},
	{id = 12292, name = "large cocoon", article = "a"},
	{id = 12293, name = "tentacle", article = "a"},
	{
		id = 12295,
		name = "unworked sacred wood",
		description = "This chunk was cut from sacred wood in the temple complex and looks ideal for carving.",
		weight = 1000
	},
	{id = 12296, name = "big table", article = "a"},
	{id = 12297, name = "sacred earth", description = "This clay has been dug from sacred ground.", weight = 1000},
	{fromId = 12298, toId = 12299, name = "dragon scales"},
	{
		id = 12300,
		name = "lump of sacred clay",
		article = "a",
		description = "This clay has been mixed with sacred earth.",
		weight = 1000
	},
	{id = 12301, name = "basin full of sacred coal", article = "a"},
	{id = 12302, name = "timber wall", article = "a"},
	{
		id = 12303,
		name = "sacred bowl of purification",
		article = "a",
		description = "This bowl was coated with sacred clay and can be used to purify small amounts of corrupted water.",
		weight = 1000
	},
	{id = 12304, name = "purified water"},
	{fromId = 12305, toId = 12315, name = "tentacle", article = "a"},
	{id = 12316, name = "dead Keeper", article = "the", decayTo = 0, duration = 900},
	{id = 12317, name = "psychic residue", decayTo = 0, duration = 60},
	{id = 12318, name = "replica of the sceptre", article = "a", weight = 1400},
	{
		id = 12320,
		name = "flask of plant poison",
		article = "a",
		description = "This plant poison is meant to destroy the growths near the Keeper's lair deep beneath the gardens.",
		weight = 180
	},
	{id = 12321, name = "ramp", article = "a", floorChange = TILESTATE_FLOORCHANGE_NORTH},
	{id = 12322, name = "corrupted mud"},
	{id = 12323, name = "tail of the Keeper", article = "the", weight = 450},
	{id = 12324, name = "sceptre part", article = "a", weight = 1210},
	{id = 12325, name = "sceptre part", article = "a", weight = 40},
	{id = 12326, name = "sceptre part", article = "a", weight = 100},
	{id = 12327, name = "snake sceptre", article = "a", weight = 1400},
	{
		id = 12328,
		name = "interdimensional potion",
		article = "an",
		description = "This potion will help you enter the dreams of any lifeform.",
		weight = 180
	},
	{id = 12329, name = "large cocoon", article = "a"},
	{fromId = 12330, toId = 12333, name = "tentacle", article = "a"},
	{id = 12334, name = "plant poison"},
	{id = 12335, name = "harmless gas"},
	{fromId = 12336, toId = 12347, name = "archway", article = "an"},
	{fromId = 12348, toId = 12349, name = "small dragon tooth shelf", article = "a"},
	{fromId = 12350, toId = 12360, name = "sleeping dragon", article = "a"},
	{fromId = 12361, toId = 12381, name = "cracked jade floor"},
	{
		id = 12382,
		name = "scribbled sheet of paper",
		article = "a",
		description = "Only a single word is scribbled on the sheet: SOLOSARASATIQUARIUM.",
		weight = 250
	},
	{fromId = 12383, toId = 12384, name = "large black crystal", article = "a"},
	{id = 12385, name = "ashes of Zalamon", decayTo = 0, duration = 60},
	{fromId = 12386, toId = 12387, name = "wardrobe", article = "a"},
	{fromId = 12388, toId = 12395, name = "slimy cocoon", article = "a"},
	{fromId = 12396, toId = 12398, name = "large book", article = "a"},
	{id = 12399, name = "girlish hair decoration", article = "a", weight = 50},
	{id = 12400, name = "protective charm", article = "a", weight = 120},
	{id = 12401, name = "bamboo stick", article = "a", weight = 112},
	{id = 12402, name = "hair of a banshee", weight = 46, showCount = false},
	{
		id = 12403,
		name = "battle stone",
		article = "a",
		description = "It seems to be perfect to shape a weapon from it. Someone could definitely be interested in it.",
		weight = 150
	},
	{id = 12404, name = "black wool", weight = 118, showCount = false},
	{id = 12405, name = "blood preservation", description = "Someone put a cocktail straw in it.", weight = 80},
	{
		id = 12406,
		name = "small notebook",
		article = "a",
		description = "It contains a long list of 'saved maidens' and their addresses. Someone might be interested in it.",
		weight = 80
	},
	{id = 12407, name = "broken crossbow", article = "a", weight = 130},
	{id = 12408, name = "broken shamanic staff", article = "a", weight = 128},
	{id = 12409, name = "broken helmet", article = "a", weight = 156},
	{id = 12410, name = "luminous orb", article = "a", weight = 94},
	{id = 12411, name = "cultish symbol", article = "a", weight = 82},
	{id = 12412, name = "dirty turban", article = "a", weight = 134},
	{id = 12413, name = "dragon's tail", article = "a", plural = "dragon tails", weight = 250},
	{
		id = 12414,
		name = "geomancer's robe",
		article = "a",
		plural = "geomancer robes",
		description = "It's too tiny to be worn by humans.",
		weight = 130
	},
	{id = 12415, name = "pineapple", article = "a", weight = 750},
	{id = 12416, name = "aubergine", article = "an", weight = 200},
	{id = 12417, name = "broccoli", weight = 300, showCount = false},
	{id = 12418, name = "cauliflower", article = "a", weight = 680},
	{id = 12419, name = "geomancer's staff", article = "a", plural = "geomancer staffs", weight = 122},
	{id = 12420, name = "elven scouting glass", article = "an", weight = 80},
	{id = 12421, name = "elven astral observer", article = "an", weight = 112},
	{id = 12422, name = "flask of embalming fluid", article = "a", plural = "flasks of embalming fluid", weight = 75},
	{id = 12423, name = "ghoul snack", article = "a", weight = 140},
	{id = 12424, name = "ornamented brooch", article = "an", armor = 2, slotPosition = SLOTP_NECKLACE, weight = 840},
	{id = 12425, name = "hunter's quiver", article = "a", plural = "hunter quivers", weight = 132},
	{id = 12426, name = "jewelled belt", article = "a", weight = 124},
	{id = 12427, name = "kongra's shoulderpad", article = "a", plural = "kongra shoulderpads", weight = 140},
	{id = 12428, name = "minotaur horn", article = "a", weight = 111},
	{
		id = 12429,
		name = "purple robe",
		article = "a",
		description = "It's too large to be worn by humans, but rather light.",
		weight = 230
	},
	{id = 12430, name = "miraculum", article = "a", weight = 140},
	{id = 12431, name = "necromantic robe", article = "a", description = "A dark curse prevents you from wearing it.", weight = 220},
	{
		id = 12432,
		name = "nettle spit",
		description = "Yuck. This might only be interesting to botanists.",
		weight = 90,
		showCount = false
	},
	{
		id = 12433,
		name = "orcish gear",
		description = "The strong smell of orcish sweat sticks to it.",
		weight = 180,
		showCount = false
	},
	{id = 12434, name = "shamanic hood", article = "a", weight = 90},
	{id = 12435, name = "orc leather", weight = 50, showCount = false},
	{id = 12436, name = "skull belt", article = "a", weight = 116},
	{id = 12437, name = "pelvis bone", article = "a", weight = 130},
	{id = 12438, name = "piece of warrior armor", article = "a", plural = "pieces of warrior armor", weight = 110},
	{id = 12439, name = "piece of archer armor", article = "a", plural = "pieces of archer armor", weight = 110},
	{id = 12440, name = "pile of grave earth", article = "a", plural = "piles of grave earth", weight = 98},
	{id = 12441, name = "poison spider shell", article = "a", weight = 130},
	{id = 12442, name = "noble turban", article = "a", weight = 144},
	{id = 12443, name = "quara tentacle", article = "a", weight = 107},
	{id = 12444, name = "quara eye", article = "a", weight = 80},
	{id = 12445, name = "mantassin tail", article = "a", weight = 115},
	{id = 12446, name = "quara pincers", weight = 120},
	{id = 12447, name = "quara bone", article = "a", weight = 144},
	{
		id = 12448,
		name = "rope belt",
		article = "a",
		description = "Though the name implies it, this simple and thin belt is not suited to be used as rope.",
		weight = 97
	},
	{id = 12449, name = "safety pin", article = "a", weight = 50},
	{fromId = 12450, toId = 12453, name = "basin", article = "a"},
	{fromId = 12454, toId = 12457, name = "dragon basin", article = "a"},
	{fromId = 12458, toId = 12461, name = "blazing altar basin", article = "a"},
	{fromId = 12462, toId = 12465, name = "large dragon basin", article = "a"},
	{id = 12466, name = "scroll of heroic deeds", article = "a", plural = "scrolls of heroic deeds", weight = 79},
	{id = 12467, name = "banana sash", article = "a", plural = "banana sashes", weight = 68},
	{id = 12468, name = "small flask of eyedrops", article = "a", plural = "small flasks of eyedrops", weight = 50},
	{id = 12469, name = "small pitchfork", article = "a", weight = 110},
	{id = 12470, name = "colourful feather", article = "a", weight = 36},
	{id = 12471, name = "trollroot", description = "Distinctive shape and flavour.", weight = 140},
	{id = 12472, name = "floating cask", article = "a"},
	{id = 12473, name = "floating table", article = "a"},
	{fromId = 12474, toId = 12475, name = "floating junk"},
	{id = 12476, name = "floating box", article = "a"},
	{id = 12477, name = "floating crate", article = "a"},
	{fromId = 12478, toId = 12479, name = "floating chair", article = "a"},
	{id = 12480, name = "floating junk"},
	{id = 12481, name = "floating ship parts"},
	{id = 12482, name = "floating wood"},
	{fromId = 12483, toId = 12484, name = "floating ship parts"},
	{id = 12485, name = "floating cask", article = "a"},
	{id = 12486, name = "floating bucket", article = "a"},
	{id = 12487, name = "floating green flask", article = "a"},
	{id = 12488, name = "floating glass"},
	{id = 12489, name = "floating bone", article = "a"},
	{id = 12490, name = "floating cloth"},
	{id = 12491, name = "floating junk"},
	{id = 12492, name = "floating bones"},
	{fromId = 12493, toId = 12494, name = "floating junk"},
	{id = 12495, name = "goblin ear", article = "a", weight = 75},
	{id = 12496, name = "heavy crate", article = "a"},
	{
		id = 12497,
		name = "Jean Pierre's Cookbook II",
		description = "It was given to you by the djinn maitre and contains new recipes you cooked.",
		weight = 1500
	},
	{id = 12498, name = "fish tail", article = "a", weight = 250, slotPosition = SLOTP_FEET, transformEquipTo = 13580},
	{id = 12499, name = "fish tail", weight = 250},
	{
		id = 12500,
		name = "faded last will",
		article = "a",
		description = "Supposedly the last will of someone. Whatever may have been written on it is long vanished.",
		weight = 200
	},
	{id = 12501, name = "exquisite silk", weight = 10},
	{id = 12502, name = "spectral cloth", weight = 500},
	{id = 12503, name = "exquisite wood", weight = 500},
	{id = 12504, name = "strong sinew", weight = 35},
	{id = 12505, name = "old iron", weight = 222},
	{id = 12506, name = "flexible dragon scale", article = "a", weight = 80},
	{id = 12507, name = "mystic root", article = "a", weight = 60},
	{id = 12508, name = "magic crystal", article = "a", description = "It is able to store memories and thoughts.", weight = 140},
	{
		fromId = 12509,
		toId = 12510,
		name = "gate of deathstruction",
		article = "a",
		type = ITEM_TYPE_TELEPORT,
		effect = CONST_ME_TELEPORT
	},
	{fromId = 12511, toId = 12526, name = "palisade", article = "a"},
	{
		id = 12527,
		name = "dead brimstone bug",
		article = "a",
		containerSize = 10,
		decayTo = 12528,
		duration = 10,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{
		id = 12528,
		name = "dead brimstone bug",
		article = "a",
		containerSize = 10,
		decayTo = 12538,
		duration = 900,
		corpseType = RACE_VENOM,
		fluidSource = FLUID_SLIME
	},
	{fromId = 12529, toId = 12536, name = "palisade", article = "a"},
	{id = 12537, name = "wooden pole", article = "a"},
	{id = 12538, name = "dead brimstone bug", article = "a", decayTo = 12539, duration = 600, corpseType = RACE_VENOM},
	{id = 12539, name = "dead brimstone bug", article = "a", decayTo = 0, duration = 600, corpseType = RACE_VENOM},
	{
		id = 12540,
		name = "coconut shrimp bake",
		article = "a",
		description = "It looks as if it was sealed with milky goodness.",
		weight = 2000
	},
	{
		id = 12541,
		name = "helmet of the deep",
		article = "a",
		weight = 21000,
		armor = 2,
		slotPosition = SLOTP_HEAD,
		conditionSuppressions = CONDITION_DROWN,
		speed = 600,
		decayTo = 5461,
		duration = 21600,
		transformDeEquipTo = 5461,
		showDuration = true,
		showAttributes = true
	},
	{
		id = 12542,
		name = "pot of blackjack",
		article = "a",
		description = "Nomads state that this meal fills you with energy several times before the pot is empty.",
		weight = 1200
	},
	{
		id = 12543,
		name = "demonic candy ball",
		article = "a",
		description = "You're never sure what demonic candy balls will do, but they sure taste sweet and exciting.",
		weight = 950
	},
	{
		id = 12544,
		name = "sweet mangonaise elixir",
		article = "a",
		description = "It's said to have incredible effects if you drink it while wearing a volatile magical ring with time limit.",
		weight = 300
	},
	{id = 12545, name = "dead glitterscale", article = "the", decayTo = 0, duration = 500},
	{id = 12546, name = "dead heoni", article = "the", decayTo = 0, duration = 500},
	{id = 12547, name = "spider victim", article = "a"},
	{fromId = 12548, toId = 12549, name = "hedge", article = "a"},
	{id = 12550, name = "blackened hedge", article = "a"},
	{fromId = 12551, toId = 12554, name = "hedge", article = "a"},
	{fromId = 12555, toId = 12558, name = "blackened hedge", article = "a"},
	{id = 12559, name = "silver rune emblem", article = "a", description = "It's an adorned ultimate healing rune.", weight = 120},
	{id = 12560, name = "golden rune emblem", article = "a", description = "It's an adorned ultimate healing rune.", weight = 120},
	{id = 12561, name = "silver rune emblem", article = "a", description = "It's an adorned heavy magic missile rune.", weight = 120},
	{id = 12562, name = "golden rune emblem", article = "a", description = "It's an adorned heavy magic missile rune.", weight = 120},
	{id = 12563, name = "silver rune emblem", article = "a", description = "It's an adorned explosion rune.", weight = 210},
	{id = 12564, name = "golden rune emblem", article = "a", description = "It's an adorned explosion rune.", weight = 120},
	{id = 12565, name = "silver rune emblem", article = "a", description = "It's an adorned sudden death rune.", weight = 120},
	{id = 12566, name = "golden rune emblem", article = "a", description = "It's an adorned sudden death rune.", weight = 120},
	{id = 12567, name = "silver rune emblem", article = "a", description = "It's an adorned magic wall rune.", weight = 120},
	{id = 12568, name = "golden rune emblem", article = "a", description = "It's an adorned magic wall rune.", weight = 120},
	{id = 12569, name = "silver rune emblem", article = "a", description = "It's an adorned animate dead rune.", weight = 120},
	{id = 12570, name = "golden rune emblem", article = "a", description = "It's an adorned animate dead rune.", weight = 120},
	{id = 12571, name = "silver rune emblem", article = "a", description = "It's an adorned great fireball rune.", weight = 120},
	{id = 12572, name = "golden rune emblem", article = "a", description = "It's an adorned great fireball rune.", weight = 120},
	{id = 12573, name = "silver rune emblem", article = "a", description = "It's an adorned fireball rune.", weight = 120},
	{id = 12574, name = "golden rune emblem", article = "a", description = "It's an adorned fireball rune.", weight = 120},
	{id = 12575, name = "silver rune emblem", article = "a", description = "It's an adorned thunderstorm rune.", weight = 120},
	{id = 12576, name = "golden rune emblem", article = "a", description = "It's an adorned thunderstorm rune.", weight = 120},
	{id = 12577, name = "silver rune emblem", article = "a", description = "It's an adorned icicle rune.", weight = 120},
	{id = 12578, name = "golden rune emblem", article = "a", description = "It's an adorned icicle rune.", weight = 120},
	{id = 12579, name = "silver rune emblem", article = "a", description = "It's an adorned avalanche rune.", weight = 120},
	{id = 12580, name = "golden rune emblem", article = "a", description = "It's an adorned avalanche rune.", weight = 120},
	{id = 12581, name = "silver rune emblem", article = "a", description = "It's an adorned holy missile rune.", weight = 120},
	{id = 12582, name = "golden rune emblem", article = "a", description = "It's an adorned holy missile rune.", weight = 120},
	{id = 12583, name = "silver rune emblem", article = "a", description = "It's an adorned energy bomb rune.", weight = 120},
	{id = 12584, name = "golden rune emblem", article = "a", description = "It's an adorned energy bomb rune.", weight = 120},
	{id = 12585, name = "silver rune emblem", article = "a", description = "It's an adorned paralyze rune.", weight = 120},
	{id = 12586, name = "golden rune emblem", article = "a", description = "It's an adorned paralyze rune.", weight = 120},
	{id = 12587, name = "silver rune emblem", article = "a", description = "It's an adorned desintegrate rune.", weight = 120},
	{id = 12588, name = "golden rune emblem", article = "a", description = "It's an adorned desintegrate rune.", weight = 120},
	{id = 12589, name = "silver rune emblem", article = "a", description = "It's an adorned chameleon rune.", weight = 120},
	{id = 12590, name = "golden rune emblem", article = "a", description = "It's an adorned chameleon rune.", weight = 120},
	{id = 12591, name = "silver rune emblem", article = "a", description = "It's an adorned energy wall rune.", weight = 120},
	{id = 12592, name = "golden rune emblem", article = "a", description = "It's an adorned energy wall rune.", weight = 120},
	{id = 12593, name = "silver rune emblem", article = "a", description = "It's an adorned soulfire rune.", weight = 120},
	{id = 12594, name = "golden rune emblem", article = "a", description = "It's an adorned soulfire rune.", weight = 120},
	{id = 12595, name = "silver rune emblem", article = "a", description = "It's an adorned destroy field rune.", weight = 120},
	{id = 12596, name = "golden rune emblem", article = "a", description = "It's an adorned destroy field rune.", weight = 120},
	{id = 12597, name = "silver rune emblem", article = "a", description = "It's an adorned wild growth rune.", weight = 120},
	{id = 12598, name = "golden rune emblem", article = "a", description = "It's an adorned wild growth rune.", weight = 120},
	{id = 12599, name = "silver rune emblem", article = "a", description = "It's an adorned firebomb rune.", weight = 120},
	{id = 12600, name = "golden rune emblem", article = "a", description = "It's an adorned firebomb rune.", weight = 120},
	{id = 12601, name = "silver rune emblem", article = "a", description = "It's an adorned poison bomb rune.", weight = 120},
	{id = 12602, name = "golden rune emblem", article = "a", description = "It's an adorned poison bomb rune.", weight = 120},
	{id = 12603, name = "silver rune emblem", article = "a", description = "It's an adorned light magic missile rune.", weight = 120},
	{id = 12604, name = "golden rune emblem", article = "a", description = "It's an adorned light magic missile rune.", weight = 120},
	{id = 12605, name = "silver rune emblem", article = "a", description = "It's an adorned fire field rune.", weight = 120},
	{id = 12606, name = "golden rune emblem", article = "a", description = "It's an adorned fire field rune.", weight = 120},
	{id = 12607, name = "elite draken mail", article = "an", weight = 12000, armor = 15, slotPosition = SLOTP_ARMOR, speed = 20},
	{id = 12608, name = "broken key ring", article = "a", weight = 50},
	{
		id = 12609,
		name = "dead draken elite",
		article = "a",
		containerSize = 32,
		decayTo = 12610,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 12610,
		name = "dead draken elite",
		article = "a",
		containerSize = 32,
		decayTo = 12611,
		duration = 900,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 12611, name = "dead draken elite", article = "a", decayTo = 12612, duration = 600, corpseType = RACE_BLOOD},
	{id = 12612, name = "dead draken elite", article = "a", decayTo = 0, duration = 600, corpseType = RACE_BLOOD},
	{
		id = 12613,
		name = "twiceslicer",
		article = "a",
		weight = 18000,
		defense = 30,
		attack = 47,
		weaponType = WEAPON_SWORD,
		slotPosition = SLOTP_TWO_HAND
	},
	{id = 12614, name = "draken sulphur", weight = 68, showCount = false},
	{id = 12615, name = "draken wristbands", weight = 78, showCount = false},
	{id = 12616, name = "broken draken mail", article = "a", weight = 200},
	{id = 12617, name = "broken slicer", article = "a", weight = 140},
	{fromId = 12618, toId = 12621, name = "dead spawn", article = "a"},
	{id = 12622, name = "tentacle piece", article = "a", weight = 300},
	{
		id = 12623,
		name = "dead draken abomination",
		article = "a",
		containerSize = 32,
		decayTo = 12624,
		duration = 10,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{
		id = 12624,
		name = "dead draken abomination",
		article = "a",
		containerSize = 32,
		decayTo = 12625,
		duration = 300,
		corpseType = RACE_BLOOD,
		fluidSource = FLUID_BLOOD
	},
	{id = 12625, name = "dead draken abomination", article = "a", decayTo = 12626, duration = 300, corpseType = RACE_BLOOD},
	{id = 12626, name = "dead draken abomination", article = "a", decayTo = 0, duration = 60, corpseType = RACE_BLOOD},
	{id = 12627, name = "eye of corruption", article = "an", plural = "eyes of corruption", weight = 93},
	{id = 12628, name = "tail of corruption", article = "a", plural = "tails of corruption", weight = 93},
	{id = 12629, name = "scale of corruption", article = "a", plural = "scales of corruption", weight = 93},
	{
		id = 12630,
		name = "cobra crown",
		article = "a",
		weight = 850,
		armor = 3,
		magicLevelPoints = 2,
		absorbPercent = {[COMBAT_EARTHDAMAGE] = 5, [COMBAT_FIREDAMAGE] = -5},
		slotPosition = SLOTP_HEAD
	},
	{
		id = 12631,
		name = "dissolved souleater",
		article = "a",
		containerSize = 20,
		decayTo = 12632,
		duration = 10,
		corpseType = RACE_UNDEAD
	},
	{
		id = 12632,
		name = "dissolved souleater",
		article = "a",
		containerSize = 20,
		decayTo = 12633,
		duration = 300,
		corpseType = RACE_UNDEAD
	},
	{id = 12633, name = "dissolved souleater", article = "a", decayTo = 12634, duration = 300, corpseType = RACE_UNDEAD},
	{id = 12634, name = "dissolved souleater", article = "a", decayTo = 0, duration = 60, corpseType = RACE_UNDEAD},
	{id = 12635, name = "souleater trophy", article = "a", slotPosition = SLOTP_AMMO, weight = 500},
	{id = 12636, name = "lizard essence", article = "a", weight = 150},
	{id = 12637, name = "ectoplasmic sushi", weight = 400, showCount = false},
	{id = 12638, name = "dragonfruit", article = "a", weight = 350, showCount = false},
	{id = 12639, name = "peas", weight = 80, showCount = false},
	{id = 12640, name = "downy feather", article = "a", weight = 32},
	{id = 12641, name = "cheese cookie", article = "a", weight = 10},
	{
		id = 12642,
		name = "royal draken mail",
		article = "a",
		weight = 13000,
		armor = 16,
		slotPosition = SLOTP_ARMOR,
		skillShield = 3,
		absorbPercent = {[COMBAT_PHYSICALDAMAGE] = 5}
	},
	{
		id = 12643,
		name = "royal scale robe",
		article = "a",
		weight = 4500,
		armor = 12,
		slotPosition = SLOTP_ARMOR,
		magicLevelPoints = 2,
		absorbPercent = {[COMBAT_FIREDAMAGE] = 5}
	},
	{
		id = 12644,
		name = "shield of corruption",
		article = "a",
		weight = 4900,
		defense = 36,
		skillSword = 3,
		weaponType = WEAPON_SHIELD,
		showAttributes = true
	},
	{
		id = 12645,
		name = "elite draken helmet",
		article = "an",
		weight = 4300,
		armor = 9,
		slotPosition = SLOTP_HEAD,
		absorbPercent = {[COMBAT_DEATHDAMAGE] = 3},
		skillDist = 1
	},
	{id = 12646, name = "draken boots", armor = 3, speed = 30, weight = 2500, slotPosition = SLOTP_FEET},
	{
		id = 12647,
		name = "snake god's wristguard",
		article = "a",
		description = "It shows your spells and can also shield against attacks when worn.",
		weight = 2800,
		magicLevelPoints = 3,
		defense = 14,
		weaponType = WEAPON_SHIELD
	},
	{
		id = 12648,
		name = "snake god's sceptre",
		article = "a",
		weight = 12000,
		defense = 29,
		attack = 48,
		weaponType = WEAPON_CLUB,
		extraDefense = 3
	},
	{
		id = 12649,
		name = "blade of corruption",
		article = "a",
		weight = 6400,
		defense = 29,
		attack = 48,
		weaponType = WEAPON_SWORD,
		extraDefense = 2
	},
	{id = 12650, name = "snake god trophy", article = "a", weight = 500},
	{id = 12651, name = "black jade cobra", article = "a", slotPosition = SLOTP_AMMO, weight = 650},
	{fromId = 12652, toId = 12653, name = "gate guardian", article = "a"},
	{id = 12654, name = "loot bag", article = "a", containerSize = 60, weight = 000},
	{
		id = 12655,
		name = "botany almanach",
		article = "a",
		description = "The title of this heavy book reads: 'Rabaz' Unabridged Almanach Of Botany'.",
		weight = 1500
	},
	{
		id = 12656,
		name = "sedge hat",
		article = "a",
		description = "This simple hat might be more worth than what it looks like.",
		weight = 1800,
		armor = 2,
		slotPosition = SLOTP_HEAD
	},
	{
		id = 12657,
		name = "old cape",
		article = "an",
		description = "This old cape might be worth more than what it looks like.",
		weight = 3500,
		armor = 1,
		slotPosition = SLOTP_ARMOR
	},
	{id = 12658, name = "brimstone fangs", plural = "brimstone fangs", weight = 112},
	{id = 12659, name = "brimstone shell", article = "a", weight = 112},
	{
		id = 12660,
		name = "trashed draken boots",
		description = "They will expire within a short time, sell them back to Esrik before they do.",
		weight = 2500
	}
}

Game.registerItemTypes(items)
items = nil
collectgarbage()
